﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.

using Azure.Tests;
using Fluent.Tests.Common;
using Xunit;
using Xunit.Abstractions;

namespace Samples.Tests
{
    public class Storage : Samples.Tests.TestBase
    {
        public Storage(ITestOutputHelper output)
            : base(output)
        {
        }

        [Fact]
        [Trait("Samples", "Storage")]
        public void ManageStorageAccountTest()
        {
            using (var context = FluentMockContext.Start(this.GetType().FullName))
            {
                var rollUpClient = TestHelper.CreateRollupClient();
                ManageStorageAccount.Program.RunSample(rollUpClient);
            }
        }

        [Fact]
        [Trait("Samples", "Storage")]
        public void ManageStorageAccountTestAsync()
        {
            RunSampleAsTest(
                this.GetType().FullName,
                (azure) => ManageStorageAccountAsync.Program
                            .RunSampleAsync(azure)
                            .GetAwaiter()
                            .GetResult());
        }

        [Fact]
        [Trait("Samples", "Storage")]
        public void ManageManageStorageAccountNetworkRulesTest()
        {
            using (var context = FluentMockContext.Start(this.GetType().FullName))
            {
                var rollUpClient = TestHelper.CreateRollupClient();
                ManageStorageAccountNetworkRules.Program.RunSample(rollUpClient);
            }
        }
    }
}
