// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Batch.Fluent.Models
{
    using Newtonsoft.Json;
    using Newtonsoft.Json.Converters;
    using System.Runtime;
    using System.Runtime.Serialization;

    /// <summary>
    /// Defines values for ContainerWorkingDirectory.
    /// </summary>
    [JsonConverter(typeof(StringEnumConverter))]
    public enum ContainerWorkingDirectory
    {
        /// <summary>
        /// Use the standard Batch service task working directory, which will
        /// contain the Task resource files populated by Batch.
        /// </summary>
        [EnumMember(Value = "TaskWorkingDirectory")]
        TaskWorkingDirectory,
        /// <summary>
        /// Using container image defined working directory. Beware that this
        /// directory will not contain the resource files downloaded by Batch.
        /// </summary>
        [EnumMember(Value = "ContainerImageDefault")]
        ContainerImageDefault
    }
    internal static class ContainerWorkingDirectoryEnumExtension
    {
        internal static string ToSerializedValue(this ContainerWorkingDirectory? value)
        {
            return value == null ? null : ((ContainerWorkingDirectory)value).ToSerializedValue();
        }

        internal static string ToSerializedValue(this ContainerWorkingDirectory value)
        {
            switch( value )
            {
                case ContainerWorkingDirectory.TaskWorkingDirectory:
                    return "TaskWorkingDirectory";
                case ContainerWorkingDirectory.ContainerImageDefault:
                    return "ContainerImageDefault";
            }
            return null;
        }

        internal static ContainerWorkingDirectory? ParseContainerWorkingDirectory(this string value)
        {
            switch( value )
            {
                case "TaskWorkingDirectory":
                    return ContainerWorkingDirectory.TaskWorkingDirectory;
                case "ContainerImageDefault":
                    return ContainerWorkingDirectory.ContainerImageDefault;
            }
            return null;
        }
    }
}
