// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Batch.Fluent.Models
{
    using Newtonsoft.Json;
    using Newtonsoft.Json.Converters;
    using System.Runtime;
    using System.Runtime.Serialization;

    /// <summary>
    /// Defines values for ProvisioningState.
    /// </summary>
    [JsonConverter(typeof(StringEnumConverter))]
    public enum ProvisioningState
    {
        /// <summary>
        /// The account is in an invalid state.
        /// </summary>
        [EnumMember(Value = "Invalid")]
        Invalid,
        /// <summary>
        /// The account is being created.
        /// </summary>
        [EnumMember(Value = "Creating")]
        Creating,
        /// <summary>
        /// The account is being deleted.
        /// </summary>
        [EnumMember(Value = "Deleting")]
        Deleting,
        /// <summary>
        /// The account has been created and is ready for use.
        /// </summary>
        [EnumMember(Value = "Succeeded")]
        Succeeded,
        /// <summary>
        /// The last operation for the account is failed.
        /// </summary>
        [EnumMember(Value = "Failed")]
        Failed,
        /// <summary>
        /// The last operation for the account is cancelled.
        /// </summary>
        [EnumMember(Value = "Cancelled")]
        Cancelled
    }
    internal static class ProvisioningStateEnumExtension
    {
        internal static string ToSerializedValue(this ProvisioningState? value)
        {
            return value == null ? null : ((ProvisioningState)value).ToSerializedValue();
        }

        internal static string ToSerializedValue(this ProvisioningState value)
        {
            switch( value )
            {
                case ProvisioningState.Invalid:
                    return "Invalid";
                case ProvisioningState.Creating:
                    return "Creating";
                case ProvisioningState.Deleting:
                    return "Deleting";
                case ProvisioningState.Succeeded:
                    return "Succeeded";
                case ProvisioningState.Failed:
                    return "Failed";
                case ProvisioningState.Cancelled:
                    return "Cancelled";
            }
            return null;
        }

        internal static ProvisioningState? ParseProvisioningState(this string value)
        {
            switch( value )
            {
                case "Invalid":
                    return ProvisioningState.Invalid;
                case "Creating":
                    return ProvisioningState.Creating;
                case "Deleting":
                    return ProvisioningState.Deleting;
                case "Succeeded":
                    return ProvisioningState.Succeeded;
                case "Failed":
                    return ProvisioningState.Failed;
                case "Cancelled":
                    return ProvisioningState.Cancelled;
            }
            return null;
        }
    }
}
