// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Batch.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Scale settings for the pool
    /// </summary>
    /// <remarks>
    /// Defines the desired size of the pool. This can either be 'fixedScale'
    /// where the requested targetDedicatedNodes is specified, or 'autoScale'
    /// which defines a formula which is periodically reevaluated. If this
    /// property is not specified, the pool will have a fixed scale with 0
    /// targetDedicatedNodes.
    /// </remarks>
    public partial class ScaleSettings
    {
        /// <summary>
        /// Initializes a new instance of the ScaleSettings class.
        /// </summary>
        public ScaleSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScaleSettings class.
        /// </summary>
        /// <param name="fixedScale">Fixed scale settings for the pool.</param>
        /// <param name="autoScale">AutoScale settings for the pool.</param>
        public ScaleSettings(FixedScaleSettings fixedScale = default(FixedScaleSettings), AutoScaleSettings autoScale = default(AutoScaleSettings))
        {
            FixedScale = fixedScale;
            AutoScale = autoScale;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets fixed scale settings for the pool.
        /// </summary>
        /// <remarks>
        /// This property and autoScale are mutually exclusive and one of the
        /// properties must be specified.
        /// </remarks>
        [JsonProperty(PropertyName = "fixedScale")]
        public FixedScaleSettings FixedScale { get; set; }

        /// <summary>
        /// Gets or sets autoScale settings for the pool.
        /// </summary>
        /// <remarks>
        /// This property and fixedScale are mutually exclusive and one of the
        /// properties must be specified.
        /// </remarks>
        [JsonProperty(PropertyName = "autoScale")]
        public AutoScaleSettings AutoScale { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AutoScale != null)
            {
                AutoScale.Validate();
            }
        }
    }
}
