// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Class representing Abnormal Time Period identified in diagnosis
    /// </summary>
    public partial class AbnormalTimePeriod
    {
        /// <summary>
        /// Initializes a new instance of the AbnormalTimePeriod class.
        /// </summary>
        public AbnormalTimePeriod()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AbnormalTimePeriod class.
        /// </summary>
        /// <param name="startTime">Start time of the downtime</param>
        /// <param name="endTime">End time of the downtime</param>
        /// <param name="events">List of Possible Cause of downtime</param>
        /// <param name="solutions">List of proposed solutions</param>
        public AbnormalTimePeriod(System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), IList<DetectorAbnormalTimePeriod> events = default(IList<DetectorAbnormalTimePeriod>), IList<Solution> solutions = default(IList<Solution>))
        {
            StartTime = startTime;
            EndTime = endTime;
            Events = events;
            Solutions = solutions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets start time of the downtime
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets end time of the downtime
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets list of Possible Cause of downtime
        /// </summary>
        [JsonProperty(PropertyName = "events")]
        public IList<DetectorAbnormalTimePeriod> Events { get; set; }

        /// <summary>
        /// Gets or sets list of proposed solutions
        /// </summary>
        [JsonProperty(PropertyName = "solutions")]
        public IList<Solution> Solutions { get; set; }

    }
}
