// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// ARM resource for a ApplicationStack.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ApplicationStackResource : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationStackResource class.
        /// </summary>
        public ApplicationStackResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationStackResource class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="applicationStackResourceName">Application stack
        /// name.</param>
        /// <param name="display">Application stack display name.</param>
        /// <param name="dependency">Application stack dependency.</param>
        /// <param name="majorVersions">List of major versions
        /// available.</param>
        /// <param name="frameworks">List of frameworks associated with
        /// application stack.</param>
        public ApplicationStackResource(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string applicationStackResourceName = default(string), string display = default(string), string dependency = default(string), IList<StackMajorVersion> majorVersions = default(IList<StackMajorVersion>), IList<ApplicationStack> frameworks = default(IList<ApplicationStack>))
            : base(id, name, type, kind)
        {
            ApplicationStackResourceName = applicationStackResourceName;
            Display = display;
            Dependency = dependency;
            MajorVersions = majorVersions;
            Frameworks = frameworks;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets application stack name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.name")]
        public string ApplicationStackResourceName { get; set; }

        /// <summary>
        /// Gets or sets application stack display name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.display")]
        public string Display { get; set; }

        /// <summary>
        /// Gets or sets application stack dependency.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dependency")]
        public string Dependency { get; set; }

        /// <summary>
        /// Gets or sets list of major versions available.
        /// </summary>
        [JsonProperty(PropertyName = "properties.majorVersions")]
        public IList<StackMajorVersion> MajorVersions { get; set; }

        /// <summary>
        /// Gets or sets list of frameworks associated with application stack.
        /// </summary>
        [JsonProperty(PropertyName = "properties.frameworks")]
        public IList<ApplicationStack> Frameworks { get; set; }

    }
}
