// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Actions which to take by the auto-heal module when a rule is triggered.
    /// </summary>
    public partial class AutoHealActions
    {
        /// <summary>
        /// Initializes a new instance of the AutoHealActions class.
        /// </summary>
        public AutoHealActions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AutoHealActions class.
        /// </summary>
        /// <param name="actionType">Predefined action to be taken. Possible
        /// values include: 'Recycle', 'LogEvent', 'CustomAction'</param>
        /// <param name="customAction">Custom action to be taken.</param>
        /// <param name="minProcessExecutionTime">Minimum time the process must
        /// execute
        /// before taking the action</param>
        public AutoHealActions(AutoHealActionType? actionType = default(AutoHealActionType?), AutoHealCustomAction customAction = default(AutoHealCustomAction), string minProcessExecutionTime = default(string))
        {
            ActionType = actionType;
            CustomAction = customAction;
            MinProcessExecutionTime = minProcessExecutionTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets predefined action to be taken. Possible values
        /// include: 'Recycle', 'LogEvent', 'CustomAction'
        /// </summary>
        [JsonProperty(PropertyName = "actionType")]
        public AutoHealActionType? ActionType { get; set; }

        /// <summary>
        /// Gets or sets custom action to be taken.
        /// </summary>
        [JsonProperty(PropertyName = "customAction")]
        public AutoHealCustomAction CustomAction { get; set; }

        /// <summary>
        /// Gets or sets minimum time the process must execute
        /// before taking the action
        /// </summary>
        [JsonProperty(PropertyName = "minProcessExecutionTime")]
        public string MinProcessExecutionTime { get; set; }

    }
}
