// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Triggers for auto-heal.
    /// </summary>
    public partial class AutoHealTriggers
    {
        /// <summary>
        /// Initializes a new instance of the AutoHealTriggers class.
        /// </summary>
        public AutoHealTriggers()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AutoHealTriggers class.
        /// </summary>
        /// <param name="requests">A rule based on total requests.</param>
        /// <param name="privateBytesInKB">A rule based on private
        /// bytes.</param>
        /// <param name="statusCodes">A rule based on status codes.</param>
        /// <param name="slowRequests">A rule based on request execution
        /// time.</param>
        public AutoHealTriggers(RequestsBasedTrigger requests = default(RequestsBasedTrigger), int? privateBytesInKB = default(int?), IList<StatusCodesBasedTrigger> statusCodes = default(IList<StatusCodesBasedTrigger>), SlowRequestsBasedTrigger slowRequests = default(SlowRequestsBasedTrigger))
        {
            Requests = requests;
            PrivateBytesInKB = privateBytesInKB;
            StatusCodes = statusCodes;
            SlowRequests = slowRequests;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a rule based on total requests.
        /// </summary>
        [JsonProperty(PropertyName = "requests")]
        public RequestsBasedTrigger Requests { get; set; }

        /// <summary>
        /// Gets or sets a rule based on private bytes.
        /// </summary>
        [JsonProperty(PropertyName = "privateBytesInKB")]
        public int? PrivateBytesInKB { get; set; }

        /// <summary>
        /// Gets or sets a rule based on status codes.
        /// </summary>
        [JsonProperty(PropertyName = "statusCodes")]
        public IList<StatusCodesBasedTrigger> StatusCodes { get; set; }

        /// <summary>
        /// Gets or sets a rule based on request execution time.
        /// </summary>
        [JsonProperty(PropertyName = "slowRequests")]
        public SlowRequestsBasedTrigger SlowRequests { get; set; }

    }
}
