// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Http logs to azure blob storage configuration.
    /// </summary>
    public partial class AzureBlobStorageHttpLogsConfig
    {
        /// <summary>
        /// Initializes a new instance of the AzureBlobStorageHttpLogsConfig
        /// class.
        /// </summary>
        public AzureBlobStorageHttpLogsConfig()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureBlobStorageHttpLogsConfig
        /// class.
        /// </summary>
        /// <param name="sasUrl">SAS url to a azure blob container with
        /// read/write/list/delete permissions.</param>
        /// <param name="retentionInDays">Retention in days.
        /// Remove blobs older than X days.
        /// 0 or lower means no retention.</param>
        /// <param name="enabled">True if configuration is enabled, false if it
        /// is disabled and null if configuration is not set.</param>
        public AzureBlobStorageHttpLogsConfig(string sasUrl = default(string), int? retentionInDays = default(int?), bool? enabled = default(bool?))
        {
            SasUrl = sasUrl;
            RetentionInDays = retentionInDays;
            Enabled = enabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets SAS url to a azure blob container with
        /// read/write/list/delete permissions.
        /// </summary>
        [JsonProperty(PropertyName = "sasUrl")]
        public string SasUrl { get; set; }

        /// <summary>
        /// Gets or sets retention in days.
        /// Remove blobs older than X days.
        /// 0 or lower means no retention.
        /// </summary>
        [JsonProperty(PropertyName = "retentionInDays")]
        public int? RetentionInDays { get; set; }

        /// <summary>
        /// Gets or sets true if configuration is enabled, false if it is
        /// disabled and null if configuration is not set.
        /// </summary>
        [JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

    }
}
