// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Cross-Origin Resource Sharing (CORS) settings for the app.
    /// </summary>
    public partial class CorsSettings
    {
        /// <summary>
        /// Initializes a new instance of the CorsSettings class.
        /// </summary>
        public CorsSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CorsSettings class.
        /// </summary>
        /// <param name="allowedOrigins">Gets or sets the list of origins that
        /// should be allowed to make cross-origin
        /// calls (for example: http://example.com:12345). Use "*" to allow
        /// all.</param>
        /// <param name="supportCredentials">Gets or sets whether CORS requests
        /// with credentials are allowed. See
        /// https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Requests_with_credentials
        /// for more details.</param>
        public CorsSettings(IList<string> allowedOrigins = default(IList<string>), bool? supportCredentials = default(bool?))
        {
            AllowedOrigins = allowedOrigins;
            SupportCredentials = supportCredentials;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of origins that should be allowed to make
        /// cross-origin
        /// calls (for example: http://example.com:12345). Use "*" to allow
        /// all.
        /// </summary>
        [JsonProperty(PropertyName = "allowedOrigins")]
        public IList<string> AllowedOrigins { get; set; }

        /// <summary>
        /// Gets or sets whether CORS requests with credentials are allowed.
        /// See
        /// https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Requests_with_credentials
        /// for more details.
        /// </summary>
        [JsonProperty(PropertyName = "supportCredentials")]
        public bool? SupportCredentials { get; set; }

    }
}
