// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A deleted app.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DeletedSiteInner : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the DeletedSiteInner class.
        /// </summary>
        public DeletedSiteInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DeletedSiteInner class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="deletedSiteId">Numeric id for the deleted site</param>
        /// <param name="deletedTimestamp">Time in UTC when the app was
        /// deleted.</param>
        /// <param name="subscription">Subscription containing the deleted
        /// site</param>
        /// <param name="resourceGroup">ResourceGroup that contained the
        /// deleted site</param>
        /// <param name="deletedSiteName">Name of the deleted site</param>
        /// <param name="slot">Slot of the deleted site</param>
        /// <param name="deletedSiteKind">Kind of site that was deleted</param>
        /// <param name="geoRegionName">Geo Region of the deleted site</param>
        public DeletedSiteInner(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), int? deletedSiteId = default(int?), string deletedTimestamp = default(string), string subscription = default(string), string resourceGroup = default(string), string deletedSiteName = default(string), string slot = default(string), string deletedSiteKind = default(string), string geoRegionName = default(string))
            : base(id, name, type, kind)
        {
            DeletedSiteId = deletedSiteId;
            DeletedTimestamp = deletedTimestamp;
            Subscription = subscription;
            ResourceGroup = resourceGroup;
            DeletedSiteName = deletedSiteName;
            Slot = slot;
            DeletedSiteKind = deletedSiteKind;
            GeoRegionName = geoRegionName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets numeric id for the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.deletedSiteId")]
        public int? DeletedSiteId { get; private set; }

        /// <summary>
        /// Gets time in UTC when the app was deleted.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deletedTimestamp")]
        public string DeletedTimestamp { get; private set; }

        /// <summary>
        /// Gets subscription containing the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.subscription")]
        public string Subscription { get; private set; }

        /// <summary>
        /// Gets resourceGroup that contained the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceGroup")]
        public string ResourceGroup { get; private set; }

        /// <summary>
        /// Gets name of the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.deletedSiteName")]
        public string DeletedSiteName { get; private set; }

        /// <summary>
        /// Gets slot of the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.slot")]
        public string Slot { get; private set; }

        /// <summary>
        /// Gets kind of site that was deleted
        /// </summary>
        [JsonProperty(PropertyName = "properties.kind")]
        public string DeletedSiteKind { get; private set; }

        /// <summary>
        /// Gets geo Region of the deleted site
        /// </summary>
        [JsonProperty(PropertyName = "properties.geoRegionName")]
        public string GeoRegionName { get; private set; }

    }
}
