// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Class representing Diagnostic Metric information
    /// </summary>
    public partial class DiagnosticMetricSet
    {
        /// <summary>
        /// Initializes a new instance of the DiagnosticMetricSet class.
        /// </summary>
        public DiagnosticMetricSet()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiagnosticMetricSet class.
        /// </summary>
        /// <param name="name">Name of the metric</param>
        /// <param name="unit">Metric's unit</param>
        /// <param name="startTime">Start time of the period</param>
        /// <param name="endTime">End time of the period</param>
        /// <param name="timeGrain">Presented time grain. Supported grains at
        /// the moment are PT1M, PT1H, P1D</param>
        /// <param name="values">Collection of metric values for the selected
        /// period based on the
        /// {Microsoft.Web.Hosting.Administration.DiagnosticMetricSet.TimeGrain}</param>
        public DiagnosticMetricSet(string name = default(string), string unit = default(string), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), string timeGrain = default(string), IList<DiagnosticMetricSample> values = default(IList<DiagnosticMetricSample>))
        {
            Name = name;
            Unit = unit;
            StartTime = startTime;
            EndTime = endTime;
            TimeGrain = timeGrain;
            Values = values;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the metric
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets metric's unit
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or sets start time of the period
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets end time of the period
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets presented time grain. Supported grains at the moment
        /// are PT1M, PT1H, P1D
        /// </summary>
        [JsonProperty(PropertyName = "timeGrain")]
        public string TimeGrain { get; set; }

        /// <summary>
        /// Gets or sets collection of metric values for the selected period
        /// based on the
        /// {Microsoft.Web.Hosting.Administration.DiagnosticMetricSet.TimeGrain}
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<DiagnosticMetricSample> Values { get; set; }

    }
}
