// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A domain name that a service is reached at, including details of the
    /// current connection status.
    /// </summary>
    public partial class EndpointDependency
    {
        /// <summary>
        /// Initializes a new instance of the EndpointDependency class.
        /// </summary>
        public EndpointDependency()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EndpointDependency class.
        /// </summary>
        /// <param name="domainName">The domain name of the dependency.</param>
        /// <param name="endpointDetails">The IP Addresses and Ports used when
        /// connecting to DomainName.</param>
        public EndpointDependency(string domainName = default(string), IList<EndpointDetail> endpointDetails = default(IList<EndpointDetail>))
        {
            DomainName = domainName;
            EndpointDetails = endpointDetails;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the domain name of the dependency.
        /// </summary>
        [JsonProperty(PropertyName = "domainName")]
        public string DomainName { get; set; }

        /// <summary>
        /// Gets or sets the IP Addresses and Ports used when connecting to
        /// DomainName.
        /// </summary>
        [JsonProperty(PropertyName = "endpointDetails")]
        public IList<EndpointDetail> EndpointDetails { get; set; }

    }
}
