// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Details of a hostname derived from a domain.
    /// </summary>
    public partial class HostName
    {
        /// <summary>
        /// Initializes a new instance of the HostName class.
        /// </summary>
        public HostName()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the HostName class.
        /// </summary>
        /// <param name="name">Name of the hostname.</param>
        /// <param name="siteNames">List of apps the hostname is assigned to.
        /// This list will have more than one app only if the hostname is
        /// pointing to a Traffic Manager.</param>
        /// <param name="azureResourceName">Name of the Azure resource the
        /// hostname is assigned to. If it is assigned to a Traffic Manager
        /// then it will be the Traffic Manager name otherwise it will be the
        /// app name.</param>
        /// <param name="azureResourceType">Type of the Azure resource the
        /// hostname is assigned to. Possible values include: 'Website',
        /// 'TrafficManager'</param>
        /// <param name="customHostNameDnsRecordType">Type of the DNS record.
        /// Possible values include: 'CName', 'A'</param>
        /// <param name="hostNameType">Type of the hostname. Possible values
        /// include: 'Verified', 'Managed'</param>
        public HostName(string name = default(string), IList<string> siteNames = default(IList<string>), string azureResourceName = default(string), AzureResourceType? azureResourceType = default(AzureResourceType?), CustomHostNameDnsRecordType? customHostNameDnsRecordType = default(CustomHostNameDnsRecordType?), HostNameType? hostNameType = default(HostNameType?))
        {
            Name = name;
            SiteNames = siteNames;
            AzureResourceName = azureResourceName;
            AzureResourceType = azureResourceType;
            CustomHostNameDnsRecordType = customHostNameDnsRecordType;
            HostNameType = hostNameType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the hostname.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets list of apps the hostname is assigned to. This list
        /// will have more than one app only if the hostname is pointing to a
        /// Traffic Manager.
        /// </summary>
        [JsonProperty(PropertyName = "siteNames")]
        public IList<string> SiteNames { get; set; }

        /// <summary>
        /// Gets or sets name of the Azure resource the hostname is assigned
        /// to. If it is assigned to a Traffic Manager then it will be the
        /// Traffic Manager name otherwise it will be the app name.
        /// </summary>
        [JsonProperty(PropertyName = "azureResourceName")]
        public string AzureResourceName { get; set; }

        /// <summary>
        /// Gets or sets type of the Azure resource the hostname is assigned
        /// to. Possible values include: 'Website', 'TrafficManager'
        /// </summary>
        [JsonProperty(PropertyName = "azureResourceType")]
        public AzureResourceType? AzureResourceType { get; set; }

        /// <summary>
        /// Gets or sets type of the DNS record. Possible values include:
        /// 'CName', 'A'
        /// </summary>
        [JsonProperty(PropertyName = "customHostNameDnsRecordType")]
        public CustomHostNameDnsRecordType? CustomHostNameDnsRecordType { get; set; }

        /// <summary>
        /// Gets or sets type of the hostname. Possible values include:
        /// 'Verified', 'Managed'
        /// </summary>
        [JsonProperty(PropertyName = "hostNameType")]
        public HostNameType? HostNameType { get; set; }

    }
}
