// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An operation on a resource.
    /// </summary>
    public partial class OperationInner
    {
        /// <summary>
        /// Initializes a new instance of the OperationInner class.
        /// </summary>
        public OperationInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationInner class.
        /// </summary>
        /// <param name="id">Operation ID.</param>
        /// <param name="name">Operation name.</param>
        /// <param name="status">The current status of the operation. Possible
        /// values include: 'InProgress', 'Failed', 'Succeeded', 'TimedOut',
        /// 'Created'</param>
        /// <param name="errors">Any errors associate with the
        /// operation.</param>
        /// <param name="createdTime">Time when operation has started.</param>
        /// <param name="modifiedTime">Time when operation has been
        /// updated.</param>
        /// <param name="expirationTime">Time when operation will
        /// expire.</param>
        /// <param name="geoMasterOperationId">Applicable only for stamp
        /// operation ids.</param>
        public OperationInner(string id = default(string), string name = default(string), OperationStatus? status = default(OperationStatus?), IList<ErrorEntity> errors = default(IList<ErrorEntity>), System.DateTime? createdTime = default(System.DateTime?), System.DateTime? modifiedTime = default(System.DateTime?), System.DateTime? expirationTime = default(System.DateTime?), System.Guid? geoMasterOperationId = default(System.Guid?))
        {
            Id = id;
            Name = name;
            Status = status;
            Errors = errors;
            CreatedTime = createdTime;
            ModifiedTime = modifiedTime;
            ExpirationTime = expirationTime;
            GeoMasterOperationId = geoMasterOperationId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets operation ID.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets operation name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the current status of the operation. Possible values
        /// include: 'InProgress', 'Failed', 'Succeeded', 'TimedOut', 'Created'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public OperationStatus? Status { get; set; }

        /// <summary>
        /// Gets or sets any errors associate with the operation.
        /// </summary>
        [JsonProperty(PropertyName = "errors")]
        public IList<ErrorEntity> Errors { get; set; }

        /// <summary>
        /// Gets or sets time when operation has started.
        /// </summary>
        [JsonProperty(PropertyName = "createdTime")]
        public System.DateTime? CreatedTime { get; set; }

        /// <summary>
        /// Gets or sets time when operation has been updated.
        /// </summary>
        [JsonProperty(PropertyName = "modifiedTime")]
        public System.DateTime? ModifiedTime { get; set; }

        /// <summary>
        /// Gets or sets time when operation will expire.
        /// </summary>
        [JsonProperty(PropertyName = "expirationTime")]
        public System.DateTime? ExpirationTime { get; set; }

        /// <summary>
        /// Gets or sets applicable only for stamp operation ids.
        /// </summary>
        [JsonProperty(PropertyName = "geoMasterOperationId")]
        public System.Guid? GeoMasterOperationId { get; set; }

    }
}
