// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// ARM resource for a PremierAddOn.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class PremierAddOnPatchResource : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the PremierAddOnPatchResource class.
        /// </summary>
        public PremierAddOnPatchResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PremierAddOnPatchResource class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="sku">Premier add on SKU.</param>
        /// <param name="product">Premier add on Product.</param>
        /// <param name="vendor">Premier add on Vendor.</param>
        /// <param name="marketplacePublisher">Premier add on Marketplace
        /// publisher.</param>
        /// <param name="marketplaceOffer">Premier add on Marketplace
        /// offer.</param>
        public PremierAddOnPatchResource(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string sku = default(string), string product = default(string), string vendor = default(string), string marketplacePublisher = default(string), string marketplaceOffer = default(string))
            : base(id, name, type, kind)
        {
            Sku = sku;
            Product = product;
            Vendor = vendor;
            MarketplacePublisher = marketplacePublisher;
            MarketplaceOffer = marketplaceOffer;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets premier add on SKU.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sku")]
        public string Sku { get; set; }

        /// <summary>
        /// Gets or sets premier add on Product.
        /// </summary>
        [JsonProperty(PropertyName = "properties.product")]
        public string Product { get; set; }

        /// <summary>
        /// Gets or sets premier add on Vendor.
        /// </summary>
        [JsonProperty(PropertyName = "properties.vendor")]
        public string Vendor { get; set; }

        /// <summary>
        /// Gets or sets premier add on Marketplace publisher.
        /// </summary>
        [JsonProperty(PropertyName = "properties.marketplacePublisher")]
        public string MarketplacePublisher { get; set; }

        /// <summary>
        /// Gets or sets premier add on Marketplace offer.
        /// </summary>
        [JsonProperty(PropertyName = "properties.marketplaceOffer")]
        public string MarketplaceOffer { get; set; }

    }
}
