// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Description of the parameters of Private Access for a Web Site.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class PrivateAccessInner : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the PrivateAccessInner class.
        /// </summary>
        public PrivateAccessInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PrivateAccessInner class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="enabled">Whether private access is enabled or
        /// not.</param>
        /// <param name="virtualNetworks">The Virtual Networks (and subnets)
        /// allowed to access the site privately.</param>
        public PrivateAccessInner(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), bool? enabled = default(bool?), IList<PrivateAccessVirtualNetwork> virtualNetworks = default(IList<PrivateAccessVirtualNetwork>))
            : base(id, name, type, kind)
        {
            Enabled = enabled;
            VirtualNetworks = virtualNetworks;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets whether private access is enabled or not.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets or sets the Virtual Networks (and subnets) allowed to access
        /// the site privately.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualNetworks")]
        public IList<PrivateAccessVirtualNetwork> VirtualNetworks { get; set; }

    }
}
