// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information regarding availability of a resource name.
    /// </summary>
    public partial class ResourceNameAvailabilityInner
    {
        /// <summary>
        /// Initializes a new instance of the ResourceNameAvailabilityInner
        /// class.
        /// </summary>
        public ResourceNameAvailabilityInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceNameAvailabilityInner
        /// class.
        /// </summary>
        /// <param name="nameAvailable">&lt;code&gt;true&lt;/code&gt; indicates
        /// name is valid and available. &lt;code&gt;false&lt;/code&gt;
        /// indicates the name is invalid, unavailable, or both.</param>
        /// <param name="reason">&lt;code&gt;Invalid&lt;/code&gt; indicates the
        /// name provided does not match Azure App Service naming requirements.
        /// &lt;code&gt;AlreadyExists&lt;/code&gt; indicates that the name is
        /// already in use and is therefore unavailable. Possible values
        /// include: 'Invalid', 'AlreadyExists'</param>
        /// <param name="message">If reason == invalid, provide the user with
        /// the reason why the given name is invalid, and provide the resource
        /// naming requirements so that the user can select a valid name. If
        /// reason == AlreadyExists, explain that resource name is already in
        /// use, and direct them to select a different name.</param>
        public ResourceNameAvailabilityInner(bool? nameAvailable = default(bool?), InAvailabilityReasonType reason = default(InAvailabilityReasonType), string message = default(string))
        {
            NameAvailable = nameAvailable;
            Reason = reason;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets &amp;lt;code&amp;gt;true&amp;lt;/code&amp;gt;
        /// indicates name is valid and available.
        /// &amp;lt;code&amp;gt;false&amp;lt;/code&amp;gt; indicates the name
        /// is invalid, unavailable, or both.
        /// </summary>
        [JsonProperty(PropertyName = "nameAvailable")]
        public bool? NameAvailable { get; set; }

        /// <summary>
        /// Gets or sets &amp;lt;code&amp;gt;Invalid&amp;lt;/code&amp;gt;
        /// indicates the name provided does not match Azure App Service naming
        /// requirements.
        /// &amp;lt;code&amp;gt;AlreadyExists&amp;lt;/code&amp;gt; indicates
        /// that the name is already in use and is therefore unavailable.
        /// Possible values include: 'Invalid', 'AlreadyExists'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public InAvailabilityReasonType Reason { get; set; }

        /// <summary>
        /// Gets or sets if reason == invalid, provide the user with the reason
        /// why the given name is invalid, and provide the resource naming
        /// requirements so that the user can select a valid name. If reason ==
        /// AlreadyExists, explain that resource name is already in use, and
        /// direct them to select a different name.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

    }
}
