// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Site Extension Information.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SiteExtensionInfoInner : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the SiteExtensionInfoInner class.
        /// </summary>
        public SiteExtensionInfoInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SiteExtensionInfoInner class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="extensionId">Site extension ID.</param>
        /// <param name="extensionType">Site extension type. Possible values
        /// include: 'Gallery', 'WebRoot'</param>
        /// <param name="summary">Summary description.</param>
        /// <param name="description">Detailed description.</param>
        /// <param name="version">Version information.</param>
        /// <param name="extensionUrl">Extension URL.</param>
        /// <param name="projectUrl">Project URL.</param>
        /// <param name="iconUrl">Icon URL.</param>
        /// <param name="licenseUrl">License URL.</param>
        /// <param name="feedUrl">Feed URL.</param>
        /// <param name="authors">List of authors.</param>
        /// <param name="installerCommandLineParams">Installer command line
        /// parameters.</param>
        /// <param name="publishedDateTime">Published timestamp.</param>
        /// <param name="downloadCount">Count of downloads.</param>
        /// <param name="localIsLatestVersion">&lt;code&gt;true&lt;/code&gt; if
        /// the local version is the latest version;
        /// &lt;code&gt;false&lt;/code&gt; otherwise.</param>
        /// <param name="localPath">Local path.</param>
        /// <param name="installedDateTime">Installed timestamp.</param>
        /// <param name="provisioningState">Provisioning state.</param>
        /// <param name="comment">Site Extension comment.</param>
        public SiteExtensionInfoInner(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string extensionId = default(string), string title = default(string), SiteExtensionType? extensionType = default(SiteExtensionType?), string summary = default(string), string description = default(string), string version = default(string), string extensionUrl = default(string), string projectUrl = default(string), string iconUrl = default(string), string licenseUrl = default(string), string feedUrl = default(string), IList<string> authors = default(IList<string>), string installerCommandLineParams = default(string), System.DateTime? publishedDateTime = default(System.DateTime?), int? downloadCount = default(int?), bool? localIsLatestVersion = default(bool?), string localPath = default(string), System.DateTime? installedDateTime = default(System.DateTime?), string provisioningState = default(string), string comment = default(string))
            : base(id, name, type, kind)
        {
            ExtensionId = extensionId;
            Title = title;
            ExtensionType = extensionType;
            Summary = summary;
            Description = description;
            Version = version;
            ExtensionUrl = extensionUrl;
            ProjectUrl = projectUrl;
            IconUrl = iconUrl;
            LicenseUrl = licenseUrl;
            FeedUrl = feedUrl;
            Authors = authors;
            InstallerCommandLineParams = installerCommandLineParams;
            PublishedDateTime = publishedDateTime;
            DownloadCount = downloadCount;
            LocalIsLatestVersion = localIsLatestVersion;
            LocalPath = localPath;
            InstalledDateTime = installedDateTime;
            ProvisioningState = provisioningState;
            Comment = comment;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets site extension ID.
        /// </summary>
        [JsonProperty(PropertyName = "properties.extension_id")]
        public string ExtensionId { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets site extension type. Possible values include:
        /// 'Gallery', 'WebRoot'
        /// </summary>
        [JsonProperty(PropertyName = "properties.extension_type")]
        public SiteExtensionType? ExtensionType { get; set; }

        /// <summary>
        /// Gets or sets summary description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.summary")]
        public string Summary { get; set; }

        /// <summary>
        /// Gets or sets detailed description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets version information.
        /// </summary>
        [JsonProperty(PropertyName = "properties.version")]
        public string Version { get; set; }

        /// <summary>
        /// Gets or sets extension URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.extension_url")]
        public string ExtensionUrl { get; set; }

        /// <summary>
        /// Gets or sets project URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.project_url")]
        public string ProjectUrl { get; set; }

        /// <summary>
        /// Gets or sets icon URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.icon_url")]
        public string IconUrl { get; set; }

        /// <summary>
        /// Gets or sets license URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.license_url")]
        public string LicenseUrl { get; set; }

        /// <summary>
        /// Gets or sets feed URL.
        /// </summary>
        [JsonProperty(PropertyName = "properties.feed_url")]
        public string FeedUrl { get; set; }

        /// <summary>
        /// Gets or sets list of authors.
        /// </summary>
        [JsonProperty(PropertyName = "properties.authors")]
        public IList<string> Authors { get; set; }

        /// <summary>
        /// Gets or sets installer command line parameters.
        /// </summary>
        [JsonProperty(PropertyName = "properties.installer_command_line_params")]
        public string InstallerCommandLineParams { get; set; }

        /// <summary>
        /// Gets or sets published timestamp.
        /// </summary>
        [JsonProperty(PropertyName = "properties.published_date_time")]
        public System.DateTime? PublishedDateTime { get; set; }

        /// <summary>
        /// Gets or sets count of downloads.
        /// </summary>
        [JsonProperty(PropertyName = "properties.download_count")]
        public int? DownloadCount { get; set; }

        /// <summary>
        /// Gets or sets &amp;lt;code&amp;gt;true&amp;lt;/code&amp;gt; if the
        /// local version is the latest version;
        /// &amp;lt;code&amp;gt;false&amp;lt;/code&amp;gt; otherwise.
        /// </summary>
        [JsonProperty(PropertyName = "properties.local_is_latest_version")]
        public bool? LocalIsLatestVersion { get; set; }

        /// <summary>
        /// Gets or sets local path.
        /// </summary>
        [JsonProperty(PropertyName = "properties.local_path")]
        public string LocalPath { get; set; }

        /// <summary>
        /// Gets or sets installed timestamp.
        /// </summary>
        [JsonProperty(PropertyName = "properties.installed_date_time")]
        public System.DateTime? InstalledDateTime { get; set; }

        /// <summary>
        /// Gets or sets provisioning state.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets site Extension comment.
        /// </summary>
        [JsonProperty(PropertyName = "properties.comment")]
        public string Comment { get; set; }

    }
}
