// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Description of the App Service plan scale options.
    /// </summary>
    public partial class SkuCapacity
    {
        /// <summary>
        /// Initializes a new instance of the SkuCapacity class.
        /// </summary>
        public SkuCapacity()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SkuCapacity class.
        /// </summary>
        /// <param name="minimum">Minimum number of workers for this App
        /// Service plan SKU.</param>
        /// <param name="maximum">Maximum number of workers for this App
        /// Service plan SKU.</param>
        /// <param name="defaultProperty">Default number of workers for this
        /// App Service plan SKU.</param>
        /// <param name="scaleType">Available scale configurations for an App
        /// Service plan.</param>
        public SkuCapacity(int? minimum = default(int?), int? maximum = default(int?), int? defaultProperty = default(int?), string scaleType = default(string))
        {
            Minimum = minimum;
            Maximum = maximum;
            DefaultProperty = defaultProperty;
            ScaleType = scaleType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets minimum number of workers for this App Service plan
        /// SKU.
        /// </summary>
        [JsonProperty(PropertyName = "minimum")]
        public int? Minimum { get; set; }

        /// <summary>
        /// Gets or sets maximum number of workers for this App Service plan
        /// SKU.
        /// </summary>
        [JsonProperty(PropertyName = "maximum")]
        public int? Maximum { get; set; }

        /// <summary>
        /// Gets or sets default number of workers for this App Service plan
        /// SKU.
        /// </summary>
        [JsonProperty(PropertyName = "default")]
        public int? DefaultProperty { get; set; }

        /// <summary>
        /// Gets or sets available scale configurations for an App Service
        /// plan.
        /// </summary>
        [JsonProperty(PropertyName = "scaleType")]
        public string ScaleType { get; set; }

    }
}
