// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// SKU discovery information.
    /// </summary>
    public partial class SkuInfo
    {
        /// <summary>
        /// Initializes a new instance of the SkuInfo class.
        /// </summary>
        public SkuInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SkuInfo class.
        /// </summary>
        /// <param name="resourceType">Resource type that this SKU applies
        /// to.</param>
        /// <param name="sku">Name and tier of the SKU.</param>
        /// <param name="capacity">Min, max, and default scale values of the
        /// SKU.</param>
        public SkuInfo(string resourceType = default(string), SkuDescription sku = default(SkuDescription), SkuCapacity capacity = default(SkuCapacity))
        {
            ResourceType = resourceType;
            Sku = sku;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource type that this SKU applies to.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets name and tier of the SKU.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public SkuDescription Sku { get; set; }

        /// <summary>
        /// Gets or sets min, max, and default scale values of the SKU.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public SkuCapacity Capacity { get; set; }

    }
}
