// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The status of the last successful slot swap operation.
    /// </summary>
    public partial class SlotSwapStatus
    {
        /// <summary>
        /// Initializes a new instance of the SlotSwapStatus class.
        /// </summary>
        public SlotSwapStatus()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SlotSwapStatus class.
        /// </summary>
        /// <param name="timestampUtc">The time the last successful slot swap
        /// completed.</param>
        /// <param name="sourceSlotName">The source slot of the last swap
        /// operation.</param>
        /// <param name="destinationSlotName">The destination slot of the last
        /// swap operation.</param>
        public SlotSwapStatus(System.DateTime? timestampUtc = default(System.DateTime?), string sourceSlotName = default(string), string destinationSlotName = default(string))
        {
            TimestampUtc = timestampUtc;
            SourceSlotName = sourceSlotName;
            DestinationSlotName = destinationSlotName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the time the last successful slot swap completed.
        /// </summary>
        [JsonProperty(PropertyName = "timestampUtc")]
        public System.DateTime? TimestampUtc { get; private set; }

        /// <summary>
        /// Gets the source slot of the last swap operation.
        /// </summary>
        [JsonProperty(PropertyName = "sourceSlotName")]
        public string SourceSlotName { get; private set; }

        /// <summary>
        /// Gets the destination slot of the last swap operation.
        /// </summary>
        [JsonProperty(PropertyName = "destinationSlotName")]
        public string DestinationSlotName { get; private set; }

    }
}
