// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Specifies the web app that snapshot contents will be retrieved from.
    /// </summary>
    public partial class SnapshotRecoverySource
    {
        /// <summary>
        /// Initializes a new instance of the SnapshotRecoverySource class.
        /// </summary>
        public SnapshotRecoverySource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SnapshotRecoverySource class.
        /// </summary>
        /// <param name="location">Geographical location of the source web app,
        /// e.g. SouthEastAsia, SouthCentralUS</param>
        /// <param name="id">ARM resource ID of the source app.
        /// /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}
        /// for production slots and
        /// /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}/slots/{slotName}
        /// for other slots.</param>
        public SnapshotRecoverySource(string location = default(string), string id = default(string))
        {
            Location = location;
            Id = id;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets geographical location of the source web app, e.g.
        /// SouthEastAsia, SouthCentralUS
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets ARM resource ID of the source app.
        /// /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}
        /// for production slots and
        /// /subscriptions/{subId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Web/sites/{siteName}/slots/{slotName}
        /// for other slots.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

    }
}
