// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details about app recovery operation.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SnapshotRestoreRequest : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the SnapshotRestoreRequest class.
        /// </summary>
        public SnapshotRestoreRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SnapshotRestoreRequest class.
        /// </summary>
        /// <param name="overwrite">If &lt;code&gt;true&lt;/code&gt; the
        /// restore operation can overwrite source app; otherwise,
        /// &lt;code&gt;false&lt;/code&gt;.</param>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="snapshotTime">Point in time in which the app restore
        /// should be done, formatted as a DateTime string.</param>
        /// <param name="recoverySource">Optional. Specifies the web app that
        /// snapshot contents will be retrieved from.
        /// If empty, the targeted web app will be used as the source.</param>
        /// <param name="recoverConfiguration">If true, site configuration, in
        /// addition to content, will be reverted.</param>
        /// <param name="ignoreConflictingHostNames">If true, custom hostname
        /// conflicts will be ignored when recovering to a target web app.
        /// This setting is only necessary when RecoverConfiguration is
        /// enabled.</param>
        /// <param name="useDRSecondary">If true, the snapshot is retrieved
        /// from DRSecondary endpoint.</param>
        public SnapshotRestoreRequest(bool overwrite, string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string snapshotTime = default(string), SnapshotRecoverySource recoverySource = default(SnapshotRecoverySource), bool? recoverConfiguration = default(bool?), bool? ignoreConflictingHostNames = default(bool?), bool? useDRSecondary = default(bool?))
            : base(id, name, type, kind)
        {
            SnapshotTime = snapshotTime;
            RecoverySource = recoverySource;
            Overwrite = overwrite;
            RecoverConfiguration = recoverConfiguration;
            IgnoreConflictingHostNames = ignoreConflictingHostNames;
            UseDRSecondary = useDRSecondary;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets point in time in which the app restore should be done,
        /// formatted as a DateTime string.
        /// </summary>
        [JsonProperty(PropertyName = "properties.snapshotTime")]
        public string SnapshotTime { get; set; }

        /// <summary>
        /// Gets or sets optional. Specifies the web app that snapshot contents
        /// will be retrieved from.
        /// If empty, the targeted web app will be used as the source.
        /// </summary>
        [JsonProperty(PropertyName = "properties.recoverySource")]
        public SnapshotRecoverySource RecoverySource { get; set; }

        /// <summary>
        /// Gets or sets if &amp;lt;code&amp;gt;true&amp;lt;/code&amp;gt; the
        /// restore operation can overwrite source app; otherwise,
        /// &amp;lt;code&amp;gt;false&amp;lt;/code&amp;gt;.
        /// </summary>
        [JsonProperty(PropertyName = "properties.overwrite")]
        public bool Overwrite { get; set; }

        /// <summary>
        /// Gets or sets if true, site configuration, in addition to content,
        /// will be reverted.
        /// </summary>
        [JsonProperty(PropertyName = "properties.recoverConfiguration")]
        public bool? RecoverConfiguration { get; set; }

        /// <summary>
        /// Gets or sets if true, custom hostname conflicts will be ignored
        /// when recovering to a target web app.
        /// This setting is only necessary when RecoverConfiguration is
        /// enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ignoreConflictingHostNames")]
        public bool? IgnoreConflictingHostNames { get; set; }

        /// <summary>
        /// Gets or sets if true, the snapshot is retrieved from DRSecondary
        /// endpoint.
        /// </summary>
        [JsonProperty(PropertyName = "properties.useDRSecondary")]
        public bool? UseDRSecondary { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
