// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Options for app content migration.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class StorageMigrationOptions : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the StorageMigrationOptions class.
        /// </summary>
        public StorageMigrationOptions()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the StorageMigrationOptions class.
        /// </summary>
        /// <param name="azurefilesConnectionString">AzureFiles connection
        /// string.</param>
        /// <param name="azurefilesShare">AzureFiles share.</param>
        /// <param name="kind">Kind of resource.</param>
        /// <param
        /// name="switchSiteAfterMigration">&lt;code&gt;true&lt;/code&gt;if the
        /// app should be switched over; otherwise,
        /// &lt;code&gt;false&lt;/code&gt;.</param>
        /// <param name="blockWriteAccessToSite">&lt;code&gt;true&lt;/code&gt;
        /// if the app should be read only during copy operation; otherwise,
        /// &lt;code&gt;false&lt;/code&gt;.</param>
        public StorageMigrationOptions(string azurefilesConnectionString, string azurefilesShare, string id = default(string), string name = default(string), string type = default(string), string kind = default(string), bool? switchSiteAfterMigration = default(bool?), bool? blockWriteAccessToSite = default(bool?))
            : base(id, name, type, kind)
        {
            AzurefilesConnectionString = azurefilesConnectionString;
            AzurefilesShare = azurefilesShare;
            SwitchSiteAfterMigration = switchSiteAfterMigration;
            BlockWriteAccessToSite = blockWriteAccessToSite;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets azureFiles connection string.
        /// </summary>
        [JsonProperty(PropertyName = "properties.azurefilesConnectionString")]
        public string AzurefilesConnectionString { get; set; }

        /// <summary>
        /// Gets or sets azureFiles share.
        /// </summary>
        [JsonProperty(PropertyName = "properties.azurefilesShare")]
        public string AzurefilesShare { get; set; }

        /// <summary>
        /// Gets or sets &amp;lt;code&amp;gt;true&amp;lt;/code&amp;gt;if the
        /// app should be switched over; otherwise,
        /// &amp;lt;code&amp;gt;false&amp;lt;/code&amp;gt;.
        /// </summary>
        [JsonProperty(PropertyName = "properties.switchSiteAfterMigration")]
        public bool? SwitchSiteAfterMigration { get; set; }

        /// <summary>
        /// Gets or sets &amp;lt;code&amp;gt;true&amp;lt;/code&amp;gt; if the
        /// app should be read only during copy operation; otherwise,
        /// &amp;lt;code&amp;gt;false&amp;lt;/code&amp;gt;.
        /// </summary>
        [JsonProperty(PropertyName = "properties.blockWriteAccessToSite")]
        public bool? BlockWriteAccessToSite { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (AzurefilesConnectionString == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AzurefilesConnectionString");
            }
            if (AzurefilesShare == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AzurefilesShare");
            }
        }
    }
}
