// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Swift Virtual Network Contract. This is used to enable the new Swift
    /// way of doing virtual network integration.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class SwiftVirtualNetworkInner : ProxyOnlyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the SwiftVirtualNetworkInner class.
        /// </summary>
        public SwiftVirtualNetworkInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SwiftVirtualNetworkInner class.
        /// </summary>
        /// <param name="kind">Kind of resource.</param>
        /// <param name="subnetResourceId">The Virtual Network subnet's
        /// resource ID. This is the subnet that this Web App will join. This
        /// subnet must have a delegation to Microsoft.Web/serverFarms defined
        /// first.</param>
        /// <param name="swiftSupported">A flag that specifies if the scale
        /// unit this Web App is on supports Swift integration.</param>
        public SwiftVirtualNetworkInner(string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string subnetResourceId = default(string), bool? swiftSupported = default(bool?))
            : base(id, name, type, kind)
        {
            SubnetResourceId = subnetResourceId;
            SwiftSupported = swiftSupported;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Virtual Network subnet's resource ID. This is the
        /// subnet that this Web App will join. This subnet must have a
        /// delegation to Microsoft.Web/serverFarms defined first.
        /// </summary>
        [JsonProperty(PropertyName = "properties.subnetResourceId")]
        public string SubnetResourceId { get; set; }

        /// <summary>
        /// Gets or sets a flag that specifies if the scale unit this Web App
        /// is on supports Swift integration.
        /// </summary>
        [JsonProperty(PropertyName = "properties.swiftSupported")]
        public bool? SwiftSupported { get; set; }

    }
}
