// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.AppService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Virtual IP mapping.
    /// </summary>
    public partial class VirtualIPMapping
    {
        /// <summary>
        /// Initializes a new instance of the VirtualIPMapping class.
        /// </summary>
        public VirtualIPMapping()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualIPMapping class.
        /// </summary>
        /// <param name="virtualIP">Virtual IP address.</param>
        /// <param name="internalHttpPort">Internal HTTP port.</param>
        /// <param name="internalHttpsPort">Internal HTTPS port.</param>
        /// <param name="inUse">Is virtual IP mapping in use.</param>
        /// <param name="serviceName">name of the service that virtual IP is
        /// assigned to</param>
        public VirtualIPMapping(string virtualIP = default(string), int? internalHttpPort = default(int?), int? internalHttpsPort = default(int?), bool? inUse = default(bool?), string serviceName = default(string))
        {
            VirtualIP = virtualIP;
            InternalHttpPort = internalHttpPort;
            InternalHttpsPort = internalHttpsPort;
            InUse = inUse;
            ServiceName = serviceName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets virtual IP address.
        /// </summary>
        [JsonProperty(PropertyName = "virtualIP")]
        public string VirtualIP { get; set; }

        /// <summary>
        /// Gets or sets internal HTTP port.
        /// </summary>
        [JsonProperty(PropertyName = "internalHttpPort")]
        public int? InternalHttpPort { get; set; }

        /// <summary>
        /// Gets or sets internal HTTPS port.
        /// </summary>
        [JsonProperty(PropertyName = "internalHttpsPort")]
        public int? InternalHttpsPort { get; set; }

        /// <summary>
        /// Gets or sets is virtual IP mapping in use.
        /// </summary>
        [JsonProperty(PropertyName = "inUse")]
        public bool? InUse { get; set; }

        /// <summary>
        /// Gets or sets name of the service that virtual IP is assigned to
        /// </summary>
        [JsonProperty(PropertyName = "serviceName")]
        public string ServiceName { get; set; }

    }
}
