// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// JobsOperations operations.
    /// </summary>
    public partial interface IJobsOperations
    {
        /// <summary>
        /// Gets a list of Jobs within the specified Experiment.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobsListByExperimentOptions'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<JobInner>>> ListByExperimentWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, JobsListByExperimentOptions jobsListByExperimentOptions = default(JobsListByExperimentOptions), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Creates a Job in the given Experiment.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='parameters'>
        /// The parameters to provide for job creation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<JobInner>> CreateWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, JobCreateParameters parameters, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Deletes a Job.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> DeleteWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Gets information about a Job.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<JobInner>> GetWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// List all directories and files inside the given directory of the
        /// Job's output directory (if the output directory is on Azure File
        /// Share or Azure Storage Container).
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='jobsListOutputFilesOptions'>
        /// Additional parameters for the operation
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<File>>> ListOutputFilesWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, JobsListOutputFilesOptions jobsListOutputFilesOptions, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Gets a list of currently existing nodes which were used for the Job
        /// execution. The returned information contains the node ID, its
        /// public IP and SSH port.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<RemoteLoginInformation>>> ListRemoteLoginInformationWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Terminates a job.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> TerminateWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Creates a Job in the given Experiment.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='parameters'>
        /// The parameters to provide for job creation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<JobInner>> BeginCreateWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, JobCreateParameters parameters, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Deletes a Job.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> BeginDeleteWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Terminates a job.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// Name of the resource group to which the resource belongs.
        /// </param>
        /// <param name='workspaceName'>
        /// The name of the workspace. Workspace names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='experimentName'>
        /// The name of the experiment. Experiment names can only contain a
        /// combination of alphanumeric characters along with dash (-) and
        /// underscore (_). The name must be from 1 through 64 characters long.
        /// </param>
        /// <param name='jobName'>
        /// The name of the job within the specified resource group. Job names
        /// can only contain a combination of alphanumeric characters along
        /// with dash (-) and underscore (_). The name must be from 1 through
        /// 64 characters long.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse> BeginTerminateWithHttpMessagesAsync(string resourceGroupName, string workspaceName, string experimentName, string jobName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Gets a list of Jobs within the specified Experiment.
        /// </summary>
        /// <param name='nextPageLink'>
        /// The NextLink from the previous successful call to List operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<JobInner>>> ListByExperimentNextWithHttpMessagesAsync(string nextPageLink, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// List all directories and files inside the given directory of the
        /// Job's output directory (if the output directory is on Azure File
        /// Share or Azure Storage Container).
        /// </summary>
        /// <param name='nextPageLink'>
        /// The NextLink from the previous successful call to List operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<File>>> ListOutputFilesNextWithHttpMessagesAsync(string nextPageLink, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
        /// <summary>
        /// Gets a list of currently existing nodes which were used for the Job
        /// execution. The returned information contains the node ID, its
        /// public IP and SSH port.
        /// </summary>
        /// <param name='nextPageLink'>
        /// The NextLink from the previous successful call to List operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="Microsoft.Rest.Azure.CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="Microsoft.Rest.SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        Task<AzureOperationResponse<IPage<RemoteLoginInformation>>> ListRemoteLoginInformationNextWithHttpMessagesAsync(string nextPageLink, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));
    }
}
