// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Caffe job settings.
    /// </summary>
    public partial class CaffeSettings
    {
        /// <summary>
        /// Initializes a new instance of the CaffeSettings class.
        /// </summary>
        public CaffeSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CaffeSettings class.
        /// </summary>
        /// <param name="configFilePath">Config file path.</param>
        /// <param name="pythonScriptFilePath">Python script file path.</param>
        /// <param name="pythonInterpreterPath">Python interpreter
        /// path.</param>
        /// <param name="commandLineArgs">Command line arguments.</param>
        /// <param name="processCount">Process count.</param>
        public CaffeSettings(string configFilePath = default(string), string pythonScriptFilePath = default(string), string pythonInterpreterPath = default(string), string commandLineArgs = default(string), int? processCount = default(int?))
        {
            ConfigFilePath = configFilePath;
            PythonScriptFilePath = pythonScriptFilePath;
            PythonInterpreterPath = pythonInterpreterPath;
            CommandLineArgs = commandLineArgs;
            ProcessCount = processCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets config file path.
        /// </summary>
        /// <remarks>
        /// Path of the config file for the job. This property cannot be
        /// specified if pythonScriptFilePath is specified.
        /// </remarks>
        [JsonProperty(PropertyName = "configFilePath")]
        public string ConfigFilePath { get; set; }

        /// <summary>
        /// Gets or sets python script file path.
        /// </summary>
        /// <remarks>
        /// Python script to execute. This property cannot be specified if
        /// configFilePath is specified.
        /// </remarks>
        [JsonProperty(PropertyName = "pythonScriptFilePath")]
        public string PythonScriptFilePath { get; set; }

        /// <summary>
        /// Gets or sets python interpreter path.
        /// </summary>
        /// <remarks>
        /// The path to the Python interpreter. The property can be specified
        /// only if the pythonScriptFilePath is specified.
        /// </remarks>
        [JsonProperty(PropertyName = "pythonInterpreterPath")]
        public string PythonInterpreterPath { get; set; }

        /// <summary>
        /// Gets or sets command line arguments.
        /// </summary>
        /// <remarks>
        /// Command line arguments that need to be passed to the Caffe job.
        /// </remarks>
        [JsonProperty(PropertyName = "commandLineArgs")]
        public string CommandLineArgs { get; set; }

        /// <summary>
        /// Gets or sets process count.
        /// </summary>
        /// <remarks>
        /// Number of processes to launch for the job execution. The default
        /// value for this property is equal to nodeCount property
        /// </remarks>
        [JsonProperty(PropertyName = "processCount")]
        public int? ProcessCount { get; set; }

    }
}
