// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Custom MPI job settings.
    /// </summary>
    public partial class CustomMpiSettings
    {
        /// <summary>
        /// Initializes a new instance of the CustomMpiSettings class.
        /// </summary>
        public CustomMpiSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CustomMpiSettings class.
        /// </summary>
        /// <param name="commandLine">Command line.</param>
        /// <param name="processCount">Process count.</param>
        public CustomMpiSettings(string commandLine, int? processCount = default(int?))
        {
            CommandLine = commandLine;
            ProcessCount = processCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets command line.
        /// </summary>
        /// <remarks>
        /// The command line to be executed by mpi runtime on each compute
        /// node.
        /// </remarks>
        [JsonProperty(PropertyName = "commandLine")]
        public string CommandLine { get; set; }

        /// <summary>
        /// Gets or sets process count.
        /// </summary>
        /// <remarks>
        /// Number of processes to launch for the job execution. The default
        /// value for this property is equal to nodeCount property
        /// </remarks>
        [JsonProperty(PropertyName = "processCount")]
        public int? ProcessCount { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CommandLine == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CommandLine");
            }
        }
    }
}
