// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An environment variable with secret value definition.
    /// </summary>
    public partial class EnvironmentVariableWithSecretValue
    {
        /// <summary>
        /// Initializes a new instance of the
        /// EnvironmentVariableWithSecretValue class.
        /// </summary>
        public EnvironmentVariableWithSecretValue()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// EnvironmentVariableWithSecretValue class.
        /// </summary>
        /// <param name="name">Name.</param>
        /// <param name="value">Value.</param>
        /// <param name="valueSecretReference">KeyVault secret
        /// reference.</param>
        public EnvironmentVariableWithSecretValue(string name, string value = default(string), KeyVaultSecretReference valueSecretReference = default(KeyVaultSecretReference))
        {
            Name = name;
            Value = value;
            ValueSecretReference = valueSecretReference;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name.
        /// </summary>
        /// <remarks>
        /// The name of the environment variable to store the secret value.
        /// </remarks>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets value.
        /// </summary>
        /// <remarks>
        /// The value of the environment variable. This value will never be
        /// reported back by Batch AI.
        /// </remarks>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets keyVault secret reference.
        /// </summary>
        /// <remarks>
        /// KeyVault store and secret which contains the value for the
        /// environment variable. One of value or valueSecretReference must be
        /// provided.
        /// </remarks>
        [JsonProperty(PropertyName = "valueSecretReference")]
        public KeyVaultSecretReference ValueSecretReference { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (ValueSecretReference != null)
            {
                ValueSecretReference.Validate();
            }
        }
    }
}
