// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Properties of the file or directory.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class File
    {
        /// <summary>
        /// Initializes a new instance of the File class.
        /// </summary>
        public File()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the File class.
        /// </summary>
        /// <param name="name">Name.</param>
        /// <param name="fileType">File type.</param>
        /// <param name="downloadUrl">Download URL.</param>
        /// <param name="lastModified">Last modified time.</param>
        /// <param name="contentLength">Content length.</param>
        public File(string name = default(string), FileType fileType = default(FileType), string downloadUrl = default(string), System.DateTime? lastModified = default(System.DateTime?), long? contentLength = default(long?))
        {
            Name = name;
            FileType = fileType;
            DownloadUrl = downloadUrl;
            LastModified = lastModified;
            ContentLength = contentLength;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets name.
        /// </summary>
        /// <remarks>
        /// Name of the file.
        /// </remarks>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets file type.
        /// </summary>
        /// <remarks>
        /// Type of the file. Possible values are file and directory. Possible
        /// values include: 'file', 'directory'
        /// </remarks>
        [JsonProperty(PropertyName = "fileType")]
        public FileType FileType { get; private set; }

        /// <summary>
        /// Gets download URL.
        /// </summary>
        /// <remarks>
        /// URL to download the corresponding file. The downloadUrl is not
        /// returned for directories.
        /// </remarks>
        [JsonProperty(PropertyName = "downloadUrl")]
        public string DownloadUrl { get; private set; }

        /// <summary>
        /// Gets last modified time.
        /// </summary>
        /// <remarks>
        /// The time at which the file was last modified.
        /// </remarks>
        [JsonProperty(PropertyName = "properties.lastModified")]
        public System.DateTime? LastModified { get; private set; }

        /// <summary>
        /// Gets content length.
        /// </summary>
        /// <remarks>
        /// The file of the size.
        /// </remarks>
        [JsonProperty(PropertyName = "properties.contentLength")]
        public long? ContentLength { get; private set; }

    }
}
