// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Input directory for the job.
    /// </summary>
    public partial class InputDirectory
    {
        /// <summary>
        /// Initializes a new instance of the InputDirectory class.
        /// </summary>
        public InputDirectory()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the InputDirectory class.
        /// </summary>
        /// <param name="id">ID.</param>
        /// <param name="path">Path.</param>
        public InputDirectory(string id, string path)
        {
            Id = id;
            Path = path;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ID.
        /// </summary>
        /// <remarks>
        /// The ID for the input directory. The job can use
        /// AZ_BATCHAI_INPUT_<id> environment variable to find the directory
        /// path, where <id> is the value of id attribute.
        /// </remarks>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets path.
        /// </summary>
        /// <remarks>
        /// The path to the input directory.
        /// </remarks>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (Path == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Path");
            }
        }
    }
}
