// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Information about the execution of a job.
    /// </summary>
    public partial class JobPropertiesExecutionInfo
    {
        /// <summary>
        /// Initializes a new instance of the JobPropertiesExecutionInfo class.
        /// </summary>
        public JobPropertiesExecutionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobPropertiesExecutionInfo class.
        /// </summary>
        /// <param name="startTime">Start time.</param>
        /// <param name="endTime">End time.</param>
        /// <param name="exitCode">Exit code.</param>
        /// <param name="errors">Errors.</param>
        public JobPropertiesExecutionInfo(System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), int? exitCode = default(int?), IList<BatchAIError> errors = default(IList<BatchAIError>))
        {
            StartTime = startTime;
            EndTime = endTime;
            ExitCode = exitCode;
            Errors = errors;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets start time.
        /// </summary>
        /// <remarks>
        /// The time at which the job started running. 'Running' corresponds to
        /// the running state. If the job has been restarted or retried, this
        /// is the most recent time at which the job started running. This
        /// property is present only for job that are in the running or
        /// completed state.
        /// </remarks>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets end time.
        /// </summary>
        /// <remarks>
        /// The time at which the job completed. This property is only returned
        /// if the job is in completed state.
        /// </remarks>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; private set; }

        /// <summary>
        /// Gets exit code.
        /// </summary>
        /// <remarks>
        /// The exit code of the job. This property is only returned if the job
        /// is in completed state.
        /// </remarks>
        [JsonProperty(PropertyName = "exitCode")]
        public int? ExitCode { get; private set; }

        /// <summary>
        /// Gets errors.
        /// </summary>
        /// <remarks>
        /// A collection of errors encountered by the service during job
        /// execution.
        /// </remarks>
        [JsonProperty(PropertyName = "errors")]
        public IList<BatchAIError> Errors { get; private set; }

    }
}
