// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// At least one of manual or autoScale settings must be specified. Only
    /// one of manual or autoScale settings can be specified. If autoScale
    /// settings are specified, the system automatically scales the cluster up
    /// and down (within the supplied limits) based on the pending jobs on the
    /// cluster.
    /// </summary>
    public partial class ScaleSettings
    {
        /// <summary>
        /// Initializes a new instance of the ScaleSettings class.
        /// </summary>
        public ScaleSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScaleSettings class.
        /// </summary>
        /// <param name="manual">Manual scale settings.</param>
        /// <param name="autoScale">Auto-scale settings.</param>
        public ScaleSettings(ManualScaleSettings manual = default(ManualScaleSettings), AutoScaleSettings autoScale = default(AutoScaleSettings))
        {
            Manual = manual;
            AutoScale = autoScale;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets manual scale settings.
        /// </summary>
        /// <remarks>
        /// Manual scale settings for the cluster.
        /// </remarks>
        [JsonProperty(PropertyName = "manual")]
        public ManualScaleSettings Manual { get; set; }

        /// <summary>
        /// Gets or sets auto-scale settings.
        /// </summary>
        /// <remarks>
        /// Auto-scale settings for the cluster.
        /// </remarks>
        [JsonProperty(PropertyName = "autoScale")]
        public AutoScaleSettings AutoScale { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Manual != null)
            {
                Manual.Validate();
            }
            if (AutoScale != null)
            {
                AutoScale.Validate();
            }
        }
    }
}
