// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Unmananged file system mounting configuration.
    /// </summary>
    public partial class UnmanagedFileSystemReference
    {
        /// <summary>
        /// Initializes a new instance of the UnmanagedFileSystemReference
        /// class.
        /// </summary>
        public UnmanagedFileSystemReference()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UnmanagedFileSystemReference
        /// class.
        /// </summary>
        /// <param name="mountCommand">Mount command.</param>
        /// <param name="relativeMountPath">Relative mount path.</param>
        public UnmanagedFileSystemReference(string mountCommand, string relativeMountPath)
        {
            MountCommand = mountCommand;
            RelativeMountPath = relativeMountPath;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets mount command.
        /// </summary>
        /// <remarks>
        /// Mount command line. Note, Batch AI will append mount path to the
        /// command on its own.
        /// </remarks>
        [JsonProperty(PropertyName = "mountCommand")]
        public string MountCommand { get; set; }

        /// <summary>
        /// Gets or sets relative mount path.
        /// </summary>
        /// <remarks>
        /// The relative path on the compute node where the unmanaged file
        /// system will be mounted. Note that all cluster level unmanaged file
        /// systems will be mounted under $AZ_BATCHAI_MOUNT_ROOT location and
        /// all job level unmanaged file systems will be mounted under
        /// $AZ_BATCHAI_JOB_MOUNT_ROOT.
        /// </remarks>
        [JsonProperty(PropertyName = "relativeMountPath")]
        public string RelativeMountPath { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MountCommand == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MountCommand");
            }
            if (RelativeMountPath == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RelativeMountPath");
            }
        }
    }
}
