// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.BatchAI.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Workspace creation parameters.
    /// </summary>
    public partial class WorkspaceCreateParameters
    {
        /// <summary>
        /// Initializes a new instance of the WorkspaceCreateParameters class.
        /// </summary>
        public WorkspaceCreateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WorkspaceCreateParameters class.
        /// </summary>
        /// <param name="location">Location.</param>
        /// <param name="tags">Tags.</param>
        public WorkspaceCreateParameters(string location, IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            Location = location;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets location.
        /// </summary>
        /// <remarks>
        /// The region in which to create the Workspace.
        /// </remarks>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets tags.
        /// </summary>
        /// <remarks>
        /// The user specified tags associated with the Workspace.
        /// </remarks>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
        }
    }
}
