// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Cdn.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A policy that specifies the delivery rules to be used for an endpoint.
    /// </summary>
    public partial class EndpointPropertiesUpdateParametersDeliveryPolicy
    {
        /// <summary>
        /// Initializes a new instance of the
        /// EndpointPropertiesUpdateParametersDeliveryPolicy class.
        /// </summary>
        public EndpointPropertiesUpdateParametersDeliveryPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// EndpointPropertiesUpdateParametersDeliveryPolicy class.
        /// </summary>
        /// <param name="rules">A list of the delivery rules.</param>
        /// <param name="description">User-friendly description of the
        /// policy.</param>
        public EndpointPropertiesUpdateParametersDeliveryPolicy(IList<DeliveryRule> rules, string description = default(string))
        {
            Description = description;
            Rules = rules;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets user-friendly description of the policy.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets a list of the delivery rules.
        /// </summary>
        [JsonProperty(PropertyName = "rules")]
        public IList<DeliveryRule> Rules { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Rules == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Rules");
            }
            if (Rules != null)
            {
                foreach (var element in Rules)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
