// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Cdn.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Rules defining user's geo access within a CDN endpoint.
    /// </summary>
    public partial class GeoFilter
    {
        /// <summary>
        /// Initializes a new instance of the GeoFilter class.
        /// </summary>
        public GeoFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GeoFilter class.
        /// </summary>
        /// <param name="relativePath">Relative path applicable to geo filter.
        /// (e.g. '/mypictures', '/mypicture/kitty.jpg', and etc.)</param>
        /// <param name="action">Action of the geo filter, i.e. allow or block
        /// access. Possible values include: 'Block', 'Allow'</param>
        /// <param name="countryCodes">Two letter country codes defining user
        /// country access in a geo filter, e.g. AU, MX, US.</param>
        public GeoFilter(string relativePath, GeoFilterActions action, IList<string> countryCodes)
        {
            RelativePath = relativePath;
            Action = action;
            CountryCodes = countryCodes;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets relative path applicable to geo filter. (e.g.
        /// '/mypictures', '/mypicture/kitty.jpg', and etc.)
        /// </summary>
        [JsonProperty(PropertyName = "relativePath")]
        public string RelativePath { get; set; }

        /// <summary>
        /// Gets or sets action of the geo filter, i.e. allow or block access.
        /// Possible values include: 'Block', 'Allow'
        /// </summary>
        [JsonProperty(PropertyName = "action")]
        public GeoFilterActions Action { get; set; }

        /// <summary>
        /// Gets or sets two letter country codes defining user country access
        /// in a geo filter, e.g. AU, MX, US.
        /// </summary>
        [JsonProperty(PropertyName = "countryCodes")]
        public IList<string> CountryCodes { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (RelativePath == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RelativePath");
            }
            if (CountryCodes == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CountryCodes");
            }
        }
    }
}
