// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
using Microsoft.Azure.Management.ResourceManager.Fluent.Core;

namespace Microsoft.Azure.Management.Compute.Fluent
{
    /// <summary>
    /// Compute resource sku names.
    /// </summary>
    ///GENTHASH:Y29tLm1pY3Jvc29mdC5henVyZS5tYW5hZ2VtZW50LmNvbXB1dGUuQ29tcHV0ZVNrdU5hbWU=
    public partial class ComputeSkuName : ExpandableStringEnum<Microsoft.Azure.Management.Compute.Fluent.ComputeSkuName>, IBeta
    {
        /**
         * Static value Standard_F32s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF32sv2 = Parse("Standard_F32s_v2");
        /**
         * Static value Standard_DS2_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS2v2 = Parse("Standard_DS2_v2");
        /**
         * Static value Standard_H16r for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH16r = Parse("Standard_H16r");
        /**
         * Static value Standard_H16m for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH16m = Parse("Standard_H16m");
        /**
         * Static value Standard_D1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD1 = Parse("Standard_D1");
        /**
         * Static value Standard_F16s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF16sv2 = Parse("Standard_F16s_v2");
        /**
         * Static value Standard_DS5_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS5v2Promo = Parse("Standard_DS5_v2_Promo");
        /**
         * Static value Standard_E4s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE4sv3 = Parse("Standard_E4s_v3");
        /**
         * Static value Standard_D1_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD1v2 = Parse("Standard_D1_v2");
        /**
         * Static value Standard_DS12_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS12v2Promo = Parse("Standard_DS12_v2_Promo");
        /**
         * Static value Standard_D64s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD64sv3 = Parse("Standard_D64s_v3");
        /**
         * Static value Standard_M128-32ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM128_32ms = Parse("Standard_M128-32ms");
        /**
         * Static value Standard_D4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD4 = Parse("Standard_D4");
        /**
         * Static value Standard_D3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD3 = Parse("Standard_D3");
        /**
         * Static value Standard_D2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD2 = Parse("Standard_D2");
        /**
         * Static value Standard_M128s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM128s = Parse("Standard_M128s");
        /**
         * Static value Standard_D4s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD4sv3 = Parse("Standard_D4s_v3");
        /**
         * Static value Standard_F2s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF2sv2 = Parse("Standard_F2s_v2");
        /**
         * Static value Standard_F1s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF1s = Parse("Standard_F1s");
        /**
         * Static value Standard_A8m_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA8mv2 = Parse("Standard_A8m_v2");
        /**
         * Static value Standard_NC24 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC24 = Parse("Standard_NC24");
        /**
         * Static value Standard_B1s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB1s = Parse("Standard_B1s");
        /**
         * Static value Standard_E2s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE2sv3 = Parse("Standard_E2s_v3");
        /**
         * Static value Standard_D8s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD8sv3 = Parse("Standard_D8s_v3");
        /**
         * Static value Standard_DS14_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS14v2 = Parse("Standard_DS14_v2");
        /**
         * Static value Standard_H16mr for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH16mr = Parse("Standard_H16mr");
        /**
         * Static value Standard_DS13_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS13v2Promo = Parse("Standard_DS13_v2_Promo");
        /**
         * Static value Standard_ND12s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardND12s = Parse("Standard_ND12s");
        /**
         * Static value Standard_DS5_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS5v2 = Parse("Standard_DS5_v2");
        /**
         * Static value Standard_D15_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD15v2 = Parse("Standard_D15_v2");
        /**
         * Static value Standard_ND24s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardND24s = Parse("Standard_ND24s");
        /**
         * Static value Standard_F4s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF4sv2 = Parse("Standard_F4s_v2");
        /**
         * Static value Standard_GS5-16 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS5_16 = Parse("Standard_GS5-16");
        /**
         * Static value Standard_F2s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF2s = Parse("Standard_F2s");
        /**
         * Static value Standard_B2ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB2ms = Parse("Standard_B2ms");
        /**
         * Static value Standard_B2s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB2s = Parse("Standard_B2s");
        /**
         * Static value Standard_E2_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE2v3 = Parse("Standard_E2_v3");
        /**
         * Static value Standard_A4_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA4v2 = Parse("Standard_A4_v2");
        /**
         * Static value Standard_DS4_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS4v2 = Parse("Standard_DS4_v2");
        /**
         * Static value Standard_F8s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF8s = Parse("Standard_F8s");
        /**
         * Static value Standard_D12_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD12v2 = Parse("Standard_D12_v2");
        /**
         * Static value Standard_A2m_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA2mv2 = Parse("Standard_A2m_v2");
        /**
         * Static value Standard_DS13-4_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS13_4v2 = Parse("Standard_DS13-4_v2");
        /**
         * Static value Standard_M128ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM128ms = Parse("Standard_M128ms");
        /**
         * Static value Standard_DS15_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS15v2 = Parse("Standard_DS15_v2");
        /**
         * Static value Standard_F2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF2 = Parse("Standard_F2");
        /**
         * Static value Standard_F1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF1 = Parse("Standard_F1");
        /**
         * Static value Standard_DS14_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS14v2Promo = Parse("Standard_DS14_v2_Promo");
        /**
         * Static value Standard_GS4-8 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS4_8 = Parse("Standard_GS4-8");
        /**
         * Static value Standard_E32-8s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE32_8sv3 = Parse("Standard_E32-8s_v3");
        /**
         * Static value Standard_F8 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF8 = Parse("Standard_F8");
        /**
         * Static value Standard_F16 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF16 = Parse("Standard_F16");
        /**
         * Static value Standard_F4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF4 = Parse("Standard_F4");
        /**
         * Static value Standard_GS4-4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS4_4 = Parse("Standard_GS4-4");
        /**
         * Static value Standard_F72s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF72sv2 = Parse("Standard_F72s_v2");
        /**
         * Static value Standard_D16s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD16sv3 = Parse("Standard_D16s_v3");
        /**
         * Static value Standard_D2_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD2v2Promo = Parse("Standard_D2_v2_Promo");
        /**
         * Static value Standard_A1_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA1v2 = Parse("Standard_A1_v2");
        /**
         * Static value Standard_NC6 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC6 = Parse("Standard_NC6");
        /**
         * Static value Standard_E16s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE16sv3 = Parse("Standard_E16s_v3");
        /**
         * Static value Standard_A10 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA10 = Parse("Standard_A10");
        /**
         * Static value Standard_A4m_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA4mv2 = Parse("Standard_A4m_v2");
        /**
         * Static value Standard_A11 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA11 = Parse("Standard_A11");
        /**
         * Static value Standard_DS12_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS12v2 = Parse("Standard_DS12_v2");
        /**
         * Static value Standard_E16_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE16v3 = Parse("Standard_E16_v3");
        /**
         * Static value Standard_D4_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD4v3 = Parse("Standard_D4_v3");
        /**
         * Static value Standard_G4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardG4 = Parse("Standard_G4");
        /**
         * Static value Standard_G3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardG3 = Parse("Standard_G3");
        /**
         * Static value Standard_NC24s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC24sv2 = Parse("Standard_NC24s_v2");
        /**
         * Static value Standard_G2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardG2 = Parse("Standard_G2");
        /**
         * Static value Classic for ComputeSkuName.
         */
        public static readonly ComputeSkuName Classic = Parse("Classic");
        /**
         * Static value Standard_D4_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD4v2 = Parse("Standard_D4_v2");
        /**
         * Static value Standard_G1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardG1 = Parse("Standard_G1");
        /**
         * Static value Standard_E64_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE64v3 = Parse("Standard_E64_v3");
        /**
         * Static value Standard_DS3_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS3v2Promo = Parse("Standard_DS3_v2_Promo");
        /**
         * Static value Standard_L4s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardL4s = Parse("Standard_L4s");
        /**
         * Static value Standard_E8_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE8v3 = Parse("Standard_E8_v3");
        /**
         * Static value Standard_G5 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardG5 = Parse("Standard_G5");
        /**
         * Static value Standard_F8s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF8sv2 = Parse("Standard_F8s_v2");
        /**
         * Static value Standard_DS11_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS11v2Promo = Parse("Standard_DS11_v2_Promo");
        /**
         * Static value Standard_D2s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD2sv3 = Parse("Standard_D2s_v3");
        /**
         * Static value Standard_D13_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD13v2Promo = Parse("Standard_D13_v2_Promo");
        /**
         * Static value Standard_NC12 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC12 = Parse("Standard_NC12");
        /**
         * Static value Standard_D4_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD4v2Promo = Parse("Standard_D4_v2_Promo");
        /**
         * Static value Standard_L16s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardL16s = Parse("Standard_L16s");
        /**
         * Static value Standard_DS13-2_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS13_2v2 = Parse("Standard_DS13-2_v2");
        /**
         * Static value Standard_DS13_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS13v2 = Parse("Standard_DS13_v2");
        /**
         * Static value Standard_GS5-8 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS5_8 = Parse("Standard_GS5-8");
        /**
         * Static value Standard_D5_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD5v2 = Parse("Standard_D5_v2");
        /**
         * Static value Standard_NC24r for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC24r = Parse("Standard_NC24r");
        /**
         * Static value Standard_L32s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardL32s = Parse("Standard_L32s");
        /**
         * Static value Standard_D14_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD14v2 = Parse("Standard_D14_v2");
        /**
         * Static value Standard_E32_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE32v3 = Parse("Standard_E32_v3");
        /**
         * Static value Standard_ND6s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardND6s = Parse("Standard_ND6s");
        /**
         * Static value Standard_H8 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH8 = Parse("Standard_H8");
        /**
         * Static value Basic_A4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName BasicA4 = Parse("Basic_A4");
        /**
         * Static value Standard_DS2_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS2v2Promo = Parse("Standard_DS2_v2_Promo");
        /**
         * Static value Basic_A1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName BasicA1 = Parse("Basic_A1");
        /**
         * Static value Basic_A0 for ComputeSkuName.
         */
        public static readonly ComputeSkuName BasicA0 = Parse("Basic_A0");
        /**
         * Static value Basic_A3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName BasicA3 = Parse("Basic_A3");
        /**
         * Static value Basic_A2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName BasicA2 = Parse("Basic_A2");
        /**
         * Static value Standard_D11_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD11v2 = Parse("Standard_D11_v2");
        /**
         * Static value Standard_DS14-8_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS14_8v2 = Parse("Standard_DS14-8_v2");
        /**
         * Static value Standard_DS1_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS1v2 = Parse("Standard_DS1_v2");
        /**
         * Static value Standard_E64-16s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE64_16sv3 = Parse("Standard_E64-16s_v3");
        /**
         * Static value Standard_D2_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD2v2 = Parse("Standard_D2_v2");
        /**
         * Static value Standard_D2_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD2v3 = Parse("Standard_D2_v3");
        /**
         * Static value Standard_D32_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD32v3 = Parse("Standard_D32_v3");
        /**
         * Static value Standard_D11_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD11v2Promo = Parse("Standard_D11_v2_Promo");
        /**
         * Static value Standard_F64s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF64sv2 = Parse("Standard_F64s_v2");
        /**
         * Static value Standard_A6 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA6 = Parse("Standard_A6");
        /**
         * Static value Standard_M128-64ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM128_64ms = Parse("Standard_M128-64ms");
        /**
         * Static value Standard_A5 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA5 = Parse("Standard_A5");
        /**
         * Static value Standard_A4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA4 = Parse("Standard_A4");
        /**
         * Static value Standard_A3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA3 = Parse("Standard_A3");
        /**
         * Static value Standard_A2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA2 = Parse("Standard_A2");
        /**
         * Static value Standard_D32s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD32sv3 = Parse("Standard_D32s_v3");
        /**
         * Static value Standard_A1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA1 = Parse("Standard_A1");
        /**
         * Static value Standard_A0 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA0 = Parse("Standard_A0");
        /**
         * Static value Standard_M64-32ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM64_32ms = Parse("Standard_M64-32ms");
        /**
         * Static value Standard_A8_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA8v2 = Parse("Standard_A8_v2");
        /**
         * Static value Standard_B4ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB4ms = Parse("Standard_B4ms");
        /**
         * Static value Standard_GS3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS3 = Parse("Standard_GS3");
        /**
         * Static value Standard_GS2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS2 = Parse("Standard_GS2");
        /**
         * Static value Standard_GS5 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS5 = Parse("Standard_GS5");
        /**
         * Static value Standard_GS4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS4 = Parse("Standard_GS4");
        /**
         * Static value Standard_B8ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB8ms = Parse("Standard_B8ms");
        /**
         * Static value Standard_D64_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD64v3 = Parse("Standard_D64_v3");
        /**
         * Static value Standard_A9 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA9 = Parse("Standard_A9");
        /**
         * Static value Standard_A8 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA8 = Parse("Standard_A8");
        /**
         * Static value Standard_GS1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardGS1 = Parse("Standard_GS1");
        /**
         * Static value Standard_A7 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA7 = Parse("Standard_A7");
        /**
         * Static value Standard_E64-32s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE64_32sv3 = Parse("Standard_E64-32s_v3");
        /**
         * Static value Standard_NV12 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNV12 = Parse("Standard_NV12");
        /**
         * Static value Standard_NC6s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC6sv2 = Parse("Standard_NC6s_v2");
        /**
         * Static value Standard_NC24rs_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC24rsv2 = Parse("Standard_NC24rs_v2");
        /**
         * Static value Standard_H8m for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH8m = Parse("Standard_H8m");
        /**
         * Static value Standard_DS11_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS11v2 = Parse("Standard_DS11_v2");
        /**
         * Static value Premium_LRS for ComputeSkuName.
         */
        public static readonly ComputeSkuName PremiumLRS = Parse("Premium_LRS");
        /**
         * Static value Standard_D3_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD3v2 = Parse("Standard_D3_v2");
        /**
         * Static value Standard_D16_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD16v3 = Parse("Standard_D16_v3");
        /**
         * Static value Standard_F16s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF16s = Parse("Standard_F16s");
        /**
         * Static value Standard_ND24rs for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardND24rs = Parse("Standard_ND24rs");
        /**
         * Static value Standard_DS13 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS13 = Parse("Standard_DS13");
        /**
         * Static value Standard_NV6 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNV6 = Parse("Standard_NV6");
        /**
         * Static value Standard_DS12 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS12 = Parse("Standard_DS12");
        /**
         * Static value Standard_E8s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE8sv3 = Parse("Standard_E8s_v3");
        /**
         * Static value Standard_DS11 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS11 = Parse("Standard_DS11");
        /**
         * Static value Standard_H16 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardH16 = Parse("Standard_H16");
        /**
         * Static value Standard_DS14 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS14 = Parse("Standard_DS14");
        /**
         * Static value Standard_D14 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD14 = Parse("Standard_D14");
        /**
         * Static value Standard_D12_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD12v2Promo = Parse("Standard_D12_v2_Promo");
        /**
         * Static value Standard_D13 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD13 = Parse("Standard_D13");
        /**
         * Static value Standard_D5_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD5v2Promo = Parse("Standard_D5_v2_Promo");
        /**
         * Static value Standard_DS14-4_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS14_4v2 = Parse("Standard_DS14-4_v2");
        /**
         * Static value Standard_D12 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD12 = Parse("Standard_D12");
        /**
         * Static value Standard_D11 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD11 = Parse("Standard_D11");
        /**
         * Static value Standard_DS3_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS3v2 = Parse("Standard_DS3_v2");
        /**
         * Static value Standard_D14_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD14v2Promo = Parse("Standard_D14_v2_Promo");
        /**
         * Static value Standard_D8_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD8v3 = Parse("Standard_D8_v3");
        /**
         * Static value Standard_NV24 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNV24 = Parse("Standard_NV24");
        /**
         * Static value Standard_DS4_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS4v2Promo = Parse("Standard_DS4_v2_Promo");
        /**
         * Static value Standard_D13_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD13v2 = Parse("Standard_D13_v2");
        /**
         * Static value Standard_M64s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM64s = Parse("Standard_M64s");
        /**
         * Static value Standard_M64ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM64ms = Parse("Standard_M64ms");
        /**
         * Static value Standard_E32s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE32sv3 = Parse("Standard_E32s_v3");
        /**
         * Static value Standard_M64-16ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardM64_16ms = Parse("Standard_M64-16ms");
        /**
         * Static value Standard_E32-16s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE32_16sv3 = Parse("Standard_E32-16s_v3");
        /**
         * Static value Standard_D3_v2_Promo for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardD3v2Promo = Parse("Standard_D3_v2_Promo");
        /**
         * Static value Standard_B1ms for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardB1ms = Parse("Standard_B1ms");
        /**
         * Static value Standard_E64s_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE64sv3 = Parse("Standard_E64s_v3");
        /**
         * Static value Standard_LRS for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardLRS = Parse("Standard_LRS");
        /**
         * Static value Standard_NC12s_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardNC12sv2 = Parse("Standard_NC12s_v2");
        /**
         * Static value Standard_L8s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardL8s = Parse("Standard_L8s");
        /**
         * Static value Standard_E4_v3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardE4v3 = Parse("Standard_E4_v3");
        /**
         * Static value Aligned for ComputeSkuName.
         */
        public static readonly ComputeSkuName Aligned = Parse("Aligned");
        /**
         * Static value Standard_DS2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS2 = Parse("Standard_DS2");
        /**
         * Static value Standard_DS1 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS1 = Parse("Standard_DS1");
        /**
         * Static value Standard_F4s for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardF4s = Parse("Standard_F4s");
        /**
         * Static value Standard_DS4 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS4 = Parse("Standard_DS4");
        /**
         * Static value Standard_A2_v2 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardA2v2 = Parse("Standard_A2_v2");
        /**
         * Static value Standard_DS3 for ComputeSkuName.
         */
        public static readonly ComputeSkuName StandardDS3 = Parse("Standard_DS3");
    }
}