// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Enables or disables a capability on the virtual machine or virtual
    /// machine scale set.
    /// </summary>
    public partial class AdditionalCapabilities
    {
        /// <summary>
        /// Initializes a new instance of the AdditionalCapabilities class.
        /// </summary>
        public AdditionalCapabilities()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AdditionalCapabilities class.
        /// </summary>
        /// <param name="ultraSSDEnabled">The flag that enables or disables a
        /// capability to have one or more managed data disks with UltraSSD_LRS
        /// storage account type on the VM or VMSS. Managed disks with storage
        /// account type UltraSSD_LRS can be added to a virtual machine or
        /// virtual machine scale set only if this property is enabled.</param>
        public AdditionalCapabilities(bool? ultraSSDEnabled = default(bool?))
        {
            UltraSSDEnabled = ultraSSDEnabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the flag that enables or disables a capability to have
        /// one or more managed data disks with UltraSSD_LRS storage account
        /// type on the VM or VMSS. Managed disks with storage account type
        /// UltraSSD_LRS can be added to a virtual machine or virtual machine
        /// scale set only if this property is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "ultraSSDEnabled")]
        public bool? UltraSSDEnabled { get; set; }

    }
}
