// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The configuration parameters used for performing automatic OS upgrade.
    /// </summary>
    public partial class AutomaticOSUpgradePolicy
    {
        /// <summary>
        /// Initializes a new instance of the AutomaticOSUpgradePolicy class.
        /// </summary>
        public AutomaticOSUpgradePolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AutomaticOSUpgradePolicy class.
        /// </summary>
        /// <param name="enableAutomaticOSUpgrade">Indicates whether OS
        /// upgrades should automatically be applied to scale set instances in
        /// a rolling fashion when a newer version of the OS image becomes
        /// available. Default value is false. &lt;br&gt;&lt;br&gt; If this is
        /// set to true for Windows based scale sets,
        /// [enableAutomaticUpdates](https://docs.microsoft.com/dotnet/api/microsoft.azure.management.compute.models.windowsconfiguration.enableautomaticupdates?view=azure-dotnet)
        /// is automatically set to false and cannot be set to true.</param>
        /// <param name="disableAutomaticRollback">Whether OS image rollback
        /// feature should be disabled. Default value is false.</param>
        public AutomaticOSUpgradePolicy(bool? enableAutomaticOSUpgrade = default(bool?), bool? disableAutomaticRollback = default(bool?))
        {
            EnableAutomaticOSUpgrade = enableAutomaticOSUpgrade;
            DisableAutomaticRollback = disableAutomaticRollback;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets indicates whether OS upgrades should automatically be
        /// applied to scale set instances in a rolling fashion when a newer
        /// version of the OS image becomes available. Default value is false.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; If this is set to true for
        /// Windows based scale sets,
        /// [enableAutomaticUpdates](https://docs.microsoft.com/dotnet/api/microsoft.azure.management.compute.models.windowsconfiguration.enableautomaticupdates?view=azure-dotnet)
        /// is automatically set to false and cannot be set to true.
        /// </summary>
        [JsonProperty(PropertyName = "enableAutomaticOSUpgrade")]
        public bool? EnableAutomaticOSUpgrade { get; set; }

        /// <summary>
        /// Gets or sets whether OS image rollback feature should be disabled.
        /// Default value is false.
        /// </summary>
        [JsonProperty(PropertyName = "disableAutomaticRollback")]
        public bool? DisableAutomaticRollback { get; set; }

    }
}
