// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The instance view of a virtual machine boot diagnostics.
    /// </summary>
    public partial class BootDiagnosticsInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the BootDiagnosticsInstanceView
        /// class.
        /// </summary>
        public BootDiagnosticsInstanceView()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BootDiagnosticsInstanceView
        /// class.
        /// </summary>
        /// <param name="consoleScreenshotBlobUri">The console screenshot blob
        /// URI.</param>
        /// <param name="serialConsoleLogBlobUri">The Linux serial console log
        /// blob Uri.</param>
        /// <param name="status">The boot diagnostics status information for
        /// the VM. &lt;br&gt;&lt;br&gt; NOTE: It will be set only if there are
        /// errors encountered in enabling boot diagnostics.</param>
        public BootDiagnosticsInstanceView(string consoleScreenshotBlobUri = default(string), string serialConsoleLogBlobUri = default(string), InstanceViewStatus status = default(InstanceViewStatus))
        {
            ConsoleScreenshotBlobUri = consoleScreenshotBlobUri;
            SerialConsoleLogBlobUri = serialConsoleLogBlobUri;
            Status = status;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the console screenshot blob URI.
        /// </summary>
        [JsonProperty(PropertyName = "consoleScreenshotBlobUri")]
        public string ConsoleScreenshotBlobUri { get; private set; }

        /// <summary>
        /// Gets the Linux serial console log blob Uri.
        /// </summary>
        [JsonProperty(PropertyName = "serialConsoleLogBlobUri")]
        public string SerialConsoleLogBlobUri { get; private set; }

        /// <summary>
        /// Gets the boot diagnostics status information for the VM.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; NOTE: It will be set only if
        /// there are errors encountered in enabling boot diagnostics.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public InstanceViewStatus Status { get; private set; }

    }
}
