// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class ContainerServiceDiagnosticsProfile
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ContainerServiceDiagnosticsProfile class.
        /// </summary>
        public ContainerServiceDiagnosticsProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ContainerServiceDiagnosticsProfile class.
        /// </summary>
        /// <param name="vmDiagnostics">Profile for the container service VM
        /// diagnostic agent.</param>
        public ContainerServiceDiagnosticsProfile(ContainerServiceVMDiagnostics vmDiagnostics)
        {
            VmDiagnostics = vmDiagnostics;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets profile for the container service VM diagnostic agent.
        /// </summary>
        [JsonProperty(PropertyName = "vmDiagnostics")]
        public ContainerServiceVMDiagnostics VmDiagnostics { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VmDiagnostics == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VmDiagnostics");
            }
            if (VmDiagnostics != null)
            {
                VmDiagnostics.Validate();
            }
        }
    }
}
