// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Dedicated host unutilized capacity.
    /// </summary>
    public partial class DedicatedHostAvailableCapacity
    {
        /// <summary>
        /// Initializes a new instance of the DedicatedHostAvailableCapacity
        /// class.
        /// </summary>
        public DedicatedHostAvailableCapacity()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DedicatedHostAvailableCapacity
        /// class.
        /// </summary>
        /// <param name="allocatableVMs">The unutilized capacity of the
        /// dedicated host represented in terms of each VM size that is allowed
        /// to be deployed to the dedicated host.</param>
        public DedicatedHostAvailableCapacity(IList<DedicatedHostAllocatableVM> allocatableVMs = default(IList<DedicatedHostAllocatableVM>))
        {
            AllocatableVMs = allocatableVMs;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unutilized capacity of the dedicated host
        /// represented in terms of each VM size that is allowed to be deployed
        /// to the dedicated host.
        /// </summary>
        [JsonProperty(PropertyName = "allocatableVMs")]
        public IList<DedicatedHostAllocatableVM> AllocatableVMs { get; set; }

    }
}
