// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The instance view of the disk.
    /// </summary>
    public partial class DiskInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the DiskInstanceView class.
        /// </summary>
        public DiskInstanceView()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DiskInstanceView class.
        /// </summary>
        /// <param name="name">The disk name.</param>
        /// <param name="encryptionSettings">Specifies the encryption settings
        /// for the OS Disk. &lt;br&gt;&lt;br&gt; Minimum api-version:
        /// 2015-06-15</param>
        /// <param name="statuses">The resource status information.</param>
        public DiskInstanceView(string name = default(string), IList<DiskEncryptionSettings> encryptionSettings = default(IList<DiskEncryptionSettings>), IList<InstanceViewStatus> statuses = default(IList<InstanceViewStatus>))
        {
            Name = name;
            EncryptionSettings = encryptionSettings;
            Statuses = statuses;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the disk name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets specifies the encryption settings for the OS Disk.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; Minimum api-version:
        /// 2015-06-15
        /// </summary>
        [JsonProperty(PropertyName = "encryptionSettings")]
        public IList<DiskEncryptionSettings> EncryptionSettings { get; set; }

        /// <summary>
        /// Gets or sets the resource status information.
        /// </summary>
        [JsonProperty(PropertyName = "statuses")]
        public IList<InstanceViewStatus> Statuses { get; set; }

    }
}
