// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Specifies information about the gallery Application Definition that you
    /// want to create or update.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class GalleryApplicationInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the GalleryApplicationInner class.
        /// </summary>
        public GalleryApplicationInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GalleryApplicationInner class.
        /// </summary>
        /// <param name="supportedOSType">This property allows you to specify
        /// the supported type of the OS that application is built for.
        /// &lt;br&gt;&lt;br&gt; Possible values are: &lt;br&gt;&lt;br&gt;
        /// **Windows** &lt;br&gt;&lt;br&gt; **Linux**. Possible values
        /// include: 'Windows', 'Linux'</param>
        /// <param name="description">The description of this gallery
        /// Application Definition resource. This property is
        /// updatable.</param>
        /// <param name="eula">The Eula agreement for the gallery Application
        /// Definition.</param>
        /// <param name="privacyStatementUri">The privacy statement
        /// uri.</param>
        /// <param name="releaseNoteUri">The release note uri.</param>
        /// <param name="endOfLifeDate">The end of life date of the gallery
        /// Application Definition. This property can be used for
        /// decommissioning purposes. This property is updatable.</param>
        public GalleryApplicationInner(string location, OperatingSystemTypes supportedOSType, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string description = default(string), string eula = default(string), string privacyStatementUri = default(string), string releaseNoteUri = default(string), System.DateTime? endOfLifeDate = default(System.DateTime?))
            : base(location, id, name, type, tags)
        {
            Description = description;
            Eula = eula;
            PrivacyStatementUri = privacyStatementUri;
            ReleaseNoteUri = releaseNoteUri;
            EndOfLifeDate = endOfLifeDate;
            SupportedOSType = supportedOSType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the description of this gallery Application Definition
        /// resource. This property is updatable.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the Eula agreement for the gallery Application
        /// Definition.
        /// </summary>
        [JsonProperty(PropertyName = "properties.eula")]
        public string Eula { get; set; }

        /// <summary>
        /// Gets or sets the privacy statement uri.
        /// </summary>
        [JsonProperty(PropertyName = "properties.privacyStatementUri")]
        public string PrivacyStatementUri { get; set; }

        /// <summary>
        /// Gets or sets the release note uri.
        /// </summary>
        [JsonProperty(PropertyName = "properties.releaseNoteUri")]
        public string ReleaseNoteUri { get; set; }

        /// <summary>
        /// Gets or sets the end of life date of the gallery Application
        /// Definition. This property can be used for decommissioning purposes.
        /// This property is updatable.
        /// </summary>
        [JsonProperty(PropertyName = "properties.endOfLifeDate")]
        public System.DateTime? EndOfLifeDate { get; set; }

        /// <summary>
        /// Gets or sets this property allows you to specify the supported type
        /// of the OS that application is built for.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; Possible values are:
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; **Windows**
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; **Linux**. Possible values
        /// include: 'Windows', 'Linux'
        /// </summary>
        [JsonProperty(PropertyName = "properties.supportedOSType")]
        public OperatingSystemTypes SupportedOSType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
