// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This is the disk image base class.
    /// </summary>
    public partial class GalleryDiskImage
    {
        /// <summary>
        /// Initializes a new instance of the GalleryDiskImage class.
        /// </summary>
        public GalleryDiskImage()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GalleryDiskImage class.
        /// </summary>
        /// <param name="sizeInGB">This property indicates the size of the VHD
        /// to be created.</param>
        /// <param name="hostCaching">The host caching of the disk. Valid
        /// values are 'None', 'ReadOnly', and 'ReadWrite'. Possible values
        /// include: 'None', 'ReadOnly', 'ReadWrite'</param>
        public GalleryDiskImage(int? sizeInGB = default(int?), HostCaching? hostCaching = default(HostCaching?), GalleryArtifactVersionSource source = default(GalleryArtifactVersionSource))
        {
            SizeInGB = sizeInGB;
            HostCaching = hostCaching;
            Source = source;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets this property indicates the size of the VHD to be created.
        /// </summary>
        [JsonProperty(PropertyName = "sizeInGB")]
        public int? SizeInGB { get; private set; }

        /// <summary>
        /// Gets or sets the host caching of the disk. Valid values are 'None',
        /// 'ReadOnly', and 'ReadWrite'. Possible values include: 'None',
        /// 'ReadOnly', 'ReadWrite'
        /// </summary>
        [JsonProperty(PropertyName = "hostCaching")]
        public HostCaching? HostCaching { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "source")]
        public GalleryArtifactVersionSource Source { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Source != null)
            {
                Source.Validate();
            }
        }
    }
}
