// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// This is the gallery Image Definition identifier.
    /// </summary>
    public partial class GalleryImageIdentifier
    {
        /// <summary>
        /// Initializes a new instance of the GalleryImageIdentifier class.
        /// </summary>
        public GalleryImageIdentifier()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GalleryImageIdentifier class.
        /// </summary>
        /// <param name="publisher">The name of the gallery Image Definition
        /// publisher.</param>
        /// <param name="offer">The name of the gallery Image Definition
        /// offer.</param>
        /// <param name="sku">The name of the gallery Image Definition
        /// SKU.</param>
        public GalleryImageIdentifier(string publisher, string offer, string sku)
        {
            Publisher = publisher;
            Offer = offer;
            Sku = sku;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the gallery Image Definition publisher.
        /// </summary>
        [JsonProperty(PropertyName = "publisher")]
        public string Publisher { get; set; }

        /// <summary>
        /// Gets or sets the name of the gallery Image Definition offer.
        /// </summary>
        [JsonProperty(PropertyName = "offer")]
        public string Offer { get; set; }

        /// <summary>
        /// Gets or sets the name of the gallery Image Definition SKU.
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public string Sku { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Publisher == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Publisher");
            }
            if (Offer == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Offer");
            }
            if (Sku == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Sku");
            }
        }
    }
}
