// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// This is the storage profile of a Gallery Image Version.
    /// </summary>
    public partial class GalleryImageVersionStorageProfile
    {
        /// <summary>
        /// Initializes a new instance of the GalleryImageVersionStorageProfile
        /// class.
        /// </summary>
        public GalleryImageVersionStorageProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GalleryImageVersionStorageProfile
        /// class.
        /// </summary>
        /// <param name="dataDiskImages">A list of data disk images.</param>
        public GalleryImageVersionStorageProfile(GalleryArtifactVersionSource source = default(GalleryArtifactVersionSource), GalleryOSDiskImage osDiskImage = default(GalleryOSDiskImage), IList<GalleryDataDiskImage> dataDiskImages = default(IList<GalleryDataDiskImage>))
        {
            Source = source;
            OsDiskImage = osDiskImage;
            DataDiskImages = dataDiskImages;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "source")]
        public GalleryArtifactVersionSource Source { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "osDiskImage")]
        public GalleryOSDiskImage OsDiskImage { get; set; }

        /// <summary>
        /// Gets or sets a list of data disk images.
        /// </summary>
        [JsonProperty(PropertyName = "dataDiskImages")]
        public IList<GalleryDataDiskImage> DataDiskImages { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Source != null)
            {
                Source.Validate();
            }
            if (OsDiskImage != null)
            {
                OsDiskImage.Validate();
            }
            if (DataDiskImages != null)
            {
                foreach (var element in DataDiskImages)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
