// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes scaling information of a SKU.
    /// </summary>
    public partial class ResourceSkuCapacity
    {
        /// <summary>
        /// Initializes a new instance of the ResourceSkuCapacity class.
        /// </summary>
        public ResourceSkuCapacity()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceSkuCapacity class.
        /// </summary>
        /// <param name="minimum">The minimum capacity.</param>
        /// <param name="maximum">The maximum capacity that can be set.</param>
        /// <param name="defaultProperty">The default capacity.</param>
        /// <param name="scaleType">The scale type applicable to the sku.
        /// Possible values include: 'Automatic', 'Manual', 'None'</param>
        public ResourceSkuCapacity(long? minimum = default(long?), long? maximum = default(long?), long? defaultProperty = default(long?), ResourceSkuCapacityScaleType? scaleType = default(ResourceSkuCapacityScaleType?))
        {
            Minimum = minimum;
            Maximum = maximum;
            DefaultProperty = defaultProperty;
            ScaleType = scaleType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the minimum capacity.
        /// </summary>
        [JsonProperty(PropertyName = "minimum")]
        public long? Minimum { get; private set; }

        /// <summary>
        /// Gets the maximum capacity that can be set.
        /// </summary>
        [JsonProperty(PropertyName = "maximum")]
        public long? Maximum { get; private set; }

        /// <summary>
        /// Gets the default capacity.
        /// </summary>
        [JsonProperty(PropertyName = "default")]
        public long? DefaultProperty { get; private set; }

        /// <summary>
        /// Gets the scale type applicable to the sku. Possible values include:
        /// 'Automatic', 'Manual', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "scaleType")]
        public ResourceSkuCapacityScaleType? ScaleType { get; private set; }

    }
}
