// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about rollback on failed VM instances after a OS Upgrade
    /// operation.
    /// </summary>
    public partial class RollbackStatusInfo
    {
        /// <summary>
        /// Initializes a new instance of the RollbackStatusInfo class.
        /// </summary>
        public RollbackStatusInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RollbackStatusInfo class.
        /// </summary>
        /// <param name="successfullyRolledbackInstanceCount">The number of
        /// instances which have been successfully rolled back.</param>
        /// <param name="failedRolledbackInstanceCount">The number of instances
        /// which failed to rollback.</param>
        /// <param name="rollbackError">Error details if OS rollback
        /// failed.</param>
        public RollbackStatusInfo(int? successfullyRolledbackInstanceCount = default(int?), int? failedRolledbackInstanceCount = default(int?), ApiError rollbackError = default(ApiError))
        {
            SuccessfullyRolledbackInstanceCount = successfullyRolledbackInstanceCount;
            FailedRolledbackInstanceCount = failedRolledbackInstanceCount;
            RollbackError = rollbackError;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the number of instances which have been successfully rolled
        /// back.
        /// </summary>
        [JsonProperty(PropertyName = "successfullyRolledbackInstanceCount")]
        public int? SuccessfullyRolledbackInstanceCount { get; private set; }

        /// <summary>
        /// Gets the number of instances which failed to rollback.
        /// </summary>
        [JsonProperty(PropertyName = "failedRolledbackInstanceCount")]
        public int? FailedRolledbackInstanceCount { get; private set; }

        /// <summary>
        /// Gets error details if OS rollback failed.
        /// </summary>
        [JsonProperty(PropertyName = "rollbackError")]
        public ApiError RollbackError { get; private set; }

    }
}
