// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Information about the current running state of the overall upgrade.
    /// </summary>
    public partial class RollingUpgradeRunningStatus
    {
        /// <summary>
        /// Initializes a new instance of the RollingUpgradeRunningStatus
        /// class.
        /// </summary>
        public RollingUpgradeRunningStatus()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RollingUpgradeRunningStatus
        /// class.
        /// </summary>
        /// <param name="code">Code indicating the current status of the
        /// upgrade. Possible values include: 'RollingForward', 'Cancelled',
        /// 'Completed', 'Faulted'</param>
        /// <param name="startTime">Start time of the upgrade.</param>
        /// <param name="lastAction">The last action performed on the rolling
        /// upgrade. Possible values include: 'Start', 'Cancel'</param>
        /// <param name="lastActionTime">Last action time of the
        /// upgrade.</param>
        public RollingUpgradeRunningStatus(RollingUpgradeStatusCode? code = default(RollingUpgradeStatusCode?), System.DateTime? startTime = default(System.DateTime?), RollingUpgradeActionType? lastAction = default(RollingUpgradeActionType?), System.DateTime? lastActionTime = default(System.DateTime?))
        {
            Code = code;
            StartTime = startTime;
            LastAction = lastAction;
            LastActionTime = lastActionTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets code indicating the current status of the upgrade. Possible
        /// values include: 'RollingForward', 'Cancelled', 'Completed',
        /// 'Faulted'
        /// </summary>
        [JsonProperty(PropertyName = "code")]
        public RollingUpgradeStatusCode? Code { get; private set; }

        /// <summary>
        /// Gets start time of the upgrade.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets the last action performed on the rolling upgrade. Possible
        /// values include: 'Start', 'Cancel'
        /// </summary>
        [JsonProperty(PropertyName = "lastAction")]
        public RollingUpgradeActionType? LastAction { get; private set; }

        /// <summary>
        /// Gets last action time of the upgrade.
        /// </summary>
        [JsonProperty(PropertyName = "lastActionTime")]
        public System.DateTime? LastActionTime { get; private set; }

    }
}
