// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the properties of a run command parameter.
    /// </summary>
    public partial class RunCommandParameterDefinition
    {
        /// <summary>
        /// Initializes a new instance of the RunCommandParameterDefinition
        /// class.
        /// </summary>
        public RunCommandParameterDefinition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RunCommandParameterDefinition
        /// class.
        /// </summary>
        /// <param name="name">The run command parameter name.</param>
        /// <param name="type">The run command parameter type.</param>
        /// <param name="defaultValue">The run command parameter default
        /// value.</param>
        /// <param name="required">The run command parameter required.</param>
        public RunCommandParameterDefinition(string name, string type, string defaultValue = default(string), bool? required = default(bool?))
        {
            Name = name;
            Type = type;
            DefaultValue = defaultValue;
            Required = required;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the run command parameter name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the run command parameter type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the run command parameter default value.
        /// </summary>
        [JsonProperty(PropertyName = "defaultValue")]
        public string DefaultValue { get; set; }

        /// <summary>
        /// Gets or sets the run command parameter required.
        /// </summary>
        [JsonProperty(PropertyName = "required")]
        public bool? Required { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (Type == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Type");
            }
        }
    }
}
