// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes a scale-in policy for a virtual machine scale set.
    /// </summary>
    public partial class ScaleInPolicy
    {
        /// <summary>
        /// Initializes a new instance of the ScaleInPolicy class.
        /// </summary>
        public ScaleInPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScaleInPolicy class.
        /// </summary>
        /// <param name="rules">The rules to be followed when scaling-in a
        /// virtual machine scale set. &lt;br&gt;&lt;br&gt; Possible values
        /// are: &lt;br&gt;&lt;br&gt; **Default** When a virtual machine scale
        /// set is scaled in, the scale set will first be balanced across zones
        /// if it is a zonal scale set. Then, it will be balanced across Fault
        /// Domains as far as possible. Within each Fault Domain, the virtual
        /// machines chosen for removal will be the newest ones that are not
        /// protected from scale-in. &lt;br&gt;&lt;br&gt; **OldestVM** When a
        /// virtual machine scale set is being scaled-in, the oldest virtual
        /// machines that are not protected from scale-in will be chosen for
        /// removal. For zonal virtual machine scale sets, the scale set will
        /// first be balanced across zones. Within each zone, the oldest
        /// virtual machines that are not protected will be chosen for removal.
        /// &lt;br&gt;&lt;br&gt; **NewestVM** When a virtual machine scale set
        /// is being scaled-in, the newest virtual machines that are not
        /// protected from scale-in will be chosen for removal. For zonal
        /// virtual machine scale sets, the scale set will first be balanced
        /// across zones. Within each zone, the newest virtual machines that
        /// are not protected will be chosen for removal.
        /// &lt;br&gt;&lt;br&gt;</param>
        public ScaleInPolicy(IList<VirtualMachineScaleSetScaleInRules> rules = default(IList<VirtualMachineScaleSetScaleInRules>))
        {
            Rules = rules;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the rules to be followed when scaling-in a virtual
        /// machine scale set. &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; Possible
        /// values are: &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; **Default** When a
        /// virtual machine scale set is scaled in, the scale set will first be
        /// balanced across zones if it is a zonal scale set. Then, it will be
        /// balanced across Fault Domains as far as possible. Within each Fault
        /// Domain, the virtual machines chosen for removal will be the newest
        /// ones that are not protected from scale-in.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; **OldestVM** When a virtual
        /// machine scale set is being scaled-in, the oldest virtual machines
        /// that are not protected from scale-in will be chosen for removal.
        /// For zonal virtual machine scale sets, the scale set will first be
        /// balanced across zones. Within each zone, the oldest virtual
        /// machines that are not protected will be chosen for removal.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt; **NewestVM** When a virtual
        /// machine scale set is being scaled-in, the newest virtual machines
        /// that are not protected from scale-in will be chosen for removal.
        /// For zonal virtual machine scale sets, the scale set will first be
        /// balanced across zones. Within each zone, the newest virtual
        /// machines that are not protected will be chosen for removal.
        /// &amp;lt;br&amp;gt;&amp;lt;br&amp;gt;
        /// </summary>
        [JsonProperty(PropertyName = "rules")]
        public IList<VirtualMachineScaleSetScaleInRules> Rules { get; set; }

    }
}
