// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes the target region information.
    /// </summary>
    public partial class TargetRegion
    {
        /// <summary>
        /// Initializes a new instance of the TargetRegion class.
        /// </summary>
        public TargetRegion()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TargetRegion class.
        /// </summary>
        /// <param name="name">The name of the region.</param>
        /// <param name="regionalReplicaCount">The number of replicas of the
        /// Image Version to be created per region. This property is
        /// updatable.</param>
        /// <param name="storageAccountType">Specifies the storage account type
        /// to be used to store the image. This property is not updatable.
        /// Possible values include: 'Standard_LRS', 'Standard_ZRS'</param>
        public TargetRegion(string name, int? regionalReplicaCount = default(int?), StorageAccountType storageAccountType = default(StorageAccountType))
        {
            Name = name;
            RegionalReplicaCount = regionalReplicaCount;
            StorageAccountType = storageAccountType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the region.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the number of replicas of the Image Version to be
        /// created per region. This property is updatable.
        /// </summary>
        [JsonProperty(PropertyName = "regionalReplicaCount")]
        public int? RegionalReplicaCount { get; set; }

        /// <summary>
        /// Gets or sets specifies the storage account type to be used to store
        /// the image. This property is not updatable. Possible values include:
        /// 'Standard_LRS', 'Standard_ZRS'
        /// </summary>
        [JsonProperty(PropertyName = "storageAccountType")]
        public StorageAccountType StorageAccountType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
