// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes each OS upgrade on the Virtual Machine Scale Set.
    /// </summary>
    public partial class UpgradeOperationHistoricalStatusInfoProperties
    {
        /// <summary>
        /// Initializes a new instance of the
        /// UpgradeOperationHistoricalStatusInfoProperties class.
        /// </summary>
        public UpgradeOperationHistoricalStatusInfoProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// UpgradeOperationHistoricalStatusInfoProperties class.
        /// </summary>
        /// <param name="runningStatus">Information about the overall status of
        /// the upgrade operation.</param>
        /// <param name="progress">Counts of the VMs in each state.</param>
        /// <param name="error">Error Details for this upgrade if there are
        /// any.</param>
        /// <param name="startedBy">Invoker of the Upgrade Operation. Possible
        /// values include: 'Unknown', 'User', 'Platform'</param>
        /// <param name="targetImageReference">Image Reference details</param>
        /// <param name="rollbackInfo">Information about OS rollback if
        /// performed</param>
        public UpgradeOperationHistoricalStatusInfoProperties(UpgradeOperationHistoryStatus runningStatus = default(UpgradeOperationHistoryStatus), RollingUpgradeProgressInfo progress = default(RollingUpgradeProgressInfo), ApiError error = default(ApiError), UpgradeOperationInvoker? startedBy = default(UpgradeOperationInvoker?), ImageReferenceInner targetImageReference = default(ImageReferenceInner), RollbackStatusInfo rollbackInfo = default(RollbackStatusInfo))
        {
            RunningStatus = runningStatus;
            Progress = progress;
            Error = error;
            StartedBy = startedBy;
            TargetImageReference = targetImageReference;
            RollbackInfo = rollbackInfo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets information about the overall status of the upgrade operation.
        /// </summary>
        [JsonProperty(PropertyName = "runningStatus")]
        public UpgradeOperationHistoryStatus RunningStatus { get; private set; }

        /// <summary>
        /// Gets counts of the VMs in each state.
        /// </summary>
        [JsonProperty(PropertyName = "progress")]
        public RollingUpgradeProgressInfo Progress { get; private set; }

        /// <summary>
        /// Gets error Details for this upgrade if there are any.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public ApiError Error { get; private set; }

        /// <summary>
        /// Gets invoker of the Upgrade Operation. Possible values include:
        /// 'Unknown', 'User', 'Platform'
        /// </summary>
        [JsonProperty(PropertyName = "startedBy")]
        public UpgradeOperationInvoker? StartedBy { get; private set; }

        /// <summary>
        /// Gets image Reference details
        /// </summary>
        [JsonProperty(PropertyName = "targetImageReference")]
        public ImageReferenceInner TargetImageReference { get; private set; }

        /// <summary>
        /// Gets information about OS rollback if performed
        /// </summary>
        [JsonProperty(PropertyName = "rollbackInfo")]
        public RollbackStatusInfo RollbackInfo { get; private set; }

    }
}
