// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The instance view of the VM Agent running on the virtual machine.
    /// </summary>
    public partial class VirtualMachineAgentInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineAgentInstanceView
        /// class.
        /// </summary>
        public VirtualMachineAgentInstanceView()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineAgentInstanceView
        /// class.
        /// </summary>
        /// <param name="vmAgentVersion">The VM Agent full version.</param>
        /// <param name="extensionHandlers">The virtual machine extension
        /// handler instance view.</param>
        /// <param name="statuses">The resource status information.</param>
        public VirtualMachineAgentInstanceView(string vmAgentVersion = default(string), IList<VirtualMachineExtensionHandlerInstanceView> extensionHandlers = default(IList<VirtualMachineExtensionHandlerInstanceView>), IList<InstanceViewStatus> statuses = default(IList<InstanceViewStatus>))
        {
            VmAgentVersion = vmAgentVersion;
            ExtensionHandlers = extensionHandlers;
            Statuses = statuses;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the VM Agent full version.
        /// </summary>
        [JsonProperty(PropertyName = "vmAgentVersion")]
        public string VmAgentVersion { get; set; }

        /// <summary>
        /// Gets or sets the virtual machine extension handler instance view.
        /// </summary>
        [JsonProperty(PropertyName = "extensionHandlers")]
        public IList<VirtualMachineExtensionHandlerInstanceView> ExtensionHandlers { get; set; }

        /// <summary>
        /// Gets or sets the resource status information.
        /// </summary>
        [JsonProperty(PropertyName = "statuses")]
        public IList<InstanceViewStatus> Statuses { get; set; }

    }
}
