// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Contains the IP tag associated with the public IP address.
    /// </summary>
    public partial class VirtualMachineScaleSetIpTag
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineScaleSetIpTag
        /// class.
        /// </summary>
        public VirtualMachineScaleSetIpTag()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineScaleSetIpTag
        /// class.
        /// </summary>
        /// <param name="ipTagType">IP tag type. Example:
        /// FirstPartyUsage.</param>
        /// <param name="tag">IP tag associated with the public IP. Example:
        /// SQL, Storage etc.</param>
        public VirtualMachineScaleSetIpTag(string ipTagType = default(string), string tag = default(string))
        {
            IpTagType = ipTagType;
            Tag = tag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets IP tag type. Example: FirstPartyUsage.
        /// </summary>
        [JsonProperty(PropertyName = "ipTagType")]
        public string IpTagType { get; set; }

        /// <summary>
        /// Gets or sets IP tag associated with the public IP. Example: SQL,
        /// Storage etc.
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public string Tag { get; set; }

    }
}
