// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes a Virtual Machine Scale Set VM Reimage Parameters.
    /// </summary>
    public partial class VirtualMachineScaleSetReimageParameters : VirtualMachineScaleSetVMReimageParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetReimageParameters class.
        /// </summary>
        public VirtualMachineScaleSetReimageParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetReimageParameters class.
        /// </summary>
        /// <param name="tempDisk">Specifies whether to reimage temp disk.
        /// Default value: false. Note: This temp disk reimage parameter is
        /// only supported for VM/VMSS with Ephemeral OS disk.</param>
        /// <param name="instanceIds">The virtual machine scale set instance
        /// ids. Omitting the virtual machine scale set instance ids will
        /// result in the operation being performed on all virtual machines in
        /// the virtual machine scale set.</param>
        public VirtualMachineScaleSetReimageParameters(bool? tempDisk = default(bool?), IList<string> instanceIds = default(IList<string>))
            : base(tempDisk)
        {
            InstanceIds = instanceIds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the virtual machine scale set instance ids. Omitting
        /// the virtual machine scale set instance ids will result in the
        /// operation being performed on all virtual machines in the virtual
        /// machine scale set.
        /// </summary>
        [JsonProperty(PropertyName = "instanceIds")]
        public IList<string> InstanceIds { get; set; }

    }
}
