// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.

using Microsoft.Azure.Management.Compute.Fluent.Models;
using System.Collections.Generic;

namespace Microsoft.Azure.Management.Compute.Fluent
{
    /// <summary>
    /// Scale set virtual machine sku types.
    /// </summary>
    public partial class VirtualMachineScaleSetSkuTypes
    {
        private static IDictionary<string, VirtualMachineScaleSetSkuTypes> ValuesByName;

        /** Static value Standard_A0 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA0 = new VirtualMachineScaleSetSkuTypes("Standard_A0", "Standard");

        /** Static value Standard_A1 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA1 = new VirtualMachineScaleSetSkuTypes("Standard_A1", "Standard");

        /** Static value Standard_A2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA2 = new VirtualMachineScaleSetSkuTypes("Standard_A2", "Standard");

        /** Static value Standard_A3 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA3 = new VirtualMachineScaleSetSkuTypes("Standard_A3", "Standard");

        /** Static value Standard_A4 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA4 = new VirtualMachineScaleSetSkuTypes("Standard_A4", "Standard");

        /** Static value Standard_A5 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA5 = new VirtualMachineScaleSetSkuTypes("Standard_A5", "Standard");

        /** Static value Standard_A6 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA6 = new VirtualMachineScaleSetSkuTypes("Standard_A6", "Standard");

        /** Static value Standard_A7 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA7 = new VirtualMachineScaleSetSkuTypes("Standard_A7", "Standard");

        /** Static value Standard_A8 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA8 = new VirtualMachineScaleSetSkuTypes("Standard_A8", "Standard");

        /** Static value Standard_A9 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA9 = new VirtualMachineScaleSetSkuTypes("Standard_A9", "Standard");

        /** Static value Standard_A10 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA10 = new VirtualMachineScaleSetSkuTypes("Standard_A10", "Standard");

        /** Static value Standard_A11 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardA11 = new VirtualMachineScaleSetSkuTypes("Standard_A11", "Standard");

        /** Static value Standard_D1 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD1 = new VirtualMachineScaleSetSkuTypes("Standard_D1", "Standard");

        /** Static value Standard_D2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD2 = new VirtualMachineScaleSetSkuTypes("Standard_D2", "Standard");

        /** Static value Standard_D3 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD3 = new VirtualMachineScaleSetSkuTypes("Standard_D3", "Standard");

        /** Static value Standard_D4 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD4 = new VirtualMachineScaleSetSkuTypes("Standard_D4", "Standard");

        /** Static value Standard_D11 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD11 = new VirtualMachineScaleSetSkuTypes("Standard_D11", "Standard");

        /** Static value Standard_D12 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD12 = new VirtualMachineScaleSetSkuTypes("Standard_D12", "Standard");

        /** Static value Standard_D13 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD13 = new VirtualMachineScaleSetSkuTypes("Standard_D13", "Standard");

        /** Static value Standard_D14 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD14 = new VirtualMachineScaleSetSkuTypes("Standard_D14", "Standard");

        /** Static value Standard_D1_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD1v2 = new VirtualMachineScaleSetSkuTypes("Standard_D1_v2", "Standard");

        /** Static value Standard_D2_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD2v2 = new VirtualMachineScaleSetSkuTypes("Standard_D2_v2", "Standard");

        /** Static value Standard_D3_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD3v2 = new VirtualMachineScaleSetSkuTypes("Standard_D3_v2", "Standard");

        /** Static value Standard_D4_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD4v2 = new VirtualMachineScaleSetSkuTypes("Standard_D4_v2", "Standard");

        /** Static value Standard_D5_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD5v2 = new VirtualMachineScaleSetSkuTypes("Standard_D5_v2", "Standard");

        /** Static value Standard_D11_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD11v2 = new VirtualMachineScaleSetSkuTypes("Standard_D11_v2", "Standard");

        /** Static value Standard_D12_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD12v2 = new VirtualMachineScaleSetSkuTypes("Standard_D12_v2", "Standard");

        /** Static value Standard_D13_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD13v2 = new VirtualMachineScaleSetSkuTypes("Standard_D13_v2", "Standard");

        /** Static value Standard_D14_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD14v2 = new VirtualMachineScaleSetSkuTypes("Standard_D14_v2", "Standard");

        /** Static value Standard_D15_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardD15v2 = new VirtualMachineScaleSetSkuTypes("Standard_D15_v2", "Standard");

        /** Static value Standard_DS1 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS1 = new VirtualMachineScaleSetSkuTypes("Standard_DS1", "Standard");

        /** Static value Standard_DS2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS2 = new VirtualMachineScaleSetSkuTypes("Standard_DS2", "Standard");

        /** Static value Standard_DS3 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS3 = new VirtualMachineScaleSetSkuTypes("Standard_DS3", "Standard");

        /** Static value Standard_DS4 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS4 = new VirtualMachineScaleSetSkuTypes("Standard_DS4", "Standard");

        /** Static value Standard_DS11 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS11 = new VirtualMachineScaleSetSkuTypes("Standard_DS11", "Standard");

        /** Static value Standard_DS12 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS12 = new VirtualMachineScaleSetSkuTypes("Standard_DS12", "Standard");

        /** Static value Standard_DS13 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS13 = new VirtualMachineScaleSetSkuTypes("Standard_DS13", "Standard");

        /** Static value Standard_DS14 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS14 = new VirtualMachineScaleSetSkuTypes("Standard_DS14", "Standard");

        /** Static value Standard_DS1_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS1v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS1_v2", "Standard");

        /** Static value Standard_DS2_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS2v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS2_v2", "Standard");

        /** Static value Standard_DS3_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS3v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS3_v2", "Standard");

        /** Static value Standard_DS4_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS4v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS4_v2", "Standard");

        /** Static value Standard_DS5_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS5v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS5_v2", "Standard");

        /** Static value Standard_DS11_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS11v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS11_v2", "Standard");

        /** Static value Standard_DS12_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS12v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS12_v2", "Standard");

        /** Static value Standard_DS13_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS13v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS13_v2", "Standard");

        /** Static value Standard_DS14_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS14v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS14_v2", "Standard");

        /** Static value Standard_DS15_v2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardDS15v2 = new VirtualMachineScaleSetSkuTypes("Standard_DS15_v2", "Standard");

        /** Static value STANDARD_F1S for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF1S = new VirtualMachineScaleSetSkuTypes("STANDARD_F1S", "Standard");

        /** Static value STANDARD_F2S for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF2S = new VirtualMachineScaleSetSkuTypes("STANDARD_F2S", "Standard");

        /** Static value STANDARD_F4S for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF4S = new VirtualMachineScaleSetSkuTypes("STANDARD_F4S", "Standard");

        /** Static value STANDARD_F8S for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF8S = new VirtualMachineScaleSetSkuTypes("STANDARD_F8S", "Standard");

        /** Static value STANDARD_F16S for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF16S = new VirtualMachineScaleSetSkuTypes("STANDARD_F16S", "Standard");

        /** Static value STANDARD_F1 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF1 = new VirtualMachineScaleSetSkuTypes("STANDARD_F1", "Standard");

        /** Static value STANDARD_F2 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF2 = new VirtualMachineScaleSetSkuTypes("STANDARD_F2", "Standard");

        /** Static value STANDARD_F4 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF4 = new VirtualMachineScaleSetSkuTypes("STANDARD_F4", "Standard");

        /** Static value STANDARD_F8 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF8 = new VirtualMachineScaleSetSkuTypes("STANDARD_F8", "Standard");

        /** Static value STANDARD_F16 for VirtualMachineScaleSetSkuTypes. */
        public static readonly VirtualMachineScaleSetSkuTypes StandardF16 = new VirtualMachineScaleSetSkuTypes("STANDARD_F16", "Standard");

        private Sku sku;
        private string value;
        /// <summary>
        /// Creates a custom value for VirtualMachineSizeTypes.
        /// </summary>
        /// <param name="skuName">skuName the sku name</param>
        /// <param name="skuTier">skuTier thr sku tier</param>
        public VirtualMachineScaleSetSkuTypes(string skuName, string skuTier) : this(new Sku { Name = skuName, Tier = skuTier })
        {
        }

        /// <summary>
        /// Creates a custom value for VirtualMachineSizeTypes.
        /// </summary>
        /// <param name="sku">sku the sku</param>
        public VirtualMachineScaleSetSkuTypes(Sku sku)
        {
            this.sku = CreateCopy(sku);
            value = this.sku.Name;
            if (this.sku.Tier != null)
            {
                value = value + "_" + this.sku.Tier;
            }
            if (ValuesByName == null)
            {
                ValuesByName = new Dictionary<string, VirtualMachineScaleSetSkuTypes>();
            }
            ValuesByName[value.ToLower()] = this;
        }

        /// <summary>
        /// Parses a SKU into a VMSS SKU type and creates a new VirtualMachineScaleSetSkuType instance if not found among the existing ones.
        /// </summary>
        /// <param name="sku">a VMSS SKU</param>
        public static VirtualMachineScaleSetSkuTypes FromSku(Sku sku)
        {
            if (sku == null)
            {
                return null;
            }

            string nameToLookFor = sku.Name;
            if (sku.Tier != null)
            {
                nameToLookFor += '_' + sku.Tier;
            }

            VirtualMachineScaleSetSkuTypes result;
            if (ValuesByName == null)
            {
                return new VirtualMachineScaleSetSkuTypes(sku);
            }
            else if (ValuesByName.TryGetValue(nameToLookFor.ToLower(), out result))
            {
                return result;
            }
            else
            {
                return new VirtualMachineScaleSetSkuTypes(sku);
            }
        }

        /// <summary>
        /// Parses into a VMSS SKU type and creates a new VMSS SKU type instance if not found among the existing ones.
        /// </summary>
        /// <param name="skuName">a SKU name</param>
        /// <param name="skuTier">a SKU tier</param>
        /// <returns>a VMSS SKU type</returns>
        public static VirtualMachineScaleSetSkuTypes FromSkuNameAndTier(string skuName, string skuTier)
        {
            return FromSku(new Sku()
            {
                Name = skuName,
                Tier = skuTier
            });
        }

        // Creates a copy of the given SKU
        private static Sku CreateCopy(Sku sku)
        {
            return new Sku()
            {
                Name = sku.Name,
                Tier = sku.Tier,
                Capacity = sku.Capacity
            };
        }

        /// <summary>
        /// Known virtuak machine scale set SKU types.
        /// </summary>
        public IEnumerable<VirtualMachineScaleSetSkuTypes> Values
        {
            get
            {
                return (ValuesByName != null) ? ValuesByName.Values : null;
            }
        }

        /// <returns>the sku</returns>
        public Sku Sku
        {
            get
            {
                return this.sku;
            }
        }


        public override string ToString()
        {
            return this.value;
        }

        public override int GetHashCode()
        {
            return this.value.GetHashCode();
        }

        public override bool Equals(object obj)
        {

            string value = this.ToString();
            if (!(obj is VirtualMachineScaleSetSkuTypes))
            {
                return false;
            }

            if (obj == this)
            {
                return true;
            }
            VirtualMachineScaleSetSkuTypes rhs = (VirtualMachineScaleSetSkuTypes)obj;
            if (value == null)
            {
                return rhs.value == null;
            }
            return value.Equals(rhs.value);
        }
    }
}