// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ContainerInstanceManagementClient.
    /// </summary>
    public static partial class ContainerInstanceManagementClientExtensions
    {
            /// <summary>
            /// Get the list of cached images.
            /// </summary>
            /// <remarks>
            /// Get the list of cached images on specific OS type for a subscription in a
            /// region.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='location'>
            /// The identifier for the physical azure location.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<CachedImagesListResultInner> ListCachedImagesAsync(this IContainerInstanceManagementClient operations, string location, CancellationToken cancellationToken = default(CancellationToken))
            {
            var _result = await operations.ListCachedImagesAsync(location, cancellationToken).ConfigureAwait(false);
            return _result.Body;
            }

        /// <summary>
        /// Get the list of capabilities of the location.
        /// </summary>
        /// <remarks>
        /// Get the list of CPU/memory/GPU capabilities of a region.
        /// </remarks>
        /// <param name='operations'>
        /// The operations group for this extension method.
        /// </param>
        /// <param name='location'>
        /// The identifier for the physical azure location.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        public static async Task<CapabilitiesListResultInner> ListCapabilitiesAsync(this IContainerInstanceManagementClient operations, string location, CancellationToken cancellationToken = default(CancellationToken))
        {
            return await operations.ListCapabilitiesAsync(location, cancellationToken).ConfigureAwait(false);
        }
    }
}
