// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for ContainerOperations.
    /// </summary>
    public static partial class ContainerOperationsExtensions
    {
            /// <summary>
            /// Get the logs for a specified container instance.
            /// </summary>
            /// <remarks>
            /// Get the logs for a specified container instance in a specified resource
            /// group and container group.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='containerGroupName'>
            /// The name of the container group.
            /// </param>
            /// <param name='containerName'>
            /// The name of the container instance.
            /// </param>
            /// <param name='tail'>
            /// The number of lines to show from the tail of the container instance log. If
            /// not provided, all available logs are shown up to 4mb.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<LogsInner> ListLogsAsync(this IContainerOperations operations, string resourceGroupName, string containerGroupName, string containerName, int? tail = default(int?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ListLogsWithHttpMessagesAsync(resourceGroupName, containerGroupName, containerName, tail, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Executes a command in a specific container instance.
            /// </summary>
            /// <remarks>
            /// Executes a command for a specific container instance in a specified
            /// resource group and container group.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='containerGroupName'>
            /// The name of the container group.
            /// </param>
            /// <param name='containerName'>
            /// The name of the container instance.
            /// </param>
            /// <param name='containerExecRequest'>
            /// The request for the exec command.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ContainerExecResponseInner> ExecuteCommandAsync(this IContainerOperations operations, string resourceGroupName, string containerGroupName, string containerName, ContainerExecRequestInner containerExecRequest, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.ExecuteCommandWithHttpMessagesAsync(resourceGroupName, containerGroupName, containerName, containerExecRequest, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
