// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The cached image and OS type.
    /// </summary>
    public partial class CachedImages
    {
        /// <summary>
        /// Initializes a new instance of the CachedImages class.
        /// </summary>
        public CachedImages()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CachedImages class.
        /// </summary>
        /// <param name="osType">The OS type of the cached image.</param>
        /// <param name="image">The cached image name.</param>
        /// <param name="id">The resource Id of the cached image.</param>
        public CachedImages(string osType, string image, string id = default(string))
        {
            Id = id;
            OsType = osType;
            Image = image;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the resource Id of the cached image.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the OS type of the cached image.
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; set; }

        /// <summary>
        /// Gets or sets the cached image name.
        /// </summary>
        [JsonProperty(PropertyName = "image")]
        public string Image { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (OsType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OsType");
            }
            if (Image == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Image");
            }
        }
    }
}
