// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The regional capabilities.
    /// </summary>
    public partial class Capabilities
    {
        /// <summary>
        /// Initializes a new instance of the Capabilities class.
        /// </summary>
        public Capabilities()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Capabilities class.
        /// </summary>
        /// <param name="resourceType">The resource type that this capability
        /// describes.</param>
        /// <param name="osType">The OS type that this capability
        /// describes.</param>
        /// <param name="location">The resource location.</param>
        /// <param name="ipAddressType">The ip address type that this
        /// capability describes.</param>
        /// <param name="gpu">The GPU sku that this capability
        /// describes.</param>
        /// <param name="capabilitiesProperty">The supported
        /// capabilities.</param>
        public Capabilities(string resourceType = default(string), string osType = default(string), string location = default(string), string ipAddressType = default(string), string gpu = default(string), CapabilitiesCapabilities capabilitiesProperty = default(CapabilitiesCapabilities))
        {
            ResourceType = resourceType;
            OsType = osType;
            Location = location;
            IpAddressType = ipAddressType;
            Gpu = gpu;
            CapabilitiesProperty = capabilitiesProperty;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the resource type that this capability describes.
        /// </summary>
        [JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; private set; }

        /// <summary>
        /// Gets the OS type that this capability describes.
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; private set; }

        /// <summary>
        /// Gets the resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets the ip address type that this capability describes.
        /// </summary>
        [JsonProperty(PropertyName = "ipAddressType")]
        public string IpAddressType { get; private set; }

        /// <summary>
        /// Gets the GPU sku that this capability describes.
        /// </summary>
        [JsonProperty(PropertyName = "gpu")]
        public string Gpu { get; private set; }

        /// <summary>
        /// Gets the supported capabilities.
        /// </summary>
        [JsonProperty(PropertyName = "capabilities")]
        public CapabilitiesCapabilities CapabilitiesProperty { get; private set; }

    }
}
