// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The supported capabilities.
    /// </summary>
    public partial class CapabilitiesCapabilities
    {
        /// <summary>
        /// Initializes a new instance of the CapabilitiesCapabilities class.
        /// </summary>
        public CapabilitiesCapabilities()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CapabilitiesCapabilities class.
        /// </summary>
        /// <param name="maxMemoryInGB">The maximum allowed memory request in
        /// GB.</param>
        /// <param name="maxCpu">The maximum allowed CPU request in
        /// cores.</param>
        /// <param name="maxGpuCount">The maximum allowed GPU count.</param>
        public CapabilitiesCapabilities(double? maxMemoryInGB = default(double?), double? maxCpu = default(double?), double? maxGpuCount = default(double?))
        {
            MaxMemoryInGB = maxMemoryInGB;
            MaxCpu = maxCpu;
            MaxGpuCount = maxGpuCount;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the maximum allowed memory request in GB.
        /// </summary>
        [JsonProperty(PropertyName = "maxMemoryInGB")]
        public double? MaxMemoryInGB { get; private set; }

        /// <summary>
        /// Gets the maximum allowed CPU request in cores.
        /// </summary>
        [JsonProperty(PropertyName = "maxCpu")]
        public double? MaxCpu { get; private set; }

        /// <summary>
        /// Gets the maximum allowed GPU count.
        /// </summary>
        [JsonProperty(PropertyName = "maxGpuCount")]
        public double? MaxGpuCount { get; private set; }

    }
}
