// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The container Http Get settings, for liveness or readiness probe
    /// </summary>
    public partial class ContainerHttpGet
    {
        /// <summary>
        /// Initializes a new instance of the ContainerHttpGet class.
        /// </summary>
        public ContainerHttpGet()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerHttpGet class.
        /// </summary>
        /// <param name="port">The port number to probe.</param>
        /// <param name="path">The path to probe.</param>
        /// <param name="scheme">The scheme. Possible values include: 'http',
        /// 'https'</param>
        public ContainerHttpGet(int port, string path = default(string), string scheme = default(string))
        {
            Path = path;
            Port = port;
            Scheme = scheme;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the path to probe.
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the port number to probe.
        /// </summary>
        [JsonProperty(PropertyName = "port")]
        public int Port { get; set; }

        /// <summary>
        /// Gets or sets the scheme. Possible values include: 'http', 'https'
        /// </summary>
        [JsonProperty(PropertyName = "scheme")]
        public string Scheme { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
