// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The instance view of the container instance. Only valid in response.
    /// </summary>
    public partial class ContainerPropertiesInstanceView
    {
        /// <summary>
        /// Initializes a new instance of the ContainerPropertiesInstanceView
        /// class.
        /// </summary>
        public ContainerPropertiesInstanceView()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerPropertiesInstanceView
        /// class.
        /// </summary>
        /// <param name="restartCount">The number of times that the container
        /// instance has been restarted.</param>
        /// <param name="currentState">Current container instance
        /// state.</param>
        /// <param name="previousState">Previous container instance
        /// state.</param>
        /// <param name="events">The events of the container instance.</param>
        public ContainerPropertiesInstanceView(int? restartCount = default(int?), ContainerState currentState = default(ContainerState), ContainerState previousState = default(ContainerState), IList<EventModel> events = default(IList<EventModel>))
        {
            RestartCount = restartCount;
            CurrentState = currentState;
            PreviousState = previousState;
            Events = events;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the number of times that the container instance has been
        /// restarted.
        /// </summary>
        [JsonProperty(PropertyName = "restartCount")]
        public int? RestartCount { get; private set; }

        /// <summary>
        /// Gets current container instance state.
        /// </summary>
        [JsonProperty(PropertyName = "currentState")]
        public ContainerState CurrentState { get; private set; }

        /// <summary>
        /// Gets previous container instance state.
        /// </summary>
        [JsonProperty(PropertyName = "previousState")]
        public ContainerState PreviousState { get; private set; }

        /// <summary>
        /// Gets the events of the container instance.
        /// </summary>
        [JsonProperty(PropertyName = "events")]
        public IList<EventModel> Events { get; private set; }

    }
}
