// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The container instance state.
    /// </summary>
    public partial class ContainerState
    {
        /// <summary>
        /// Initializes a new instance of the ContainerState class.
        /// </summary>
        public ContainerState()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ContainerState class.
        /// </summary>
        /// <param name="state">The state of the container instance.</param>
        /// <param name="startTime">The date-time when the container instance
        /// state started.</param>
        /// <param name="exitCode">The container instance exit codes correspond
        /// to those from the `docker run` command.</param>
        /// <param name="finishTime">The date-time when the container instance
        /// state finished.</param>
        /// <param name="detailStatus">The human-readable status of the
        /// container instance state.</param>
        public ContainerState(string state = default(string), System.DateTime? startTime = default(System.DateTime?), int? exitCode = default(int?), System.DateTime? finishTime = default(System.DateTime?), string detailStatus = default(string))
        {
            State = state;
            StartTime = startTime;
            ExitCode = exitCode;
            FinishTime = finishTime;
            DetailStatus = detailStatus;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the state of the container instance.
        /// </summary>
        [JsonProperty(PropertyName = "state")]
        public string State { get; set; }

        /// <summary>
        /// Gets or sets the date-time when the container instance state
        /// started.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets the container instance exit codes correspond to those
        /// from the `docker run` command.
        /// </summary>
        [JsonProperty(PropertyName = "exitCode")]
        public int? ExitCode { get; set; }

        /// <summary>
        /// Gets or sets the date-time when the container instance state
        /// finished.
        /// </summary>
        [JsonProperty(PropertyName = "finishTime")]
        public System.DateTime? FinishTime { get; set; }

        /// <summary>
        /// Gets or sets the human-readable status of the container instance
        /// state.
        /// </summary>
        [JsonProperty(PropertyName = "detailStatus")]
        public string DetailStatus { get; set; }

    }
}
