// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// DNS configuration for the container group.
    /// </summary>
    public partial class DnsConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the DnsConfiguration class.
        /// </summary>
        public DnsConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DnsConfiguration class.
        /// </summary>
        /// <param name="nameServers">The DNS servers for the container
        /// group.</param>
        /// <param name="searchDomains">The DNS search domains for hostname
        /// lookup in the container group.</param>
        /// <param name="options">The DNS options for the container
        /// group.</param>
        public DnsConfiguration(IList<string> nameServers, string searchDomains = default(string), string options = default(string))
        {
            NameServers = nameServers;
            SearchDomains = searchDomains;
            Options = options;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the DNS servers for the container group.
        /// </summary>
        [JsonProperty(PropertyName = "nameServers")]
        public IList<string> NameServers { get; set; }

        /// <summary>
        /// Gets or sets the DNS search domains for hostname lookup in the
        /// container group.
        /// </summary>
        [JsonProperty(PropertyName = "searchDomains")]
        public string SearchDomains { get; set; }

        /// <summary>
        /// Gets or sets the DNS options for the container group.
        /// </summary>
        [JsonProperty(PropertyName = "options")]
        public string Options { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (NameServers == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "NameServers");
            }
        }
    }
}
