// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a volume that is populated with the contents of a git
    /// repository
    /// </summary>
    public partial class GitRepoVolume
    {
        /// <summary>
        /// Initializes a new instance of the GitRepoVolume class.
        /// </summary>
        public GitRepoVolume()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GitRepoVolume class.
        /// </summary>
        /// <param name="repository">Repository URL</param>
        /// <param name="directory">Target directory name. Must not contain or
        /// start with '..'.  If '.' is supplied, the volume directory will be
        /// the git repository.  Otherwise, if specified, the volume will
        /// contain the git repository in the subdirectory with the given
        /// name.</param>
        /// <param name="revision">Commit hash for the specified
        /// revision.</param>
        public GitRepoVolume(string repository, string directory = default(string), string revision = default(string))
        {
            Directory = directory;
            Repository = repository;
            Revision = revision;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets target directory name. Must not contain or start with
        /// '..'.  If '.' is supplied, the volume directory will be the git
        /// repository.  Otherwise, if specified, the volume will contain the
        /// git repository in the subdirectory with the given name.
        /// </summary>
        [JsonProperty(PropertyName = "directory")]
        public string Directory { get; set; }

        /// <summary>
        /// Gets or sets repository URL
        /// </summary>
        [JsonProperty(PropertyName = "repository")]
        public string Repository { get; set; }

        /// <summary>
        /// Gets or sets commit hash for the specified revision.
        /// </summary>
        [JsonProperty(PropertyName = "revision")]
        public string Revision { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Repository == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Repository");
            }
        }
    }
}
