// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Image registry credential.
    /// </summary>
    public partial class ImageRegistryCredential
    {
        /// <summary>
        /// Initializes a new instance of the ImageRegistryCredential class.
        /// </summary>
        public ImageRegistryCredential()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImageRegistryCredential class.
        /// </summary>
        /// <param name="server">The Docker image registry server without a
        /// protocol such as "http" and "https".</param>
        /// <param name="username">The username for the private
        /// registry.</param>
        /// <param name="password">The password for the private
        /// registry.</param>
        public ImageRegistryCredential(string server, string username, string password = default(string))
        {
            Server = server;
            Username = username;
            Password = password;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the Docker image registry server without a protocol
        /// such as "http" and "https".
        /// </summary>
        [JsonProperty(PropertyName = "server")]
        public string Server { get; set; }

        /// <summary>
        /// Gets or sets the username for the private registry.
        /// </summary>
        [JsonProperty(PropertyName = "username")]
        public string Username { get; set; }

        /// <summary>
        /// Gets or sets the password for the private registry.
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Server == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Server");
            }
            if (Username == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Username");
            }
        }
    }
}
