// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The resource requirements.
    /// </summary>
    public partial class ResourceRequirements
    {
        /// <summary>
        /// Initializes a new instance of the ResourceRequirements class.
        /// </summary>
        public ResourceRequirements()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceRequirements class.
        /// </summary>
        /// <param name="requests">The resource requests of this container
        /// instance.</param>
        /// <param name="limits">The resource limits of this container
        /// instance.</param>
        public ResourceRequirements(ResourceRequests requests, ResourceLimits limits = default(ResourceLimits))
        {
            Requests = requests;
            Limits = limits;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the resource requests of this container instance.
        /// </summary>
        [JsonProperty(PropertyName = "requests")]
        public ResourceRequests Requests { get; set; }

        /// <summary>
        /// Gets or sets the resource limits of this container instance.
        /// </summary>
        [JsonProperty(PropertyName = "limits")]
        public ResourceLimits Limits { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Requests == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Requests");
            }
            if (Requests != null)
            {
                Requests.Validate();
            }
            if (Limits != null)
            {
                Limits.Validate();
            }
        }
    }
}
