// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of the volume.
    /// </summary>
    public partial class Volume
    {
        /// <summary>
        /// Initializes a new instance of the Volume class.
        /// </summary>
        public Volume()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Volume class.
        /// </summary>
        /// <param name="name">The name of the volume.</param>
        /// <param name="azureFile">The Azure File volume.</param>
        /// <param name="emptyDir">The empty directory volume.</param>
        /// <param name="secret">The secret volume.</param>
        /// <param name="gitRepo">The git repo volume.</param>
        public Volume(string name, AzureFileVolume azureFile = default(AzureFileVolume), object emptyDir = default(object), IDictionary<string, string> secret = default(IDictionary<string, string>), GitRepoVolume gitRepo = default(GitRepoVolume))
        {
            Name = name;
            AzureFile = azureFile;
            EmptyDir = emptyDir;
            Secret = secret;
            GitRepo = gitRepo;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the volume.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the Azure File volume.
        /// </summary>
        [JsonProperty(PropertyName = "azureFile")]
        public AzureFileVolume AzureFile { get; set; }

        /// <summary>
        /// Gets or sets the empty directory volume.
        /// </summary>
        [JsonProperty(PropertyName = "emptyDir")]
        public object EmptyDir { get; set; }

        /// <summary>
        /// Gets or sets the secret volume.
        /// </summary>
        [JsonProperty(PropertyName = "secret")]
        public IDictionary<string, string> Secret { get; set; }

        /// <summary>
        /// Gets or sets the git repo volume.
        /// </summary>
        [JsonProperty(PropertyName = "gitRepo")]
        public GitRepoVolume GitRepo { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (AzureFile != null)
            {
                AzureFile.Validate();
            }
            if (GitRepo != null)
            {
                GitRepo.Validate();
            }
        }
    }
}
