// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerInstance.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of the volume mount.
    /// </summary>
    public partial class VolumeMount
    {
        /// <summary>
        /// Initializes a new instance of the VolumeMount class.
        /// </summary>
        public VolumeMount()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VolumeMount class.
        /// </summary>
        /// <param name="name">The name of the volume mount.</param>
        /// <param name="mountPath">The path within the container where the
        /// volume should be mounted. Must not contain colon (:).</param>
        /// <param name="readOnlyProperty">The flag indicating whether the
        /// volume mount is read-only.</param>
        public VolumeMount(string name, string mountPath, bool? readOnlyProperty = default(bool?))
        {
            Name = name;
            MountPath = mountPath;
            ReadOnlyProperty = readOnlyProperty;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the volume mount.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the path within the container where the volume should
        /// be mounted. Must not contain colon (:).
        /// </summary>
        [JsonProperty(PropertyName = "mountPath")]
        public string MountPath { get; set; }

        /// <summary>
        /// Gets or sets the flag indicating whether the volume mount is
        /// read-only.
        /// </summary>
        [JsonProperty(PropertyName = "readOnly")]
        public bool? ReadOnlyProperty { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (MountPath == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MountPath");
            }
        }
    }
}
