// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties for updating encoded task step.
    /// </summary>
    [Newtonsoft.Json.JsonObject("EncodedTask")]
    public partial class EncodedTaskStepUpdateParameters : TaskStepUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the EncodedTaskStepUpdateParameters
        /// class.
        /// </summary>
        public EncodedTaskStepUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EncodedTaskStepUpdateParameters
        /// class.
        /// </summary>
        /// <param name="contextPath">The URL(absolute or relative) of the
        /// source context for the task step.</param>
        /// <param name="contextAccessToken">The token (git PAT or SAS token of
        /// storage account blob) associated with the context for a
        /// step.</param>
        /// <param name="encodedTaskContent">Base64 encoded value of the
        /// template/definition file content.</param>
        /// <param name="encodedValuesContent">Base64 encoded value of the
        /// parameters/values file content.</param>
        /// <param name="values">The collection of overridable values that can
        /// be passed when running a task.</param>
        public EncodedTaskStepUpdateParameters(string contextPath = default(string), string contextAccessToken = default(string), string encodedTaskContent = default(string), string encodedValuesContent = default(string), IList<SetValue> values = default(IList<SetValue>))
            : base(contextPath, contextAccessToken)
        {
            EncodedTaskContent = encodedTaskContent;
            EncodedValuesContent = encodedValuesContent;
            Values = values;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets base64 encoded value of the template/definition file
        /// content.
        /// </summary>
        [JsonProperty(PropertyName = "encodedTaskContent")]
        public string EncodedTaskContent { get; set; }

        /// <summary>
        /// Gets or sets base64 encoded value of the parameters/values file
        /// content.
        /// </summary>
        [JsonProperty(PropertyName = "encodedValuesContent")]
        public string EncodedValuesContent { get; set; }

        /// <summary>
        /// Gets or sets the collection of overridable values that can be
        /// passed when running a task.
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<SetValue> Values { get; set; }

    }
}
