// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The event for a webhook.
    /// </summary>
    public partial class EventModel : EventInfoInner
    {
        /// <summary>
        /// Initializes a new instance of the EventModel class.
        /// </summary>
        public EventModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventModel class.
        /// </summary>
        /// <param name="id">The event ID.</param>
        /// <param name="eventRequestMessage">The event request message sent to
        /// the service URI.</param>
        /// <param name="eventResponseMessage">The event response message
        /// received from the service URI.</param>
        public EventModel(string id = default(string), EventRequestMessage eventRequestMessage = default(EventRequestMessage), EventResponseMessage eventResponseMessage = default(EventResponseMessage))
            : base(id)
        {
            EventRequestMessage = eventRequestMessage;
            EventResponseMessage = eventResponseMessage;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the event request message sent to the service URI.
        /// </summary>
        [JsonProperty(PropertyName = "eventRequestMessage")]
        public EventRequestMessage EventRequestMessage { get; set; }

        /// <summary>
        /// Gets or sets the event response message received from the service
        /// URI.
        /// </summary>
        [JsonProperty(PropertyName = "eventResponseMessage")]
        public EventResponseMessage EventResponseMessage { get; set; }

    }
}
