// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The event request message sent to the service URI.
    /// </summary>
    public partial class EventRequestMessage
    {
        /// <summary>
        /// Initializes a new instance of the EventRequestMessage class.
        /// </summary>
        public EventRequestMessage()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EventRequestMessage class.
        /// </summary>
        /// <param name="content">The content of the event request
        /// message.</param>
        /// <param name="headers">The headers of the event request
        /// message.</param>
        /// <param name="method">The HTTP method used to send the event request
        /// message.</param>
        /// <param name="requestUri">The URI used to send the event request
        /// message.</param>
        /// <param name="version">The HTTP message version.</param>
        public EventRequestMessage(EventContent content = default(EventContent), IDictionary<string, string> headers = default(IDictionary<string, string>), string method = default(string), string requestUri = default(string), string version = default(string))
        {
            Content = content;
            Headers = headers;
            Method = method;
            RequestUri = requestUri;
            Version = version;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the content of the event request message.
        /// </summary>
        [JsonProperty(PropertyName = "content")]
        public EventContent Content { get; set; }

        /// <summary>
        /// Gets or sets the headers of the event request message.
        /// </summary>
        [JsonProperty(PropertyName = "headers")]
        public IDictionary<string, string> Headers { get; set; }

        /// <summary>
        /// Gets or sets the HTTP method used to send the event request
        /// message.
        /// </summary>
        [JsonProperty(PropertyName = "method")]
        public string Method { get; set; }

        /// <summary>
        /// Gets or sets the URI used to send the event request message.
        /// </summary>
        [JsonProperty(PropertyName = "requestUri")]
        public string RequestUri { get; set; }

        /// <summary>
        /// Gets or sets the HTTP message version.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
