// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of updating a task step.
    /// </summary>
    [Newtonsoft.Json.JsonObject("FileTask")]
    public partial class FileTaskStepUpdateParameters : TaskStepUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the FileTaskStepUpdateParameters
        /// class.
        /// </summary>
        public FileTaskStepUpdateParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FileTaskStepUpdateParameters
        /// class.
        /// </summary>
        /// <param name="contextPath">The URL(absolute or relative) of the
        /// source context for the task step.</param>
        /// <param name="contextAccessToken">The token (git PAT or SAS token of
        /// storage account blob) associated with the context for a
        /// step.</param>
        /// <param name="taskFilePath">The task template/definition file path
        /// relative to the source context.</param>
        /// <param name="valuesFilePath">The values/parameters file path
        /// relative to the source context.</param>
        /// <param name="values">The collection of overridable values that can
        /// be passed when running a task.</param>
        public FileTaskStepUpdateParameters(string contextPath = default(string), string contextAccessToken = default(string), string taskFilePath = default(string), string valuesFilePath = default(string), IList<SetValue> values = default(IList<SetValue>))
            : base(contextPath, contextAccessToken)
        {
            TaskFilePath = taskFilePath;
            ValuesFilePath = valuesFilePath;
            Values = values;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the task template/definition file path relative to the
        /// source context.
        /// </summary>
        [JsonProperty(PropertyName = "taskFilePath")]
        public string TaskFilePath { get; set; }

        /// <summary>
        /// Gets or sets the values/parameters file path relative to the source
        /// context.
        /// </summary>
        [JsonProperty(PropertyName = "valuesFilePath")]
        public string ValuesFilePath { get; set; }

        /// <summary>
        /// Gets or sets the collection of overridable values that can be
        /// passed when running a task.
        /// </summary>
        [JsonProperty(PropertyName = "values")]
        public IList<SetValue> Values { get; set; }

    }
}
