// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Properties for a registry image.
    /// </summary>
    public partial class ImageDescriptor
    {
        /// <summary>
        /// Initializes a new instance of the ImageDescriptor class.
        /// </summary>
        public ImageDescriptor()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImageDescriptor class.
        /// </summary>
        /// <param name="registry">The registry login server.</param>
        /// <param name="repository">The repository name.</param>
        /// <param name="tag">The tag name.</param>
        /// <param name="digest">The sha256-based digest of the image
        /// manifest.</param>
        public ImageDescriptor(string registry = default(string), string repository = default(string), string tag = default(string), string digest = default(string))
        {
            Registry = registry;
            Repository = repository;
            Tag = tag;
            Digest = digest;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the registry login server.
        /// </summary>
        [JsonProperty(PropertyName = "registry")]
        public string Registry { get; set; }

        /// <summary>
        /// Gets or sets the repository name.
        /// </summary>
        [JsonProperty(PropertyName = "repository")]
        public string Repository { get; set; }

        /// <summary>
        /// Gets or sets the tag name.
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or sets the sha256-based digest of the image manifest.
        /// </summary>
        [JsonProperty(PropertyName = "digest")]
        public string Digest { get; set; }

    }
}
