// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class ImportSourceCredentials
    {
        /// <summary>
        /// Initializes a new instance of the ImportSourceCredentials class.
        /// </summary>
        public ImportSourceCredentials()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImportSourceCredentials class.
        /// </summary>
        /// <param name="password">The password used to authenticate with the
        /// source registry.</param>
        /// <param name="username">The username to authenticate with the source
        /// registry.</param>
        public ImportSourceCredentials(string password, string username = default(string))
        {
            Username = username;
            Password = password;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the username to authenticate with the source registry.
        /// </summary>
        [JsonProperty(PropertyName = "username")]
        public string Username { get; set; }

        /// <summary>
        /// Gets or sets the password used to authenticate with the source
        /// registry.
        /// </summary>
        [JsonProperty(PropertyName = "password")]
        public string Password { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Password == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Password");
            }
        }
    }
}
