// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// An object that represents policies for a container registry.
    /// </summary>
    public partial class RegistryPoliciesInner
    {
        /// <summary>
        /// Initializes a new instance of the RegistryPoliciesInner class.
        /// </summary>
        public RegistryPoliciesInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegistryPoliciesInner class.
        /// </summary>
        /// <param name="quarantinePolicy">An object that represents quarantine
        /// policy for a container registry.</param>
        /// <param name="trustPolicy">An object that represents content trust
        /// policy for a container registry.</param>
        public RegistryPoliciesInner(QuarantinePolicyInner quarantinePolicy = default(QuarantinePolicyInner), TrustPolicyInner trustPolicy = default(TrustPolicyInner))
        {
            QuarantinePolicy = quarantinePolicy;
            TrustPolicy = trustPolicy;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets an object that represents quarantine policy for a
        /// container registry.
        /// </summary>
        [JsonProperty(PropertyName = "quarantinePolicy")]
        public QuarantinePolicyInner QuarantinePolicy { get; set; }

        /// <summary>
        /// Gets or sets an object that represents content trust policy for a
        /// container registry.
        /// </summary>
        [JsonProperty(PropertyName = "trustPolicy")]
        public TrustPolicyInner TrustPolicy { get; set; }

    }
}
