// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The quota usage for a container registry.
    /// </summary>
    public partial class RegistryUsage
    {
        /// <summary>
        /// Initializes a new instance of the RegistryUsage class.
        /// </summary>
        public RegistryUsage()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RegistryUsage class.
        /// </summary>
        /// <param name="name">The name of the usage.</param>
        /// <param name="limit">The limit of the usage.</param>
        /// <param name="currentValue">The current value of the usage.</param>
        /// <param name="unit">The unit of measurement. Possible values
        /// include: 'Count', 'Bytes'</param>
        public RegistryUsage(string name = default(string), long? limit = default(long?), long? currentValue = default(long?), string unit = default(string))
        {
            Name = name;
            Limit = limit;
            CurrentValue = currentValue;
            Unit = unit;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the usage.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the limit of the usage.
        /// </summary>
        [JsonProperty(PropertyName = "limit")]
        public long? Limit { get; set; }

        /// <summary>
        /// Gets or sets the current value of the usage.
        /// </summary>
        [JsonProperty(PropertyName = "currentValue")]
        public long? CurrentValue { get; set; }

        /// <summary>
        /// Gets or sets the unit of measurement. Possible values include:
        /// 'Count', 'Bytes'
        /// </summary>
        [JsonProperty(PropertyName = "unit")]
        public string Unit { get; set; }

    }
}
