// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Properties that are enabled for Odata querying on runs.
    /// </summary>
    public partial class RunFilterInner
    {
        /// <summary>
        /// Initializes a new instance of the RunFilterInner class.
        /// </summary>
        public RunFilterInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RunFilterInner class.
        /// </summary>
        /// <param name="runId">The unique identifier for the run.</param>
        /// <param name="runType">The type of run. Possible values include:
        /// 'QuickBuild', 'QuickRun', 'AutoBuild', 'AutoRun'</param>
        /// <param name="status">The current status of the run. Possible values
        /// include: 'Queued', 'Started', 'Running', 'Succeeded', 'Failed',
        /// 'Canceled', 'Error', 'Timeout'</param>
        /// <param name="createTime">The create time for a run.</param>
        /// <param name="finishTime">The time the run finished.</param>
        /// <param name="outputImageManifests">The list of comma-separated
        /// image manifests that were generated from the run. This is
        /// applicable if the run is of
        /// build type.</param>
        /// <param name="isArchiveEnabled">The value that indicates whether
        /// archiving is enabled or not.</param>
        /// <param name="taskName">The name of the task that the run
        /// corresponds to.</param>
        public RunFilterInner(string runId = default(string), string runType = default(string), string status = default(string), System.DateTime? createTime = default(System.DateTime?), System.DateTime? finishTime = default(System.DateTime?), string outputImageManifests = default(string), bool? isArchiveEnabled = default(bool?), string taskName = default(string))
        {
            RunId = runId;
            RunType = runType;
            Status = status;
            CreateTime = createTime;
            FinishTime = finishTime;
            OutputImageManifests = outputImageManifests;
            IsArchiveEnabled = isArchiveEnabled;
            TaskName = taskName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the unique identifier for the run.
        /// </summary>
        [JsonProperty(PropertyName = "runId")]
        public string RunId { get; set; }

        /// <summary>
        /// Gets or sets the type of run. Possible values include:
        /// 'QuickBuild', 'QuickRun', 'AutoBuild', 'AutoRun'
        /// </summary>
        [JsonProperty(PropertyName = "runType")]
        public string RunType { get; set; }

        /// <summary>
        /// Gets or sets the current status of the run. Possible values
        /// include: 'Queued', 'Started', 'Running', 'Succeeded', 'Failed',
        /// 'Canceled', 'Error', 'Timeout'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the create time for a run.
        /// </summary>
        [JsonProperty(PropertyName = "createTime")]
        public System.DateTime? CreateTime { get; set; }

        /// <summary>
        /// Gets or sets the time the run finished.
        /// </summary>
        [JsonProperty(PropertyName = "finishTime")]
        public System.DateTime? FinishTime { get; set; }

        /// <summary>
        /// Gets or sets the list of comma-separated image manifests that were
        /// generated from the run. This is applicable if the run is of
        /// build type.
        /// </summary>
        [JsonProperty(PropertyName = "outputImageManifests")]
        public string OutputImageManifests { get; set; }

        /// <summary>
        /// Gets or sets the value that indicates whether archiving is enabled
        /// or not.
        /// </summary>
        [JsonProperty(PropertyName = "isArchiveEnabled")]
        public bool? IsArchiveEnabled { get; set; }

        /// <summary>
        /// Gets or sets the name of the task that the run corresponds to.
        /// </summary>
        [JsonProperty(PropertyName = "taskName")]
        public string TaskName { get; set; }

    }
}
