// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The properties of a overridable value that can be passed to a task
    /// template.
    /// </summary>
    public partial class SetValue
    {
        /// <summary>
        /// Initializes a new instance of the SetValue class.
        /// </summary>
        public SetValue()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SetValue class.
        /// </summary>
        /// <param name="name">The name of the overridable value.</param>
        /// <param name="value">The overridable value.</param>
        /// <param name="isSecret">Flag to indicate whether the value
        /// represents a secret or not.</param>
        public SetValue(string name, string value, bool? isSecret = default(bool?))
        {
            Name = name;
            Value = value;
            IsSecret = isSecret;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the overridable value.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the overridable value.
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets flag to indicate whether the value represents a secret
        /// or not.
        /// </summary>
        [JsonProperty(PropertyName = "isSecret")]
        public bool? IsSecret { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (Value == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Value");
            }
        }
    }
}
