// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of a source based trigger.
    /// </summary>
    public partial class SourceTrigger
    {
        /// <summary>
        /// Initializes a new instance of the SourceTrigger class.
        /// </summary>
        public SourceTrigger()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SourceTrigger class.
        /// </summary>
        /// <param name="sourceRepository">The properties that describes the
        /// source(code) for the task.</param>
        /// <param name="sourceTriggerEvents">The source event corresponding to
        /// the trigger.</param>
        /// <param name="name">The name of the trigger.</param>
        /// <param name="status">The current status of trigger. Possible values
        /// include: 'Disabled', 'Enabled'</param>
        public SourceTrigger(SourceProperties sourceRepository, IList<string> sourceTriggerEvents, string name, string status = default(string))
        {
            SourceRepository = sourceRepository;
            SourceTriggerEvents = sourceTriggerEvents;
            Status = status;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the properties that describes the source(code) for the
        /// task.
        /// </summary>
        [JsonProperty(PropertyName = "sourceRepository")]
        public SourceProperties SourceRepository { get; set; }

        /// <summary>
        /// Gets or sets the source event corresponding to the trigger.
        /// </summary>
        [JsonProperty(PropertyName = "sourceTriggerEvents")]
        public IList<string> SourceTriggerEvents { get; set; }

        /// <summary>
        /// Gets or sets the current status of trigger. Possible values
        /// include: 'Disabled', 'Enabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the name of the trigger.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceRepository == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceRepository");
            }
            if (SourceTriggerEvents == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SourceTriggerEvents");
            }
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (SourceRepository != null)
            {
                SourceRepository.Validate();
            }
        }
    }
}
