// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of a trigger.
    /// </summary>
    public partial class TriggerProperties
    {
        /// <summary>
        /// Initializes a new instance of the TriggerProperties class.
        /// </summary>
        public TriggerProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TriggerProperties class.
        /// </summary>
        /// <param name="sourceTriggers">The collection of triggers based on
        /// source code repository.</param>
        /// <param name="baseImageTrigger">The trigger based on base image
        /// dependencies.</param>
        public TriggerProperties(IList<SourceTrigger> sourceTriggers = default(IList<SourceTrigger>), BaseImageTrigger baseImageTrigger = default(BaseImageTrigger))
        {
            SourceTriggers = sourceTriggers;
            BaseImageTrigger = baseImageTrigger;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the collection of triggers based on source code
        /// repository.
        /// </summary>
        [JsonProperty(PropertyName = "sourceTriggers")]
        public IList<SourceTrigger> SourceTriggers { get; set; }

        /// <summary>
        /// Gets or sets the trigger based on base image dependencies.
        /// </summary>
        [JsonProperty(PropertyName = "baseImageTrigger")]
        public BaseImageTrigger BaseImageTrigger { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (SourceTriggers != null)
            {
                foreach (var element in SourceTriggers)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
            if (BaseImageTrigger != null)
            {
                BaseImageTrigger.Validate();
            }
        }
    }
}
