// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The parameters for creating a webhook.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class WebhookCreateParametersInner
    {
        /// <summary>
        /// Initializes a new instance of the WebhookCreateParametersInner
        /// class.
        /// </summary>
        public WebhookCreateParametersInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WebhookCreateParametersInner
        /// class.
        /// </summary>
        /// <param name="location">The location of the webhook. This cannot be
        /// changed after the resource is created.</param>
        /// <param name="serviceUri">The service URI for the webhook to post
        /// notifications.</param>
        /// <param name="actions">The list of actions that trigger the webhook
        /// to post notifications.</param>
        /// <param name="tags">The tags for the webhook.</param>
        /// <param name="customHeaders">Custom headers that will be added to
        /// the webhook notifications.</param>
        /// <param name="status">The status of the webhook at the time the
        /// operation was called. Possible values include: 'enabled',
        /// 'disabled'</param>
        /// <param name="scope">The scope of repositories where the event can
        /// be triggered. For example, 'foo:*' means events for all tags under
        /// repository 'foo'. 'foo:bar' means events for 'foo:bar' only. 'foo'
        /// is equivalent to 'foo:latest'. Empty means all events.</param>
        public WebhookCreateParametersInner(string location, string serviceUri, IList<string> actions, IDictionary<string, string> tags = default(IDictionary<string, string>), IDictionary<string, string> customHeaders = default(IDictionary<string, string>), string status = default(string), string scope = default(string))
        {
            Tags = tags;
            Location = location;
            ServiceUri = serviceUri;
            CustomHeaders = customHeaders;
            Status = status;
            Scope = scope;
            Actions = actions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the tags for the webhook.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets the location of the webhook. This cannot be changed
        /// after the resource is created.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets the service URI for the webhook to post notifications.
        /// </summary>
        [JsonProperty(PropertyName = "properties.serviceUri")]
        public string ServiceUri { get; set; }

        /// <summary>
        /// Gets or sets custom headers that will be added to the webhook
        /// notifications.
        /// </summary>
        [JsonProperty(PropertyName = "properties.customHeaders")]
        public IDictionary<string, string> CustomHeaders { get; set; }

        /// <summary>
        /// Gets or sets the status of the webhook at the time the operation
        /// was called. Possible values include: 'enabled', 'disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the scope of repositories where the event can be
        /// triggered. For example, 'foo:*' means events for all tags under
        /// repository 'foo'. 'foo:bar' means events for 'foo:bar' only. 'foo'
        /// is equivalent to 'foo:latest'. Empty means all events.
        /// </summary>
        [JsonProperty(PropertyName = "properties.scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets the list of actions that trigger the webhook to post
        /// notifications.
        /// </summary>
        [JsonProperty(PropertyName = "properties.actions")]
        public IList<string> Actions { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
            if (ServiceUri == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServiceUri");
            }
            if (Actions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Actions");
            }
        }
    }
}
