// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerRegistry.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// An object that represents a webhook for a container registry.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class WebhookInner : Microsoft.Azure.Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the WebhookInner class.
        /// </summary>
        public WebhookInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the WebhookInner class.
        /// </summary>
        /// <param name="actions">The list of actions that trigger the webhook
        /// to post notifications.</param>
        /// <param name="status">The status of the webhook at the time the
        /// operation was called. Possible values include: 'enabled',
        /// 'disabled'</param>
        /// <param name="scope">The scope of repositories where the event can
        /// be triggered. For example, 'foo:*' means events for all tags under
        /// repository 'foo'. 'foo:bar' means events for 'foo:bar' only. 'foo'
        /// is equivalent to 'foo:latest'. Empty means all events.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// webhook at the time the operation was called. Possible values
        /// include: 'Creating', 'Updating', 'Deleting', 'Succeeded', 'Failed',
        /// 'Canceled'</param>
        public WebhookInner(IList<string> actions, string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string status = default(string), string scope = default(string), string provisioningState = default(string))
            : base(location, id, name, type, tags)
        {
            Status = status;
            Scope = scope;
            Actions = actions;
            ProvisioningState = provisioningState;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the status of the webhook at the time the operation
        /// was called. Possible values include: 'enabled', 'disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the scope of repositories where the event can be
        /// triggered. For example, 'foo:*' means events for all tags under
        /// repository 'foo'. 'foo:bar' means events for 'foo:bar' only. 'foo'
        /// is equivalent to 'foo:latest'. Empty means all events.
        /// </summary>
        [JsonProperty(PropertyName = "properties.scope")]
        public string Scope { get; set; }

        /// <summary>
        /// Gets or sets the list of actions that trigger the webhook to post
        /// notifications.
        /// </summary>
        [JsonProperty(PropertyName = "properties.actions")]
        public IList<string> Actions { get; set; }

        /// <summary>
        /// Gets the provisioning state of the webhook at the time the
        /// operation was called. Possible values include: 'Creating',
        /// 'Updating', 'Deleting', 'Succeeded', 'Failed', 'Canceled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Actions == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Actions");
            }
        }
    }
}
