// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Profile of the managed cluster load balancer
    /// </summary>
    public partial class ManagedClusterLoadBalancerProfile
    {
        /// <summary>
        /// Initializes a new instance of the ManagedClusterLoadBalancerProfile
        /// class.
        /// </summary>
        public ManagedClusterLoadBalancerProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedClusterLoadBalancerProfile
        /// class.
        /// </summary>
        /// <param name="managedOutboundIPs">Desired managed outbound IPs for
        /// the cluster load balancer.</param>
        /// <param name="outboundIPPrefixes">Desired outbound IP Prefix
        /// resources for the cluster load balancer.</param>
        /// <param name="outboundIPs">Desired outbound IP resources for the
        /// cluster load balancer.</param>
        /// <param name="effectiveOutboundIPs">The effective outbound IP
        /// resources of the cluster load balancer.</param>
        public ManagedClusterLoadBalancerProfile(ManagedClusterLoadBalancerProfileManagedOutboundIPs managedOutboundIPs = default(ManagedClusterLoadBalancerProfileManagedOutboundIPs), ManagedClusterLoadBalancerProfileOutboundIPPrefixes outboundIPPrefixes = default(ManagedClusterLoadBalancerProfileOutboundIPPrefixes), ManagedClusterLoadBalancerProfileOutboundIPs outboundIPs = default(ManagedClusterLoadBalancerProfileOutboundIPs), IList<ResourceReference> effectiveOutboundIPs = default(IList<ResourceReference>))
        {
            ManagedOutboundIPs = managedOutboundIPs;
            OutboundIPPrefixes = outboundIPPrefixes;
            OutboundIPs = outboundIPs;
            EffectiveOutboundIPs = effectiveOutboundIPs;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets desired managed outbound IPs for the cluster load
        /// balancer.
        /// </summary>
        [JsonProperty(PropertyName = "managedOutboundIPs")]
        public ManagedClusterLoadBalancerProfileManagedOutboundIPs ManagedOutboundIPs { get; set; }

        /// <summary>
        /// Gets or sets desired outbound IP Prefix resources for the cluster
        /// load balancer.
        /// </summary>
        [JsonProperty(PropertyName = "outboundIPPrefixes")]
        public ManagedClusterLoadBalancerProfileOutboundIPPrefixes OutboundIPPrefixes { get; set; }

        /// <summary>
        /// Gets or sets desired outbound IP resources for the cluster load
        /// balancer.
        /// </summary>
        [JsonProperty(PropertyName = "outboundIPs")]
        public ManagedClusterLoadBalancerProfileOutboundIPs OutboundIPs { get; set; }

        /// <summary>
        /// Gets or sets the effective outbound IP resources of the cluster
        /// load balancer.
        /// </summary>
        [JsonProperty(PropertyName = "effectiveOutboundIPs")]
        public IList<ResourceReference> EffectiveOutboundIPs { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ManagedOutboundIPs != null)
            {
                ManagedOutboundIPs.Validate();
            }
        }
    }
}
