// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents the OpenShift networking configuration
    /// </summary>
    public partial class NetworkProfile
    {
        /// <summary>
        /// Initializes a new instance of the NetworkProfile class.
        /// </summary>
        public NetworkProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the NetworkProfile class.
        /// </summary>
        /// <param name="vnetCidr">CIDR for the OpenShift Vnet.</param>
        /// <param name="peerVnetId">CIDR of the Vnet to peer.</param>
        /// <param name="vnetId">ID of the Vnet created for OSA
        /// cluster.</param>
        public NetworkProfile(string vnetCidr = default(string), string peerVnetId = default(string), string vnetId = default(string))
        {
            VnetCidr = vnetCidr;
            PeerVnetId = peerVnetId;
            VnetId = vnetId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets CIDR for the OpenShift Vnet.
        /// </summary>
        [JsonProperty(PropertyName = "vnetCidr")]
        public string VnetCidr { get; set; }

        /// <summary>
        /// Gets or sets CIDR of the Vnet to peer.
        /// </summary>
        [JsonProperty(PropertyName = "peerVnetId")]
        public string PeerVnetId { get; set; }

        /// <summary>
        /// Gets or sets ID of the Vnet created for OSA cluster.
        /// </summary>
        [JsonProperty(PropertyName = "vnetId")]
        public string VnetId { get; set; }

    }
}
