// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Defines the Identity provider for MS AAD.
    /// </summary>
    [Newtonsoft.Json.JsonObject("AADIdentityProvider")]
    public partial class OpenShiftManagedClusterAADIdentityProvider : OpenShiftManagedClusterBaseIdentityProvider
    {
        /// <summary>
        /// Initializes a new instance of the
        /// OpenShiftManagedClusterAADIdentityProvider class.
        /// </summary>
        public OpenShiftManagedClusterAADIdentityProvider()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// OpenShiftManagedClusterAADIdentityProvider class.
        /// </summary>
        /// <param name="clientId">The clientId password associated with the
        /// provider.</param>
        /// <param name="secret">The secret password associated with the
        /// provider.</param>
        /// <param name="tenantId">The tenantId associated with the
        /// provider.</param>
        /// <param name="customerAdminGroupId">The groupId to be granted
        /// cluster admin role.</param>
        public OpenShiftManagedClusterAADIdentityProvider(string clientId = default(string), string secret = default(string), string tenantId = default(string), string customerAdminGroupId = default(string))
        {
            ClientId = clientId;
            Secret = secret;
            TenantId = tenantId;
            CustomerAdminGroupId = customerAdminGroupId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the clientId password associated with the provider.
        /// </summary>
        [JsonProperty(PropertyName = "clientId")]
        public string ClientId { get; set; }

        /// <summary>
        /// Gets or sets the secret password associated with the provider.
        /// </summary>
        [JsonProperty(PropertyName = "secret")]
        public string Secret { get; set; }

        /// <summary>
        /// Gets or sets the tenantId associated with the provider.
        /// </summary>
        [JsonProperty(PropertyName = "tenantId")]
        public string TenantId { get; set; }

        /// <summary>
        /// Gets or sets the groupId to be granted cluster admin role.
        /// </summary>
        [JsonProperty(PropertyName = "customerAdminGroupId")]
        public string CustomerAdminGroupId { get; set; }

    }
}
