// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ContainerService.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents an OpenShift router
    /// </summary>
    public partial class OpenShiftRouterProfile
    {
        /// <summary>
        /// Initializes a new instance of the OpenShiftRouterProfile class.
        /// </summary>
        public OpenShiftRouterProfile()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OpenShiftRouterProfile class.
        /// </summary>
        /// <param name="name">Name of the router profile.</param>
        /// <param name="publicSubdomain">DNS subdomain for OpenShift
        /// router.</param>
        /// <param name="fqdn">Auto-allocated FQDN for the OpenShift
        /// router.</param>
        public OpenShiftRouterProfile(string name = default(string), string publicSubdomain = default(string), string fqdn = default(string))
        {
            Name = name;
            PublicSubdomain = publicSubdomain;
            Fqdn = fqdn;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the router profile.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets DNS subdomain for OpenShift router.
        /// </summary>
        [JsonProperty(PropertyName = "publicSubdomain")]
        public string PublicSubdomain { get; private set; }

        /// <summary>
        /// Gets auto-allocated FQDN for the OpenShift router.
        /// </summary>
        [JsonProperty(PropertyName = "fqdn")]
        public string Fqdn { get; private set; }

    }
}
