// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
namespace Microsoft.Azure.Management.ContainerService.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager.Fluent.Core;

    /// <summary>
    /// Defines values for Kubernetes versions.
    /// </summary>
    ///GENTHASH:Y29tLm1pY3Jvc29mdC5henVyZS5tYW5hZ2VtZW50LmNvbnRhaW5lcnNlcnZpY2UuS3ViZXJuZXRlc1ZlcnNpb24=
    public class KubernetesVersion :
        ExpandableStringEnum<Microsoft.Azure.Management.ContainerService.Fluent.Models.KubernetesVersion>
    {
        public static readonly KubernetesVersion KUBERNETES_1_5_8 = Parse("1.5.8");
        public static readonly KubernetesVersion KUBERNETES_1_6_6 = Parse("1.6.6");
        public static readonly KubernetesVersion KUBERNETES_1_6_9 = Parse("1.6.9");
        public static readonly KubernetesVersion KUBERNETES_1_6_11 = Parse("1.6.11");
        public static readonly KubernetesVersion KUBERNETES_1_6_12 = Parse("1.6.12");
        public static readonly KubernetesVersion KUBERNETES_1_6_13 = Parse("1.6.13");
        public static readonly KubernetesVersion KUBERNETES_1_7_7 = Parse("1.7.7");
        public static readonly KubernetesVersion KUBERNETES_1_7_9 = Parse("1.7.9");
        public static readonly KubernetesVersion KUBERNETES_1_7_10 = Parse("1.7.10");
        public static readonly KubernetesVersion KUBERNETES_1_7_12 = Parse("1.7.12");
        public static readonly KubernetesVersion KUBERNETES_1_8_0 = Parse("1.8.0");
        public static readonly KubernetesVersion KUBERNETES_1_8_1 = Parse("1.8.1");
        public static readonly KubernetesVersion KUBERNETES_1_8_2 = Parse("1.8.2");
        public static readonly KubernetesVersion KUBERNETES_1_8_4 = Parse("1.8.4");
        public static readonly KubernetesVersion KUBERNETES_1_8_6 = Parse("1.8.6");
        public static readonly KubernetesVersion KUBERNETES_1_8_7 = Parse("1.8.7");
        public static readonly KubernetesVersion KUBERNETES_1_8_10 = Parse("1.8.10");
        public static readonly KubernetesVersion KUBERNETES_1_8_11 = Parse("1.8.11");
        public static readonly KubernetesVersion KUBERNETES_1_9_2 = Parse("1.9.2");
        public static readonly KubernetesVersion KUBERNETES_1_9_6 = Parse("1.9.6");
        public static readonly KubernetesVersion KUBERNETES_1_9_9 = Parse("1.9.9");
    }
}