// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using Newtonsoft.Json;

    /// <summary>
    /// Azure Cosmos DB Database Service Resource Provider REST API
    /// </summary>
    public partial interface ICosmosDBManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Azure subscription ID.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The ID of the target subscription.
        /// </summary>
        string SubscriptionId1 { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default
        /// value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When
        /// set to true a unique x-ms-client-request-id value is generated and
        /// included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the IDatabaseAccountsOperations.
        /// </summary>
        IDatabaseAccountsOperations DatabaseAccounts { get; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        IOperations Operations { get; }

        /// <summary>
        /// Gets the IDatabaseOperations.
        /// </summary>
        IDatabaseOperations Database { get; }

        /// <summary>
        /// Gets the ICollectionOperations.
        /// </summary>
        ICollectionOperations Collection { get; }

        /// <summary>
        /// Gets the ICollectionRegionOperations.
        /// </summary>
        ICollectionRegionOperations CollectionRegion { get; }

        /// <summary>
        /// Gets the IDatabaseAccountRegionOperations.
        /// </summary>
        IDatabaseAccountRegionOperations DatabaseAccountRegion { get; }

        /// <summary>
        /// Gets the IPercentileSourceTargetOperations.
        /// </summary>
        IPercentileSourceTargetOperations PercentileSourceTarget { get; }

        /// <summary>
        /// Gets the IPercentileTargetOperations.
        /// </summary>
        IPercentileTargetOperations PercentileTarget { get; }

        /// <summary>
        /// Gets the IPercentileOperations.
        /// </summary>
        IPercentileOperations Percentile { get; }

        /// <summary>
        /// Gets the ICollectionPartitionRegionOperations.
        /// </summary>
        ICollectionPartitionRegionOperations CollectionPartitionRegion { get; }

        /// <summary>
        /// Gets the ICollectionPartitionOperations.
        /// </summary>
        ICollectionPartitionOperations CollectionPartition { get; }

        /// <summary>
        /// Gets the IPartitionKeyRangeIdOperations.
        /// </summary>
        IPartitionKeyRangeIdOperations PartitionKeyRangeId { get; }

        /// <summary>
        /// Gets the IPartitionKeyRangeIdRegionOperations.
        /// </summary>
        IPartitionKeyRangeIdRegionOperations PartitionKeyRangeIdRegion { get; }

        /// <summary>
        /// Gets the ISqlResourcesOperations.
        /// </summary>
        ISqlResourcesOperations SqlResources { get; }

        /// <summary>
        /// Gets the IMongoDBResourcesOperations.
        /// </summary>
        IMongoDBResourcesOperations MongoDBResources { get; }

        /// <summary>
        /// Gets the ITableResourcesOperations.
        /// </summary>
        ITableResourcesOperations TableResources { get; }

        /// <summary>
        /// Gets the ICassandraResourcesOperations.
        /// </summary>
        ICassandraResourcesOperations CassandraResources { get; }

        /// <summary>
        /// Gets the IGremlinResourcesOperations.
        /// </summary>
        IGremlinResourcesOperations GremlinResources { get; }

        /// <summary>
        /// Gets the IPrivateLinkResourcesOperations.
        /// </summary>
        IPrivateLinkResourcesOperations PrivateLinkResources { get; }

        /// <summary>
        /// Gets the IPrivateEndpointConnectionsOperations.
        /// </summary>
        IPrivateEndpointConnectionsOperations PrivateEndpointConnections { get; }

    }
}
