// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Cosmos DB Cassandra table schema
    /// </summary>
    public partial class CassandraSchema
    {
        /// <summary>
        /// Initializes a new instance of the CassandraSchema class.
        /// </summary>
        public CassandraSchema()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CassandraSchema class.
        /// </summary>
        /// <param name="columns">List of Cassandra table columns.</param>
        /// <param name="partitionKeys">List of partition key.</param>
        /// <param name="clusterKeys">List of cluster key.</param>
        public CassandraSchema(IList<Column> columns = default(IList<Column>), IList<CassandraPartitionKey> partitionKeys = default(IList<CassandraPartitionKey>), IList<ClusterKey> clusterKeys = default(IList<ClusterKey>))
        {
            Columns = columns;
            PartitionKeys = partitionKeys;
            ClusterKeys = clusterKeys;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of Cassandra table columns.
        /// </summary>
        [JsonProperty(PropertyName = "columns")]
        public IList<Column> Columns { get; set; }

        /// <summary>
        /// Gets or sets list of partition key.
        /// </summary>
        [JsonProperty(PropertyName = "partitionKeys")]
        public IList<CassandraPartitionKey> PartitionKeys { get; set; }

        /// <summary>
        /// Gets or sets list of cluster key.
        /// </summary>
        [JsonProperty(PropertyName = "clusterKeys")]
        public IList<ClusterKey> ClusterKeys { get; set; }

    }
}
