// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Cosmos DB Cassandra table resource object
    /// </summary>
    public partial class CassandraTableResource
    {
        /// <summary>
        /// Initializes a new instance of the CassandraTableResource class.
        /// </summary>
        public CassandraTableResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CassandraTableResource class.
        /// </summary>
        /// <param name="id">Name of the Cosmos DB Cassandra table</param>
        /// <param name="defaultTtl">Time to live of the Cosmos DB Cassandra
        /// table</param>
        /// <param name="schema">Schema of the Cosmos DB Cassandra
        /// table</param>
        public CassandraTableResource(string id, int? defaultTtl = default(int?), CassandraSchema schema = default(CassandraSchema))
        {
            Id = id;
            DefaultTtl = defaultTtl;
            Schema = schema;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the Cosmos DB Cassandra table
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets time to live of the Cosmos DB Cassandra table
        /// </summary>
        [JsonProperty(PropertyName = "defaultTtl")]
        public int? DefaultTtl { get; set; }

        /// <summary>
        /// Gets or sets schema of the Cosmos DB Cassandra table
        /// </summary>
        [JsonProperty(PropertyName = "schema")]
        public CassandraSchema Schema { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
        }
    }
}
