// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    public partial class CompositePath
    {
        /// <summary>
        /// Initializes a new instance of the CompositePath class.
        /// </summary>
        public CompositePath()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CompositePath class.
        /// </summary>
        /// <param name="path">The path for which the indexing behavior applies
        /// to. Index paths typically start with root and end with wildcard
        /// (/path/*)</param>
        /// <param name="order">Sort order for composite paths. Possible values
        /// include: 'Ascending', 'Descending'</param>
        public CompositePath(string path = default(string), CompositePathSortOrder order = default(CompositePathSortOrder))
        {
            Path = path;
            Order = order;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the path for which the indexing behavior applies to.
        /// Index paths typically start with root and end with wildcard
        /// (/path/*)
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets sort order for composite paths. Possible values
        /// include: 'Ascending', 'Descending'
        /// </summary>
        [JsonProperty(PropertyName = "order")]
        public CompositePathSortOrder Order { get; set; }

    }
}
