// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Parameters to regenerate the keys within the database account.
    /// </summary>
    public partial class DatabaseAccountRegenerateKeyParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// DatabaseAccountRegenerateKeyParameters class.
        /// </summary>
        public DatabaseAccountRegenerateKeyParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// DatabaseAccountRegenerateKeyParameters class.
        /// </summary>
        /// <param name="keyKind">The access key to regenerate. Possible values
        /// include: 'primary', 'secondary', 'primaryReadonly',
        /// 'secondaryReadonly'</param>
        public DatabaseAccountRegenerateKeyParameters(KeyKind keyKind)
        {
            KeyKind = keyKind;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the access key to regenerate. Possible values include:
        /// 'primary', 'secondary', 'primaryReadonly', 'secondaryReadonly'
        /// </summary>
        [JsonProperty(PropertyName = "keyKind")]
        public KeyKind KeyKind { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (KeyKind == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "KeyKind");
            }
        }
    }
}
