// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The list of new failover policies for the failover priority change.
    /// </summary>
    public partial class FailoverPolicies
    {
        /// <summary>
        /// Initializes a new instance of the FailoverPolicies class.
        /// </summary>
        public FailoverPolicies()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FailoverPolicies class.
        /// </summary>
        /// <param name="failoverPoliciesProperty">List of failover
        /// policies.</param>
        public FailoverPolicies(IList<FailoverPolicy> failoverPoliciesProperty)
        {
            FailoverPoliciesProperty = failoverPoliciesProperty;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of failover policies.
        /// </summary>
        [JsonProperty(PropertyName = "failoverPolicies")]
        public IList<FailoverPolicy> FailoverPoliciesProperty { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FailoverPoliciesProperty == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FailoverPoliciesProperty");
            }
            if (FailoverPoliciesProperty != null)
            {
                foreach (var element in FailoverPoliciesProperty)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
