// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Cosmos DB Gremlin graph resource object
    /// </summary>
    public partial class GremlinGraphResource
    {
        /// <summary>
        /// Initializes a new instance of the GremlinGraphResource class.
        /// </summary>
        public GremlinGraphResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GremlinGraphResource class.
        /// </summary>
        /// <param name="id">Name of the Cosmos DB Gremlin graph</param>
        /// <param name="indexingPolicy">The configuration of the indexing
        /// policy. By default, the indexing is automatic for all document
        /// paths within the graph</param>
        /// <param name="partitionKey">The configuration of the partition key
        /// to be used for partitioning data into multiple partitions</param>
        /// <param name="defaultTtl">Default time to live</param>
        /// <param name="uniqueKeyPolicy">The unique key policy configuration
        /// for specifying uniqueness constraints on documents in the
        /// collection in the Azure Cosmos DB service.</param>
        /// <param name="conflictResolutionPolicy">The conflict resolution
        /// policy for the graph.</param>
        public GremlinGraphResource(string id, IndexingPolicy indexingPolicy = default(IndexingPolicy), ContainerPartitionKey partitionKey = default(ContainerPartitionKey), int? defaultTtl = default(int?), UniqueKeyPolicy uniqueKeyPolicy = default(UniqueKeyPolicy), ConflictResolutionPolicy conflictResolutionPolicy = default(ConflictResolutionPolicy))
        {
            Id = id;
            IndexingPolicy = indexingPolicy;
            PartitionKey = partitionKey;
            DefaultTtl = defaultTtl;
            UniqueKeyPolicy = uniqueKeyPolicy;
            ConflictResolutionPolicy = conflictResolutionPolicy;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the Cosmos DB Gremlin graph
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the configuration of the indexing policy. By default,
        /// the indexing is automatic for all document paths within the graph
        /// </summary>
        [JsonProperty(PropertyName = "indexingPolicy")]
        public IndexingPolicy IndexingPolicy { get; set; }

        /// <summary>
        /// Gets or sets the configuration of the partition key to be used for
        /// partitioning data into multiple partitions
        /// </summary>
        [JsonProperty(PropertyName = "partitionKey")]
        public ContainerPartitionKey PartitionKey { get; set; }

        /// <summary>
        /// Gets or sets default time to live
        /// </summary>
        [JsonProperty(PropertyName = "defaultTtl")]
        public int? DefaultTtl { get; set; }

        /// <summary>
        /// Gets or sets the unique key policy configuration for specifying
        /// uniqueness constraints on documents in the collection in the Azure
        /// Cosmos DB service.
        /// </summary>
        [JsonProperty(PropertyName = "uniqueKeyPolicy")]
        public UniqueKeyPolicy UniqueKeyPolicy { get; set; }

        /// <summary>
        /// Gets or sets the conflict resolution policy for the graph.
        /// </summary>
        [JsonProperty(PropertyName = "conflictResolutionPolicy")]
        public ConflictResolutionPolicy ConflictResolutionPolicy { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Id == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Id");
            }
            if (PartitionKey != null)
            {
                PartitionKey.Validate();
            }
        }
    }
}
