// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Connection State of the Private Endpoint Connection.
    /// </summary>
    public partial class PrivateLinkServiceConnectionStateProperty
    {
        /// <summary>
        /// Initializes a new instance of the
        /// PrivateLinkServiceConnectionStateProperty class.
        /// </summary>
        public PrivateLinkServiceConnectionStateProperty()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// PrivateLinkServiceConnectionStateProperty class.
        /// </summary>
        /// <param name="status">The private link service connection
        /// status.</param>
        /// <param name="description">The private link service connection
        /// description.</param>
        /// <param name="actionsRequired">Any action that is required beyond
        /// basic workflow (approve/ reject/ disconnect)</param>
        public PrivateLinkServiceConnectionStateProperty(string status = default(string), string description = default(string), string actionsRequired = default(string))
        {
            Status = status;
            Description = description;
            ActionsRequired = actionsRequired;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the private link service connection status.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or sets the private link service connection description.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets any action that is required beyond basic workflow (approve/
        /// reject/ disconnect)
        /// </summary>
        [JsonProperty(PropertyName = "actionsRequired")]
        public string ActionsRequired { get; private set; }

    }
}
