// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Cosmos DB resource throughput policy
    /// </summary>
    public partial class ThroughputPolicyResource
    {
        /// <summary>
        /// Initializes a new instance of the ThroughputPolicyResource class.
        /// </summary>
        public ThroughputPolicyResource()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ThroughputPolicyResource class.
        /// </summary>
        /// <param name="isEnabled">Determines whether the ThroughputPolicy is
        /// active or not</param>
        /// <param name="incrementPercent">Represents the percentage by which
        /// throughput can increase every time throughput policy kicks
        /// in.</param>
        public ThroughputPolicyResource(bool? isEnabled = default(bool?), int? incrementPercent = default(int?))
        {
            IsEnabled = isEnabled;
            IncrementPercent = incrementPercent;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets determines whether the ThroughputPolicy is active or
        /// not
        /// </summary>
        [JsonProperty(PropertyName = "isEnabled")]
        public bool? IsEnabled { get; set; }

        /// <summary>
        /// Gets or sets represents the percentage by which throughput can
        /// increase every time throughput policy kicks in.
        /// </summary>
        [JsonProperty(PropertyName = "incrementPercent")]
        public int? IncrementPercent { get; set; }

    }
}
