// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.CosmosDB.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The unique key policy configuration for specifying uniqueness
    /// constraints on documents in the collection in the Azure Cosmos DB
    /// service.
    /// </summary>
    public partial class UniqueKeyPolicy
    {
        /// <summary>
        /// Initializes a new instance of the UniqueKeyPolicy class.
        /// </summary>
        public UniqueKeyPolicy()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the UniqueKeyPolicy class.
        /// </summary>
        /// <param name="uniqueKeys">List of unique keys on that enforces
        /// uniqueness constraint on documents in the collection in the Azure
        /// Cosmos DB service.</param>
        public UniqueKeyPolicy(IList<UniqueKey> uniqueKeys = default(IList<UniqueKey>))
        {
            UniqueKeys = uniqueKeys;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of unique keys on that enforces uniqueness
        /// constraint on documents in the collection in the Azure Cosmos DB
        /// service.
        /// </summary>
        [JsonProperty(PropertyName = "uniqueKeys")]
        public IList<UniqueKey> UniqueKeys { get; set; }

    }
}
