// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Dns.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A CAA record.
    /// </summary>
    public partial class CaaRecord
    {
        /// <summary>
        /// Initializes a new instance of the CaaRecord class.
        /// </summary>
        public CaaRecord()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CaaRecord class.
        /// </summary>
        /// <param name="flags">The flags for this CAA record as an integer
        /// between 0 and 255.</param>
        /// <param name="tag">The tag for this CAA record.</param>
        /// <param name="value">The value for this CAA record.</param>
        public CaaRecord(int? flags = default(int?), string tag = default(string), string value = default(string))
        {
            Flags = flags;
            Tag = tag;
            Value = value;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the flags for this CAA record as an integer between 0
        /// and 255.
        /// </summary>
        [JsonProperty(PropertyName = "flags")]
        public int? Flags { get; set; }

        /// <summary>
        /// Gets or sets the tag for this CAA record.
        /// </summary>
        [JsonProperty(PropertyName = "tag")]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or sets the value for this CAA record.
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

    }
}
