// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.EventHub.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Single Namespace item in List or Get Operation
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class EHNamespaceInner : TrackedResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the EHNamespaceInner class.
        /// </summary>
        public EHNamespaceInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EHNamespaceInner class.
        /// </summary>
        /// <param name="location">Resource location</param>
        /// <param name="tags">Resource tags</param>
        /// <param name="sku">Properties of sku resource</param>
        /// <param name="provisioningState">Provisioning state of the
        /// Namespace.</param>
        /// <param name="createdAt">The time the Namespace was created.</param>
        /// <param name="updatedAt">The time the Namespace was updated.</param>
        /// <param name="serviceBusEndpoint">Endpoint you can use to perform
        /// Service Bus operations.</param>
        /// <param name="metricId">Identifier for Azure Insights
        /// metrics.</param>
        /// <param name="isAutoInflateEnabled">Value that indicates whether
        /// AutoInflate is enabled for eventhub namespace.</param>
        /// <param name="maximumThroughputUnits">Upper limit of throughput
        /// units when AutoInflate is enabled, value should be within 0 to 20
        /// throughput units. ( '0' if AutoInflateEnabled = true)</param>
        /// <param name="kafkaEnabled">Value that indicates whether Kafka is
        /// enabled for eventhub namespace.</param>
        public EHNamespaceInner(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), Sku sku = default(Sku), string provisioningState = default(string), System.DateTime? createdAt = default(System.DateTime?), System.DateTime? updatedAt = default(System.DateTime?), string serviceBusEndpoint = default(string), string metricId = default(string), bool? isAutoInflateEnabled = default(bool?), int? maximumThroughputUnits = default(int?), bool? kafkaEnabled = default(bool?))
            : base(id, name, type, location, tags)
        {
            Sku = sku;
            ProvisioningState = provisioningState;
            CreatedAt = createdAt;
            UpdatedAt = updatedAt;
            ServiceBusEndpoint = serviceBusEndpoint;
            MetricId = metricId;
            IsAutoInflateEnabled = isAutoInflateEnabled;
            MaximumThroughputUnits = maximumThroughputUnits;
            KafkaEnabled = kafkaEnabled;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets properties of sku resource
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public Sku Sku { get; set; }

        /// <summary>
        /// Gets provisioning state of the Namespace.
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; private set; }

        /// <summary>
        /// Gets the time the Namespace was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdAt")]
        public System.DateTime? CreatedAt { get; private set; }

        /// <summary>
        /// Gets the time the Namespace was updated.
        /// </summary>
        [JsonProperty(PropertyName = "properties.updatedAt")]
        public System.DateTime? UpdatedAt { get; private set; }

        /// <summary>
        /// Gets endpoint you can use to perform Service Bus operations.
        /// </summary>
        [JsonProperty(PropertyName = "properties.serviceBusEndpoint")]
        public string ServiceBusEndpoint { get; private set; }

        /// <summary>
        /// Gets identifier for Azure Insights metrics.
        /// </summary>
        [JsonProperty(PropertyName = "properties.metricId")]
        public string MetricId { get; private set; }

        /// <summary>
        /// Gets or sets value that indicates whether AutoInflate is enabled
        /// for eventhub namespace.
        /// </summary>
        [JsonProperty(PropertyName = "properties.isAutoInflateEnabled")]
        public bool? IsAutoInflateEnabled { get; set; }

        /// <summary>
        /// Gets or sets upper limit of throughput units when AutoInflate is
        /// enabled, value should be within 0 to 20 throughput units. ( '0' if
        /// AutoInflateEnabled = true)
        /// </summary>
        [JsonProperty(PropertyName = "properties.maximumThroughputUnits")]
        public int? MaximumThroughputUnits { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether Kafka is enabled for
        /// eventhub namespace.
        /// </summary>
        [JsonProperty(PropertyName = "properties.kafkaEnabled")]
        public bool? KafkaEnabled { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Sku != null)
            {
                Sku.Validate();
            }
            if (MaximumThroughputUnits > 20)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaximumThroughputUnits", 20);
            }
            if (MaximumThroughputUnits < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaximumThroughputUnits", 0);
            }
        }
    }
}
