// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.EventHub.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Description of VirtualNetworkRules - NetworkRules resource.
    /// </summary>
    public partial class NWRuleSetVirtualNetworkRules
    {
        /// <summary>
        /// Initializes a new instance of the NWRuleSetVirtualNetworkRules
        /// class.
        /// </summary>
        public NWRuleSetVirtualNetworkRules()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the NWRuleSetVirtualNetworkRules
        /// class.
        /// </summary>
        /// <param name="subnet">Subnet properties</param>
        /// <param name="ignoreMissingVnetServiceEndpoint">Value that indicates
        /// whether to ignore missing VNet Service Endpoint</param>
        public NWRuleSetVirtualNetworkRules(Subnet subnet = default(Subnet), bool? ignoreMissingVnetServiceEndpoint = default(bool?))
        {
            Subnet = subnet;
            IgnoreMissingVnetServiceEndpoint = ignoreMissingVnetServiceEndpoint;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets subnet properties
        /// </summary>
        [JsonProperty(PropertyName = "subnet")]
        public Subnet Subnet { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether to ignore missing VNet
        /// Service Endpoint
        /// </summary>
        [JsonProperty(PropertyName = "ignoreMissingVnetServiceEndpoint")]
        public bool? IgnoreMissingVnetServiceEndpoint { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Subnet != null)
            {
                Subnet.Validate();
            }
        }
    }
}
