// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Azure.Management.ResourceManager.Fluent.Core;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Models;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The Graph RBAC Management Client
    /// </summary>
    public partial class GraphRbacManagementClient : Management.ResourceManager.Fluent.Core.FluentServiceClientBase<GraphRbacManagementClient>, IGraphRbacManagementClient, IAzureClient
    {
        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        public JsonSerializerSettings SerializationSettings { get; private set; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        public JsonSerializerSettings DeserializationSettings { get; private set; }

        /// <summary>
        /// Client API version.
        /// </summary>
        public string ApiVersion { get; private set; }

        /// <summary>
        /// The tenant ID.
        /// </summary>
        public string TenantID { get; set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        public string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default value is
        /// 30.
        /// </summary>
        public int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When set to
        /// true a unique x-ms-client-request-id value is generated and included in
        /// each request. Default is true.
        /// </summary>
        public bool? GenerateClientRequestId { get; set; }

        /// <summary>
        /// Gets the ISignedInUserOperations.
        /// </summary>
        public virtual ISignedInUserOperations SignedInUser { get; private set; }

        /// <summary>
        /// Gets the IApplicationsOperations.
        /// </summary>
        public virtual IApplicationsOperations Applications { get; private set; }

        /// <summary>
        /// Gets the IDeletedApplicationsOperations.
        /// </summary>
        public virtual IDeletedApplicationsOperations DeletedApplications { get; private set; }

        /// <summary>
        /// Gets the IGroupsOperations.
        /// </summary>
        public virtual IGroupsOperations Groups { get; private set; }

        /// <summary>
        /// Gets the IServicePrincipalsOperations.
        /// </summary>
        public virtual IServicePrincipalsOperations ServicePrincipals { get; private set; }

        /// <summary>
        /// Gets the IUsersOperations.
        /// </summary>
        public virtual IUsersOperations Users { get; private set; }

        /// <summary>
        /// Gets the IObjectsOperations.
        /// </summary>
        public virtual IObjectsOperations Objects { get; private set; }

        /// <summary>
        /// Gets the IDomainsOperations.
        /// </summary>
        public virtual IDomainsOperations Domains { get; private set; }

        /// <summary>
        /// Gets the IOAuth2PermissionGrantOperations.
        /// </summary>
        public virtual IOAuth2PermissionGrantOperations OAuth2PermissionGrant { get; private set; }

        /// <summary>
        /// Initializes a new instance of the GraphRbacManagementClient class.
        /// </summary>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public GraphRbacManagementClient(RestClient restClient) : base(restClient)
        {
        }

        /// <summary>
        /// Initializes a new instance of the GraphRbacManagementClient class.
        /// </summary>
        /// <param name='baseUri'>
        /// Optional. The base URI of the service.
        /// </param>
        /// <param name="restClient">
        /// RestClient to be used
        /// </param>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public GraphRbacManagementClient(string baseUri, RestClient restClient) : base(baseUri, restClient)
        {
        }

        /// <summary>
        /// An optional partial-method to perform custom initialization.
        /// </summary>
        partial void CustomInitialize();
        /// <summary>
        /// Initializes client properties.
        /// </summary>
        protected override void Initialize()
        {
            SignedInUser = new SignedInUserOperations(this);
            Applications = new ApplicationsOperations(this);
            DeletedApplications = new DeletedApplicationsOperations(this);
            Groups = new GroupsOperations(this);
            ServicePrincipals = new ServicePrincipalsOperations(this);
            Users = new UsersOperations(this);
            Objects = new ObjectsOperations(this);
            Domains = new DomainsOperations(this);
            OAuth2PermissionGrant = new OAuth2PermissionGrantOperations(this);
            this.BaseUri = new System.Uri("https://graph.windows.net");
            ApiVersion = "1.6";
            AcceptLanguage = "en-US";
            LongRunningOperationRetryTimeout = 30;
            GenerateClientRequestId = true;
            SerializationSettings = new JsonSerializerSettings
            {
                Formatting = Newtonsoft.Json.Formatting.Indented,
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            SerializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings = new JsonSerializerSettings
            {
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            SerializationSettings.Converters.Add(new PolymorphicSerializeJsonConverter<DirectoryObject>("objectType"));
            DeserializationSettings.Converters.Add(new PolymorphicDeserializeJsonConverter<DirectoryObject>("objectType"));
            CustomInitialize();
            DeserializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings.Converters.Add(new CloudErrorJsonConverter());
        }
    }
}
