// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Deny Assignments filter
    /// </summary>
    public partial class DenyAssignmentFilter
    {
        /// <summary>
        /// Initializes a new instance of the DenyAssignmentFilter class.
        /// </summary>
        public DenyAssignmentFilter()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DenyAssignmentFilter class.
        /// </summary>
        /// <param name="denyAssignmentName">Return deny assignment with
        /// specified name.</param>
        /// <param name="principalId">Return all deny assignments where the
        /// specified principal is listed in the principals list of deny
        /// assignments.</param>
        /// <param name="gdprExportPrincipalId">Return all deny assignments
        /// where the specified principal is listed either in the principals
        /// list or exclude principals list of deny assignments.</param>
        public DenyAssignmentFilter(string denyAssignmentName = default(string), string principalId = default(string), string gdprExportPrincipalId = default(string))
        {
            DenyAssignmentName = denyAssignmentName;
            PrincipalId = principalId;
            GdprExportPrincipalId = gdprExportPrincipalId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets return deny assignment with specified name.
        /// </summary>
        [JsonProperty(PropertyName = "denyAssignmentName")]
        public string DenyAssignmentName { get; set; }

        /// <summary>
        /// Gets or sets return all deny assignments where the specified
        /// principal is listed in the principals list of deny assignments.
        /// </summary>
        [JsonProperty(PropertyName = "principalId")]
        public string PrincipalId { get; set; }

        /// <summary>
        /// Gets or sets return all deny assignments where the specified
        /// principal is listed either in the principals list or exclude
        /// principals list of deny assignments.
        /// </summary>
        [JsonProperty(PropertyName = "gdprExportPrincipalId")]
        public string GdprExportPrincipalId { get; set; }

    }
}
