// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Active Directory Domain information.
    /// </summary>
    public partial class DomainInner
    {
        /// <summary>
        /// Initializes a new instance of the DomainInner class.
        /// </summary>
        public DomainInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DomainInner class.
        /// </summary>
        /// <param name="name">the domain name.</param>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="authenticationType">the type of the authentication
        /// into the domain.</param>
        /// <param name="isDefault">if this is the default domain in the
        /// tenant.</param>
        /// <param name="isVerified">if this domain's ownership is
        /// verified.</param>
        public DomainInner(string name, IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), string authenticationType = default(string), bool? isDefault = default(bool?), bool? isVerified = default(bool?))
        {
            AdditionalProperties = additionalProperties;
            AuthenticationType = authenticationType;
            IsDefault = isDefault;
            IsVerified = isVerified;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unmatched properties from the message are deserialized
        /// this collection
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Gets the type of the authentication into the domain.
        /// </summary>
        [JsonProperty(PropertyName = "authenticationType")]
        public string AuthenticationType { get; private set; }

        /// <summary>
        /// Gets if this is the default domain in the tenant.
        /// </summary>
        [JsonProperty(PropertyName = "isDefault")]
        public bool? IsDefault { get; private set; }

        /// <summary>
        /// Gets if this domain's ownership is verified.
        /// </summary>
        [JsonProperty(PropertyName = "isVerified")]
        public bool? IsVerified { get; private set; }

        /// <summary>
        /// Gets or sets the domain name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
