// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Specifying the claims to be included in the token.
    /// </summary>
    public partial class OptionalClaims
    {
        /// <summary>
        /// Initializes a new instance of the OptionalClaims class.
        /// </summary>
        public OptionalClaims()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OptionalClaims class.
        /// </summary>
        /// <param name="idToken">Optional claims requested to be included in
        /// the id token.</param>
        /// <param name="accessToken">Optional claims requested to be included
        /// in the access token.</param>
        /// <param name="samlToken">Optional claims requested to be included in
        /// the saml token.</param>
        public OptionalClaims(IList<OptionalClaim> idToken = default(IList<OptionalClaim>), IList<OptionalClaim> accessToken = default(IList<OptionalClaim>), IList<OptionalClaim> samlToken = default(IList<OptionalClaim>))
        {
            IdToken = idToken;
            AccessToken = accessToken;
            SamlToken = samlToken;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets optional claims requested to be included in the id
        /// token.
        /// </summary>
        [JsonProperty(PropertyName = "idToken")]
        public IList<OptionalClaim> IdToken { get; set; }

        /// <summary>
        /// Gets or sets optional claims requested to be included in the access
        /// token.
        /// </summary>
        [JsonProperty(PropertyName = "accessToken")]
        public IList<OptionalClaim> AccessToken { get; set; }

        /// <summary>
        /// Gets or sets optional claims requested to be included in the saml
        /// token.
        /// </summary>
        [JsonProperty(PropertyName = "samlToken")]
        public IList<OptionalClaim> SamlToken { get; set; }

    }
}
