// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Active Directory Password Credential information.
    /// </summary>
    public partial class PasswordCredential
    {
        /// <summary>
        /// Initializes a new instance of the PasswordCredential class.
        /// </summary>
        public PasswordCredential()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PasswordCredential class.
        /// </summary>
        /// <param name="additionalProperties">Unmatched properties from the
        /// message are deserialized this collection</param>
        /// <param name="startDate">Start date.</param>
        /// <param name="endDate">End date.</param>
        /// <param name="keyId">Key ID.</param>
        /// <param name="value">Key value.</param>
        /// <param name="customKeyIdentifier">Custom Key Identifier</param>
        public PasswordCredential(IDictionary<string, object> additionalProperties = default(IDictionary<string, object>), System.DateTime? startDate = default(System.DateTime?), System.DateTime? endDate = default(System.DateTime?), string keyId = default(string), string value = default(string), byte[] customKeyIdentifier = default(byte[]))
        {
            AdditionalProperties = additionalProperties;
            StartDate = startDate;
            EndDate = endDate;
            KeyId = keyId;
            Value = value;
            CustomKeyIdentifier = customKeyIdentifier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets unmatched properties from the message are deserialized
        /// this collection
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Gets or sets start date.
        /// </summary>
        [JsonProperty(PropertyName = "startDate")]
        public System.DateTime? StartDate { get; set; }

        /// <summary>
        /// Gets or sets end date.
        /// </summary>
        [JsonProperty(PropertyName = "endDate")]
        public System.DateTime? EndDate { get; set; }

        /// <summary>
        /// Gets or sets key ID.
        /// </summary>
        [JsonProperty(PropertyName = "keyId")]
        public string KeyId { get; set; }

        /// <summary>
        /// Gets or sets key value.
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets custom Key Identifier
        /// </summary>
        [JsonProperty(PropertyName = "customKeyIdentifier")]
        public byte[] CustomKeyIdentifier { get; set; }

    }
}
