// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Deny assignment principal.
    /// </summary>
    public partial class Principal
    {
        /// <summary>
        /// Initializes a new instance of the Principal class.
        /// </summary>
        public Principal()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the Principal class.
        /// </summary>
        /// <param name="id">Object ID of the Azure AD principal (user, group,
        /// or service principal) to which the deny assignment applies. An
        /// empty guid '00000000-0000-0000-0000-000000000000' as principal id
        /// and principal type as 'Everyone' represents all users, groups and
        /// service principals.</param>
        /// <param name="type">Type of object represented by principal id
        /// (user, group, or service principal). An empty guid
        /// '00000000-0000-0000-0000-000000000000' as principal id and
        /// principal type as 'Everyone' represents all users, groups and
        /// service principals.</param>
        public Principal(string id = default(string), string type = default(string))
        {
            Id = id;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets object ID of the Azure AD principal (user, group, or service
        /// principal) to which the deny assignment applies. An empty guid
        /// '00000000-0000-0000-0000-000000000000' as principal id and
        /// principal type as 'Everyone' represents all users, groups and
        /// service principals.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets type of object represented by principal id (user, group, or
        /// service principal). An empty guid
        /// '00000000-0000-0000-0000-000000000000' as principal id and
        /// principal type as 'Everyone' represents all users, groups and
        /// service principals.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

    }
}
