// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The CheckNameAvailability operation response.
    /// </summary>
    public partial class CheckNameAvailabilityResultInner
    {
        /// <summary>
        /// Initializes a new instance of the CheckNameAvailabilityResultInner
        /// class.
        /// </summary>
        public CheckNameAvailabilityResultInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CheckNameAvailabilityResultInner
        /// class.
        /// </summary>
        /// <param name="nameAvailable">A boolean value that indicates whether
        /// the name is available for you to use. If true, the name is
        /// available. If false, the name has already been taken or is invalid
        /// and cannot be used.</param>
        /// <param name="reason">The reason that a vault name could not be
        /// used. The Reason element is only returned if NameAvailable is
        /// false. Possible values include: 'AccountNameInvalid',
        /// 'AlreadyExists'</param>
        /// <param name="message">An error message explaining the Reason value
        /// in more detail.</param>
        public CheckNameAvailabilityResultInner(bool? nameAvailable = default(bool?), Reason? reason = default(Reason?), string message = default(string))
        {
            NameAvailable = nameAvailable;
            Reason = reason;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a boolean value that indicates whether the name is available
        /// for you to use. If true, the name is available. If false, the name
        /// has already been taken or is invalid and cannot be used.
        /// </summary>
        [JsonProperty(PropertyName = "nameAvailable")]
        public bool? NameAvailable { get; private set; }

        /// <summary>
        /// Gets the reason that a vault name could not be used. The Reason
        /// element is only returned if NameAvailable is false. Possible values
        /// include: 'AccountNameInvalid', 'AlreadyExists'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public Reason? Reason { get; private set; }

        /// <summary>
        /// Gets an error message explaining the Reason value in more detail.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

    }
}
