// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties of the deleted vault.
    /// </summary>
    public partial class DeletedVaultProperties
    {
        /// <summary>
        /// Initializes a new instance of the DeletedVaultProperties class.
        /// </summary>
        public DeletedVaultProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DeletedVaultProperties class.
        /// </summary>
        /// <param name="vaultId">The resource id of the original
        /// vault.</param>
        /// <param name="location">The location of the original vault.</param>
        /// <param name="deletionDate">The deleted date.</param>
        /// <param name="scheduledPurgeDate">The scheduled purged date.</param>
        /// <param name="tags">Tags of the original vault.</param>
        public DeletedVaultProperties(string vaultId = default(string), string location = default(string), System.DateTime? deletionDate = default(System.DateTime?), System.DateTime? scheduledPurgeDate = default(System.DateTime?), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            VaultId = vaultId;
            Location = location;
            DeletionDate = deletionDate;
            ScheduledPurgeDate = scheduledPurgeDate;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the resource id of the original vault.
        /// </summary>
        [JsonProperty(PropertyName = "vaultId")]
        public string VaultId { get; private set; }

        /// <summary>
        /// Gets the location of the original vault.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets the deleted date.
        /// </summary>
        [JsonProperty(PropertyName = "deletionDate")]
        public System.DateTime? DeletionDate { get; private set; }

        /// <summary>
        /// Gets the scheduled purged date.
        /// </summary>
        [JsonProperty(PropertyName = "scheduledPurgeDate")]
        public System.DateTime? ScheduledPurgeDate { get; private set; }

        /// <summary>
        /// Gets tags of the original vault.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; private set; }

    }
}
