// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A rule governing the accessibility of a vault from a specific ip
    /// address or ip range.
    /// </summary>
    public partial class IPRule
    {
        /// <summary>
        /// Initializes a new instance of the IPRule class.
        /// </summary>
        public IPRule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IPRule class.
        /// </summary>
        /// <param name="value">An IPv4 address range in CIDR notation, such as
        /// '124.56.78.91' (simple IP address) or '124.56.78.0/24' (all
        /// addresses that start with 124.56.78).</param>
        public IPRule(string value)
        {
            Value = value;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets an IPv4 address range in CIDR notation, such as
        /// '124.56.78.91' (simple IP address) or '124.56.78.0/24' (all
        /// addresses that start with 124.56.78).
        /// </summary>
        [JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Value == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Value");
            }
        }
    }
}
