// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The parameters used to check the availability of the vault name.
    /// </summary>
    public partial class VaultCheckNameAvailabilityParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VaultCheckNameAvailabilityParameters class.
        /// </summary>
        public VaultCheckNameAvailabilityParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// VaultCheckNameAvailabilityParameters class.
        /// </summary>
        /// <param name="name">The vault name.</param>
        public VaultCheckNameAvailabilityParameters(string name)
        {
            Name = name;
            CustomInit();
        }
        /// <summary>
        /// Static constructor for VaultCheckNameAvailabilityParameters class.
        /// </summary>
        static VaultCheckNameAvailabilityParameters()
        {
            Type = "Microsoft.KeyVault/vaults";
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the vault name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// The type of resource, Microsoft.KeyVault/vaults
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public static string Type { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
