// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Parameters for creating or updating a vault
    /// </summary>
    public partial class VaultPatchParameters
    {
        /// <summary>
        /// Initializes a new instance of the VaultPatchParameters class.
        /// </summary>
        public VaultPatchParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VaultPatchParameters class.
        /// </summary>
        /// <param name="tags">The tags that will be assigned to the key vault.
        /// </param>
        /// <param name="properties">Properties of the vault</param>
        public VaultPatchParameters(IDictionary<string, string> tags = default(IDictionary<string, string>), VaultPatchProperties properties = default(VaultPatchProperties))
        {
            Tags = tags;
            Properties = properties;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the tags that will be assigned to the key vault.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets properties of the vault
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public VaultPatchProperties Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Properties != null)
            {
                Properties.Validate();
            }
        }
    }
}
