// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Locks.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The lock information.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ManagementLockObjectInner
    {
        /// <summary>
        /// Initializes a new instance of the ManagementLockObjectInner class.
        /// </summary>
        public ManagementLockObjectInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagementLockObjectInner class.
        /// </summary>
        /// <param name="level">The level of the lock. Possible values are:
        /// NotSpecified, CanNotDelete, ReadOnly. CanNotDelete means authorized
        /// users are able to read and modify the resources, but not delete.
        /// ReadOnly means authorized users can only read from a resource, but
        /// they can't modify or delete it. Possible values include:
        /// 'NotSpecified', 'CanNotDelete', 'ReadOnly'</param>
        /// <param name="notes">Notes about the lock. Maximum of 512
        /// characters.</param>
        /// <param name="owners">The owners of the lock.</param>
        /// <param name="id">The resource ID of the lock.</param>
        /// <param name="type">The resource type of the lock -
        /// Microsoft.Authorization/locks.</param>
        /// <param name="name">The name of the lock.</param>
        public ManagementLockObjectInner(string level, string notes = default(string), IList<ManagementLockOwner> owners = default(IList<ManagementLockOwner>), string id = default(string), string type = default(string), string name = default(string))
        {
            Level = level;
            Notes = notes;
            Owners = owners;
            Id = id;
            Type = type;
            Name = name;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the level of the lock. Possible values are:
        /// NotSpecified, CanNotDelete, ReadOnly. CanNotDelete means authorized
        /// users are able to read and modify the resources, but not delete.
        /// ReadOnly means authorized users can only read from a resource, but
        /// they can't modify or delete it. Possible values include:
        /// 'NotSpecified', 'CanNotDelete', 'ReadOnly'
        /// </summary>
        [JsonProperty(PropertyName = "properties.level")]
        public string Level { get; set; }

        /// <summary>
        /// Gets or sets notes about the lock. Maximum of 512 characters.
        /// </summary>
        [JsonProperty(PropertyName = "properties.notes")]
        public string Notes { get; set; }

        /// <summary>
        /// Gets or sets the owners of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "properties.owners")]
        public IList<ManagementLockOwner> Owners { get; set; }

        /// <summary>
        /// Gets the resource ID of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets the resource type of the lock - Microsoft.Authorization/locks.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Gets or sets the name of the lock.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Level == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Level");
            }
        }
    }
}
