// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Azure action group
    /// </summary>
    public partial class AzNsActionGroup
    {
        /// <summary>
        /// Initializes a new instance of the AzNsActionGroup class.
        /// </summary>
        public AzNsActionGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzNsActionGroup class.
        /// </summary>
        /// <param name="actionGroup">Azure Action Group reference.</param>
        /// <param name="emailSubject">Custom subject override for all email
        /// ids in Azure action group</param>
        /// <param name="customWebhookPayload">Custom payload to be sent for
        /// all webhook URI in Azure action group</param>
        public AzNsActionGroup(IList<string> actionGroup = default(IList<string>), string emailSubject = default(string), string customWebhookPayload = default(string))
        {
            ActionGroup = actionGroup;
            EmailSubject = emailSubject;
            CustomWebhookPayload = customWebhookPayload;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets azure Action Group reference.
        /// </summary>
        [JsonProperty(PropertyName = "actionGroup")]
        public IList<string> ActionGroup { get; set; }

        /// <summary>
        /// Gets or sets custom subject override for all email ids in Azure
        /// action group
        /// </summary>
        [JsonProperty(PropertyName = "emailSubject")]
        public string EmailSubject { get; set; }

        /// <summary>
        /// Gets or sets custom payload to be sent for all webhook URI in Azure
        /// action group
        /// </summary>
        [JsonProperty(PropertyName = "customWebhookPayload")]
        public string CustomWebhookPayload { get; set; }

    }
}
