// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The Azure mobile App push notification receiver.
    /// </summary>
    public partial class AzureAppPushReceiver
    {
        /// <summary>
        /// Initializes a new instance of the AzureAppPushReceiver class.
        /// </summary>
        public AzureAppPushReceiver()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureAppPushReceiver class.
        /// </summary>
        /// <param name="name">The name of the Azure mobile app push receiver.
        /// Names must be unique across all receivers within an action
        /// group.</param>
        /// <param name="emailAddress">The email address registered for the
        /// Azure mobile app.</param>
        public AzureAppPushReceiver(string name, string emailAddress)
        {
            Name = name;
            EmailAddress = emailAddress;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the Azure mobile app push receiver. Names
        /// must be unique across all receivers within an action group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the email address registered for the Azure mobile app.
        /// </summary>
        [JsonProperty(PropertyName = "emailAddress")]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
            if (EmailAddress == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "EmailAddress");
            }
        }
    }
}
