// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The baseline values for a single sensitivity value.
    /// </summary>
    public partial class BaselineInner
    {
        /// <summary>
        /// Initializes a new instance of the BaselineInner class.
        /// </summary>
        public BaselineInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BaselineInner class.
        /// </summary>
        /// <param name="sensitivity">the sensitivity of the baseline. Possible
        /// values include: 'Low', 'Medium', 'High'</param>
        /// <param name="lowThresholds">The low thresholds of the
        /// baseline.</param>
        /// <param name="highThresholds">The high thresholds of the
        /// baseline.</param>
        public BaselineInner(Sensitivity sensitivity, IList<double?> lowThresholds, IList<double?> highThresholds)
        {
            Sensitivity = sensitivity;
            LowThresholds = lowThresholds;
            HighThresholds = highThresholds;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the sensitivity of the baseline. Possible values
        /// include: 'Low', 'Medium', 'High'
        /// </summary>
        [JsonProperty(PropertyName = "sensitivity")]
        public Sensitivity Sensitivity { get; set; }

        /// <summary>
        /// Gets or sets the low thresholds of the baseline.
        /// </summary>
        [JsonProperty(PropertyName = "lowThresholds")]
        public IList<double?> LowThresholds { get; set; }

        /// <summary>
        /// Gets or sets the high thresholds of the baseline.
        /// </summary>
        [JsonProperty(PropertyName = "highThresholds")]
        public IList<double?> HighThresholds { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (LowThresholds == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LowThresholds");
            }
            if (HighThresholds == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "HighThresholds");
            }
        }
    }
}
