// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The minimum number of violations required within the selected lookback
    /// time window required to raise an alert.
    /// </summary>
    public partial class DynamicThresholdFailingPeriods
    {
        /// <summary>
        /// Initializes a new instance of the DynamicThresholdFailingPeriods
        /// class.
        /// </summary>
        public DynamicThresholdFailingPeriods()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DynamicThresholdFailingPeriods
        /// class.
        /// </summary>
        /// <param name="numberOfEvaluationPeriods">The number of aggregated
        /// lookback points. The lookback time window is calculated based on
        /// the aggregation granularity (windowSize) and the selected number of
        /// aggregated points.</param>
        /// <param name="minFailingPeriodsToAlert">The number of violations to
        /// trigger an alert. Should be smaller or equal to
        /// numberOfEvaluationPeriods.</param>
        public DynamicThresholdFailingPeriods(double numberOfEvaluationPeriods, double minFailingPeriodsToAlert)
        {
            NumberOfEvaluationPeriods = numberOfEvaluationPeriods;
            MinFailingPeriodsToAlert = minFailingPeriodsToAlert;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the number of aggregated lookback points. The lookback
        /// time window is calculated based on the aggregation granularity
        /// (windowSize) and the selected number of aggregated points.
        /// </summary>
        [JsonProperty(PropertyName = "numberOfEvaluationPeriods")]
        public double NumberOfEvaluationPeriods { get; set; }

        /// <summary>
        /// Gets or sets the number of violations to trigger an alert. Should
        /// be smaller or equal to numberOfEvaluationPeriods.
        /// </summary>
        [JsonProperty(PropertyName = "minFailingPeriodsToAlert")]
        public double MinFailingPeriodsToAlert { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
