// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// How the data that is collected should be combined over time.
    /// </summary>
    public partial class ManagementEventAggregationCondition
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ManagementEventAggregationCondition class.
        /// </summary>
        public ManagementEventAggregationCondition()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ManagementEventAggregationCondition class.
        /// </summary>
        /// <param name="operatorProperty">the condition operator. Possible
        /// values include: 'GreaterThan', 'GreaterThanOrEqual', 'LessThan',
        /// 'LessThanOrEqual'</param>
        /// <param name="threshold">The threshold value that activates the
        /// alert.</param>
        /// <param name="windowSize">the period of time (in ISO 8601 duration
        /// format) that is used to monitor alert activity based on the
        /// threshold. If specified then it must be between 5 minutes and 1
        /// day.</param>
        public ManagementEventAggregationCondition(ConditionOperator? operatorProperty = default(ConditionOperator?), double? threshold = default(double?), System.TimeSpan? windowSize = default(System.TimeSpan?))
        {
            OperatorProperty = operatorProperty;
            Threshold = threshold;
            WindowSize = windowSize;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the condition operator. Possible values include:
        /// 'GreaterThan', 'GreaterThanOrEqual', 'LessThan', 'LessThanOrEqual'
        /// </summary>
        [JsonProperty(PropertyName = "operator")]
        public ConditionOperator? OperatorProperty { get; set; }

        /// <summary>
        /// Gets or sets the threshold value that activates the alert.
        /// </summary>
        [JsonProperty(PropertyName = "threshold")]
        public double? Threshold { get; set; }

        /// <summary>
        /// Gets or sets the period of time (in ISO 8601 duration format) that
        /// is used to monitor alert activity based on the threshold. If
        /// specified then it must be between 5 minutes and 1 day.
        /// </summary>
        [JsonProperty(PropertyName = "windowSize")]
        public System.TimeSpan? WindowSize { get; set; }

    }
}
