// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Monitor.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A rule that provide the triggers and parameters for the scaling action.
    /// </summary>
    public partial class ScaleRuleInner
    {
        /// <summary>
        /// Initializes a new instance of the ScaleRuleInner class.
        /// </summary>
        public ScaleRuleInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ScaleRuleInner class.
        /// </summary>
        /// <param name="metricTrigger">the trigger that results in a scaling
        /// action.</param>
        /// <param name="scaleAction">the parameters for the scaling
        /// action.</param>
        public ScaleRuleInner(MetricTrigger metricTrigger, ScaleAction scaleAction)
        {
            MetricTrigger = metricTrigger;
            ScaleAction = scaleAction;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the trigger that results in a scaling action.
        /// </summary>
        [JsonProperty(PropertyName = "metricTrigger")]
        public MetricTrigger MetricTrigger { get; set; }

        /// <summary>
        /// Gets or sets the parameters for the scaling action.
        /// </summary>
        [JsonProperty(PropertyName = "scaleAction")]
        public ScaleAction ScaleAction { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MetricTrigger == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MetricTrigger");
            }
            if (ScaleAction == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ScaleAction");
            }
            if (MetricTrigger != null)
            {
                MetricTrigger.Validate();
            }
            if (ScaleAction != null)
            {
                ScaleAction.Validate();
            }
        }
    }
}
