// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Msi.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Describes an identity resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class IdentityInner : Microsoft.Azure.Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the IdentityInner class.
        /// </summary>
        public IdentityInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IdentityInner class.
        /// </summary>
        /// <param name="id">The id of the created identity.</param>
        /// <param name="name">The name of the created identity.</param>
        /// <param name="location">The Azure region where the identity
        /// lives.</param>
        /// <param name="tags">Resource tags</param>
        /// <param name="tenantId">The id of the tenant which the identity
        /// belongs to.</param>
        /// <param name="principalId">The id of the service principal object
        /// associated with the created identity.</param>
        /// <param name="clientId">The id of the app associated with the
        /// identity. This is a random generated UUID by MSI.</param>
        /// <param name="clientSecretUrl"> The ManagedServiceIdentity DataPlane
        /// URL that can be queried to obtain the identity credentials. If
        /// identity is user assigned, then the clientSecretUrl will not be
        /// present in the response, otherwise it will be present.</param>
        /// <param name="type">The type of resource i.e.
        /// Microsoft.ManagedIdentity/userAssignedIdentities. Possible values
        /// include: 'Microsoft.ManagedIdentity/userAssignedIdentities'</param>
        public IdentityInner(string id = default(string), string name = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), System.Guid? tenantId = default(System.Guid?), System.Guid? principalId = default(System.Guid?), System.Guid? clientId = default(System.Guid?), string clientSecretUrl = default(string), string type = default(string))
            : base(location, id, name, type, tags)
        {
            TenantId = tenantId;
            PrincipalId = principalId;
            ClientId = clientId;
            ClientSecretUrl = clientSecretUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the id of the tenant which the identity belongs to.
        /// </summary>
        [JsonProperty(PropertyName = "properties.tenantId")]
        public System.Guid? TenantId { get; private set; }

        /// <summary>
        /// Gets the id of the service principal object associated with the
        /// created identity.
        /// </summary>
        [JsonProperty(PropertyName = "properties.principalId")]
        public System.Guid? PrincipalId { get; private set; }

        /// <summary>
        /// Gets the id of the app associated with the identity. This is a
        /// random generated UUID by MSI.
        /// </summary>
        [JsonProperty(PropertyName = "properties.clientId")]
        public System.Guid? ClientId { get; private set; }

        /// <summary>
        /// Gets  The ManagedServiceIdentity DataPlane URL that can be queried
        /// to obtain the identity credentials. If identity is user assigned,
        /// then the clientSecretUrl will not be present in the response,
        /// otherwise it will be present.
        /// </summary>
        [JsonProperty(PropertyName = "properties.clientSecretUrl")]
        public string ClientSecretUrl { get; private set; }
    }
}
