// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Msi.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Operation Display.
    /// </summary>
    /// <remarks>
    /// The object that describes the operation.
    /// </remarks>
    public partial class OperationDisplay
    {
        /// <summary>
        /// Initializes a new instance of the OperationDisplay class.
        /// </summary>
        public OperationDisplay()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OperationDisplay class.
        /// </summary>
        /// <param name="provider">Resource Provider Name.</param>
        /// <param name="operation">Operation Type.</param>
        /// <param name="resource">Resource Type.</param>
        /// <param name="description">Operation description</param>
        public OperationDisplay(string provider = default(string), string operation = default(string), string resource = default(string), string description = default(string))
        {
            Provider = provider;
            Operation = operation;
            Resource = resource;
            Description = description;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource Provider Name.
        /// </summary>
        /// <remarks>
        /// Friendly name of the resource provider.
        /// </remarks>
        [JsonProperty(PropertyName = "provider")]
        public string Provider { get; set; }

        /// <summary>
        /// Gets or sets operation Type.
        /// </summary>
        /// <remarks>
        /// The type of operation. For example: read, write, delete.
        /// </remarks>
        [JsonProperty(PropertyName = "operation")]
        public string Operation { get; set; }

        /// <summary>
        /// Gets or sets resource Type.
        /// </summary>
        /// <remarks>
        /// The resource type on which the operation is performed.
        /// </remarks>
        [JsonProperty(PropertyName = "resource")]
        public string Resource { get; set; }

        /// <summary>
        /// Gets or sets operation description
        /// </summary>
        /// <remarks>
        /// A description of the operation.
        /// </remarks>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

    }
}
