// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// AAD Vpn authentication type related parameters.
    /// </summary>
    public partial class AadAuthenticationParameters
    {
        /// <summary>
        /// Initializes a new instance of the AadAuthenticationParameters
        /// class.
        /// </summary>
        public AadAuthenticationParameters()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AadAuthenticationParameters
        /// class.
        /// </summary>
        /// <param name="aadTenant">AAD Vpn authentication parameter AAD
        /// tenant.</param>
        /// <param name="aadAudience">AAD Vpn authentication parameter AAD
        /// audience.</param>
        /// <param name="aadIssuer">AAD Vpn authentication parameter AAD
        /// issuer.</param>
        public AadAuthenticationParameters(string aadTenant = default(string), string aadAudience = default(string), string aadIssuer = default(string))
        {
            AadTenant = aadTenant;
            AadAudience = aadAudience;
            AadIssuer = aadIssuer;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets AAD Vpn authentication parameter AAD tenant.
        /// </summary>
        [JsonProperty(PropertyName = "aadTenant")]
        public string AadTenant { get; set; }

        /// <summary>
        /// Gets or sets AAD Vpn authentication parameter AAD audience.
        /// </summary>
        [JsonProperty(PropertyName = "aadAudience")]
        public string AadAudience { get; set; }

        /// <summary>
        /// Gets or sets AAD Vpn authentication parameter AAD issuer.
        /// </summary>
        [JsonProperty(PropertyName = "aadIssuer")]
        public string AadIssuer { get; set; }

    }
}
