// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Application Gateway autoscale configuration.
    /// </summary>
    public partial class ApplicationGatewayAutoscaleConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationGatewayAutoscaleConfiguration class.
        /// </summary>
        public ApplicationGatewayAutoscaleConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationGatewayAutoscaleConfiguration class.
        /// </summary>
        /// <param name="minCapacity">Lower bound on number of Application
        /// Gateway capacity.</param>
        /// <param name="maxCapacity">Upper bound on number of Application
        /// Gateway capacity.</param>
        public ApplicationGatewayAutoscaleConfiguration(int minCapacity, int? maxCapacity = default(int?))
        {
            MinCapacity = minCapacity;
            MaxCapacity = maxCapacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets lower bound on number of Application Gateway capacity.
        /// </summary>
        [JsonProperty(PropertyName = "minCapacity")]
        public int MinCapacity { get; set; }

        /// <summary>
        /// Gets or sets upper bound on number of Application Gateway capacity.
        /// </summary>
        [JsonProperty(PropertyName = "maxCapacity")]
        public int? MaxCapacity { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MinCapacity < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MinCapacity", 0);
            }
            if (MaxCapacity < 2)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxCapacity", 2);
            }
        }
    }
}
