// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Customer error of an application gateway.
    /// </summary>
    public partial class ApplicationGatewayCustomError
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayCustomError
        /// class.
        /// </summary>
        public ApplicationGatewayCustomError()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayCustomError
        /// class.
        /// </summary>
        /// <param name="statusCode">Status code of the application gateway
        /// customer error. Possible values include: 'HttpStatus403',
        /// 'HttpStatus502'</param>
        /// <param name="customErrorPageUrl">Error page URL of the application
        /// gateway customer error.</param>
        public ApplicationGatewayCustomError(ApplicationGatewayCustomErrorStatusCode statusCode = default(ApplicationGatewayCustomErrorStatusCode), string customErrorPageUrl = default(string))
        {
            StatusCode = statusCode;
            CustomErrorPageUrl = customErrorPageUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets status code of the application gateway customer error.
        /// Possible values include: 'HttpStatus403', 'HttpStatus502'
        /// </summary>
        [JsonProperty(PropertyName = "statusCode")]
        public ApplicationGatewayCustomErrorStatusCode StatusCode { get; set; }

        /// <summary>
        /// Gets or sets error page URL of the application gateway customer
        /// error.
        /// </summary>
        [JsonProperty(PropertyName = "customErrorPageUrl")]
        public string CustomErrorPageUrl { get; set; }

    }
}
