// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Allow to exclude some variable satisfy the condition for the WAF check.
    /// </summary>
    public partial class ApplicationGatewayFirewallExclusion
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationGatewayFirewallExclusion class.
        /// </summary>
        public ApplicationGatewayFirewallExclusion()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ApplicationGatewayFirewallExclusion class.
        /// </summary>
        /// <param name="matchVariable">The variable to be excluded.</param>
        /// <param name="selectorMatchOperator">When matchVariable is a
        /// collection, operate on the selector to specify which elements in
        /// the collection this exclusion applies to.</param>
        /// <param name="selector">When matchVariable is a collection, operator
        /// used to specify which elements in the collection this exclusion
        /// applies to.</param>
        public ApplicationGatewayFirewallExclusion(string matchVariable, string selectorMatchOperator, string selector)
        {
            MatchVariable = matchVariable;
            SelectorMatchOperator = selectorMatchOperator;
            Selector = selector;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the variable to be excluded.
        /// </summary>
        [JsonProperty(PropertyName = "matchVariable")]
        public string MatchVariable { get; set; }

        /// <summary>
        /// Gets or sets when matchVariable is a collection, operate on the
        /// selector to specify which elements in the collection this exclusion
        /// applies to.
        /// </summary>
        [JsonProperty(PropertyName = "selectorMatchOperator")]
        public string SelectorMatchOperator { get; set; }

        /// <summary>
        /// Gets or sets when matchVariable is a collection, operator used to
        /// specify which elements in the collection this exclusion applies to.
        /// </summary>
        [JsonProperty(PropertyName = "selector")]
        public string Selector { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (MatchVariable == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MatchVariable");
            }
            if (SelectorMatchOperator == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "SelectorMatchOperator");
            }
            if (Selector == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Selector");
            }
        }
    }
}
