// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Details of on demand test probe request.
    /// </summary>
    public partial class ApplicationGatewayOnDemandProbe
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayOnDemandProbe
        /// class.
        /// </summary>
        public ApplicationGatewayOnDemandProbe()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayOnDemandProbe
        /// class.
        /// </summary>
        /// <param name="protocol">The protocol used for the probe. Possible
        /// values include: 'Http', 'Https'</param>
        /// <param name="host">Host name to send the probe to.</param>
        /// <param name="path">Relative path of probe. Valid path starts from
        /// '/'. Probe is sent to
        /// &lt;Protocol&gt;://&lt;host&gt;:&lt;port&gt;&lt;path&gt;.</param>
        /// <param name="timeout">The probe timeout in seconds. Probe marked as
        /// failed if valid response is not received with this timeout period.
        /// Acceptable values are from 1 second to 86400 seconds.</param>
        /// <param name="pickHostNameFromBackendHttpSettings">Whether the host
        /// header should be picked from the backend http settings. Default
        /// value is false.</param>
        /// <param name="match">Criterion for classifying a healthy probe
        /// response.</param>
        /// <param name="backendAddressPool">Reference of backend pool of
        /// application gateway to which probe request will be sent.</param>
        /// <param name="backendHttpSettings">Reference of backend http setting
        /// of application gateway to be used for test probe.</param>
        public ApplicationGatewayOnDemandProbe(ApplicationGatewayProtocol protocol = default(ApplicationGatewayProtocol), string host = default(string), string path = default(string), int? timeout = default(int?), bool? pickHostNameFromBackendHttpSettings = default(bool?), ApplicationGatewayProbeHealthResponseMatch match = default(ApplicationGatewayProbeHealthResponseMatch), Management.ResourceManager.Fluent.SubResource backendAddressPool = default(Management.ResourceManager.Fluent.SubResource), Management.ResourceManager.Fluent.SubResource backendHttpSettings = default(Management.ResourceManager.Fluent.SubResource))
        {
            Protocol = protocol;
            Host = host;
            Path = path;
            Timeout = timeout;
            PickHostNameFromBackendHttpSettings = pickHostNameFromBackendHttpSettings;
            Match = match;
            BackendAddressPool = backendAddressPool;
            BackendHttpSettings = backendHttpSettings;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the protocol used for the probe. Possible values
        /// include: 'Http', 'Https'
        /// </summary>
        [JsonProperty(PropertyName = "protocol")]
        public ApplicationGatewayProtocol Protocol { get; set; }

        /// <summary>
        /// Gets or sets host name to send the probe to.
        /// </summary>
        [JsonProperty(PropertyName = "host")]
        public string Host { get; set; }

        /// <summary>
        /// Gets or sets relative path of probe. Valid path starts from '/'.
        /// Probe is sent to
        /// &amp;lt;Protocol&amp;gt;://&amp;lt;host&amp;gt;:&amp;lt;port&amp;gt;&amp;lt;path&amp;gt;.
        /// </summary>
        [JsonProperty(PropertyName = "path")]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the probe timeout in seconds. Probe marked as failed
        /// if valid response is not received with this timeout period.
        /// Acceptable values are from 1 second to 86400 seconds.
        /// </summary>
        [JsonProperty(PropertyName = "timeout")]
        public int? Timeout { get; set; }

        /// <summary>
        /// Gets or sets whether the host header should be picked from the
        /// backend http settings. Default value is false.
        /// </summary>
        [JsonProperty(PropertyName = "pickHostNameFromBackendHttpSettings")]
        public bool? PickHostNameFromBackendHttpSettings { get; set; }

        /// <summary>
        /// Gets or sets criterion for classifying a healthy probe response.
        /// </summary>
        [JsonProperty(PropertyName = "match")]
        public ApplicationGatewayProbeHealthResponseMatch Match { get; set; }

        /// <summary>
        /// Gets or sets reference of backend pool of application gateway to
        /// which probe request will be sent.
        /// </summary>
        [JsonProperty(PropertyName = "backendAddressPool")]
        public Management.ResourceManager.Fluent.SubResource BackendAddressPool { get; set; }

        /// <summary>
        /// Gets or sets reference of backend http setting of application
        /// gateway to be used for test probe.
        /// </summary>
        [JsonProperty(PropertyName = "backendHttpSettings")]
        public Management.ResourceManager.Fluent.SubResource BackendHttpSettings { get; set; }

    }
}
