// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// SKU of an application gateway.
    /// </summary>
    public partial class ApplicationGatewaySku
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewaySku class.
        /// </summary>
        public ApplicationGatewaySku()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewaySku class.
        /// </summary>
        /// <param name="name">Name of an application gateway SKU. Possible
        /// values include: 'Standard_Small', 'Standard_Medium',
        /// 'Standard_Large', 'WAF_Medium', 'WAF_Large', 'Standard_v2',
        /// 'WAF_v2'</param>
        /// <param name="tier">Tier of an application gateway. Possible values
        /// include: 'Standard', 'WAF', 'Standard_v2', 'WAF_v2'</param>
        /// <param name="capacity">Capacity (instance count) of an application
        /// gateway.</param>
        public ApplicationGatewaySku(ApplicationGatewaySkuName name = default(ApplicationGatewaySkuName), ApplicationGatewayTier tier = default(ApplicationGatewayTier), int? capacity = default(int?))
        {
            Name = name;
            Tier = tier;
            Capacity = capacity;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of an application gateway SKU. Possible values
        /// include: 'Standard_Small', 'Standard_Medium', 'Standard_Large',
        /// 'WAF_Medium', 'WAF_Large', 'Standard_v2', 'WAF_v2'
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public ApplicationGatewaySkuName Name { get; set; }

        /// <summary>
        /// Gets or sets tier of an application gateway. Possible values
        /// include: 'Standard', 'WAF', 'Standard_v2', 'WAF_v2'
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public ApplicationGatewayTier Tier { get; set; }

        /// <summary>
        /// Gets or sets capacity (instance count) of an application gateway.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public int? Capacity { get; set; }

    }
}
