// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Management.ResourceManager;
    using Management.ResourceManager.Fluent;
    using Management.ResourceManager.Fluent.Core;

    using Newtonsoft.Json;
    /// <summary>
    /// Defines values for ApplicationGatewaySslCipherSuite.
    /// </summary>
    /// <summary>
    /// Determine base value for a given allowed value if exists, else return
    /// the value itself
    /// </summary>
    [JsonConverter(typeof(Management.ResourceManager.Fluent.Core.ExpandableStringEnumConverter<ApplicationGatewaySslCipherSuite>))]
    public class ApplicationGatewaySslCipherSuite : Management.ResourceManager.Fluent.Core.ExpandableStringEnum<ApplicationGatewaySslCipherSuite>
    {
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES256CBCSHA384 = Parse("TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES128CBCSHA256 = Parse("TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES256CBCSHA = Parse("TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES128CBCSHA = Parse("TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHERSAWITHAES256GCMSHA384 = Parse("TLS_DHE_RSA_WITH_AES_256_GCM_SHA384");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHERSAWITHAES128GCMSHA256 = Parse("TLS_DHE_RSA_WITH_AES_128_GCM_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHERSAWITHAES256CBCSHA = Parse("TLS_DHE_RSA_WITH_AES_256_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHERSAWITHAES128CBCSHA = Parse("TLS_DHE_RSA_WITH_AES_128_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES256GCMSHA384 = Parse("TLS_RSA_WITH_AES_256_GCM_SHA384");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES128GCMSHA256 = Parse("TLS_RSA_WITH_AES_128_GCM_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES256CBCSHA256 = Parse("TLS_RSA_WITH_AES_256_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES128CBCSHA256 = Parse("TLS_RSA_WITH_AES_128_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES256CBCSHA = Parse("TLS_RSA_WITH_AES_256_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITHAES128CBCSHA = Parse("TLS_RSA_WITH_AES_128_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES256GCMSHA384 = Parse("TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES128GCMSHA256 = Parse("TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES256CBCSHA384 = Parse("TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA384");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES128CBCSHA256 = Parse("TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES256CBCSHA = Parse("TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHEECDSAWITHAES128CBCSHA = Parse("TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHEDSSWITHAES256CBCSHA256 = Parse("TLS_DHE_DSS_WITH_AES_256_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHEDSSWITHAES128CBCSHA256 = Parse("TLS_DHE_DSS_WITH_AES_128_CBC_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHEDSSWITHAES256CBCSHA = Parse("TLS_DHE_DSS_WITH_AES_256_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHEDSSWITHAES128CBCSHA = Parse("TLS_DHE_DSS_WITH_AES_128_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSRSAWITH3DESEDECBCSHA = Parse("TLS_RSA_WITH_3DES_EDE_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSDHEDSSWITH3DESEDECBCSHA = Parse("TLS_DHE_DSS_WITH_3DES_EDE_CBC_SHA");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES128GCMSHA256 = Parse("TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256");
        public static readonly ApplicationGatewaySslCipherSuite TLSECDHERSAWITHAES256GCMSHA384 = Parse("TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384");
    }
}
