// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The serviceName of an AvailableDelegation indicates a possible
    /// delegation for a subnet.
    /// </summary>
    public partial class AvailableDelegationInner
    {
        /// <summary>
        /// Initializes a new instance of the AvailableDelegationInner class.
        /// </summary>
        public AvailableDelegationInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AvailableDelegationInner class.
        /// </summary>
        /// <param name="name">The name of the AvailableDelegation
        /// resource.</param>
        /// <param name="id">A unique identifier of the AvailableDelegation
        /// resource.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="serviceName">The name of the service and
        /// resource.</param>
        /// <param name="actions">Describes the actions permitted to the
        /// service upon delegation.</param>
        public AvailableDelegationInner(string name = default(string), string id = default(string), string type = default(string), string serviceName = default(string), IList<string> actions = default(IList<string>))
        {
            Name = name;
            Id = id;
            Type = type;
            ServiceName = serviceName;
            Actions = actions;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the AvailableDelegation resource.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a unique identifier of the AvailableDelegation
        /// resource.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets resource type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the name of the service and resource.
        /// </summary>
        [JsonProperty(PropertyName = "serviceName")]
        public string ServiceName { get; set; }

        /// <summary>
        /// Gets or sets describes the actions permitted to the service upon
        /// delegation.
        /// </summary>
        [JsonProperty(PropertyName = "actions")]
        public IList<string> Actions { get; set; }

    }
}
