// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The response body contains the status of the specified asynchronous
    /// operation, indicating whether it has succeeded, is in progress, or has
    /// failed. Note that this status is distinct from the HTTP status code
    /// returned for the Get Operation Status operation itself. If the
    /// asynchronous operation succeeded, the response body includes the HTTP
    /// status code for the successful request. If the asynchronous operation
    /// failed, the response body includes the HTTP status code for the failed
    /// request and error information regarding the failure.
    /// </summary>
    public partial class AzureAsyncOperationResult
    {
        /// <summary>
        /// Initializes a new instance of the AzureAsyncOperationResult class.
        /// </summary>
        public AzureAsyncOperationResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureAsyncOperationResult class.
        /// </summary>
        /// <param name="status">Status of the Azure async operation. Possible
        /// values include: 'InProgress', 'Succeeded', 'Failed'</param>
        /// <param name="error">Details of the error occurred during specified
        /// asynchronous operation.</param>
        public AzureAsyncOperationResult(NetworkOperationStatus status = default(NetworkOperationStatus), Error error = default(Error))
        {
            Status = status;
            Error = error;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets status of the Azure async operation. Possible values
        /// include: 'InProgress', 'Succeeded', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public NetworkOperationStatus Status { get; set; }

        /// <summary>
        /// Gets or sets details of the error occurred during specified
        /// asynchronous operation.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public Error Error { get; set; }

    }
}
