// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties of the network rule.
    /// </summary>
    public partial class AzureFirewallNetworkRule
    {
        /// <summary>
        /// Initializes a new instance of the AzureFirewallNetworkRule class.
        /// </summary>
        public AzureFirewallNetworkRule()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AzureFirewallNetworkRule class.
        /// </summary>
        /// <param name="name">Name of the network rule.</param>
        /// <param name="description">Description of the rule.</param>
        /// <param name="protocols">Array of
        /// AzureFirewallNetworkRuleProtocols.</param>
        /// <param name="sourceAddresses">List of source IP addresses for this
        /// rule.</param>
        /// <param name="destinationAddresses">List of destination IP
        /// addresses.</param>
        /// <param name="destinationPorts">List of destination ports.</param>
        /// <param name="destinationFqdns">List of destination FQDNs.</param>
        /// <param name="sourceIpGroups">List of source IpGroups for this
        /// rule.</param>
        /// <param name="destinationIpGroups">List of destination IpGroups for
        /// this rule.</param>
        public AzureFirewallNetworkRule(string name = default(string), string description = default(string), IList<AzureFirewallNetworkRuleProtocol> protocols = default(IList<AzureFirewallNetworkRuleProtocol>), IList<string> sourceAddresses = default(IList<string>), IList<string> destinationAddresses = default(IList<string>), IList<string> destinationPorts = default(IList<string>), IList<string> destinationFqdns = default(IList<string>), IList<string> sourceIpGroups = default(IList<string>), IList<string> destinationIpGroups = default(IList<string>))
        {
            Name = name;
            Description = description;
            Protocols = protocols;
            SourceAddresses = sourceAddresses;
            DestinationAddresses = destinationAddresses;
            DestinationPorts = destinationPorts;
            DestinationFqdns = destinationFqdns;
            SourceIpGroups = sourceIpGroups;
            DestinationIpGroups = destinationIpGroups;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the network rule.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets description of the rule.
        /// </summary>
        [JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets array of AzureFirewallNetworkRuleProtocols.
        /// </summary>
        [JsonProperty(PropertyName = "protocols")]
        public IList<AzureFirewallNetworkRuleProtocol> Protocols { get; set; }

        /// <summary>
        /// Gets or sets list of source IP addresses for this rule.
        /// </summary>
        [JsonProperty(PropertyName = "sourceAddresses")]
        public IList<string> SourceAddresses { get; set; }

        /// <summary>
        /// Gets or sets list of destination IP addresses.
        /// </summary>
        [JsonProperty(PropertyName = "destinationAddresses")]
        public IList<string> DestinationAddresses { get; set; }

        /// <summary>
        /// Gets or sets list of destination ports.
        /// </summary>
        [JsonProperty(PropertyName = "destinationPorts")]
        public IList<string> DestinationPorts { get; set; }

        /// <summary>
        /// Gets or sets list of destination FQDNs.
        /// </summary>
        [JsonProperty(PropertyName = "destinationFqdns")]
        public IList<string> DestinationFqdns { get; set; }

        /// <summary>
        /// Gets or sets list of source IpGroups for this rule.
        /// </summary>
        [JsonProperty(PropertyName = "sourceIpGroups")]
        public IList<string> SourceIpGroups { get; set; }

        /// <summary>
        /// Gets or sets list of destination IpGroups for this rule.
        /// </summary>
        [JsonProperty(PropertyName = "destinationIpGroups")]
        public IList<string> DestinationIpGroups { get; set; }

    }
}
