// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Service Community Properties.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BgpServiceCommunityInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the BgpServiceCommunityInner class.
        /// </summary>
        public BgpServiceCommunityInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BgpServiceCommunityInner class.
        /// </summary>
        /// <param name="serviceName">The name of the bgp community. e.g.
        /// Skype.</param>
        /// <param name="bgpCommunities">A list of bgp communities.</param>
        public BgpServiceCommunityInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string serviceName = default(string), IList<BGPCommunity> bgpCommunities = default(IList<BGPCommunity>))
            : base(location, id, name, type, tags)
        {
            ServiceName = serviceName;
            BgpCommunities = bgpCommunities;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the bgp community. e.g. Skype.
        /// </summary>
        [JsonProperty(PropertyName = "properties.serviceName")]
        public string ServiceName { get; set; }

        /// <summary>
        /// Gets or sets a list of bgp communities.
        /// </summary>
        [JsonProperty(PropertyName = "properties.bgpCommunities")]
        public IList<BGPCommunity> BgpCommunities { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
