// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Connection state snapshot.
    /// </summary>
    public partial class ConnectionStateSnapshot
    {
        /// <summary>
        /// Initializes a new instance of the ConnectionStateSnapshot class.
        /// </summary>
        public ConnectionStateSnapshot()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectionStateSnapshot class.
        /// </summary>
        /// <param name="connectionState">The connection state. Possible values
        /// include: 'Reachable', 'Unreachable', 'Unknown'</param>
        /// <param name="startTime">The start time of the connection
        /// snapshot.</param>
        /// <param name="endTime">The end time of the connection
        /// snapshot.</param>
        /// <param name="evaluationState">Connectivity analysis evaluation
        /// state. Possible values include: 'NotStarted', 'InProgress',
        /// 'Completed'</param>
        /// <param name="avgLatencyInMs">Average latency in ms.</param>
        /// <param name="minLatencyInMs">Minimum latency in ms.</param>
        /// <param name="maxLatencyInMs">Maximum latency in ms.</param>
        /// <param name="probesSent">The number of sent probes.</param>
        /// <param name="probesFailed">The number of failed probes.</param>
        /// <param name="hops">List of hops between the source and the
        /// destination.</param>
        public ConnectionStateSnapshot(ConnectionState connectionState = default(ConnectionState), System.DateTime? startTime = default(System.DateTime?), System.DateTime? endTime = default(System.DateTime?), EvaluationState evaluationState = default(EvaluationState), int? avgLatencyInMs = default(int?), int? minLatencyInMs = default(int?), int? maxLatencyInMs = default(int?), int? probesSent = default(int?), int? probesFailed = default(int?), IList<ConnectivityHop> hops = default(IList<ConnectivityHop>))
        {
            ConnectionState = connectionState;
            StartTime = startTime;
            EndTime = endTime;
            EvaluationState = evaluationState;
            AvgLatencyInMs = avgLatencyInMs;
            MinLatencyInMs = minLatencyInMs;
            MaxLatencyInMs = maxLatencyInMs;
            ProbesSent = probesSent;
            ProbesFailed = probesFailed;
            Hops = hops;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the connection state. Possible values include:
        /// 'Reachable', 'Unreachable', 'Unknown'
        /// </summary>
        [JsonProperty(PropertyName = "connectionState")]
        public ConnectionState ConnectionState { get; set; }

        /// <summary>
        /// Gets or sets the start time of the connection snapshot.
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public System.DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets or sets the end time of the connection snapshot.
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public System.DateTime? EndTime { get; set; }

        /// <summary>
        /// Gets or sets connectivity analysis evaluation state. Possible
        /// values include: 'NotStarted', 'InProgress', 'Completed'
        /// </summary>
        [JsonProperty(PropertyName = "evaluationState")]
        public EvaluationState EvaluationState { get; set; }

        /// <summary>
        /// Gets or sets average latency in ms.
        /// </summary>
        [JsonProperty(PropertyName = "avgLatencyInMs")]
        public int? AvgLatencyInMs { get; set; }

        /// <summary>
        /// Gets or sets minimum latency in ms.
        /// </summary>
        [JsonProperty(PropertyName = "minLatencyInMs")]
        public int? MinLatencyInMs { get; set; }

        /// <summary>
        /// Gets or sets maximum latency in ms.
        /// </summary>
        [JsonProperty(PropertyName = "maxLatencyInMs")]
        public int? MaxLatencyInMs { get; set; }

        /// <summary>
        /// Gets or sets the number of sent probes.
        /// </summary>
        [JsonProperty(PropertyName = "probesSent")]
        public int? ProbesSent { get; set; }

        /// <summary>
        /// Gets or sets the number of failed probes.
        /// </summary>
        [JsonProperty(PropertyName = "probesFailed")]
        public int? ProbesFailed { get; set; }

        /// <summary>
        /// Gets list of hops between the source and the destination.
        /// </summary>
        [JsonProperty(PropertyName = "hops")]
        public IList<ConnectivityHop> Hops { get; private set; }

    }
}
