// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Information about an issue encountered in the process of checking for
    /// connectivity.
    /// </summary>
    public partial class ConnectivityIssue
    {
        /// <summary>
        /// Initializes a new instance of the ConnectivityIssue class.
        /// </summary>
        public ConnectivityIssue()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ConnectivityIssue class.
        /// </summary>
        /// <param name="origin">The origin of the issue. Possible values
        /// include: 'Local', 'Inbound', 'Outbound'</param>
        /// <param name="severity">The severity of the issue. Possible values
        /// include: 'Error', 'Warning'</param>
        /// <param name="type">The type of issue. Possible values include:
        /// 'Unknown', 'AgentStopped', 'GuestFirewall', 'DnsResolution',
        /// 'SocketBind', 'NetworkSecurityRule', 'UserDefinedRoute',
        /// 'PortThrottled', 'Platform'</param>
        /// <param name="context">Provides additional context on the
        /// issue.</param>
        public ConnectivityIssue(Origin origin = default(Origin), Severity severity = default(Severity), IssueType type = default(IssueType), IList<IDictionary<string, string>> context = default(IList<IDictionary<string, string>>))
        {
            Origin = origin;
            Severity = severity;
            Type = type;
            Context = context;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the origin of the issue. Possible values include: 'Local',
        /// 'Inbound', 'Outbound'
        /// </summary>
        [JsonProperty(PropertyName = "origin")]
        public Origin Origin { get; private set; }

        /// <summary>
        /// Gets the severity of the issue. Possible values include: 'Error',
        /// 'Warning'
        /// </summary>
        [JsonProperty(PropertyName = "severity")]
        public Severity Severity { get; private set; }

        /// <summary>
        /// Gets the type of issue. Possible values include: 'Unknown',
        /// 'AgentStopped', 'GuestFirewall', 'DnsResolution', 'SocketBind',
        /// 'NetworkSecurityRule', 'UserDefinedRoute', 'PortThrottled',
        /// 'Platform'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public IssueType Type { get; private set; }

        /// <summary>
        /// Gets provides additional context on the issue.
        /// </summary>
        [JsonProperty(PropertyName = "context")]
        public IList<IDictionary<string, string>> Context { get; private set; }

    }
}
