// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Results of network security group evaluation.
    /// </summary>
    public partial class EvaluatedNetworkSecurityGroup
    {
        /// <summary>
        /// Initializes a new instance of the EvaluatedNetworkSecurityGroup
        /// class.
        /// </summary>
        public EvaluatedNetworkSecurityGroup()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the EvaluatedNetworkSecurityGroup
        /// class.
        /// </summary>
        /// <param name="networkSecurityGroupId">Network security group
        /// ID.</param>
        /// <param name="appliedTo">Resource ID of nic or subnet to which
        /// network security group is applied.</param>
        /// <param name="matchedRule">Matched network security rule.</param>
        /// <param name="rulesEvaluationResult">List of network security rules
        /// evaluation results.</param>
        public EvaluatedNetworkSecurityGroup(string networkSecurityGroupId = default(string), string appliedTo = default(string), MatchedRule matchedRule = default(MatchedRule), IList<NetworkSecurityRulesEvaluationResult> rulesEvaluationResult = default(IList<NetworkSecurityRulesEvaluationResult>))
        {
            NetworkSecurityGroupId = networkSecurityGroupId;
            AppliedTo = appliedTo;
            MatchedRule = matchedRule;
            RulesEvaluationResult = rulesEvaluationResult;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets network security group ID.
        /// </summary>
        [JsonProperty(PropertyName = "networkSecurityGroupId")]
        public string NetworkSecurityGroupId { get; set; }

        /// <summary>
        /// Gets or sets resource ID of nic or subnet to which network security
        /// group is applied.
        /// </summary>
        [JsonProperty(PropertyName = "appliedTo")]
        public string AppliedTo { get; set; }

        /// <summary>
        /// Gets or sets matched network security rule.
        /// </summary>
        [JsonProperty(PropertyName = "matchedRule")]
        public MatchedRule MatchedRule { get; set; }

        /// <summary>
        /// Gets list of network security rules evaluation results.
        /// </summary>
        [JsonProperty(PropertyName = "rulesEvaluationResult")]
        public IList<NetworkSecurityRulesEvaluationResult> RulesEvaluationResult { get; private set; }

    }
}
