// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// List of Vpn-Sites.
    /// </summary>
    public partial class GetVpnSitesConfigurationRequest
    {
        /// <summary>
        /// Initializes a new instance of the GetVpnSitesConfigurationRequest
        /// class.
        /// </summary>
        public GetVpnSitesConfigurationRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the GetVpnSitesConfigurationRequest
        /// class.
        /// </summary>
        /// <param name="outputBlobSasUrl">The sas-url to download the
        /// configurations for vpn-sites.</param>
        /// <param name="vpnSites">List of resource-ids of the vpn-sites for
        /// which config is to be downloaded.</param>
        public GetVpnSitesConfigurationRequest(string outputBlobSasUrl, IList<string> vpnSites = default(IList<string>))
        {
            VpnSites = vpnSites;
            OutputBlobSasUrl = outputBlobSasUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of resource-ids of the vpn-sites for which config
        /// is to be downloaded.
        /// </summary>
        [JsonProperty(PropertyName = "vpnSites")]
        public IList<string> VpnSites { get; set; }

        /// <summary>
        /// Gets or sets the sas-url to download the configurations for
        /// vpn-sites.
        /// </summary>
        [JsonProperty(PropertyName = "outputBlobSasUrl")]
        public string OutputBlobSasUrl { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (OutputBlobSasUrl == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OutputBlobSasUrl");
            }
        }
    }
}
