// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The IpGroups resource information.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class IpGroupInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the IpGroupInner class.
        /// </summary>
        public IpGroupInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the IpGroupInner class.
        /// </summary>
        /// <param name="provisioningState">The provisioning state of the
        /// IpGroups resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="ipAddresses">IpAddresses/IpAddressPrefixes in the
        /// IpGroups resource.</param>
        /// <param name="firewalls">List of references to Azure resources that
        /// this IpGroups is associated with.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public IpGroupInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), ProvisioningState provisioningState = default(ProvisioningState), IList<string> ipAddresses = default(IList<string>), IList<Management.ResourceManager.Fluent.SubResource> firewalls = default(IList<Management.ResourceManager.Fluent.SubResource>), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            ProvisioningState = provisioningState;
            IpAddresses = ipAddresses;
            Firewalls = firewalls;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the provisioning state of the IpGroups resource. Possible
        /// values include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets ipAddresses/IpAddressPrefixes in the IpGroups
        /// resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ipAddresses")]
        public IList<string> IpAddresses { get; set; }

        /// <summary>
        /// Gets list of references to Azure resources that this IpGroups is
        /// associated with.
        /// </summary>
        [JsonProperty(PropertyName = "properties.firewalls")]
        public IList<Management.ResourceManager.Fluent.SubResource> Firewalls { get; private set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
