// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Define match variables.
    /// </summary>
    public partial class MatchVariable
    {
        /// <summary>
        /// Initializes a new instance of the MatchVariable class.
        /// </summary>
        public MatchVariable()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the MatchVariable class.
        /// </summary>
        /// <param name="variableName">Match Variable. Possible values include:
        /// 'RemoteAddr', 'RequestMethod', 'QueryString', 'PostArgs',
        /// 'RequestUri', 'RequestHeaders', 'RequestBody',
        /// 'RequestCookies'</param>
        /// <param name="selector">Describes field of the matchVariable
        /// collection.</param>
        public MatchVariable(WebApplicationFirewallMatchVariable variableName, string selector = default(string))
        {
            VariableName = variableName;
            Selector = selector;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets match Variable. Possible values include: 'RemoteAddr',
        /// 'RequestMethod', 'QueryString', 'PostArgs', 'RequestUri',
        /// 'RequestHeaders', 'RequestBody', 'RequestCookies'
        /// </summary>
        [JsonProperty(PropertyName = "variableName")]
        public WebApplicationFirewallMatchVariable VariableName { get; set; }

        /// <summary>
        /// Gets or sets describes field of the matchVariable collection.
        /// </summary>
        [JsonProperty(PropertyName = "selector")]
        public string Selector { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VariableName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VariableName");
            }
        }
    }
}
