// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Network configuration diagnostic result corresponded to provided
    /// traffic query.
    /// </summary>
    public partial class NetworkConfigurationDiagnosticResult
    {
        /// <summary>
        /// Initializes a new instance of the
        /// NetworkConfigurationDiagnosticResult class.
        /// </summary>
        public NetworkConfigurationDiagnosticResult()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// NetworkConfigurationDiagnosticResult class.
        /// </summary>
        /// <param name="profile">Network configuration diagnostic
        /// profile.</param>
        /// <param name="networkSecurityGroupResult">Network security group
        /// result.</param>
        public NetworkConfigurationDiagnosticResult(NetworkConfigurationDiagnosticProfile profile = default(NetworkConfigurationDiagnosticProfile), NetworkSecurityGroupResult networkSecurityGroupResult = default(NetworkSecurityGroupResult))
        {
            Profile = profile;
            NetworkSecurityGroupResult = networkSecurityGroupResult;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets network configuration diagnostic profile.
        /// </summary>
        [JsonProperty(PropertyName = "profile")]
        public NetworkConfigurationDiagnosticProfile Profile { get; set; }

        /// <summary>
        /// Gets or sets network security group result.
        /// </summary>
        [JsonProperty(PropertyName = "networkSecurityGroupResult")]
        public NetworkSecurityGroupResult NetworkSecurityGroupResult { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Profile != null)
            {
                Profile.Validate();
            }
        }
    }
}
