// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// List of P2S Vpn connection health request.
    /// </summary>
    public partial class P2SVpnConnectionHealthRequest
    {
        /// <summary>
        /// Initializes a new instance of the P2SVpnConnectionHealthRequest
        /// class.
        /// </summary>
        public P2SVpnConnectionHealthRequest()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the P2SVpnConnectionHealthRequest
        /// class.
        /// </summary>
        /// <param name="vpnUserNamesFilter">The list of p2s vpn user names
        /// whose p2s vpn connection detailed health to retrieve for.</param>
        /// <param name="outputBlobSasUrl">The sas-url to download the P2S Vpn
        /// connection health detail.</param>
        public P2SVpnConnectionHealthRequest(IList<string> vpnUserNamesFilter = default(IList<string>), string outputBlobSasUrl = default(string))
        {
            VpnUserNamesFilter = vpnUserNamesFilter;
            OutputBlobSasUrl = outputBlobSasUrl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the list of p2s vpn user names whose p2s vpn
        /// connection detailed health to retrieve for.
        /// </summary>
        [JsonProperty(PropertyName = "vpnUserNamesFilter")]
        public IList<string> VpnUserNamesFilter { get; set; }

        /// <summary>
        /// Gets or sets the sas-url to download the P2S Vpn connection health
        /// detail.
        /// </summary>
        [JsonProperty(PropertyName = "outputBlobSasUrl")]
        public string OutputBlobSasUrl { get; set; }

    }
}
