// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// VirtualNetworkGatewayConnection properties.
    /// </summary>
    public partial class TunnelConnectionHealth
    {
        /// <summary>
        /// Initializes a new instance of the TunnelConnectionHealth class.
        /// </summary>
        public TunnelConnectionHealth()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TunnelConnectionHealth class.
        /// </summary>
        /// <param name="tunnel">Tunnel name.</param>
        /// <param name="connectionStatus">Virtual Network Gateway connection
        /// status. Possible values include: 'Unknown', 'Connecting',
        /// 'Connected', 'NotConnected'</param>
        /// <param name="ingressBytesTransferred">The Ingress Bytes Transferred
        /// in this connection.</param>
        /// <param name="egressBytesTransferred">The Egress Bytes Transferred
        /// in this connection.</param>
        /// <param name="lastConnectionEstablishedUtcTime">The time at which
        /// connection was established in Utc format.</param>
        public TunnelConnectionHealth(string tunnel = default(string), VirtualNetworkGatewayConnectionStatus connectionStatus = default(VirtualNetworkGatewayConnectionStatus), long? ingressBytesTransferred = default(long?), long? egressBytesTransferred = default(long?), string lastConnectionEstablishedUtcTime = default(string))
        {
            Tunnel = tunnel;
            ConnectionStatus = connectionStatus;
            IngressBytesTransferred = ingressBytesTransferred;
            EgressBytesTransferred = egressBytesTransferred;
            LastConnectionEstablishedUtcTime = lastConnectionEstablishedUtcTime;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets tunnel name.
        /// </summary>
        [JsonProperty(PropertyName = "tunnel")]
        public string Tunnel { get; private set; }

        /// <summary>
        /// Gets virtual Network Gateway connection status. Possible values
        /// include: 'Unknown', 'Connecting', 'Connected', 'NotConnected'
        /// </summary>
        [JsonProperty(PropertyName = "connectionStatus")]
        public VirtualNetworkGatewayConnectionStatus ConnectionStatus { get; private set; }

        /// <summary>
        /// Gets the Ingress Bytes Transferred in this connection.
        /// </summary>
        [JsonProperty(PropertyName = "ingressBytesTransferred")]
        public long? IngressBytesTransferred { get; private set; }

        /// <summary>
        /// Gets the Egress Bytes Transferred in this connection.
        /// </summary>
        [JsonProperty(PropertyName = "egressBytesTransferred")]
        public long? EgressBytesTransferred { get; private set; }

        /// <summary>
        /// Gets the time at which connection was established in Utc format.
        /// </summary>
        [JsonProperty(PropertyName = "lastConnectionEstablishedUtcTime")]
        public string LastConnectionEstablishedUtcTime { get; private set; }

    }
}
