// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// VirtualHubRouteTableV2 Resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VirtualHubRouteTableV2Inner : Management.ResourceManager.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the VirtualHubRouteTableV2Inner
        /// class.
        /// </summary>
        public VirtualHubRouteTableV2Inner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualHubRouteTableV2Inner
        /// class.
        /// </summary>
        /// <param name="routes">List of all routes.</param>
        /// <param name="attachedConnections">List of all connections attached
        /// to this route table v2.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// virtual hub route table v2 resource. Possible values include:
        /// 'Succeeded', 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="name">The name of the resource that is unique within a
        /// resource group. This name can be used to access the
        /// resource.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public VirtualHubRouteTableV2Inner(string id = default(string), IList<VirtualHubRouteV2> routes = default(IList<VirtualHubRouteV2>), IList<string> attachedConnections = default(IList<string>), ProvisioningState provisioningState = default(ProvisioningState), string name = default(string), string etag = default(string))
            : base(id)
        {
            Routes = routes;
            AttachedConnections = attachedConnections;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets list of all routes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.routes")]
        public IList<VirtualHubRouteV2> Routes { get; set; }

        /// <summary>
        /// Gets or sets list of all connections attached to this route table
        /// v2.
        /// </summary>
        [JsonProperty(PropertyName = "properties.attachedConnections")]
        public IList<string> AttachedConnections { get; set; }

        /// <summary>
        /// Gets the provisioning state of the virtual hub route table v2
        /// resource. Possible values include: 'Succeeded', 'Updating',
        /// 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets the name of the resource that is unique within a
        /// resource group. This name can be used to access the resource.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

    }
}
