// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// VirtualHubRouteTableV2 route.
    /// </summary>
    public partial class VirtualHubRouteV2
    {
        /// <summary>
        /// Initializes a new instance of the VirtualHubRouteV2 class.
        /// </summary>
        public VirtualHubRouteV2()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualHubRouteV2 class.
        /// </summary>
        /// <param name="destinationType">The type of destinations.</param>
        /// <param name="destinations">List of all destinations.</param>
        /// <param name="nextHopType">The type of next hops.</param>
        /// <param name="nextHops">NextHops ip address.</param>
        public VirtualHubRouteV2(string destinationType = default(string), IList<string> destinations = default(IList<string>), string nextHopType = default(string), IList<string> nextHops = default(IList<string>))
        {
            DestinationType = destinationType;
            Destinations = destinations;
            NextHopType = nextHopType;
            NextHops = nextHops;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the type of destinations.
        /// </summary>
        [JsonProperty(PropertyName = "destinationType")]
        public string DestinationType { get; set; }

        /// <summary>
        /// Gets or sets list of all destinations.
        /// </summary>
        [JsonProperty(PropertyName = "destinations")]
        public IList<string> Destinations { get; set; }

        /// <summary>
        /// Gets or sets the type of next hops.
        /// </summary>
        [JsonProperty(PropertyName = "nextHopType")]
        public string NextHopType { get; set; }

        /// <summary>
        /// Gets or sets nextHops ip address.
        /// </summary>
        [JsonProperty(PropertyName = "nextHops")]
        public IList<string> NextHops { get; set; }

    }
}
