// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Virtual Network resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VirtualNetworkInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkInner class.
        /// </summary>
        public VirtualNetworkInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualNetworkInner class.
        /// </summary>
        /// <param name="addressSpace">The AddressSpace that contains an array
        /// of IP address ranges that can be used by subnets.</param>
        /// <param name="dhcpOptions">The dhcpOptions that contains an array of
        /// DNS servers available to VMs deployed in the virtual
        /// network.</param>
        /// <param name="subnets">A list of subnets in a Virtual
        /// Network.</param>
        /// <param name="virtualNetworkPeerings">A list of peerings in a
        /// Virtual Network.</param>
        /// <param name="resourceGuid">The resourceGuid property of the Virtual
        /// Network resource.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// virtual network resource. Possible values include: 'Succeeded',
        /// 'Updating', 'Deleting', 'Failed'</param>
        /// <param name="enableDdosProtection">Indicates if DDoS protection is
        /// enabled for all the protected resources in the virtual network. It
        /// requires a DDoS protection plan associated with the
        /// resource.</param>
        /// <param name="enableVmProtection">Indicates if VM protection is
        /// enabled for all the subnets in the virtual network.</param>
        /// <param name="ddosProtectionPlan">The DDoS protection plan
        /// associated with the virtual network.</param>
        /// <param name="bgpCommunities">Bgp Communities sent over ExpressRoute
        /// with each route corresponding to a prefix in this VNET.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public VirtualNetworkInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), AddressSpace addressSpace = default(AddressSpace), DhcpOptions dhcpOptions = default(DhcpOptions), IList<SubnetInner> subnets = default(IList<SubnetInner>), IList<VirtualNetworkPeeringInner> virtualNetworkPeerings = default(IList<VirtualNetworkPeeringInner>), string resourceGuid = default(string), ProvisioningState provisioningState = default(ProvisioningState), bool? enableDdosProtection = default(bool?), bool? enableVmProtection = default(bool?), Management.ResourceManager.Fluent.SubResource ddosProtectionPlan = default(Management.ResourceManager.Fluent.SubResource), VirtualNetworkBgpCommunities bgpCommunities = default(VirtualNetworkBgpCommunities), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            AddressSpace = addressSpace;
            DhcpOptions = dhcpOptions;
            Subnets = subnets;
            VirtualNetworkPeerings = virtualNetworkPeerings;
            ResourceGuid = resourceGuid;
            ProvisioningState = provisioningState;
            EnableDdosProtection = enableDdosProtection;
            EnableVmProtection = enableVmProtection;
            DdosProtectionPlan = ddosProtectionPlan;
            BgpCommunities = bgpCommunities;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the AddressSpace that contains an array of IP address
        /// ranges that can be used by subnets.
        /// </summary>
        [JsonProperty(PropertyName = "properties.addressSpace")]
        public AddressSpace AddressSpace { get; set; }

        /// <summary>
        /// Gets or sets the dhcpOptions that contains an array of DNS servers
        /// available to VMs deployed in the virtual network.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dhcpOptions")]
        public DhcpOptions DhcpOptions { get; set; }

        /// <summary>
        /// Gets or sets a list of subnets in a Virtual Network.
        /// </summary>
        [JsonProperty(PropertyName = "properties.subnets")]
        public IList<SubnetInner> Subnets { get; set; }

        /// <summary>
        /// Gets or sets a list of peerings in a Virtual Network.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualNetworkPeerings")]
        public IList<VirtualNetworkPeeringInner> VirtualNetworkPeerings { get; set; }

        /// <summary>
        /// Gets the resourceGuid property of the Virtual Network resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceGuid")]
        public string ResourceGuid { get; private set; }

        /// <summary>
        /// Gets the provisioning state of the virtual network resource.
        /// Possible values include: 'Succeeded', 'Updating', 'Deleting',
        /// 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets indicates if DDoS protection is enabled for all the
        /// protected resources in the virtual network. It requires a DDoS
        /// protection plan associated with the resource.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableDdosProtection")]
        public bool? EnableDdosProtection { get; set; }

        /// <summary>
        /// Gets or sets indicates if VM protection is enabled for all the
        /// subnets in the virtual network.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableVmProtection")]
        public bool? EnableVmProtection { get; set; }

        /// <summary>
        /// Gets or sets the DDoS protection plan associated with the virtual
        /// network.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ddosProtectionPlan")]
        public Management.ResourceManager.Fluent.SubResource DdosProtectionPlan { get; set; }

        /// <summary>
        /// Gets or sets bgp Communities sent over ExpressRoute with each route
        /// corresponding to a prefix in this VNET.
        /// </summary>
        [JsonProperty(PropertyName = "properties.bgpCommunities")]
        public VirtualNetworkBgpCommunities BgpCommunities { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (BgpCommunities != null)
            {
                BgpCommunities.Validate();
            }
        }
    }
}
