// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// VirtualRouter Resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VirtualRouterInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the VirtualRouterInner class.
        /// </summary>
        public VirtualRouterInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualRouterInner class.
        /// </summary>
        /// <param name="virtualRouterAsn">VirtualRouter ASN.</param>
        /// <param name="virtualRouterIps">VirtualRouter IPs.</param>
        /// <param name="hostedSubnet">The Subnet on which VirtualRouter is
        /// hosted.</param>
        /// <param name="hostedGateway">The Gateway on which VirtualRouter is
        /// hosted.</param>
        /// <param name="peerings">List of references to
        /// VirtualRouterPeerings.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// resource. Possible values include: 'Succeeded', 'Updating',
        /// 'Deleting', 'Failed'</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public VirtualRouterInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), long? virtualRouterAsn = default(long?), IList<string> virtualRouterIps = default(IList<string>), Management.ResourceManager.Fluent.SubResource hostedSubnet = default(Management.ResourceManager.Fluent.SubResource), Management.ResourceManager.Fluent.SubResource hostedGateway = default(Management.ResourceManager.Fluent.SubResource), IList<Management.ResourceManager.Fluent.SubResource> peerings = default(IList<Management.ResourceManager.Fluent.SubResource>), ProvisioningState provisioningState = default(ProvisioningState), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            VirtualRouterAsn = virtualRouterAsn;
            VirtualRouterIps = virtualRouterIps;
            HostedSubnet = hostedSubnet;
            HostedGateway = hostedGateway;
            Peerings = peerings;
            ProvisioningState = provisioningState;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets virtualRouter ASN.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualRouterAsn")]
        public long? VirtualRouterAsn { get; set; }

        /// <summary>
        /// Gets or sets virtualRouter IPs.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualRouterIps")]
        public IList<string> VirtualRouterIps { get; set; }

        /// <summary>
        /// Gets or sets the Subnet on which VirtualRouter is hosted.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hostedSubnet")]
        public Management.ResourceManager.Fluent.SubResource HostedSubnet { get; set; }

        /// <summary>
        /// Gets or sets the Gateway on which VirtualRouter is hosted.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hostedGateway")]
        public Management.ResourceManager.Fluent.SubResource HostedGateway { get; set; }

        /// <summary>
        /// Gets list of references to VirtualRouterPeerings.
        /// </summary>
        [JsonProperty(PropertyName = "properties.peerings")]
        public IList<Management.ResourceManager.Fluent.SubResource> Peerings { get; private set; }

        /// <summary>
        /// Gets the provisioning state of the resource. Possible values
        /// include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VirtualRouterAsn > 4294967295)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "VirtualRouterAsn", 4294967295);
            }
            if (VirtualRouterAsn < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "VirtualRouterAsn", 0);
            }
        }
    }
}
