// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Virtual Router Peering resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VirtualRouterPeeringInner : Management.ResourceManager.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the VirtualRouterPeeringInner class.
        /// </summary>
        public VirtualRouterPeeringInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualRouterPeeringInner class.
        /// </summary>
        /// <param name="peerAsn">Peer ASN.</param>
        /// <param name="peerIp">Peer IP.</param>
        /// <param name="provisioningState">The provisioning state of the
        /// resource. Possible values include: 'Succeeded', 'Updating',
        /// 'Deleting', 'Failed'</param>
        /// <param name="name">Name of the virtual router peering that is
        /// unique within a virtual router.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        /// <param name="type">Peering type.</param>
        public VirtualRouterPeeringInner(string id = default(string), long? peerAsn = default(long?), string peerIp = default(string), ProvisioningState provisioningState = default(ProvisioningState), string name = default(string), string etag = default(string), string type = default(string))
            : base(id)
        {
            PeerAsn = peerAsn;
            PeerIp = peerIp;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets peer ASN.
        /// </summary>
        [JsonProperty(PropertyName = "properties.peerAsn")]
        public long? PeerAsn { get; set; }

        /// <summary>
        /// Gets or sets peer IP.
        /// </summary>
        [JsonProperty(PropertyName = "properties.peerIp")]
        public string PeerIp { get; set; }

        /// <summary>
        /// Gets the provisioning state of the resource. Possible values
        /// include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets name of the virtual router peering that is unique
        /// within a virtual router.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Gets peering type.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PeerAsn > 4294967295)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "PeerAsn", 4294967295);
            }
            if (PeerAsn < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "PeerAsn", 0);
            }
        }
    }
}
