// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Collection of SecurityProviders.
    /// </summary>
    public partial class VirtualWanSecurityProvider
    {
        /// <summary>
        /// Initializes a new instance of the VirtualWanSecurityProvider class.
        /// </summary>
        public VirtualWanSecurityProvider()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualWanSecurityProvider class.
        /// </summary>
        /// <param name="name">Name of the security provider.</param>
        /// <param name="url">Url of the security provider.</param>
        /// <param name="type">Name of the security provider. Possible values
        /// include: 'External', 'Native'</param>
        public VirtualWanSecurityProvider(string name = default(string), string url = default(string), VirtualWanSecurityProviderType type = default(VirtualWanSecurityProviderType))
        {
            Name = name;
            Url = url;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets name of the security provider.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets url of the security provider.
        /// </summary>
        [JsonProperty(PropertyName = "url")]
        public string Url { get; set; }

        /// <summary>
        /// Gets or sets name of the security provider. Possible values
        /// include: 'External', 'Native'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public VirtualWanSecurityProviderType Type { get; set; }

    }
}
