// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// VpnClientConfiguration for P2S client.
    /// </summary>
    public partial class VpnClientConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the VpnClientConfiguration class.
        /// </summary>
        public VpnClientConfiguration()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VpnClientConfiguration class.
        /// </summary>
        /// <param name="vpnClientAddressPool">The reference of the address
        /// space resource which represents Address space for P2S
        /// VpnClient.</param>
        /// <param name="vpnClientRootCertificates">VpnClientRootCertificate
        /// for virtual network gateway.</param>
        /// <param
        /// name="vpnClientRevokedCertificates">VpnClientRevokedCertificate for
        /// Virtual network gateway.</param>
        /// <param name="vpnClientProtocols">VpnClientProtocols for Virtual
        /// network gateway.</param>
        /// <param name="vpnClientIpsecPolicies">VpnClientIpsecPolicies for
        /// virtual network gateway P2S client.</param>
        /// <param name="radiusServerAddress">The radius server address
        /// property of the VirtualNetworkGateway resource for vpn client
        /// connection.</param>
        /// <param name="radiusServerSecret">The radius secret property of the
        /// VirtualNetworkGateway resource for vpn client connection.</param>
        /// <param name="aadTenant">The AADTenant property of the
        /// VirtualNetworkGateway resource for vpn client connection used for
        /// AAD authentication.</param>
        /// <param name="aadAudience">The AADAudience property of the
        /// VirtualNetworkGateway resource for vpn client connection used for
        /// AAD authentication.</param>
        /// <param name="aadIssuer">The AADIssuer property of the
        /// VirtualNetworkGateway resource for vpn client connection used for
        /// AAD authentication.</param>
        public VpnClientConfiguration(AddressSpace vpnClientAddressPool = default(AddressSpace), IList<VpnClientRootCertificateInner> vpnClientRootCertificates = default(IList<VpnClientRootCertificateInner>), IList<VpnClientRevokedCertificateInner> vpnClientRevokedCertificates = default(IList<VpnClientRevokedCertificateInner>), IList<VpnClientProtocol> vpnClientProtocols = default(IList<VpnClientProtocol>), IList<IpsecPolicy> vpnClientIpsecPolicies = default(IList<IpsecPolicy>), string radiusServerAddress = default(string), string radiusServerSecret = default(string), string aadTenant = default(string), string aadAudience = default(string), string aadIssuer = default(string))
        {
            VpnClientAddressPool = vpnClientAddressPool;
            VpnClientRootCertificates = vpnClientRootCertificates;
            VpnClientRevokedCertificates = vpnClientRevokedCertificates;
            VpnClientProtocols = vpnClientProtocols;
            VpnClientIpsecPolicies = vpnClientIpsecPolicies;
            RadiusServerAddress = radiusServerAddress;
            RadiusServerSecret = radiusServerSecret;
            AadTenant = aadTenant;
            AadAudience = aadAudience;
            AadIssuer = aadIssuer;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the reference of the address space resource which
        /// represents Address space for P2S VpnClient.
        /// </summary>
        [JsonProperty(PropertyName = "vpnClientAddressPool")]
        public AddressSpace VpnClientAddressPool { get; set; }

        /// <summary>
        /// Gets or sets vpnClientRootCertificate for virtual network gateway.
        /// </summary>
        [JsonProperty(PropertyName = "vpnClientRootCertificates")]
        public IList<VpnClientRootCertificateInner> VpnClientRootCertificates { get; set; }

        /// <summary>
        /// Gets or sets vpnClientRevokedCertificate for Virtual network
        /// gateway.
        /// </summary>
        [JsonProperty(PropertyName = "vpnClientRevokedCertificates")]
        public IList<VpnClientRevokedCertificateInner> VpnClientRevokedCertificates { get; set; }

        /// <summary>
        /// Gets or sets vpnClientProtocols for Virtual network gateway.
        /// </summary>
        [JsonProperty(PropertyName = "vpnClientProtocols")]
        public IList<VpnClientProtocol> VpnClientProtocols { get; set; }

        /// <summary>
        /// Gets or sets vpnClientIpsecPolicies for virtual network gateway P2S
        /// client.
        /// </summary>
        [JsonProperty(PropertyName = "vpnClientIpsecPolicies")]
        public IList<IpsecPolicy> VpnClientIpsecPolicies { get; set; }

        /// <summary>
        /// Gets or sets the radius server address property of the
        /// VirtualNetworkGateway resource for vpn client connection.
        /// </summary>
        [JsonProperty(PropertyName = "radiusServerAddress")]
        public string RadiusServerAddress { get; set; }

        /// <summary>
        /// Gets or sets the radius secret property of the
        /// VirtualNetworkGateway resource for vpn client connection.
        /// </summary>
        [JsonProperty(PropertyName = "radiusServerSecret")]
        public string RadiusServerSecret { get; set; }

        /// <summary>
        /// Gets or sets the AADTenant property of the VirtualNetworkGateway
        /// resource for vpn client connection used for AAD authentication.
        /// </summary>
        [JsonProperty(PropertyName = "aadTenant")]
        public string AadTenant { get; set; }

        /// <summary>
        /// Gets or sets the AADAudience property of the VirtualNetworkGateway
        /// resource for vpn client connection used for AAD authentication.
        /// </summary>
        [JsonProperty(PropertyName = "aadAudience")]
        public string AadAudience { get; set; }

        /// <summary>
        /// Gets or sets the AADIssuer property of the VirtualNetworkGateway
        /// resource for vpn client connection used for AAD authentication.
        /// </summary>
        [JsonProperty(PropertyName = "aadIssuer")]
        public string AadIssuer { get; set; }

    }
}
