// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// BGP settings details for a link.
    /// </summary>
    public partial class VpnLinkBgpSettings
    {
        /// <summary>
        /// Initializes a new instance of the VpnLinkBgpSettings class.
        /// </summary>
        public VpnLinkBgpSettings()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VpnLinkBgpSettings class.
        /// </summary>
        /// <param name="asn">The BGP speaker's ASN.</param>
        /// <param name="bgpPeeringAddress">The BGP peering address and BGP
        /// identifier of this BGP speaker.</param>
        public VpnLinkBgpSettings(long? asn = default(long?), string bgpPeeringAddress = default(string))
        {
            Asn = asn;
            BgpPeeringAddress = bgpPeeringAddress;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the BGP speaker's ASN.
        /// </summary>
        [JsonProperty(PropertyName = "asn")]
        public long? Asn { get; set; }

        /// <summary>
        /// Gets or sets the BGP peering address and BGP identifier of this BGP
        /// speaker.
        /// </summary>
        [JsonProperty(PropertyName = "bgpPeeringAddress")]
        public string BgpPeeringAddress { get; set; }

    }
}
