// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// VpnSite Resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VpnSiteInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the VpnSiteInner class.
        /// </summary>
        public VpnSiteInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VpnSiteInner class.
        /// </summary>
        /// <param name="virtualWan">The VirtualWAN to which the vpnSite
        /// belongs.</param>
        /// <param name="deviceProperties">The device properties.</param>
        /// <param name="ipAddress">The ip-address for the vpn-site.</param>
        /// <param name="siteKey">The key for vpn-site that can be used for
        /// connections.</param>
        /// <param name="addressSpace">The AddressSpace that contains an array
        /// of IP address ranges.</param>
        /// <param name="bgpProperties">The set of bgp properties.</param>
        /// <param name="provisioningState">The provisioning state of the VPN
        /// site resource. Possible values include: 'Succeeded', 'Updating',
        /// 'Deleting', 'Failed'</param>
        /// <param name="isSecuritySite">IsSecuritySite flag.</param>
        /// <param name="vpnSiteLinks">List of all vpn site links.</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated.</param>
        public VpnSiteInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), Management.ResourceManager.Fluent.SubResource virtualWan = default(Management.ResourceManager.Fluent.SubResource), DeviceProperties deviceProperties = default(DeviceProperties), string ipAddress = default(string), string siteKey = default(string), AddressSpace addressSpace = default(AddressSpace), BgpSettings bgpProperties = default(BgpSettings), ProvisioningState provisioningState = default(ProvisioningState), bool? isSecuritySite = default(bool?), IList<VpnSiteLinkInner> vpnSiteLinks = default(IList<VpnSiteLinkInner>), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            VirtualWan = virtualWan;
            DeviceProperties = deviceProperties;
            IpAddress = ipAddress;
            SiteKey = siteKey;
            AddressSpace = addressSpace;
            BgpProperties = bgpProperties;
            ProvisioningState = provisioningState;
            IsSecuritySite = isSecuritySite;
            VpnSiteLinks = vpnSiteLinks;
            Etag = etag;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the VirtualWAN to which the vpnSite belongs.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualWan")]
        public Management.ResourceManager.Fluent.SubResource VirtualWan { get; set; }

        /// <summary>
        /// Gets or sets the device properties.
        /// </summary>
        [JsonProperty(PropertyName = "properties.deviceProperties")]
        public DeviceProperties DeviceProperties { get; set; }

        /// <summary>
        /// Gets or sets the ip-address for the vpn-site.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ipAddress")]
        public string IpAddress { get; set; }

        /// <summary>
        /// Gets or sets the key for vpn-site that can be used for connections.
        /// </summary>
        [JsonProperty(PropertyName = "properties.siteKey")]
        public string SiteKey { get; set; }

        /// <summary>
        /// Gets or sets the AddressSpace that contains an array of IP address
        /// ranges.
        /// </summary>
        [JsonProperty(PropertyName = "properties.addressSpace")]
        public AddressSpace AddressSpace { get; set; }

        /// <summary>
        /// Gets or sets the set of bgp properties.
        /// </summary>
        [JsonProperty(PropertyName = "properties.bgpProperties")]
        public BgpSettings BgpProperties { get; set; }

        /// <summary>
        /// Gets the provisioning state of the VPN site resource. Possible
        /// values include: 'Succeeded', 'Updating', 'Deleting', 'Failed'
        /// </summary>
        [JsonProperty(PropertyName = "properties.provisioningState")]
        public ProvisioningState ProvisioningState { get; private set; }

        /// <summary>
        /// Gets or sets isSecuritySite flag.
        /// </summary>
        [JsonProperty(PropertyName = "properties.isSecuritySite")]
        public bool? IsSecuritySite { get; set; }

        /// <summary>
        /// Gets or sets list of all vpn site links.
        /// </summary>
        [JsonProperty(PropertyName = "properties.vpnSiteLinks")]
        public IList<VpnSiteLinkInner> VpnSiteLinks { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
