// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Network.Fluent
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Azure.Management.ResourceManager.Fluent.Core;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Models;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;
    using System.Net;
    using System.Net.Http;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Network Client
    /// </summary>
    public partial class NetworkManagementClient : Management.ResourceManager.Fluent.Core.FluentServiceClientBase<NetworkManagementClient>, INetworkManagementClient, IAzureClient
    {
        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        public JsonSerializerSettings SerializationSettings { get; private set; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        public JsonSerializerSettings DeserializationSettings { get; private set; }

        /// <summary>
        /// The subscription credentials which uniquely identify the Microsoft Azure
        /// subscription. The subscription ID forms part of the URI for every service
        /// call.
        /// </summary>
        public string SubscriptionId { get; set; }

        /// <summary>
        /// Client API version.
        /// </summary>
        public string ApiVersion { get; private set; }

        /// <summary>
        /// The preferred language for the response.
        /// </summary>
        public string AcceptLanguage { get; set; }

        /// <summary>
        /// The retry timeout in seconds for Long Running Operations. Default value is
        /// 30.
        /// </summary>
        public int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// Whether a unique x-ms-client-request-id should be generated. When set to
        /// true a unique x-ms-client-request-id value is generated and included in
        /// each request. Default is true.
        /// </summary>
        public bool? GenerateClientRequestId { get; set; }

        /// <summary>
        /// Gets the IApplicationGatewaysOperations.
        /// </summary>
        public virtual IApplicationGatewaysOperations ApplicationGateways { get; private set; }

        /// <summary>
        /// Gets the IApplicationSecurityGroupsOperations.
        /// </summary>
        public virtual IApplicationSecurityGroupsOperations ApplicationSecurityGroups { get; private set; }

        /// <summary>
        /// Gets the IAvailableDelegationsOperations.
        /// </summary>
        public virtual IAvailableDelegationsOperations AvailableDelegations { get; private set; }

        /// <summary>
        /// Gets the IAvailableResourceGroupDelegationsOperations.
        /// </summary>
        public virtual IAvailableResourceGroupDelegationsOperations AvailableResourceGroupDelegations { get; private set; }

        /// <summary>
        /// Gets the IAvailableServiceAliasesOperations.
        /// </summary>
        public virtual IAvailableServiceAliasesOperations AvailableServiceAliases { get; private set; }

        /// <summary>
        /// Gets the IAzureFirewallsOperations.
        /// </summary>
        public virtual IAzureFirewallsOperations AzureFirewalls { get; private set; }

        /// <summary>
        /// Gets the IAzureFirewallFqdnTagsOperations.
        /// </summary>
        public virtual IAzureFirewallFqdnTagsOperations AzureFirewallFqdnTags { get; private set; }

        /// <summary>
        /// Gets the IBastionHostsOperations.
        /// </summary>
        public virtual IBastionHostsOperations BastionHosts { get; private set; }

        /// <summary>
        /// Gets the IDdosCustomPoliciesOperations.
        /// </summary>
        public virtual IDdosCustomPoliciesOperations DdosCustomPolicies { get; private set; }

        /// <summary>
        /// Gets the IDdosProtectionPlansOperations.
        /// </summary>
        public virtual IDdosProtectionPlansOperations DdosProtectionPlans { get; private set; }

        /// <summary>
        /// Gets the IAvailableEndpointServicesOperations.
        /// </summary>
        public virtual IAvailableEndpointServicesOperations AvailableEndpointServices { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCircuitAuthorizationsOperations.
        /// </summary>
        public virtual IExpressRouteCircuitAuthorizationsOperations ExpressRouteCircuitAuthorizations { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCircuitPeeringsOperations.
        /// </summary>
        public virtual IExpressRouteCircuitPeeringsOperations ExpressRouteCircuitPeerings { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCircuitConnectionsOperations.
        /// </summary>
        public virtual IExpressRouteCircuitConnectionsOperations ExpressRouteCircuitConnections { get; private set; }

        /// <summary>
        /// Gets the IPeerExpressRouteCircuitConnectionsOperations.
        /// </summary>
        public virtual IPeerExpressRouteCircuitConnectionsOperations PeerExpressRouteCircuitConnections { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCircuitsOperations.
        /// </summary>
        public virtual IExpressRouteCircuitsOperations ExpressRouteCircuits { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteServiceProvidersOperations.
        /// </summary>
        public virtual IExpressRouteServiceProvidersOperations ExpressRouteServiceProviders { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCrossConnectionsOperations.
        /// </summary>
        public virtual IExpressRouteCrossConnectionsOperations ExpressRouteCrossConnections { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteCrossConnectionPeeringsOperations.
        /// </summary>
        public virtual IExpressRouteCrossConnectionPeeringsOperations ExpressRouteCrossConnectionPeerings { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteGatewaysOperations.
        /// </summary>
        public virtual IExpressRouteGatewaysOperations ExpressRouteGateways { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteConnectionsOperations.
        /// </summary>
        public virtual IExpressRouteConnectionsOperations ExpressRouteConnections { get; private set; }

        /// <summary>
        /// Gets the IExpressRoutePortsLocationsOperations.
        /// </summary>
        public virtual IExpressRoutePortsLocationsOperations ExpressRoutePortsLocations { get; private set; }

        /// <summary>
        /// Gets the IExpressRoutePortsOperations.
        /// </summary>
        public virtual IExpressRoutePortsOperations ExpressRoutePorts { get; private set; }

        /// <summary>
        /// Gets the IExpressRouteLinksOperations.
        /// </summary>
        public virtual IExpressRouteLinksOperations ExpressRouteLinks { get; private set; }

        /// <summary>
        /// Gets the IFirewallPoliciesOperations.
        /// </summary>
        public virtual IFirewallPoliciesOperations FirewallPolicies { get; private set; }

        /// <summary>
        /// Gets the IFirewallPolicyRuleGroupsOperations.
        /// </summary>
        public virtual IFirewallPolicyRuleGroupsOperations FirewallPolicyRuleGroups { get; private set; }

        /// <summary>
        /// Gets the IIpGroupsOperations.
        /// </summary>
        public virtual IIpGroupsOperations IpGroups { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancersOperations.
        /// </summary>
        public virtual ILoadBalancersOperations LoadBalancers { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerBackendAddressPoolsOperations.
        /// </summary>
        public virtual ILoadBalancerBackendAddressPoolsOperations LoadBalancerBackendAddressPools { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerFrontendIPConfigurationsOperations.
        /// </summary>
        public virtual ILoadBalancerFrontendIPConfigurationsOperations LoadBalancerFrontendIPConfigurations { get; private set; }

        /// <summary>
        /// Gets the IInboundNatRulesOperations.
        /// </summary>
        public virtual IInboundNatRulesOperations InboundNatRules { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerLoadBalancingRulesOperations.
        /// </summary>
        public virtual ILoadBalancerLoadBalancingRulesOperations LoadBalancerLoadBalancingRules { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerOutboundRulesOperations.
        /// </summary>
        public virtual ILoadBalancerOutboundRulesOperations LoadBalancerOutboundRules { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerNetworkInterfacesOperations.
        /// </summary>
        public virtual ILoadBalancerNetworkInterfacesOperations LoadBalancerNetworkInterfaces { get; private set; }

        /// <summary>
        /// Gets the ILoadBalancerProbesOperations.
        /// </summary>
        public virtual ILoadBalancerProbesOperations LoadBalancerProbes { get; private set; }

        /// <summary>
        /// Gets the INatGatewaysOperations.
        /// </summary>
        public virtual INatGatewaysOperations NatGateways { get; private set; }

        /// <summary>
        /// Gets the INetworkInterfacesOperations.
        /// </summary>
        public virtual INetworkInterfacesOperations NetworkInterfaces { get; private set; }

        /// <summary>
        /// Gets the INetworkInterfaceIPConfigurationsOperations.
        /// </summary>
        public virtual INetworkInterfaceIPConfigurationsOperations NetworkInterfaceIPConfigurations { get; private set; }

        /// <summary>
        /// Gets the INetworkInterfaceLoadBalancersOperations.
        /// </summary>
        public virtual INetworkInterfaceLoadBalancersOperations NetworkInterfaceLoadBalancers { get; private set; }

        /// <summary>
        /// Gets the INetworkInterfaceTapConfigurationsOperations.
        /// </summary>
        public virtual INetworkInterfaceTapConfigurationsOperations NetworkInterfaceTapConfigurations { get; private set; }

        /// <summary>
        /// Gets the INetworkProfilesOperations.
        /// </summary>
        public virtual INetworkProfilesOperations NetworkProfiles { get; private set; }

        /// <summary>
        /// Gets the INetworkSecurityGroupsOperations.
        /// </summary>
        public virtual INetworkSecurityGroupsOperations NetworkSecurityGroups { get; private set; }

        /// <summary>
        /// Gets the ISecurityRulesOperations.
        /// </summary>
        public virtual ISecurityRulesOperations SecurityRules { get; private set; }

        /// <summary>
        /// Gets the IDefaultSecurityRulesOperations.
        /// </summary>
        public virtual IDefaultSecurityRulesOperations DefaultSecurityRules { get; private set; }

        /// <summary>
        /// Gets the INetworkWatchersOperations.
        /// </summary>
        public virtual INetworkWatchersOperations NetworkWatchers { get; private set; }

        /// <summary>
        /// Gets the IPacketCapturesOperations.
        /// </summary>
        public virtual IPacketCapturesOperations PacketCaptures { get; private set; }

        /// <summary>
        /// Gets the IConnectionMonitorsOperations.
        /// </summary>
        public virtual IConnectionMonitorsOperations ConnectionMonitors { get; private set; }

        /// <summary>
        /// Gets the IOperations.
        /// </summary>
        public virtual IOperations Operations { get; private set; }

        /// <summary>
        /// Gets the IPrivateEndpointsOperations.
        /// </summary>
        public virtual IPrivateEndpointsOperations PrivateEndpoints { get; private set; }

        /// <summary>
        /// Gets the IAvailablePrivateEndpointTypesOperations.
        /// </summary>
        public virtual IAvailablePrivateEndpointTypesOperations AvailablePrivateEndpointTypes { get; private set; }

        /// <summary>
        /// Gets the IPrivateLinkServicesOperations.
        /// </summary>
        public virtual IPrivateLinkServicesOperations PrivateLinkServices { get; private set; }

        /// <summary>
        /// Gets the IPublicIPAddressesOperations.
        /// </summary>
        public virtual IPublicIPAddressesOperations PublicIPAddresses { get; private set; }

        /// <summary>
        /// Gets the IPublicIPPrefixesOperations.
        /// </summary>
        public virtual IPublicIPPrefixesOperations PublicIPPrefixes { get; private set; }

        /// <summary>
        /// Gets the IRouteFiltersOperations.
        /// </summary>
        public virtual IRouteFiltersOperations RouteFilters { get; private set; }

        /// <summary>
        /// Gets the IRouteFilterRulesOperations.
        /// </summary>
        public virtual IRouteFilterRulesOperations RouteFilterRules { get; private set; }

        /// <summary>
        /// Gets the IRouteTablesOperations.
        /// </summary>
        public virtual IRouteTablesOperations RouteTables { get; private set; }

        /// <summary>
        /// Gets the IRoutesOperations.
        /// </summary>
        public virtual IRoutesOperations Routes { get; private set; }

        /// <summary>
        /// Gets the IBgpServiceCommunitiesOperations.
        /// </summary>
        public virtual IBgpServiceCommunitiesOperations BgpServiceCommunities { get; private set; }

        /// <summary>
        /// Gets the IServiceEndpointPoliciesOperations.
        /// </summary>
        public virtual IServiceEndpointPoliciesOperations ServiceEndpointPolicies { get; private set; }

        /// <summary>
        /// Gets the IServiceEndpointPolicyDefinitionsOperations.
        /// </summary>
        public virtual IServiceEndpointPolicyDefinitionsOperations ServiceEndpointPolicyDefinitions { get; private set; }

        /// <summary>
        /// Gets the IServiceTagsOperations.
        /// </summary>
        public virtual IServiceTagsOperations ServiceTags { get; private set; }

        /// <summary>
        /// Gets the IUsagesOperations.
        /// </summary>
        public virtual IUsagesOperations Usages { get; private set; }

        /// <summary>
        /// Gets the IVirtualNetworksOperations.
        /// </summary>
        public virtual IVirtualNetworksOperations VirtualNetworks { get; private set; }

        /// <summary>
        /// Gets the ISubnetsOperations.
        /// </summary>
        public virtual ISubnetsOperations Subnets { get; private set; }

        /// <summary>
        /// Gets the IResourceNavigationLinksOperations.
        /// </summary>
        public virtual IResourceNavigationLinksOperations ResourceNavigationLinks { get; private set; }

        /// <summary>
        /// Gets the IServiceAssociationLinksOperations.
        /// </summary>
        public virtual IServiceAssociationLinksOperations ServiceAssociationLinks { get; private set; }

        /// <summary>
        /// Gets the IVirtualNetworkPeeringsOperations.
        /// </summary>
        public virtual IVirtualNetworkPeeringsOperations VirtualNetworkPeerings { get; private set; }

        /// <summary>
        /// Gets the IVirtualNetworkGatewaysOperations.
        /// </summary>
        public virtual IVirtualNetworkGatewaysOperations VirtualNetworkGateways { get; private set; }

        /// <summary>
        /// Gets the IVirtualNetworkGatewayConnectionsOperations.
        /// </summary>
        public virtual IVirtualNetworkGatewayConnectionsOperations VirtualNetworkGatewayConnections { get; private set; }

        /// <summary>
        /// Gets the ILocalNetworkGatewaysOperations.
        /// </summary>
        public virtual ILocalNetworkGatewaysOperations LocalNetworkGateways { get; private set; }

        /// <summary>
        /// Gets the IVirtualNetworkTapsOperations.
        /// </summary>
        public virtual IVirtualNetworkTapsOperations VirtualNetworkTaps { get; private set; }

        /// <summary>
        /// Gets the IVirtualRoutersOperations.
        /// </summary>
        public virtual IVirtualRoutersOperations VirtualRouters { get; private set; }

        /// <summary>
        /// Gets the IVirtualRouterPeeringsOperations.
        /// </summary>
        public virtual IVirtualRouterPeeringsOperations VirtualRouterPeerings { get; private set; }

        /// <summary>
        /// Gets the IVirtualWansOperations.
        /// </summary>
        public virtual IVirtualWansOperations VirtualWans { get; private set; }

        /// <summary>
        /// Gets the IVpnSitesOperations.
        /// </summary>
        public virtual IVpnSitesOperations VpnSites { get; private set; }

        /// <summary>
        /// Gets the IVpnSiteLinksOperations.
        /// </summary>
        public virtual IVpnSiteLinksOperations VpnSiteLinks { get; private set; }

        /// <summary>
        /// Gets the IVpnSitesConfigurationOperations.
        /// </summary>
        public virtual IVpnSitesConfigurationOperations VpnSitesConfiguration { get; private set; }

        /// <summary>
        /// Gets the IVpnServerConfigurationsOperations.
        /// </summary>
        public virtual IVpnServerConfigurationsOperations VpnServerConfigurations { get; private set; }

        /// <summary>
        /// Gets the IVirtualHubsOperations.
        /// </summary>
        public virtual IVirtualHubsOperations VirtualHubs { get; private set; }

        /// <summary>
        /// Gets the IHubVirtualNetworkConnectionsOperations.
        /// </summary>
        public virtual IHubVirtualNetworkConnectionsOperations HubVirtualNetworkConnections { get; private set; }

        /// <summary>
        /// Gets the IVpnGatewaysOperations.
        /// </summary>
        public virtual IVpnGatewaysOperations VpnGateways { get; private set; }

        /// <summary>
        /// Gets the IVpnConnectionsOperations.
        /// </summary>
        public virtual IVpnConnectionsOperations VpnConnections { get; private set; }

        /// <summary>
        /// Gets the IVpnSiteLinkConnectionsOperations.
        /// </summary>
        public virtual IVpnSiteLinkConnectionsOperations VpnSiteLinkConnections { get; private set; }

        /// <summary>
        /// Gets the IVpnLinkConnectionsOperations.
        /// </summary>
        public virtual IVpnLinkConnectionsOperations VpnLinkConnections { get; private set; }

        /// <summary>
        /// Gets the IP2sVpnGatewaysOperations.
        /// </summary>
        public virtual IP2sVpnGatewaysOperations P2sVpnGateways { get; private set; }

        /// <summary>
        /// Gets the IVpnServerConfigurationsAssociatedWithVirtualWanOperations.
        /// </summary>
        public virtual IVpnServerConfigurationsAssociatedWithVirtualWanOperations VpnServerConfigurationsAssociatedWithVirtualWan { get; private set; }

        /// <summary>
        /// Gets the IVirtualHubRouteTableV2sOperations.
        /// </summary>
        public virtual IVirtualHubRouteTableV2sOperations VirtualHubRouteTableV2s { get; private set; }

        /// <summary>
        /// Gets the IWebApplicationFirewallPoliciesOperations.
        /// </summary>
        public virtual IWebApplicationFirewallPoliciesOperations WebApplicationFirewallPolicies { get; private set; }

        /// <summary>
        /// Initializes a new instance of the NetworkManagementClient class.
        /// </summary>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        public NetworkManagementClient(RestClient restClient) : base(restClient)
        {
        }

        /// <summary>
        /// An optional partial-method to perform custom initialization.
        /// </summary>
        partial void CustomInitialize();
        /// <summary>
        /// Initializes client properties.
        /// </summary>
        protected override void Initialize()
        {
            ApplicationGateways = new ApplicationGatewaysOperations(this);
            ApplicationSecurityGroups = new ApplicationSecurityGroupsOperations(this);
            AvailableDelegations = new AvailableDelegationsOperations(this);
            AvailableResourceGroupDelegations = new AvailableResourceGroupDelegationsOperations(this);
            AvailableServiceAliases = new AvailableServiceAliasesOperations(this);
            AzureFirewalls = new AzureFirewallsOperations(this);
            AzureFirewallFqdnTags = new AzureFirewallFqdnTagsOperations(this);
            BastionHosts = new BastionHostsOperations(this);
            DdosCustomPolicies = new DdosCustomPoliciesOperations(this);
            DdosProtectionPlans = new DdosProtectionPlansOperations(this);
            AvailableEndpointServices = new AvailableEndpointServicesOperations(this);
            ExpressRouteCircuitAuthorizations = new ExpressRouteCircuitAuthorizationsOperations(this);
            ExpressRouteCircuitPeerings = new ExpressRouteCircuitPeeringsOperations(this);
            ExpressRouteCircuitConnections = new ExpressRouteCircuitConnectionsOperations(this);
            PeerExpressRouteCircuitConnections = new PeerExpressRouteCircuitConnectionsOperations(this);
            ExpressRouteCircuits = new ExpressRouteCircuitsOperations(this);
            ExpressRouteServiceProviders = new ExpressRouteServiceProvidersOperations(this);
            ExpressRouteCrossConnections = new ExpressRouteCrossConnectionsOperations(this);
            ExpressRouteCrossConnectionPeerings = new ExpressRouteCrossConnectionPeeringsOperations(this);
            ExpressRouteGateways = new ExpressRouteGatewaysOperations(this);
            ExpressRouteConnections = new ExpressRouteConnectionsOperations(this);
            ExpressRoutePortsLocations = new ExpressRoutePortsLocationsOperations(this);
            ExpressRoutePorts = new ExpressRoutePortsOperations(this);
            ExpressRouteLinks = new ExpressRouteLinksOperations(this);
            FirewallPolicies = new FirewallPoliciesOperations(this);
            FirewallPolicyRuleGroups = new FirewallPolicyRuleGroupsOperations(this);
            IpGroups = new IpGroupsOperations(this);
            LoadBalancers = new LoadBalancersOperations(this);
            LoadBalancerBackendAddressPools = new LoadBalancerBackendAddressPoolsOperations(this);
            LoadBalancerFrontendIPConfigurations = new LoadBalancerFrontendIPConfigurationsOperations(this);
            InboundNatRules = new InboundNatRulesOperations(this);
            LoadBalancerLoadBalancingRules = new LoadBalancerLoadBalancingRulesOperations(this);
            LoadBalancerOutboundRules = new LoadBalancerOutboundRulesOperations(this);
            LoadBalancerNetworkInterfaces = new LoadBalancerNetworkInterfacesOperations(this);
            LoadBalancerProbes = new LoadBalancerProbesOperations(this);
            NatGateways = new NatGatewaysOperations(this);
            NetworkInterfaces = new NetworkInterfacesOperations(this);
            NetworkInterfaceIPConfigurations = new NetworkInterfaceIPConfigurationsOperations(this);
            NetworkInterfaceLoadBalancers = new NetworkInterfaceLoadBalancersOperations(this);
            NetworkInterfaceTapConfigurations = new NetworkInterfaceTapConfigurationsOperations(this);
            NetworkProfiles = new NetworkProfilesOperations(this);
            NetworkSecurityGroups = new NetworkSecurityGroupsOperations(this);
            SecurityRules = new SecurityRulesOperations(this);
            DefaultSecurityRules = new DefaultSecurityRulesOperations(this);
            NetworkWatchers = new NetworkWatchersOperations(this);
            PacketCaptures = new PacketCapturesOperations(this);
            ConnectionMonitors = new ConnectionMonitorsOperations(this);
            Operations = new Operations(this);
            PrivateEndpoints = new PrivateEndpointsOperations(this);
            AvailablePrivateEndpointTypes = new AvailablePrivateEndpointTypesOperations(this);
            PrivateLinkServices = new PrivateLinkServicesOperations(this);
            PublicIPAddresses = new PublicIPAddressesOperations(this);
            PublicIPPrefixes = new PublicIPPrefixesOperations(this);
            RouteFilters = new RouteFiltersOperations(this);
            RouteFilterRules = new RouteFilterRulesOperations(this);
            RouteTables = new RouteTablesOperations(this);
            Routes = new RoutesOperations(this);
            BgpServiceCommunities = new BgpServiceCommunitiesOperations(this);
            ServiceEndpointPolicies = new ServiceEndpointPoliciesOperations(this);
            ServiceEndpointPolicyDefinitions = new ServiceEndpointPolicyDefinitionsOperations(this);
            ServiceTags = new ServiceTagsOperations(this);
            Usages = new UsagesOperations(this);
            VirtualNetworks = new VirtualNetworksOperations(this);
            Subnets = new SubnetsOperations(this);
            ResourceNavigationLinks = new ResourceNavigationLinksOperations(this);
            ServiceAssociationLinks = new ServiceAssociationLinksOperations(this);
            VirtualNetworkPeerings = new VirtualNetworkPeeringsOperations(this);
            VirtualNetworkGateways = new VirtualNetworkGatewaysOperations(this);
            VirtualNetworkGatewayConnections = new VirtualNetworkGatewayConnectionsOperations(this);
            LocalNetworkGateways = new LocalNetworkGatewaysOperations(this);
            VirtualNetworkTaps = new VirtualNetworkTapsOperations(this);
            VirtualRouters = new VirtualRoutersOperations(this);
            VirtualRouterPeerings = new VirtualRouterPeeringsOperations(this);
            VirtualWans = new VirtualWansOperations(this);
            VpnSites = new VpnSitesOperations(this);
            VpnSiteLinks = new VpnSiteLinksOperations(this);
            VpnSitesConfiguration = new VpnSitesConfigurationOperations(this);
            VpnServerConfigurations = new VpnServerConfigurationsOperations(this);
            VirtualHubs = new VirtualHubsOperations(this);
            HubVirtualNetworkConnections = new HubVirtualNetworkConnectionsOperations(this);
            VpnGateways = new VpnGatewaysOperations(this);
            VpnConnections = new VpnConnectionsOperations(this);
            VpnSiteLinkConnections = new VpnSiteLinkConnectionsOperations(this);
            VpnLinkConnections = new VpnLinkConnectionsOperations(this);
            P2sVpnGateways = new P2sVpnGatewaysOperations(this);
            VpnServerConfigurationsAssociatedWithVirtualWan = new VpnServerConfigurationsAssociatedWithVirtualWanOperations(this);
            VirtualHubRouteTableV2s = new VirtualHubRouteTableV2sOperations(this);
            WebApplicationFirewallPolicies = new WebApplicationFirewallPoliciesOperations(this);
            this.BaseUri = new System.Uri("https://management.azure.com");
            AcceptLanguage = "en-US";
            LongRunningOperationRetryTimeout = 30;
            GenerateClientRequestId = true;
            SerializationSettings = new JsonSerializerSettings
            {
                Formatting = Newtonsoft.Json.Formatting.Indented,
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            SerializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings = new JsonSerializerSettings
            {
                DateFormatHandling = Newtonsoft.Json.DateFormatHandling.IsoDateFormat,
                DateTimeZoneHandling = Newtonsoft.Json.DateTimeZoneHandling.Utc,
                NullValueHandling = Newtonsoft.Json.NullValueHandling.Ignore,
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Serialize,
                ContractResolver = new ReadOnlyJsonContractResolver(),
                Converters = new List<JsonConverter>
                    {
                        new Iso8601TimeSpanConverter()
                    }
            };
            SerializationSettings.Converters.Add(new PolymorphicSerializeJsonConverter<FirewallPolicyRule>("ruleType"));
            DeserializationSettings.Converters.Add(new PolymorphicDeserializeJsonConverter<FirewallPolicyRule>("ruleType"));
            SerializationSettings.Converters.Add(new PolymorphicSerializeJsonConverter<FirewallPolicyRuleCondition>("ruleConditionType"));
            DeserializationSettings.Converters.Add(new PolymorphicDeserializeJsonConverter<FirewallPolicyRuleCondition>("ruleConditionType"));
            CustomInitialize();
            DeserializationSettings.Converters.Add(new TransformationJsonConverter());
            DeserializationSettings.Converters.Add(new CloudErrorJsonConverter());
        }
        /// <summary>
        /// Checks whether a domain name in the cloudapp.azure.com zone is available
        /// for use.
        /// </summary>
        /// <param name='location'>
        /// The location of the domain name.
        /// </param>
        /// <param name='domainNameLabel'>
        /// The domain name to be verified. It must conform to the following regular
        /// expression: ^[a-z][a-z0-9-]{1,61}[a-z0-9]$.
        /// </param>
        /// <param name='customHeaders'>
        /// Headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <return>
        /// A response object containing the response body and response headers.
        /// </return>
        public async Task<AzureOperationResponse<DnsNameAvailabilityResultInner>> CheckDnsNameAvailabilityWithHttpMessagesAsync(string location, string domainNameLabel, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken))
        {
            if (location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "location");
            }
            if (domainNameLabel == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "domainNameLabel");
            }
            if (SubscriptionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "this.SubscriptionId");
            }
            string apiVersion = "2019-09-01";
            // Tracing
            bool _shouldTrace = ServiceClientTracing.IsEnabled;
            string _invocationId = null;
            if (_shouldTrace)
            {
                _invocationId = ServiceClientTracing.NextInvocationId.ToString();
                Dictionary<string, object> tracingParameters = new Dictionary<string, object>();
                tracingParameters.Add("location", location);
                tracingParameters.Add("domainNameLabel", domainNameLabel);
                tracingParameters.Add("apiVersion", apiVersion);
                tracingParameters.Add("cancellationToken", cancellationToken);
                ServiceClientTracing.Enter(_invocationId, this, "CheckDnsNameAvailability", tracingParameters);
            }
            // Construct URL
            var _baseUrl = this.BaseUri.AbsoluteUri;
            var _url = new System.Uri(new System.Uri(_baseUrl + (_baseUrl.EndsWith("/") ? "" : "/")), "subscriptions/{subscriptionId}/providers/Microsoft.Network/locations/{location}/CheckDnsNameAvailability").ToString();
            _url = _url.Replace("{location}", System.Uri.EscapeDataString(location));
            _url = _url.Replace("{subscriptionId}", System.Uri.EscapeDataString(SubscriptionId));
            List<string> _queryParameters = new List<string>();
            if (domainNameLabel != null)
            {
                _queryParameters.Add(string.Format("domainNameLabel={0}", System.Uri.EscapeDataString(domainNameLabel)));
            }
            if (apiVersion != null)
            {
                _queryParameters.Add(string.Format("api-version={0}", System.Uri.EscapeDataString(apiVersion)));
            }
            if (_queryParameters.Count > 0)
            {
                _url += (_url.Contains("?") ? "&" : "?") + string.Join("&", _queryParameters);
            }
            // Create HTTP transport objects
            var _httpRequest = new HttpRequestMessage();
            HttpResponseMessage _httpResponse = null;
            _httpRequest.Method = new HttpMethod("GET");
            _httpRequest.RequestUri = new System.Uri(_url);
            // Set Headers
            if (GenerateClientRequestId != null && GenerateClientRequestId.Value)
            {
                _httpRequest.Headers.TryAddWithoutValidation("x-ms-client-request-id", System.Guid.NewGuid().ToString());
            }
            if (AcceptLanguage != null)
            {
                if (_httpRequest.Headers.Contains("accept-language"))
                {
                    _httpRequest.Headers.Remove("accept-language");
                }
                _httpRequest.Headers.TryAddWithoutValidation("accept-language", AcceptLanguage);
            }


            if (customHeaders != null)
            {
                foreach(var _header in customHeaders)
                {
                    if (_httpRequest.Headers.Contains(_header.Key))
                    {
                        _httpRequest.Headers.Remove(_header.Key);
                    }
                    _httpRequest.Headers.TryAddWithoutValidation(_header.Key, _header.Value);
                }
            }

            // Serialize Request
            string _requestContent = null;
            // Set Credentials
            if (this.Credentials != null)
            {
                cancellationToken.ThrowIfCancellationRequested();
                await this.Credentials.ProcessHttpRequestAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            }
            // Send Request
            if (_shouldTrace)
            {
                ServiceClientTracing.SendRequest(_invocationId, _httpRequest);
            }
            cancellationToken.ThrowIfCancellationRequested();
            _httpResponse = await this.HttpClient.SendAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            if (_shouldTrace)
            {
                ServiceClientTracing.ReceiveResponse(_invocationId, _httpResponse);
            }
            HttpStatusCode _statusCode = _httpResponse.StatusCode;
            cancellationToken.ThrowIfCancellationRequested();
            string _responseContent = null;
            if ((int)_statusCode != 200)
            {
                var ex = new CloudException(string.Format("Operation returned an invalid status code '{0}'", _statusCode));
                try
                {
                    _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                    CloudError _errorBody =  SafeJsonConvert.DeserializeObject<CloudError>(_responseContent, DeserializationSettings);
                    if (_errorBody != null)
                    {
                        ex = new CloudException(_errorBody.Message);
                        ex.Body = _errorBody;
                    }
                }
                catch (JsonException)
                {
                    // Ignore the exception
                }
                ex.Request = new HttpRequestMessageWrapper(_httpRequest, _requestContent);
                ex.Response = new HttpResponseMessageWrapper(_httpResponse, _responseContent);
                if (_httpResponse.Headers.Contains("x-ms-request-id"))
                {
                    ex.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
                }
                if (_shouldTrace)
                {
                    ServiceClientTracing.Error(_invocationId, ex);
                }
                _httpRequest.Dispose();
                if (_httpResponse != null)
                {
                    _httpResponse.Dispose();
                }
                throw ex;
            }
            // Create Result
            var _result = new AzureOperationResponse<DnsNameAvailabilityResultInner>();
            _result.Request = _httpRequest;
            _result.Response = _httpResponse;
            if (_httpResponse.Headers.Contains("x-ms-request-id"))
            {
                _result.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
            }
            // Deserialize Response
            if ((int)_statusCode == 200)
            {
                _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                try
                {
                    _result.Body = SafeJsonConvert.DeserializeObject<DnsNameAvailabilityResultInner>(_responseContent, DeserializationSettings);
                }
                catch (JsonException ex)
                {
                    _httpRequest.Dispose();
                    if (_httpResponse != null)
                    {
                        _httpResponse.Dispose();
                    }
                    throw new SerializationException("Unable to deserialize the response.", _responseContent, ex);
                }
            }
            if (_shouldTrace)
            {
                ServiceClientTracing.Exit(_invocationId, _result);
            }
            return _result;
        }

        /// <summary>
        /// Gives the supported security providers for the virtual wan.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The resource group name.
        /// </param>
        /// <param name='virtualWANName'>
        /// The name of the VirtualWAN for which supported security providers are
        /// needed.
        /// </param>
        /// <param name='customHeaders'>
        /// Headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <return>
        /// A response object containing the response body and response headers.
        /// </return>
        public async Task<AzureOperationResponse<VirtualWanSecurityProvidersInner>> SupportedSecurityProvidersWithHttpMessagesAsync(string resourceGroupName, string virtualWANName, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken))
        {
            if (SubscriptionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "this.SubscriptionId");
            }
            if (resourceGroupName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "resourceGroupName");
            }
            if (virtualWANName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "virtualWANName");
            }
            string apiVersion = "2019-09-01";
            // Tracing
            bool _shouldTrace = ServiceClientTracing.IsEnabled;
            string _invocationId = null;
            if (_shouldTrace)
            {
                _invocationId = ServiceClientTracing.NextInvocationId.ToString();
                Dictionary<string, object> tracingParameters = new Dictionary<string, object>();
                tracingParameters.Add("resourceGroupName", resourceGroupName);
                tracingParameters.Add("virtualWANName", virtualWANName);
                tracingParameters.Add("apiVersion", apiVersion);
                tracingParameters.Add("cancellationToken", cancellationToken);
                ServiceClientTracing.Enter(_invocationId, this, "SupportedSecurityProviders", tracingParameters);
            }
            // Construct URL
            var _baseUrl = this.BaseUri.AbsoluteUri;
            var _url = new System.Uri(new System.Uri(_baseUrl + (_baseUrl.EndsWith("/") ? "" : "/")), "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualWans/{virtualWANName}/supportedSecurityProviders").ToString();
            _url = _url.Replace("{subscriptionId}", System.Uri.EscapeDataString(SubscriptionId));
            _url = _url.Replace("{resourceGroupName}", System.Uri.EscapeDataString(resourceGroupName));
            _url = _url.Replace("{virtualWANName}", System.Uri.EscapeDataString(virtualWANName));
            List<string> _queryParameters = new List<string>();
            if (apiVersion != null)
            {
                _queryParameters.Add(string.Format("api-version={0}", System.Uri.EscapeDataString(apiVersion)));
            }
            if (_queryParameters.Count > 0)
            {
                _url += (_url.Contains("?") ? "&" : "?") + string.Join("&", _queryParameters);
            }
            // Create HTTP transport objects
            var _httpRequest = new HttpRequestMessage();
            HttpResponseMessage _httpResponse = null;
            _httpRequest.Method = new HttpMethod("GET");
            _httpRequest.RequestUri = new System.Uri(_url);
            // Set Headers
            if (GenerateClientRequestId != null && GenerateClientRequestId.Value)
            {
                _httpRequest.Headers.TryAddWithoutValidation("x-ms-client-request-id", System.Guid.NewGuid().ToString());
            }
            if (AcceptLanguage != null)
            {
                if (_httpRequest.Headers.Contains("accept-language"))
                {
                    _httpRequest.Headers.Remove("accept-language");
                }
                _httpRequest.Headers.TryAddWithoutValidation("accept-language", AcceptLanguage);
            }


            if (customHeaders != null)
            {
                foreach(var _header in customHeaders)
                {
                    if (_httpRequest.Headers.Contains(_header.Key))
                    {
                        _httpRequest.Headers.Remove(_header.Key);
                    }
                    _httpRequest.Headers.TryAddWithoutValidation(_header.Key, _header.Value);
                }
            }

            // Serialize Request
            string _requestContent = null;
            // Set Credentials
            if (this.Credentials != null)
            {
                cancellationToken.ThrowIfCancellationRequested();
                await this.Credentials.ProcessHttpRequestAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            }
            // Send Request
            if (_shouldTrace)
            {
                ServiceClientTracing.SendRequest(_invocationId, _httpRequest);
            }
            cancellationToken.ThrowIfCancellationRequested();
            _httpResponse = await this.HttpClient.SendAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            if (_shouldTrace)
            {
                ServiceClientTracing.ReceiveResponse(_invocationId, _httpResponse);
            }
            HttpStatusCode _statusCode = _httpResponse.StatusCode;
            cancellationToken.ThrowIfCancellationRequested();
            string _responseContent = null;
            if ((int)_statusCode != 200)
            {
                var ex = new CloudException(string.Format("Operation returned an invalid status code '{0}'", _statusCode));
                try
                {
                    _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                    CloudError _errorBody =  SafeJsonConvert.DeserializeObject<CloudError>(_responseContent, DeserializationSettings);
                    if (_errorBody != null)
                    {
                        ex = new CloudException(_errorBody.Message);
                        ex.Body = _errorBody;
                    }
                }
                catch (JsonException)
                {
                    // Ignore the exception
                }
                ex.Request = new HttpRequestMessageWrapper(_httpRequest, _requestContent);
                ex.Response = new HttpResponseMessageWrapper(_httpResponse, _responseContent);
                if (_httpResponse.Headers.Contains("x-ms-request-id"))
                {
                    ex.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
                }
                if (_shouldTrace)
                {
                    ServiceClientTracing.Error(_invocationId, ex);
                }
                _httpRequest.Dispose();
                if (_httpResponse != null)
                {
                    _httpResponse.Dispose();
                }
                throw ex;
            }
            // Create Result
            var _result = new AzureOperationResponse<VirtualWanSecurityProvidersInner>();
            _result.Request = _httpRequest;
            _result.Response = _httpResponse;
            if (_httpResponse.Headers.Contains("x-ms-request-id"))
            {
                _result.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
            }
            // Deserialize Response
            if ((int)_statusCode == 200)
            {
                _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                try
                {
                    _result.Body = SafeJsonConvert.DeserializeObject<VirtualWanSecurityProvidersInner>(_responseContent, DeserializationSettings);
                }
                catch (JsonException ex)
                {
                    _httpRequest.Dispose();
                    if (_httpResponse != null)
                    {
                        _httpResponse.Dispose();
                    }
                    throw new SerializationException("Unable to deserialize the response.", _responseContent, ex);
                }
            }
            if (_shouldTrace)
            {
                ServiceClientTracing.Exit(_invocationId, _result);
            }
            return _result;
        }

        /// <summary>
        /// Generates a unique VPN profile for P2S clients for VirtualWan and
        /// associated VpnServerConfiguration combination in the specified resource
        /// group.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The resource group name.
        /// </param>
        /// <param name='virtualWANName'>
        /// The name of the VirtualWAN whose associated VpnServerConfigurations is
        /// needed.
        /// </param>
        /// <param name='vpnClientParams'>
        /// Parameters supplied to the generate VirtualWan VPN profile generation
        /// operation.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        public async Task<AzureOperationResponse<VpnProfileResponseInner>> GeneratevirtualwanvpnserverconfigurationvpnprofileWithHttpMessagesAsync(string resourceGroupName, string virtualWANName, VirtualWanVpnProfileParameters vpnClientParams, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken))
        {
            // Send request
            AzureOperationResponse<VpnProfileResponseInner> _response = await BeginGeneratevirtualwanvpnserverconfigurationvpnprofileWithHttpMessagesAsync(resourceGroupName, virtualWANName, vpnClientParams, customHeaders, cancellationToken).ConfigureAwait(false);
            return await this.GetPostOrDeleteOperationResultAsync(_response, customHeaders, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Generates a unique VPN profile for P2S clients for VirtualWan and
        /// associated VpnServerConfiguration combination in the specified resource
        /// group.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The resource group name.
        /// </param>
        /// <param name='virtualWANName'>
        /// The name of the VirtualWAN whose associated VpnServerConfigurations is
        /// needed.
        /// </param>
        /// <param name='vpnClientParams'>
        /// Parameters supplied to the generate VirtualWan VPN profile generation
        /// operation.
        /// </param>
        /// <param name='customHeaders'>
        /// Headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        /// <exception cref="CloudException">
        /// Thrown when the operation returned an invalid status code
        /// </exception>
        /// <exception cref="SerializationException">
        /// Thrown when unable to deserialize the response
        /// </exception>
        /// <exception cref="ValidationException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <exception cref="System.ArgumentNullException">
        /// Thrown when a required parameter is null
        /// </exception>
        /// <return>
        /// A response object containing the response body and response headers.
        /// </return>
        public async Task<AzureOperationResponse<VpnProfileResponseInner>> BeginGeneratevirtualwanvpnserverconfigurationvpnprofileWithHttpMessagesAsync(string resourceGroupName, string virtualWANName, VirtualWanVpnProfileParameters vpnClientParams, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken))
        {
            if (SubscriptionId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "this.SubscriptionId");
            }
            if (resourceGroupName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "resourceGroupName");
            }
            if (virtualWANName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "virtualWANName");
            }
            if (vpnClientParams == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "vpnClientParams");
            }
            string apiVersion = "2019-09-01";
            // Tracing
            bool _shouldTrace = ServiceClientTracing.IsEnabled;
            string _invocationId = null;
            if (_shouldTrace)
            {
                _invocationId = ServiceClientTracing.NextInvocationId.ToString();
                Dictionary<string, object> tracingParameters = new Dictionary<string, object>();
                tracingParameters.Add("resourceGroupName", resourceGroupName);
                tracingParameters.Add("virtualWANName", virtualWANName);
                tracingParameters.Add("vpnClientParams", vpnClientParams);
                tracingParameters.Add("apiVersion", apiVersion);
                tracingParameters.Add("cancellationToken", cancellationToken);
                ServiceClientTracing.Enter(_invocationId, this, "BeginGeneratevirtualwanvpnserverconfigurationvpnprofile", tracingParameters);
            }
            // Construct URL
            var _baseUrl = this.BaseUri.AbsoluteUri;
            var _url = new System.Uri(new System.Uri(_baseUrl + (_baseUrl.EndsWith("/") ? "" : "/")), "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualWans/{virtualWANName}/GenerateVpnProfile").ToString();
            _url = _url.Replace("{subscriptionId}", System.Uri.EscapeDataString(SubscriptionId));
            _url = _url.Replace("{resourceGroupName}", System.Uri.EscapeDataString(resourceGroupName));
            _url = _url.Replace("{virtualWANName}", System.Uri.EscapeDataString(virtualWANName));
            List<string> _queryParameters = new List<string>();
            if (apiVersion != null)
            {
                _queryParameters.Add(string.Format("api-version={0}", System.Uri.EscapeDataString(apiVersion)));
            }
            if (_queryParameters.Count > 0)
            {
                _url += (_url.Contains("?") ? "&" : "?") + string.Join("&", _queryParameters);
            }
            // Create HTTP transport objects
            var _httpRequest = new HttpRequestMessage();
            HttpResponseMessage _httpResponse = null;
            _httpRequest.Method = new HttpMethod("POST");
            _httpRequest.RequestUri = new System.Uri(_url);
            // Set Headers
            if (GenerateClientRequestId != null && GenerateClientRequestId.Value)
            {
                _httpRequest.Headers.TryAddWithoutValidation("x-ms-client-request-id", System.Guid.NewGuid().ToString());
            }
            if (AcceptLanguage != null)
            {
                if (_httpRequest.Headers.Contains("accept-language"))
                {
                    _httpRequest.Headers.Remove("accept-language");
                }
                _httpRequest.Headers.TryAddWithoutValidation("accept-language", AcceptLanguage);
            }


            if (customHeaders != null)
            {
                foreach(var _header in customHeaders)
                {
                    if (_httpRequest.Headers.Contains(_header.Key))
                    {
                        _httpRequest.Headers.Remove(_header.Key);
                    }
                    _httpRequest.Headers.TryAddWithoutValidation(_header.Key, _header.Value);
                }
            }

            // Serialize Request
            string _requestContent = null;
            if(vpnClientParams != null)
            {
                _requestContent = SafeJsonConvert.SerializeObject(vpnClientParams, SerializationSettings);
                _httpRequest.Content = new StringContent(_requestContent, System.Text.Encoding.UTF8);
                _httpRequest.Content.Headers.ContentType =System.Net.Http.Headers.MediaTypeHeaderValue.Parse("application/json; charset=utf-8");
            }
            // Set Credentials
            if (this.Credentials != null)
            {
                cancellationToken.ThrowIfCancellationRequested();
                await this.Credentials.ProcessHttpRequestAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            }
            // Send Request
            if (_shouldTrace)
            {
                ServiceClientTracing.SendRequest(_invocationId, _httpRequest);
            }
            cancellationToken.ThrowIfCancellationRequested();
            _httpResponse = await this.HttpClient.SendAsync(_httpRequest, cancellationToken).ConfigureAwait(false);
            if (_shouldTrace)
            {
                ServiceClientTracing.ReceiveResponse(_invocationId, _httpResponse);
            }
            HttpStatusCode _statusCode = _httpResponse.StatusCode;
            cancellationToken.ThrowIfCancellationRequested();
            string _responseContent = null;
            if ((int)_statusCode != 200 && (int)_statusCode != 202)
            {
                var ex = new CloudException(string.Format("Operation returned an invalid status code '{0}'", _statusCode));
                try
                {
                    _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                    CloudError _errorBody =  SafeJsonConvert.DeserializeObject<CloudError>(_responseContent, DeserializationSettings);
                    if (_errorBody != null)
                    {
                        ex = new CloudException(_errorBody.Message);
                        ex.Body = _errorBody;
                    }
                }
                catch (JsonException)
                {
                    // Ignore the exception
                }
                ex.Request = new HttpRequestMessageWrapper(_httpRequest, _requestContent);
                ex.Response = new HttpResponseMessageWrapper(_httpResponse, _responseContent);
                if (_httpResponse.Headers.Contains("x-ms-request-id"))
                {
                    ex.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
                }
                if (_shouldTrace)
                {
                    ServiceClientTracing.Error(_invocationId, ex);
                }
                _httpRequest.Dispose();
                if (_httpResponse != null)
                {
                    _httpResponse.Dispose();
                }
                throw ex;
            }
            // Create Result
            var _result = new AzureOperationResponse<VpnProfileResponseInner>();
            _result.Request = _httpRequest;
            _result.Response = _httpResponse;
            if (_httpResponse.Headers.Contains("x-ms-request-id"))
            {
                _result.RequestId = _httpResponse.Headers.GetValues("x-ms-request-id").FirstOrDefault();
            }
            // Deserialize Response
            if ((int)_statusCode == 200)
            {
                _responseContent = await _httpResponse.Content.ReadAsStringAsync().ConfigureAwait(false);
                try
                {
                    _result.Body = SafeJsonConvert.DeserializeObject<VpnProfileResponseInner>(_responseContent, DeserializationSettings);
                }
                catch (JsonException ex)
                {
                    _httpRequest.Dispose();
                    if (_httpResponse != null)
                    {
                        _httpResponse.Dispose();
                    }
                    throw new SerializationException("Unable to deserialize the response.", _responseContent, ex);
                }
            }
            if (_shouldTrace)
            {
                ServiceClientTracing.Exit(_invocationId, _result);
            }
            return _result;
        }

    }
}
