﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Core
{
    /// <summary>
    /// Defines values for country codes in ISO standard.
    /// E.g.the country code for United Kingdom is 'GB'.
    /// </summary>
    public class CountryISOCode : ExpandableStringEnum<CountryISOCode>
    {
        public static readonly CountryISOCode Afghanistan = Parse("AF");
        public static readonly CountryISOCode Albania = Parse("AL");
        public static readonly CountryISOCode Algeria = Parse("DZ");
        public static readonly CountryISOCode AmericanSamoa = Parse("AS");
        public static readonly CountryISOCode Andorra = Parse("AD");
        public static readonly CountryISOCode Angola = Parse("AO");
        public static readonly CountryISOCode Anguilla = Parse("AI");
        public static readonly CountryISOCode Antarctica = Parse("AQ");
        public static readonly CountryISOCode AntiguaAndBarbuda = Parse("AG");
        public static readonly CountryISOCode Argentina = Parse("AR");
        public static readonly CountryISOCode Armenia = Parse("AM");
        public static readonly CountryISOCode Aruba = Parse("AW");
        public static readonly CountryISOCode Australia = Parse("AU");
        public static readonly CountryISOCode Austria = Parse("AT");
        public static readonly CountryISOCode Azerbaijan = Parse("AZ");
        public static readonly CountryISOCode Bahamas = Parse("BS");
        public static readonly CountryISOCode Bahrain = Parse("BH");
        public static readonly CountryISOCode Bangladesh = Parse("BD");
        public static readonly CountryISOCode Barbados = Parse("BB");
        public static readonly CountryISOCode Belarus = Parse("BY");
        public static readonly CountryISOCode Belgium = Parse("BE");
        public static readonly CountryISOCode Belize = Parse("BZ");
        public static readonly CountryISOCode Benin = Parse("BJ");
        public static readonly CountryISOCode Bermuda = Parse("BM");
        public static readonly CountryISOCode Bhutan = Parse("BT");
        public static readonly CountryISOCode Bolivia = Parse("BO");
        public static readonly CountryISOCode BosniaAndHerzegovina = Parse("BA");
        public static readonly CountryISOCode Botswana = Parse("BW");
        public static readonly CountryISOCode BouvetIsland = Parse("BV");
        public static readonly CountryISOCode Brazil = Parse("BR");
        public static readonly CountryISOCode BritishIndianOceanTerritory = Parse("IO");
        public static readonly CountryISOCode BruneiDarussalam = Parse("BN");
        public static readonly CountryISOCode Bulgaria = Parse("BG");
        public static readonly CountryISOCode BurkinaFaso = Parse("BF");
        public static readonly CountryISOCode Burundi = Parse("BI");
        public static readonly CountryISOCode Cambodia = Parse("KH");
        public static readonly CountryISOCode Cameroon = Parse("CM");
        public static readonly CountryISOCode Canada = Parse("CA");
        public static readonly CountryISOCode CapeVerde = Parse("CV");
        public static readonly CountryISOCode CaymanIslands = Parse("KY");
        public static readonly CountryISOCode CentralAfricanRepublic = Parse("CF");
        public static readonly CountryISOCode Chad = Parse("TD");
        public static readonly CountryISOCode Chile = Parse("CL");
        public static readonly CountryISOCode China = Parse("CN");
        public static readonly CountryISOCode ChristmasIsland = Parse("CX");
        public static readonly CountryISOCode CocosKeelingIslands = Parse("CC");
        public static readonly CountryISOCode Colombia = Parse("CO");
        public static readonly CountryISOCode Comoros = Parse("KM");
        public static readonly CountryISOCode Congo = Parse("CG");
        public static readonly CountryISOCode CongoDemocraticRepublic = Parse("CD");
        public static readonly CountryISOCode CookIslands = Parse("CK");
        public static readonly CountryISOCode CostaRica = Parse("CR");
        public static readonly CountryISOCode IvoryCoast = Parse("CI");
        public static readonly CountryISOCode Croatia = Parse("HR");
        public static readonly CountryISOCode Cyprus = Parse("CY");
        public static readonly CountryISOCode CzechRepublic = Parse("CZ");
        public static readonly CountryISOCode Denmark = Parse("DK");
        public static readonly CountryISOCode Djibouti = Parse("DJ");
        public static readonly CountryISOCode Dominica = Parse("DM");
        public static readonly CountryISOCode DominicanRepublic = Parse("DO");
        public static readonly CountryISOCode Ecuador = Parse("EC");
        public static readonly CountryISOCode Egypt = Parse("EG");
        public static readonly CountryISOCode ElSalvador = Parse("SV");
        public static readonly CountryISOCode EquatorialGuinea = Parse("GQ");
        public static readonly CountryISOCode Eritrea = Parse("ER");
        public static readonly CountryISOCode Estonia = Parse("EE");
        public static readonly CountryISOCode Ethiopia = Parse("ET");
        public static readonly CountryISOCode FalklandIslandsMalvinas = Parse("FK");
        public static readonly CountryISOCode FaroeIslands = Parse("FO");
        public static readonly CountryISOCode Fiji = Parse("FJ");
        public static readonly CountryISOCode Finland = Parse("FI");
        public static readonly CountryISOCode France = Parse("FR");
        public static readonly CountryISOCode FrenchGuiana = Parse("GF");
        public static readonly CountryISOCode FrenchPolynesia = Parse("PF");
        public static readonly CountryISOCode FrenchSouthernTerritories = Parse("TF");
        public static readonly CountryISOCode Gabon = Parse("GA");
        public static readonly CountryISOCode Gambia = Parse("GM");
        public static readonly CountryISOCode Georgia = Parse("GE");
        public static readonly CountryISOCode Germany = Parse("DE");
        public static readonly CountryISOCode Ghana = Parse("GH");
        public static readonly CountryISOCode Gibraltar = Parse("GI");
        public static readonly CountryISOCode Greece = Parse("GR");
        public static readonly CountryISOCode Greenland = Parse("GL");
        public static readonly CountryISOCode Grenada = Parse("GD");
        public static readonly CountryISOCode Guadeloupe = Parse("GP");
        public static readonly CountryISOCode Guam = Parse("GU");
        public static readonly CountryISOCode Guatemala = Parse("GT");
        public static readonly CountryISOCode Guernsey = Parse("GG");
        public static readonly CountryISOCode Guinea = Parse("GN");
        public static readonly CountryISOCode GuineaBissau = Parse("GW");
        public static readonly CountryISOCode Guyana = Parse("GY");
        public static readonly CountryISOCode Haiti = Parse("HT");
        public static readonly CountryISOCode HeardIslandMcdonaldIslands = Parse("HM");
        public static readonly CountryISOCode HolySeeVaticanCityState = Parse("VA");
        public static readonly CountryISOCode Honduras = Parse("HN");
        public static readonly CountryISOCode HongKong = Parse("HK");
        public static readonly CountryISOCode Hungary = Parse("HU");
        public static readonly CountryISOCode Iceland = Parse("IS");
        public static readonly CountryISOCode India = Parse("IN");
        public static readonly CountryISOCode Indonesia = Parse("ID");
        public static readonly CountryISOCode Iraq = Parse("IQ");
        public static readonly CountryISOCode Ireland = Parse("IE");
        public static readonly CountryISOCode IsleOfMan = Parse("IM");
        public static readonly CountryISOCode Israel = Parse("IL");
        public static readonly CountryISOCode Italy = Parse("IT");
        public static readonly CountryISOCode Jamaica = Parse("JM");
        public static readonly CountryISOCode Japan = Parse("JP");
        public static readonly CountryISOCode Jersey = Parse("JE");
        public static readonly CountryISOCode Jordan = Parse("JO");
        public static readonly CountryISOCode Kazakhstan = Parse("KZ");
        public static readonly CountryISOCode Kenya = Parse("KE");
        public static readonly CountryISOCode Kiribati = Parse("KI");
        public static readonly CountryISOCode Korea = Parse("KR");
        public static readonly CountryISOCode Kuwait = Parse("KW");
        public static readonly CountryISOCode Kyrgyzstan = Parse("KG");
        public static readonly CountryISOCode LaoPeoplesDemocraticRepublic = Parse("LA");
        public static readonly CountryISOCode Latvia = Parse("LV");
        public static readonly CountryISOCode Lebanon = Parse("LB");
        public static readonly CountryISOCode Lesotho = Parse("LS");
        public static readonly CountryISOCode Liberia = Parse("LR");
        public static readonly CountryISOCode StateOfLibya = Parse("LY");
        public static readonly CountryISOCode Liechtenstein = Parse("LI");
        public static readonly CountryISOCode Lithuania = Parse("LT");
        public static readonly CountryISOCode Luxembourg = Parse("LU");
        public static readonly CountryISOCode Macao = Parse("MO");
        public static readonly CountryISOCode Macedonia = Parse("MK");
        public static readonly CountryISOCode Madagascar = Parse("MG");
        public static readonly CountryISOCode Malawi = Parse("MW");
        public static readonly CountryISOCode Malaysia = Parse("MY");
        public static readonly CountryISOCode Maldives = Parse("MV");
        public static readonly CountryISOCode Mali = Parse("ML");
        public static readonly CountryISOCode Malta = Parse("MT");
        public static readonly CountryISOCode MarshallIslands = Parse("MH");
        public static readonly CountryISOCode Martinique = Parse("MQ");
        public static readonly CountryISOCode Mauritania = Parse("MR");
        public static readonly CountryISOCode Mauritius = Parse("MU");
        public static readonly CountryISOCode Mayotte = Parse("YT");
        public static readonly CountryISOCode Mexico = Parse("MX");
        public static readonly CountryISOCode MicronesiaFederatedStatesOf = Parse("FM");
        public static readonly CountryISOCode Moldova = Parse("MD");
        public static readonly CountryISOCode Monaco = Parse("MC");
        public static readonly CountryISOCode Mongolia = Parse("MN");
        public static readonly CountryISOCode Montenegro = Parse("ME");
        public static readonly CountryISOCode Montserrat = Parse("MS");
        public static readonly CountryISOCode Morocco = Parse("MA");
        public static readonly CountryISOCode Mozambique = Parse("MZ");
        public static readonly CountryISOCode Myanmar = Parse("MM");
        public static readonly CountryISOCode Namibia = Parse("NA");
        public static readonly CountryISOCode Nauru = Parse("NR");
        public static readonly CountryISOCode Nepal = Parse("NP");
        public static readonly CountryISOCode Netherlands = Parse("NL");
        public static readonly CountryISOCode NewCaledonia = Parse("NC");
        public static readonly CountryISOCode NewZealand = Parse("NZ");
        public static readonly CountryISOCode Nicaragua = Parse("NI");
        public static readonly CountryISOCode Niger = Parse("NE");
        public static readonly CountryISOCode Nigeria = Parse("NG");
        public static readonly CountryISOCode Niue = Parse("NU");
        public static readonly CountryISOCode NorfolkIsland = Parse("NF");
        public static readonly CountryISOCode NorthernMarianaIslands = Parse("MP");
        public static readonly CountryISOCode Norway = Parse("NO");
        public static readonly CountryISOCode Oman = Parse("OM");
        public static readonly CountryISOCode Pakistan = Parse("PK");
        public static readonly CountryISOCode Palau = Parse("PW");
        public static readonly CountryISOCode PalestinianTerritoryOccupied = Parse("PS");
        public static readonly CountryISOCode Panama = Parse("PA");
        public static readonly CountryISOCode PapuaNewGuinea = Parse("PG");
        public static readonly CountryISOCode Paraguay = Parse("PY");
        public static readonly CountryISOCode Peru = Parse("PE");
        public static readonly CountryISOCode Philippines = Parse("PH");
        public static readonly CountryISOCode Pitcairn = Parse("PN");
        public static readonly CountryISOCode Poland = Parse("PL");
        public static readonly CountryISOCode Portugal = Parse("PT");
        public static readonly CountryISOCode PuertoRico = Parse("PR");
        public static readonly CountryISOCode Qatar = Parse("QA");
        public static readonly CountryISOCode Reunion = Parse("RE");
        public static readonly CountryISOCode Romania = Parse("RO");
        public static readonly CountryISOCode RussianFederation = Parse("RU");
        public static readonly CountryISOCode Rwanda = Parse("RW");
        public static readonly CountryISOCode SaintHelena = Parse("SH");
        public static readonly CountryISOCode SaintKittsAndNevis = Parse("KN");
        public static readonly CountryISOCode SaintLucia = Parse("LC");
        public static readonly CountryISOCode SaintPierreAndMiquelon = Parse("PM");
        public static readonly CountryISOCode SaintVincentAndGrenadines = Parse("VC");
        public static readonly CountryISOCode Samoa = Parse("WS");
        public static readonly CountryISOCode SanMarino = Parse("SM");
        public static readonly CountryISOCode SaoTomeAndPrincipe = Parse("ST");
        public static readonly CountryISOCode SaudiArabia = Parse("SA");
        public static readonly CountryISOCode Senegal = Parse("SN");
        public static readonly CountryISOCode Serbia = Parse("RS");
        public static readonly CountryISOCode Seychelles = Parse("SC");
        public static readonly CountryISOCode SierraLeone = Parse("SL");
        public static readonly CountryISOCode Singapore = Parse("SG");
        public static readonly CountryISOCode Slovakia = Parse("SK");
        public static readonly CountryISOCode Slovenia = Parse("SI");
        public static readonly CountryISOCode SolomonIslands = Parse("SB");
        public static readonly CountryISOCode Somalia = Parse("SO");
        public static readonly CountryISOCode SouthAfrica = Parse("ZA");
        public static readonly CountryISOCode SouthGeorgiaAndSandwichIsland = Parse("GS");
        public static readonly CountryISOCode Spain = Parse("ES");
        public static readonly CountryISOCode SriLanka = Parse("LK");
        public static readonly CountryISOCode Suriname = Parse("SR");
        public static readonly CountryISOCode SvalbardAndJanMayen = Parse("SJ");
        public static readonly CountryISOCode Swaziland = Parse("SZ");
        public static readonly CountryISOCode Sweden = Parse("SE");
        public static readonly CountryISOCode Switzerland = Parse("CH");
        public static readonly CountryISOCode Taiwan = Parse("TW");
        public static readonly CountryISOCode Tajikistan = Parse("TJ");
        public static readonly CountryISOCode Tanzania = Parse("TZ");
        public static readonly CountryISOCode Thailand = Parse("TH");
        public static readonly CountryISOCode TimorLeste = Parse("TL");
        public static readonly CountryISOCode Togo = Parse("TG");
        public static readonly CountryISOCode Tokelau = Parse("TK");
        public static readonly CountryISOCode Tonga = Parse("TO");
        public static readonly CountryISOCode TrinidadAndTobago = Parse("TT");
        public static readonly CountryISOCode Tunisia = Parse("TN");
        public static readonly CountryISOCode Turkey = Parse("TR");
        public static readonly CountryISOCode Turkmenistan = Parse("TM");
        public static readonly CountryISOCode TurksAndCaicosIslands = Parse("TC");
        public static readonly CountryISOCode Tuvalu = Parse("TV");
        public static readonly CountryISOCode Uganda = Parse("UG");
        public static readonly CountryISOCode Ukraine = Parse("UA");
        public static readonly CountryISOCode UnitedArabEmirates = Parse("AE");
        public static readonly CountryISOCode UnitedKingdom = Parse("GB");
        public static readonly CountryISOCode UnitedStates = Parse("US");
        public static readonly CountryISOCode UnitedStatesOutlyingIslands = Parse("UM");
        public static readonly CountryISOCode Uruguay = Parse("UY");
        public static readonly CountryISOCode Uzbekistan = Parse("UZ");
        public static readonly CountryISOCode Vanuatu = Parse("VU");
        public static readonly CountryISOCode Venezuela = Parse("VE");
        public static readonly CountryISOCode Vietnam = Parse("VN");
        public static readonly CountryISOCode VirginIslandsBritish = Parse("VG");
        public static readonly CountryISOCode VirginIslandsUs = Parse("VI");
        public static readonly CountryISOCode WallisAndFutuna = Parse("WF");
        public static readonly CountryISOCode WesternSahara = Parse("EH");
        public static readonly CountryISOCode Yemen = Parse("YE");
        public static readonly CountryISOCode Zambia = Parse("ZM");
        public static readonly CountryISOCode Zimbabwe = Parse("ZW");
    }
}
