// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The debug setting.
    /// </summary>
    public partial class DebugSetting
    {
        /// <summary>
        /// Initializes a new instance of the DebugSetting class.
        /// </summary>
        public DebugSetting()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DebugSetting class.
        /// </summary>
        /// <param name="detailLevel">Specifies the type of information to log
        /// for debugging. The permitted values are none, requestContent,
        /// responseContent, or both requestContent and responseContent
        /// separated by a comma. The default is none. When setting this value,
        /// carefully consider the type of information you are passing in
        /// during deployment. By logging information about the request or
        /// response, you could potentially expose sensitive data that is
        /// retrieved through the deployment operations.</param>
        public DebugSetting(string detailLevel = default(string))
        {
            DetailLevel = detailLevel;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets specifies the type of information to log for
        /// debugging. The permitted values are none, requestContent,
        /// responseContent, or both requestContent and responseContent
        /// separated by a comma. The default is none. When setting this value,
        /// carefully consider the type of information you are passing in
        /// during deployment. By logging information about the request or
        /// response, you could potentially expose sensitive data that is
        /// retrieved through the deployment operations.
        /// </summary>
        [JsonProperty(PropertyName = "detailLevel")]
        public string DetailLevel { get; set; }

    }
}
