// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Previewed feature information.
    /// </summary>
    public partial class FeatureResultInner
    {
        /// <summary>
        /// Initializes a new instance of the FeatureResultInner class.
        /// </summary>
        public FeatureResultInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FeatureResultInner class.
        /// </summary>
        /// <param name="name">The name of the feature.</param>
        /// <param name="properties">Properties of the previewed
        /// feature.</param>
        /// <param name="id">The resource ID of the feature.</param>
        /// <param name="type">The resource type of the feature.</param>
        public FeatureResultInner(string name = default(string), FeatureProperties properties = default(FeatureProperties), string id = default(string), string type = default(string))
        {
            Name = name;
            Properties = properties;
            Id = id;
            Type = type;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the feature.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets properties of the previewed feature.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public FeatureProperties Properties { get; set; }

        /// <summary>
        /// Gets or sets the resource ID of the feature.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the resource type of the feature.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

    }
}
