// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Deployment on error behavior.
    /// </summary>
    public partial class OnErrorDeployment
    {
        /// <summary>
        /// Initializes a new instance of the OnErrorDeployment class.
        /// </summary>
        public OnErrorDeployment()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the OnErrorDeployment class.
        /// </summary>
        /// <param name="type">The deployment on error behavior type. Possible
        /// values are LastSuccessful and SpecificDeployment. Possible values
        /// include: 'LastSuccessful', 'SpecificDeployment'</param>
        /// <param name="deploymentName">The deployment to be used on error
        /// case.</param>
        public OnErrorDeployment(OnErrorDeploymentType? type = default(OnErrorDeploymentType?), string deploymentName = default(string))
        {
            Type = type;
            DeploymentName = deploymentName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the deployment on error behavior type. Possible values
        /// are LastSuccessful and SpecificDeployment. Possible values include:
        /// 'LastSuccessful', 'SpecificDeployment'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public OnErrorDeploymentType? Type { get; set; }

        /// <summary>
        /// Gets or sets the deployment to be used on error case.
        /// </summary>
        [JsonProperty(PropertyName = "deploymentName")]
        public string DeploymentName { get; set; }

    }
}
