// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// The policy sku. This property is optional, obsolete, and will be
    /// ignored.
    /// </summary>
    public partial class PolicySku
    {
        /// <summary>
        /// Initializes a new instance of the PolicySku class.
        /// </summary>
        public PolicySku()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PolicySku class.
        /// </summary>
        /// <param name="name">The name of the policy sku. Possible values are
        /// A0 and A1.</param>
        /// <param name="tier">The policy sku tier. Possible values are Free
        /// and Standard.</param>
        public PolicySku(string name, string tier = default(string))
        {
            Name = name;
            Tier = tier;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the policy sku. Possible values are A0 and
        /// A1.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the policy sku tier. Possible values are Free and
        /// Standard.
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public string Tier { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Name == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Name");
            }
        }
    }
}
