// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.ResourceManager.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Resource group information.
    /// </summary>
    public partial class ResourceGroupPatchable
    {
        /// <summary>
        /// Initializes a new instance of the ResourceGroupPatchable class.
        /// </summary>
        public ResourceGroupPatchable()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ResourceGroupPatchable class.
        /// </summary>
        /// <param name="name">The name of the resource group.</param>
        /// <param name="properties">The resource group properties.</param>
        /// <param name="managedBy">The ID of the resource that manages this
        /// resource group.</param>
        /// <param name="tags">The tags attached to the resource group.</param>
        public ResourceGroupPatchable(string name = default(string), ResourceGroupProperties properties = default(ResourceGroupProperties), string managedBy = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            Name = name;
            Properties = properties;
            ManagedBy = managedBy;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the name of the resource group.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the resource group properties.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public ResourceGroupProperties Properties { get; set; }

        /// <summary>
        /// Gets or sets the ID of the resource that manages this resource
        /// group.
        /// </summary>
        [JsonProperty(PropertyName = "managedBy")]
        public string ManagedBy { get; set; }

        /// <summary>
        /// Gets or sets the tags attached to the resource group.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

    }
}
