// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Search.Fluent.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.Search;
    using Microsoft.Azure.Management.Search.Fluent;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Response containing the primary and secondary admin API keys for a
    /// given Azure Search service.
    /// </summary>
    public partial class AdminKeyResultInner
    {
        /// <summary>
        /// Initializes a new instance of the AdminKeyResultInner class.
        /// </summary>
        public AdminKeyResultInner()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the AdminKeyResultInner class.
        /// </summary>
        /// <param name="primaryKey">The primary admin API key of the Search
        /// service.</param>
        /// <param name="secondaryKey">The secondary admin API key of the
        /// Search service.</param>
        public AdminKeyResultInner(string primaryKey = default(string), string secondaryKey = default(string))
        {
            PrimaryKey = primaryKey;
            SecondaryKey = secondaryKey;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the primary admin API key of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "primaryKey")]
        public string PrimaryKey { get; private set; }

        /// <summary>
        /// Gets the secondary admin API key of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "secondaryKey")]
        public string SecondaryKey { get; private set; }

    }
}
