// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Search.Fluent.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.Search;
    using Microsoft.Azure.Management.Search.Fluent;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Output of check name availability API.
    /// </summary>
    public partial class CheckNameAvailabilityOutputInner
    {
        /// <summary>
        /// Initializes a new instance of the CheckNameAvailabilityOutputInner
        /// class.
        /// </summary>
        public CheckNameAvailabilityOutputInner()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CheckNameAvailabilityOutputInner
        /// class.
        /// </summary>
        /// <param name="isNameAvailable">A value indicating whether the name
        /// is available.</param>
        /// <param name="reason">The reason why the name is not available.
        /// 'Invalid' indicates the name provided does not match the naming
        /// requirements (incorrect length, unsupported characters, etc.).
        /// 'AlreadyExists' indicates that the name is already in use and is
        /// therefore unavailable. Possible values include: 'Invalid',
        /// 'AlreadyExists'</param>
        /// <param name="message">A message that explains why the name is
        /// invalid and provides resource naming requirements. Available only
        /// if 'Invalid' is returned in the 'reason' property.</param>
        public CheckNameAvailabilityOutputInner(bool? isNameAvailable = default(bool?), string reason = default(string), string message = default(string))
        {
            IsNameAvailable = isNameAvailable;
            Reason = reason;
            Message = message;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets a value indicating whether the name is available.
        /// </summary>
        [JsonProperty(PropertyName = "nameAvailable")]
        public bool? IsNameAvailable { get; private set; }

        /// <summary>
        /// Gets the reason why the name is not available. 'Invalid' indicates
        /// the name provided does not match the naming requirements (incorrect
        /// length, unsupported characters, etc.). 'AlreadyExists' indicates
        /// that the name is already in use and is therefore unavailable.
        /// Possible values include: 'Invalid', 'AlreadyExists'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; private set; }

        /// <summary>
        /// Gets a message that explains why the name is invalid and provides
        /// resource naming requirements. Available only if 'Invalid' is
        /// returned in the 'reason' property.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

    }
}
