// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Search.Fluent.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.Search;
    using Microsoft.Azure.Management.Search.Fluent;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Describes an API key for a given Azure Search service that has
    /// permissions for query operations only.
    /// </summary>
    public partial class QueryKeyInner
    {
        /// <summary>
        /// Initializes a new instance of the QueryKeyInner class.
        /// </summary>
        public QueryKeyInner()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the QueryKeyInner class.
        /// </summary>
        /// <param name="name">The name of the query API key; may be
        /// empty.</param>
        /// <param name="key">The value of the query API key.</param>
        public QueryKeyInner(string name = default(string), string key = default(string))
        {
            Name = name;
            Key = key;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the name of the query API key; may be empty.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the value of the query API key.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; private set; }

    }
}
