// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator 1.0.1.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServiceBus.Fluent.Models
{
    using Microsoft.Azure;
    using Microsoft.Azure.Management;
    using Microsoft.Azure.Management.ServiceBus.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Description of topic resource.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class TopicInner : Microsoft.Azure.Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the TopicInner class.
        /// </summary>
        public TopicInner()
        {
          CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TopicInner class.
        /// </summary>
        /// <param name="accessedAt">Last time the message was sent, or a
        /// request was received, for this topic.</param>
        /// <param name="autoDeleteOnIdle">TimeSpan idle interval after which
        /// the topic is automatically deleted. The minimum duration is 5
        /// minutes. The service accepts a C# Standard TimeSpan Format for loc
        /// duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days</param>
        /// <param name="createdAt">Exact time the Tpoic was created.</param>
        /// <param name="defaultMessageTimeToLive">Default message time to live
        /// value. This is the duration after which the message expires,
        /// starting from when the message is sent to Service Bus. This is the
        /// default value used when TimeToLive is not set on a message itself.
        /// The service accepts a C# Standard TimeSpan Format for loc duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days</param>
        /// <param name="duplicateDetectionHistoryTimeWindow">TimeSpan
        /// structure that defines the duration of the duplicate detection
        /// history. The default value is 10 minutes. The service accepts a C#
        /// Standard TimeSpan Format for loc duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days</param>
        /// <param name="enableBatchedOperations">Value that indicates whether
        /// server-side batched operations are enabled.</param>
        /// <param name="enableExpress">Value that indicates whether Express
        /// Entities are enabled. An express topic holds a message in memory
        /// temporarily before writing it to persistent storage.</param>
        /// <param name="enablePartitioning">Value that indicates whether the
        /// topic to be partitioned across multiple message brokers is
        /// enabled.</param>
        /// <param name="maxSizeInMegabytes">Maximum size of the topic in
        /// megabytes, which is the size of the memory allocated for the
        /// topic.</param>
        /// <param name="requiresDuplicateDetection">Value indicating if this
        /// topic requires duplicate detection.</param>
        /// <param name="sizeInBytes">Size of the topic, in bytes.</param>
        /// <param name="status">Enumerates the possible values for the status
        /// of a messaging entity. Possible values include: 'Active',
        /// 'Creating', 'Deleting', 'Disabled', 'ReceiveDisabled', 'Renaming',
        /// 'Restoring', 'SendDisabled', 'Unknown'</param>
        /// <param name="subscriptionCount">Number of subscriptions.</param>
        /// <param name="supportOrdering">Value that indicates whether the
        /// topic supports ordering.</param>
        /// <param name="updatedAt">The exact time the Topic was
        /// updated.</param>
        public TopicInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), System.DateTime? accessedAt = default(System.DateTime?), string autoDeleteOnIdle = default(string), System.DateTime? createdAt = default(System.DateTime?), MessageCountDetails countDetails = default(MessageCountDetails), string defaultMessageTimeToLive = default(string), string duplicateDetectionHistoryTimeWindow = default(string), bool? enableBatchedOperations = default(bool?), bool? enableExpress = default(bool?), bool? enablePartitioning = default(bool?), long? maxSizeInMegabytes = default(long?), bool? requiresDuplicateDetection = default(bool?), long? sizeInBytes = default(long?), EntityStatus? status = default(EntityStatus?), int? subscriptionCount = default(int?), bool? supportOrdering = default(bool?), System.DateTime? updatedAt = default(System.DateTime?))
            : base(location, id, name, type, tags)
        {
            AccessedAt = accessedAt;
            AutoDeleteOnIdle = autoDeleteOnIdle;
            CreatedAt = createdAt;
            CountDetails = countDetails;
            DefaultMessageTimeToLive = defaultMessageTimeToLive;
            DuplicateDetectionHistoryTimeWindow = duplicateDetectionHistoryTimeWindow;
            EnableBatchedOperations = enableBatchedOperations;
            EnableExpress = enableExpress;
            EnablePartitioning = enablePartitioning;
            MaxSizeInMegabytes = maxSizeInMegabytes;
            RequiresDuplicateDetection = requiresDuplicateDetection;
            SizeInBytes = sizeInBytes;
            Status = status;
            SubscriptionCount = subscriptionCount;
            SupportOrdering = supportOrdering;
            UpdatedAt = updatedAt;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets last time the message was sent, or a request was received, for
        /// this topic.
        /// </summary>
        [JsonProperty(PropertyName = "properties.accessedAt")]
        public System.DateTime? AccessedAt { get; private set; }

        /// <summary>
        /// Gets or sets timeSpan idle interval after which the topic is
        /// automatically deleted. The minimum duration is 5 minutes. The
        /// service accepts a C# Standard TimeSpan Format for loc duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days
        /// </summary>
        [JsonProperty(PropertyName = "properties.autoDeleteOnIdle")]
        public string AutoDeleteOnIdle { get; set; }

        /// <summary>
        /// Gets exact time the Tpoic was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdAt")]
        public System.DateTime? CreatedAt { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.countDetails")]
        public MessageCountDetails CountDetails { get; private set; }

        /// <summary>
        /// Gets or sets default message time to live value. This is the
        /// duration after which the message expires, starting from when the
        /// message is sent to Service Bus. This is the default value used when
        /// TimeToLive is not set on a message itself. The service accepts a C#
        /// Standard TimeSpan Format for loc duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days
        /// </summary>
        [JsonProperty(PropertyName = "properties.defaultMessageTimeToLive")]
        public string DefaultMessageTimeToLive { get; set; }

        /// <summary>
        /// Gets or sets timeSpan structure that defines the duration of the
        /// duplicate detection history. The default value is 10 minutes. The
        /// service accepts a C# Standard TimeSpan Format for loc duration
        /// https://msdn.microsoft.com/en-us/library/ee372286(v=vs.110).aspx .
        /// Format is 'DD.HH:MM:SS' and default value of this property is
        /// 10675199 days
        /// </summary>
        [JsonProperty(PropertyName = "properties.duplicateDetectionHistoryTimeWindow")]
        public string DuplicateDetectionHistoryTimeWindow { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether server-side batched
        /// operations are enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableBatchedOperations")]
        public bool? EnableBatchedOperations { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether Express Entities are
        /// enabled. An express topic holds a message in memory temporarily
        /// before writing it to persistent storage.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enableExpress")]
        public bool? EnableExpress { get; set; }

        /// <summary>
        /// Gets or sets value that indicates whether the topic to be
        /// partitioned across multiple message brokers is enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.enablePartitioning")]
        public bool? EnablePartitioning { get; set; }

        /// <summary>
        /// Gets or sets maximum size of the topic in megabytes, which is the
        /// size of the memory allocated for the topic.
        /// </summary>
        [JsonProperty(PropertyName = "properties.maxSizeInMegabytes")]
        public long? MaxSizeInMegabytes { get; set; }

        /// <summary>
        /// Gets or sets value indicating if this topic requires duplicate
        /// detection.
        /// </summary>
        [JsonProperty(PropertyName = "properties.requiresDuplicateDetection")]
        public bool? RequiresDuplicateDetection { get; set; }

        /// <summary>
        /// Gets size of the topic, in bytes.
        /// </summary>
        [JsonProperty(PropertyName = "properties.sizeInBytes")]
        public long? SizeInBytes { get; private set; }

        /// <summary>
        /// Gets enumerates the possible values for the status of a messaging
        /// entity. Possible values include: 'Active', 'Creating', 'Deleting',
        /// 'Disabled', 'ReceiveDisabled', 'Renaming', 'Restoring',
        /// 'SendDisabled', 'Unknown'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public EntityStatus? Status { get; private set; }

        /// <summary>
        /// Gets number of subscriptions.
        /// </summary>
        [JsonProperty(PropertyName = "properties.subscriptionCount")]
        public int? SubscriptionCount { get; private set; }

        /// <summary>
        /// Gets or sets value that indicates whether the topic supports
        /// ordering.
        /// </summary>
        [JsonProperty(PropertyName = "properties.supportOrdering")]
        public bool? SupportOrdering { get; set; }

        /// <summary>
        /// Gets the exact time the Topic was updated.
        /// </summary>
        [JsonProperty(PropertyName = "properties.updatedAt")]
        public System.DateTime? UpdatedAt { get; private set; }

    }
}
