// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A backup long term retention vault
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class BackupLongTermRetentionVaultInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the BackupLongTermRetentionVaultInner
        /// class.
        /// </summary>
        public BackupLongTermRetentionVaultInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the BackupLongTermRetentionVaultInner
        /// class.
        /// </summary>
        /// <param name="recoveryServicesVaultResourceId">The azure recovery
        /// services vault resource id</param>
        /// <param name="location">The geo-location where the resource
        /// lives</param>
        public BackupLongTermRetentionVaultInner(string recoveryServicesVaultResourceId, string id = default(string), string name = default(string), string type = default(string), string location = default(string))
            : base(id, name, type)
        {
            Location = location;
            RecoveryServicesVaultResourceId = recoveryServicesVaultResourceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the geo-location where the resource lives
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets or sets the azure recovery services vault resource id
        /// </summary>
        [JsonProperty(PropertyName = "properties.recoveryServicesVaultResourceId")]
        public string RecoveryServicesVaultResourceId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (RecoveryServicesVaultResourceId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "RecoveryServicesVaultResourceId");
            }
        }
    }
}
