// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A response indicating whether the specified name for a resource is
    /// available.
    /// </summary>
    public partial class CheckNameAvailabilityResponseInner
    {
        /// <summary>
        /// Initializes a new instance of the
        /// CheckNameAvailabilityResponseInner class.
        /// </summary>
        public CheckNameAvailabilityResponseInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// CheckNameAvailabilityResponseInner class.
        /// </summary>
        /// <param name="available">True if the name is available, otherwise
        /// false.</param>
        /// <param name="message">A message explaining why the name is
        /// unavailable. Will be null if the name is available.</param>
        /// <param name="name">The name whose availability was checked.</param>
        /// <param name="reason">The reason code explaining why the name is
        /// unavailable. Will be null if the name is available. Possible values
        /// include: 'Invalid', 'AlreadyExists'</param>
        public CheckNameAvailabilityResponseInner(bool? available = default(bool?), string message = default(string), string name = default(string), CheckNameAvailabilityReason? reason = default(CheckNameAvailabilityReason?))
        {
            Available = available;
            Message = message;
            Name = name;
            Reason = reason;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets true if the name is available, otherwise false.
        /// </summary>
        [JsonProperty(PropertyName = "available")]
        public bool? Available { get; private set; }

        /// <summary>
        /// Gets a message explaining why the name is unavailable. Will be null
        /// if the name is available.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; private set; }

        /// <summary>
        /// Gets the name whose availability was checked.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the reason code explaining why the name is unavailable. Will
        /// be null if the name is available. Possible values include:
        /// 'Invalid', 'AlreadyExists'
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public CheckNameAvailabilityReason? Reason { get; private set; }

    }
}
