// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A database operation.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DatabaseOperationInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the DatabaseOperationInner class.
        /// </summary>
        public DatabaseOperationInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the DatabaseOperationInner class.
        /// </summary>
        /// <param name="databaseName">The name of the database the operation
        /// is being performed on.</param>
        /// <param name="operation">The name of operation.</param>
        /// <param name="operationFriendlyName">The friendly name of
        /// operation.</param>
        /// <param name="percentComplete">The percentage of the operation
        /// completed.</param>
        /// <param name="serverName">The name of the server.</param>
        /// <param name="startTime">The operation start time.</param>
        /// <param name="state">The operation state. Possible values include:
        /// 'Pending', 'InProgress', 'Succeeded', 'Failed', 'CancelInProgress',
        /// 'Cancelled'</param>
        /// <param name="errorCode">The operation error code.</param>
        /// <param name="errorDescription">The operation error
        /// description.</param>
        /// <param name="errorSeverity">The operation error severity.</param>
        /// <param name="isUserError">Whether or not the error is a user
        /// error.</param>
        /// <param name="estimatedCompletionTime">The estimated completion time
        /// of the operation.</param>
        /// <param name="description">The operation description.</param>
        /// <param name="isCancellable">Whether the operation can be
        /// cancelled.</param>
        public DatabaseOperationInner(string id = default(string), string name = default(string), string type = default(string), string databaseName = default(string), string operation = default(string), string operationFriendlyName = default(string), int? percentComplete = default(int?), string serverName = default(string), System.DateTime? startTime = default(System.DateTime?), ManagementOperationState state = default(ManagementOperationState), int? errorCode = default(int?), string errorDescription = default(string), int? errorSeverity = default(int?), bool? isUserError = default(bool?), System.DateTime? estimatedCompletionTime = default(System.DateTime?), string description = default(string), bool? isCancellable = default(bool?))
            : base(id, name, type)
        {
            DatabaseName = databaseName;
            Operation = operation;
            OperationFriendlyName = operationFriendlyName;
            PercentComplete = percentComplete;
            ServerName = serverName;
            StartTime = startTime;
            State = state;
            ErrorCode = errorCode;
            ErrorDescription = errorDescription;
            ErrorSeverity = errorSeverity;
            IsUserError = isUserError;
            EstimatedCompletionTime = estimatedCompletionTime;
            Description = description;
            IsCancellable = isCancellable;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the name of the database the operation is being performed on.
        /// </summary>
        [JsonProperty(PropertyName = "properties.databaseName")]
        public string DatabaseName { get; private set; }

        /// <summary>
        /// Gets the name of operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.operation")]
        public string Operation { get; private set; }

        /// <summary>
        /// Gets the friendly name of operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.operationFriendlyName")]
        public string OperationFriendlyName { get; private set; }

        /// <summary>
        /// Gets the percentage of the operation completed.
        /// </summary>
        [JsonProperty(PropertyName = "properties.percentComplete")]
        public int? PercentComplete { get; private set; }

        /// <summary>
        /// Gets the name of the server.
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverName")]
        public string ServerName { get; private set; }

        /// <summary>
        /// Gets the operation start time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.startTime")]
        public System.DateTime? StartTime { get; private set; }

        /// <summary>
        /// Gets the operation state. Possible values include: 'Pending',
        /// 'InProgress', 'Succeeded', 'Failed', 'CancelInProgress',
        /// 'Cancelled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public ManagementOperationState State { get; private set; }

        /// <summary>
        /// Gets the operation error code.
        /// </summary>
        [JsonProperty(PropertyName = "properties.errorCode")]
        public int? ErrorCode { get; private set; }

        /// <summary>
        /// Gets the operation error description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.errorDescription")]
        public string ErrorDescription { get; private set; }

        /// <summary>
        /// Gets the operation error severity.
        /// </summary>
        [JsonProperty(PropertyName = "properties.errorSeverity")]
        public int? ErrorSeverity { get; private set; }

        /// <summary>
        /// Gets whether or not the error is a user error.
        /// </summary>
        [JsonProperty(PropertyName = "properties.isUserError")]
        public bool? IsUserError { get; private set; }

        /// <summary>
        /// Gets the estimated completion time of the operation.
        /// </summary>
        [JsonProperty(PropertyName = "properties.estimatedCompletionTime")]
        public System.DateTime? EstimatedCompletionTime { get; private set; }

        /// <summary>
        /// Gets the operation description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; private set; }

        /// <summary>
        /// Gets whether the operation can be cancelled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.isCancellable")]
        public bool? IsCancellable { get; private set; }

    }
}
