// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The elastic pool edition capabilities.
    /// </summary>
    public partial class ElasticPoolEditionCapability
    {
        /// <summary>
        /// Initializes a new instance of the ElasticPoolEditionCapability
        /// class.
        /// </summary>
        public ElasticPoolEditionCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ElasticPoolEditionCapability
        /// class.
        /// </summary>
        /// <param name="name">The elastic pool edition name.</param>
        /// <param name="status">The status of the elastic pool edition.
        /// Possible values include: 'Visible', 'Available', 'Default',
        /// 'Disabled'</param>
        /// <param name="supportedElasticPoolDtus">The list of supported
        /// elastic pool DTU levels for the edition.</param>
        /// <param name="zoneRedundant">Whether or not zone redundancy is
        /// supported for the edition.</param>
        public ElasticPoolEditionCapability(string name = default(string), CapabilityStatus? status = default(CapabilityStatus?), IList<ElasticPoolDtuCapability> supportedElasticPoolDtus = default(IList<ElasticPoolDtuCapability>), bool? zoneRedundant = default(bool?))
        {
            Name = name;
            Status = status;
            SupportedElasticPoolDtus = supportedElasticPoolDtus;
            ZoneRedundant = zoneRedundant;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the elastic pool edition name.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets the status of the elastic pool edition. Possible values
        /// include: 'Visible', 'Available', 'Default', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CapabilityStatus? Status { get; private set; }

        /// <summary>
        /// Gets the list of supported elastic pool DTU levels for the edition.
        /// </summary>
        [JsonProperty(PropertyName = "supportedElasticPoolDtus")]
        public IList<ElasticPoolDtuCapability> SupportedElasticPoolDtus { get; private set; }

        /// <summary>
        /// Gets whether or not zone redundancy is supported for the edition.
        /// </summary>
        [JsonProperty(PropertyName = "zoneRedundant")]
        public bool? ZoneRedundant { get; private set; }

    }
}
