// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The max per-database DTU capability.
    /// </summary>
    public partial class ElasticPoolPerDatabaseMaxDtuCapability
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerDatabaseMaxDtuCapability class.
        /// </summary>
        public ElasticPoolPerDatabaseMaxDtuCapability()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// ElasticPoolPerDatabaseMaxDtuCapability class.
        /// </summary>
        /// <param name="limit">The maximum DTUs per database.</param>
        /// <param name="status">The status of the capability. Possible values
        /// include: 'Visible', 'Available', 'Default', 'Disabled'</param>
        /// <param name="supportedPerDatabaseMinDtus">The list of supported min
        /// database DTUs.</param>
        public ElasticPoolPerDatabaseMaxDtuCapability(long? limit = default(long?), CapabilityStatus? status = default(CapabilityStatus?), IList<ElasticPoolPerDatabaseMinDtuCapability> supportedPerDatabaseMinDtus = default(IList<ElasticPoolPerDatabaseMinDtuCapability>))
        {
            Limit = limit;
            Status = status;
            SupportedPerDatabaseMinDtus = supportedPerDatabaseMinDtus;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets the maximum DTUs per database.
        /// </summary>
        [JsonProperty(PropertyName = "limit")]
        public long? Limit { get; private set; }

        /// <summary>
        /// Gets the status of the capability. Possible values include:
        /// 'Visible', 'Available', 'Default', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public CapabilityStatus? Status { get; private set; }

        /// <summary>
        /// Gets the list of supported min database DTUs.
        /// </summary>
        [JsonProperty(PropertyName = "supportedPerDatabaseMinDtus")]
        public IList<ElasticPoolPerDatabaseMinDtuCapability> SupportedPerDatabaseMinDtus { get; private set; }

    }
}
