// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Azure.Management.ResourceManager;
    using Microsoft.Azure.Management.ResourceManager.Fluent;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Represents an elastic pool update.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ElasticPoolUpdateInner : Management.ResourceManager.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the ElasticPoolUpdateInner class.
        /// </summary>
        public ElasticPoolUpdateInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ElasticPoolUpdateInner class.
        /// </summary>
        /// <param name="tags">Resource tags.</param>
        /// <param name="creationDate">The creation date of the elastic pool
        /// (ISO8601 format).</param>
        /// <param name="state">The state of the elastic pool. Possible values
        /// include: 'Creating', 'Ready', 'Disabled'</param>
        /// <param name="edition">The edition of the elastic pool. Possible
        /// values include: 'Basic', 'Standard', 'Premium', 'GeneralPurpose',
        /// 'BusinessCritical'</param>
        /// <param name="dtu">The total shared DTU for the database elastic
        /// pool.</param>
        /// <param name="databaseDtuMax">The maximum DTU any one database can
        /// consume.</param>
        /// <param name="databaseDtuMin">The minimum DTU all databases are
        /// guaranteed.</param>
        /// <param name="storageMB">Gets storage limit for the database elastic
        /// pool in MB.</param>
        /// <param name="zoneRedundant">Whether or not this database elastic
        /// pool is zone redundant, which means the replicas of this database
        /// will be spread across multiple availability zones.</param>
        public ElasticPoolUpdateInner(string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), System.DateTime? creationDate = default(System.DateTime?), ElasticPoolState state = default(ElasticPoolState), ElasticPoolEdition edition = default(ElasticPoolEdition), int? dtu = default(int?), int? databaseDtuMax = default(int?), int? databaseDtuMin = default(int?), int? storageMB = default(int?), bool? zoneRedundant = default(bool?))
            : base(id, name, type)
        {
            Tags = tags;
            CreationDate = creationDate;
            State = state;
            Edition = edition;
            Dtu = dtu;
            DatabaseDtuMax = databaseDtuMax;
            DatabaseDtuMin = databaseDtuMin;
            StorageMB = storageMB;
            ZoneRedundant = zoneRedundant;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets resource tags.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets the creation date of the elastic pool (ISO8601 format).
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationDate")]
        public System.DateTime? CreationDate { get; private set; }

        /// <summary>
        /// Gets the state of the elastic pool. Possible values include:
        /// 'Creating', 'Ready', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public ElasticPoolState State { get; private set; }

        /// <summary>
        /// Gets or sets the edition of the elastic pool. Possible values
        /// include: 'Basic', 'Standard', 'Premium', 'GeneralPurpose',
        /// 'BusinessCritical'
        /// </summary>
        [JsonProperty(PropertyName = "properties.edition")]
        public ElasticPoolEdition Edition { get; set; }

        /// <summary>
        /// Gets or sets the total shared DTU for the database elastic pool.
        /// </summary>
        [JsonProperty(PropertyName = "properties.dtu")]
        public int? Dtu { get; set; }

        /// <summary>
        /// Gets or sets the maximum DTU any one database can consume.
        /// </summary>
        [JsonProperty(PropertyName = "properties.databaseDtuMax")]
        public int? DatabaseDtuMax { get; set; }

        /// <summary>
        /// Gets or sets the minimum DTU all databases are guaranteed.
        /// </summary>
        [JsonProperty(PropertyName = "properties.databaseDtuMin")]
        public int? DatabaseDtuMin { get; set; }

        /// <summary>
        /// Gets storage limit for the database elastic pool in MB.
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageMB")]
        public int? StorageMB { get; set; }

        /// <summary>
        /// Gets or sets whether or not this database elastic pool is zone
        /// redundant, which means the replicas of this database will be spread
        /// across multiple availability zones.
        /// </summary>
        [JsonProperty(PropertyName = "properties.zoneRedundant")]
        public bool? ZoneRedundant { get; set; }

    }
}
