// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A failover group update request.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class FailoverGroupUpdate
    {
        /// <summary>
        /// Initializes a new instance of the FailoverGroupUpdate class.
        /// </summary>
        public FailoverGroupUpdate()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the FailoverGroupUpdate class.
        /// </summary>
        /// <param name="readWriteEndpoint">Read-write endpoint of the failover
        /// group instance.</param>
        /// <param name="readOnlyEndpoint">Read-only endpoint of the failover
        /// group instance.</param>
        /// <param name="databases">List of databases in the failover
        /// group.</param>
        /// <param name="tags">Resource tags.</param>
        public FailoverGroupUpdate(FailoverGroupReadWriteEndpoint readWriteEndpoint = default(FailoverGroupReadWriteEndpoint), FailoverGroupReadOnlyEndpoint readOnlyEndpoint = default(FailoverGroupReadOnlyEndpoint), IList<string> databases = default(IList<string>), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            ReadWriteEndpoint = readWriteEndpoint;
            ReadOnlyEndpoint = readOnlyEndpoint;
            Databases = databases;
            Tags = tags;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets read-write endpoint of the failover group instance.
        /// </summary>
        [JsonProperty(PropertyName = "properties.readWriteEndpoint")]
        public FailoverGroupReadWriteEndpoint ReadWriteEndpoint { get; set; }

        /// <summary>
        /// Gets or sets read-only endpoint of the failover group instance.
        /// </summary>
        [JsonProperty(PropertyName = "properties.readOnlyEndpoint")]
        public FailoverGroupReadOnlyEndpoint ReadOnlyEndpoint { get; set; }

        /// <summary>
        /// Gets or sets list of databases in the failover group.
        /// </summary>
        [JsonProperty(PropertyName = "properties.databases")]
        public IList<string> Databases { get; set; }

        /// <summary>
        /// Gets or sets resource tags.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ReadWriteEndpoint != null)
            {
                ReadWriteEndpoint.Validate();
            }
        }
    }
}
