// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A stored credential that can be used by a job to connect to target
    /// databases.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class JobCredentialInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the JobCredentialInner class.
        /// </summary>
        public JobCredentialInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobCredentialInner class.
        /// </summary>
        /// <param name="username">The credential user name.</param>
        /// <param name="password">The credential password.</param>
        public JobCredentialInner(string username, string password, string id = default(string), string name = default(string), string type = default(string))
            : base(id, name, type)
        {
            Username = username;
            Password = password;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the credential user name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.username")]
        public string Username { get; set; }

        /// <summary>
        /// Gets or sets the credential password.
        /// </summary>
        [JsonProperty(PropertyName = "properties.password")]
        public string Password { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Username == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Username");
            }
            if (Password == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Password");
            }
        }
    }
}
