// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A job.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class JobInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the JobInner class.
        /// </summary>
        public JobInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobInner class.
        /// </summary>
        /// <param name="description">User-defined description of the
        /// job.</param>
        /// <param name="version">The job version number.</param>
        /// <param name="schedule">Schedule properties of the job.</param>
        public JobInner(string id = default(string), string name = default(string), string type = default(string), string description = default(string), int? version = default(int?), JobSchedule schedule = default(JobSchedule))
            : base(id, name, type)
        {
            Description = description;
            Version = version;
            Schedule = schedule;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets user-defined description of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets the job version number.
        /// </summary>
        [JsonProperty(PropertyName = "properties.version")]
        public int? Version { get; private set; }

        /// <summary>
        /// Gets or sets schedule properties of the job.
        /// </summary>
        [JsonProperty(PropertyName = "properties.schedule")]
        public JobSchedule Schedule { get; set; }

    }
}
