// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A group of job targets.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class JobTargetGroupInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the JobTargetGroupInner class.
        /// </summary>
        public JobTargetGroupInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the JobTargetGroupInner class.
        /// </summary>
        /// <param name="members">Members of the target group.</param>
        public JobTargetGroupInner(IList<JobTarget> members, string id = default(string), string name = default(string), string type = default(string))
            : base(id, name, type)
        {
            Members = members;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets members of the target group.
        /// </summary>
        [JsonProperty(PropertyName = "properties.members")]
        public IList<JobTarget> Members { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Members == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Members");
            }
            if (Members != null)
            {
                foreach (var element in Members)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
