// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A managed instance key.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ManagedInstanceKeyInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the ManagedInstanceKeyInner class.
        /// </summary>
        public ManagedInstanceKeyInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedInstanceKeyInner class.
        /// </summary>
        /// <param name="serverKeyType">The key type like 'ServiceManaged',
        /// 'AzureKeyVault'. Possible values include: 'ServiceManaged',
        /// 'AzureKeyVault'</param>
        /// <param name="kind">Kind of encryption protector. This is metadata
        /// used for the Azure portal experience.</param>
        /// <param name="uri">The URI of the key. If the ServerKeyType is
        /// AzureKeyVault, then the URI is required.</param>
        /// <param name="thumbprint">Thumbprint of the key.</param>
        /// <param name="creationDate">The key creation date.</param>
        public ManagedInstanceKeyInner(ServerKeyType serverKeyType, string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string uri = default(string), string thumbprint = default(string), System.DateTime? creationDate = default(System.DateTime?))
            : base(id, name, type)
        {
            Kind = kind;
            ServerKeyType = serverKeyType;
            Uri = uri;
            Thumbprint = thumbprint;
            CreationDate = creationDate;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets kind of encryption protector. This is metadata used for the
        /// Azure portal experience.
        /// </summary>
        [JsonProperty(PropertyName = "kind")]
        public string Kind { get; private set; }

        /// <summary>
        /// Gets or sets the key type like 'ServiceManaged', 'AzureKeyVault'.
        /// Possible values include: 'ServiceManaged', 'AzureKeyVault'
        /// </summary>
        [JsonProperty(PropertyName = "properties.serverKeyType")]
        public ServerKeyType ServerKeyType { get; set; }

        /// <summary>
        /// Gets or sets the URI of the key. If the ServerKeyType is
        /// AzureKeyVault, then the URI is required.
        /// </summary>
        [JsonProperty(PropertyName = "properties.uri")]
        public string Uri { get; set; }

        /// <summary>
        /// Gets thumbprint of the key.
        /// </summary>
        [JsonProperty(PropertyName = "properties.thumbprint")]
        public string Thumbprint { get; private set; }

        /// <summary>
        /// Gets the key creation date.
        /// </summary>
        [JsonProperty(PropertyName = "properties.creationDate")]
        public System.DateTime? CreationDate { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (ServerKeyType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ServerKeyType");
            }
        }
    }
}
