// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Pairs of Managed Instances in the failover group.
    /// </summary>
    public partial class ManagedInstancePairInfo
    {
        /// <summary>
        /// Initializes a new instance of the ManagedInstancePairInfo class.
        /// </summary>
        public ManagedInstancePairInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ManagedInstancePairInfo class.
        /// </summary>
        /// <param name="primaryManagedInstanceId">Id of Primary Managed
        /// Instance in pair.</param>
        /// <param name="partnerManagedInstanceId">Id of Partner Managed
        /// Instance in pair.</param>
        public ManagedInstancePairInfo(string primaryManagedInstanceId = default(string), string partnerManagedInstanceId = default(string))
        {
            PrimaryManagedInstanceId = primaryManagedInstanceId;
            PartnerManagedInstanceId = partnerManagedInstanceId;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets id of Primary Managed Instance in pair.
        /// </summary>
        [JsonProperty(PropertyName = "primaryManagedInstanceId")]
        public string PrimaryManagedInstanceId { get; set; }

        /// <summary>
        /// Gets or sets id of Partner Managed Instance in pair.
        /// </summary>
        [JsonProperty(PropertyName = "partnerManagedInstanceId")]
        public string PartnerManagedInstanceId { get; set; }

    }
}
