// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Partner region information for the failover group.
    /// </summary>
    public partial class PartnerRegionInfo
    {
        /// <summary>
        /// Initializes a new instance of the PartnerRegionInfo class.
        /// </summary>
        public PartnerRegionInfo()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PartnerRegionInfo class.
        /// </summary>
        /// <param name="location">Geo location of the partner managed
        /// instances.</param>
        /// <param name="replicationRole">Replication role of the partner
        /// managed instances. Possible values include: 'Primary',
        /// 'Secondary'</param>
        public PartnerRegionInfo(string location = default(string), InstanceFailoverGroupReplicationRole replicationRole = default(InstanceFailoverGroupReplicationRole))
        {
            Location = location;
            ReplicationRole = replicationRole;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets geo location of the partner managed instances.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets replication role of the partner managed instances. Possible
        /// values include: 'Primary', 'Secondary'
        /// </summary>
        [JsonProperty(PropertyName = "replicationRole")]
        public InstanceFailoverGroupReplicationRole ReplicationRole { get; private set; }

    }
}
