// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Database restore points.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class RestorePointInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the RestorePointInner class.
        /// </summary>
        public RestorePointInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the RestorePointInner class.
        /// </summary>
        /// <param name="location">Resource location.</param>
        /// <param name="restorePointType">The type of restore point. Possible
        /// values include: 'CONTINUOUS', 'DISCRETE'</param>
        /// <param name="earliestRestoreDate">The earliest time to which this
        /// database can be restored</param>
        /// <param name="restorePointCreationDate">The time the backup was
        /// taken</param>
        /// <param name="restorePointLabel">The label of restore point for
        /// backup request by user</param>
        public RestorePointInner(string id = default(string), string name = default(string), string type = default(string), string location = default(string), RestorePointType? restorePointType = default(RestorePointType?), System.DateTime? earliestRestoreDate = default(System.DateTime?), System.DateTime? restorePointCreationDate = default(System.DateTime?), string restorePointLabel = default(string))
            : base(id, name, type)
        {
            Location = location;
            RestorePointType = restorePointType;
            EarliestRestoreDate = earliestRestoreDate;
            RestorePointCreationDate = restorePointCreationDate;
            RestorePointLabel = restorePointLabel;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets the type of restore point. Possible values include:
        /// 'CONTINUOUS', 'DISCRETE'
        /// </summary>
        [JsonProperty(PropertyName = "properties.restorePointType")]
        public RestorePointType? RestorePointType { get; private set; }

        /// <summary>
        /// Gets the earliest time to which this database can be restored
        /// </summary>
        [JsonProperty(PropertyName = "properties.earliestRestoreDate")]
        public System.DateTime? EarliestRestoreDate { get; private set; }

        /// <summary>
        /// Gets the time the backup was taken
        /// </summary>
        [JsonProperty(PropertyName = "properties.restorePointCreationDate")]
        public System.DateTime? RestorePointCreationDate { get; private set; }

        /// <summary>
        /// Gets the label of restore point for backup request by user
        /// </summary>
        [JsonProperty(PropertyName = "properties.restorePointLabel")]
        public string RestorePointLabel { get; private set; }

    }
}
