// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A server secure connection policy.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ServerConnectionPolicyInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the ServerConnectionPolicyInner
        /// class.
        /// </summary>
        public ServerConnectionPolicyInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ServerConnectionPolicyInner
        /// class.
        /// </summary>
        /// <param name="connectionType">The server connection type. Possible
        /// values include: 'Default', 'Proxy', 'Redirect'</param>
        /// <param name="kind">Metadata used for the Azure portal
        /// experience.</param>
        /// <param name="location">Resource location.</param>
        public ServerConnectionPolicyInner(ServerConnectionType connectionType, string id = default(string), string name = default(string), string type = default(string), string kind = default(string), string location = default(string))
            : base(id, name, type)
        {
            Kind = kind;
            Location = location;
            ConnectionType = connectionType;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets metadata used for the Azure portal experience.
        /// </summary>
        [JsonProperty(PropertyName = "kind")]
        public string Kind { get; private set; }

        /// <summary>
        /// Gets resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets or sets the server connection type. Possible values include:
        /// 'Default', 'Proxy', 'Redirect'
        /// </summary>
        [JsonProperty(PropertyName = "properties.connectionType")]
        public ServerConnectionType ConnectionType { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
