// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Properties of the table in the database full schema.
    /// </summary>
    public partial class SyncFullSchemaTable
    {
        /// <summary>
        /// Initializes a new instance of the SyncFullSchemaTable class.
        /// </summary>
        public SyncFullSchemaTable()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the SyncFullSchemaTable class.
        /// </summary>
        /// <param name="columns">List of columns in the table of database full
        /// schema.</param>
        /// <param name="errorId">Error id of the table.</param>
        /// <param name="hasError">If there is error in the table.</param>
        /// <param name="name">Name of the table.</param>
        /// <param name="quotedName">Quoted name of the table.</param>
        public SyncFullSchemaTable(IList<SyncFullSchemaTableColumn> columns = default(IList<SyncFullSchemaTableColumn>), string errorId = default(string), bool? hasError = default(bool?), string name = default(string), string quotedName = default(string))
        {
            Columns = columns;
            ErrorId = errorId;
            HasError = hasError;
            Name = name;
            QuotedName = quotedName;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets list of columns in the table of database full schema.
        /// </summary>
        [JsonProperty(PropertyName = "columns")]
        public IList<SyncFullSchemaTableColumn> Columns { get; private set; }

        /// <summary>
        /// Gets error id of the table.
        /// </summary>
        [JsonProperty(PropertyName = "errorId")]
        public string ErrorId { get; private set; }

        /// <summary>
        /// Gets if there is error in the table.
        /// </summary>
        [JsonProperty(PropertyName = "hasError")]
        public bool? HasError { get; private set; }

        /// <summary>
        /// Gets name of the table.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; private set; }

        /// <summary>
        /// Gets quoted name of the table.
        /// </summary>
        [JsonProperty(PropertyName = "quotedName")]
        public string QuotedName { get; private set; }

    }
}
