// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A TDE certificate that can be uploaded into a server.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class TdeCertificateInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the TdeCertificateInner class.
        /// </summary>
        public TdeCertificateInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TdeCertificateInner class.
        /// </summary>
        /// <param name="privateBlob">The base64 encoded certificate private
        /// blob.</param>
        /// <param name="certPassword">The certificate password.</param>
        public TdeCertificateInner(string privateBlob, string id = default(string), string name = default(string), string type = default(string), string certPassword = default(string))
            : base(id, name, type)
        {
            PrivateBlob = privateBlob;
            CertPassword = certPassword;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the base64 encoded certificate private blob.
        /// </summary>
        [JsonProperty(PropertyName = "properties.privateBlob")]
        public string PrivateBlob { get; set; }

        /// <summary>
        /// Gets or sets the certificate password.
        /// </summary>
        [JsonProperty(PropertyName = "properties.certPassword")]
        public string CertPassword { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (PrivateBlob == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "PrivateBlob");
            }
        }
    }
}
