// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Represents a database transparent data encryption configuration.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class TransparentDataEncryptionInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the TransparentDataEncryptionInner
        /// class.
        /// </summary>
        public TransparentDataEncryptionInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the TransparentDataEncryptionInner
        /// class.
        /// </summary>
        /// <param name="location">Resource location.</param>
        /// <param name="status">The status of the database transparent data
        /// encryption. Possible values include: 'Enabled', 'Disabled'</param>
        public TransparentDataEncryptionInner(string id = default(string), string name = default(string), string type = default(string), string location = default(string), TransparentDataEncryptionStatus? status = default(TransparentDataEncryptionStatus?))
            : base(id, name, type)
        {
            Location = location;
            Status = status;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets resource location.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; private set; }

        /// <summary>
        /// Gets or sets the status of the database transparent data
        /// encryption. Possible values include: 'Enabled', 'Disabled'
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public TransparentDataEncryptionStatus? Status { get; set; }

    }
}
