// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A virtual network rule.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class VirtualNetworkRuleInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the VirtualNetworkRuleInner class.
        /// </summary>
        public VirtualNetworkRuleInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the VirtualNetworkRuleInner class.
        /// </summary>
        /// <param name="virtualNetworkSubnetId">The ARM resource id of the
        /// virtual network subnet.</param>
        /// <param name="ignoreMissingVnetServiceEndpoint">Create firewall rule
        /// before the virtual network has vnet service endpoint
        /// enabled.</param>
        /// <param name="state">Virtual Network Rule State. Possible values
        /// include: 'Initializing', 'InProgress', 'Ready', 'Deleting',
        /// 'Unknown'</param>
        public VirtualNetworkRuleInner(string virtualNetworkSubnetId, string id = default(string), string name = default(string), string type = default(string), bool? ignoreMissingVnetServiceEndpoint = default(bool?), VirtualNetworkRuleState state = default(VirtualNetworkRuleState))
            : base(id, name, type)
        {
            VirtualNetworkSubnetId = virtualNetworkSubnetId;
            IgnoreMissingVnetServiceEndpoint = ignoreMissingVnetServiceEndpoint;
            State = state;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the ARM resource id of the virtual network subnet.
        /// </summary>
        [JsonProperty(PropertyName = "properties.virtualNetworkSubnetId")]
        public string VirtualNetworkSubnetId { get; set; }

        /// <summary>
        /// Gets or sets create firewall rule before the virtual network has
        /// vnet service endpoint enabled.
        /// </summary>
        [JsonProperty(PropertyName = "properties.ignoreMissingVnetServiceEndpoint")]
        public bool? IgnoreMissingVnetServiceEndpoint { get; set; }

        /// <summary>
        /// Gets virtual Network Rule State. Possible values include:
        /// 'Initializing', 'InProgress', 'Ready', 'Deleting', 'Unknown'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public VirtualNetworkRuleState State { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (VirtualNetworkSubnetId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "VirtualNetworkSubnetId");
            }
        }
    }
}
