// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
namespace Microsoft.Azure.Management.Sql.Fluent
{
    /// <summary>
    /// The minimum limit of the reserved eDTUs value range for a "Premium" edition of an Azure SQL Elastic Pool.
    /// </summary>
    public enum SqlElasticPoolPremiumMinEDTUs : int
    {
        /** 0 reserved minimum eDTUs available for each database in the pool. */
        eDTU_0 = 0,

        /** 0 reserved minimum eDTUs available for each database in the pool. */
        eDTU_25 = 25,

        /** 50 reserved minimum eDTUs available for each database in the pool. */
        eDTU_50 = 50,

        /** 75 reserved minimum eDTUs available for each database in the pool. */
        eDTU_75 = 75,

        /** 125 reserved minimum eDTUs available for each database in the pool. */
        eDTU_125 = 125,

        /** 250 reserved minimum eDTUs available for each database in the pool. */
        eDTU_250 = 250,

        /** 500 reserved minimum eDTUs available for each database in the pool. */
        eDTU_500 = 500,

        /** 1000 reserved minimum eDTUs available for each database in the pool. */
        eDTU_1000 = 1000,

        /** 1750 reserved minimum eDTUs available for each database in the pool. */
        eDTU_1750 = 1750,

        /** 4000 reserved minimum eDTUs available for each database in the pool. */
        eDTU_4000 = 4000
    }
}