// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Storage.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The properties of an ImmutabilityPolicy of a blob container.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class ImmutabilityPolicyProperties
    {
        /// <summary>
        /// Initializes a new instance of the ImmutabilityPolicyProperties
        /// class.
        /// </summary>
        public ImmutabilityPolicyProperties()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the ImmutabilityPolicyProperties
        /// class.
        /// </summary>
        /// <param name="immutabilityPeriodSinceCreationInDays">The
        /// immutability period for the blobs in the container since the policy
        /// creation, in days.</param>
        /// <param name="state">The ImmutabilityPolicy state of a blob
        /// container, possible values include: Locked and Unlocked. Possible
        /// values include: 'Locked', 'Unlocked'</param>
        /// <param name="etag">ImmutabilityPolicy Etag.</param>
        /// <param name="updateHistory">The ImmutabilityPolicy update history
        /// of the blob container.</param>
        public ImmutabilityPolicyProperties(int immutabilityPeriodSinceCreationInDays, ImmutabilityPolicyState state = default(ImmutabilityPolicyState), string etag = default(string), IList<UpdateHistoryProperty> updateHistory = default(IList<UpdateHistoryProperty>))
        {
            ImmutabilityPeriodSinceCreationInDays = immutabilityPeriodSinceCreationInDays;
            State = state;
            Etag = etag;
            UpdateHistory = updateHistory;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the immutability period for the blobs in the container
        /// since the policy creation, in days.
        /// </summary>
        [JsonProperty(PropertyName = "properties.immutabilityPeriodSinceCreationInDays")]
        public int ImmutabilityPeriodSinceCreationInDays { get; set; }

        /// <summary>
        /// Gets the ImmutabilityPolicy state of a blob container, possible
        /// values include: Locked and Unlocked. Possible values include:
        /// 'Locked', 'Unlocked'
        /// </summary>
        [JsonProperty(PropertyName = "properties.state")]
        public ImmutabilityPolicyState State { get; private set; }

        /// <summary>
        /// Gets immutabilityPolicy Etag.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; private set; }

        /// <summary>
        /// Gets the ImmutabilityPolicy update history of the blob container.
        /// </summary>
        [JsonProperty(PropertyName = "updateHistory")]
        public IList<UpdateHistoryProperty> UpdateHistory { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
