// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.TrafficManager.Fluent.Models
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// Class representing a Traffic Manager HeatMap query experience
    /// properties.
    /// </summary>
    public partial class QueryExperience
    {
        /// <summary>
        /// Initializes a new instance of the QueryExperience class.
        /// </summary>
        public QueryExperience()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the QueryExperience class.
        /// </summary>
        /// <param name="endpointId">The id of the endpoint from the
        /// 'endpoints' array which these queries were routed to.</param>
        /// <param name="queryCount">The number of queries originating from
        /// this location.</param>
        /// <param name="latency">The latency experienced by queries
        /// originating from this location.</param>
        public QueryExperience(int endpointId, int queryCount, double? latency = default(double?))
        {
            EndpointId = endpointId;
            QueryCount = queryCount;
            Latency = latency;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the id of the endpoint from the 'endpoints' array
        /// which these queries were routed to.
        /// </summary>
        [JsonProperty(PropertyName = "endpointId")]
        public int EndpointId { get; set; }

        /// <summary>
        /// Gets or sets the number of queries originating from this location.
        /// </summary>
        [JsonProperty(PropertyName = "queryCount")]
        public int QueryCount { get; set; }

        /// <summary>
        /// Gets or sets the latency experienced by queries originating from
        /// this location.
        /// </summary>
        [JsonProperty(PropertyName = "latency")]
        public double? Latency { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
