// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for DatabaseVulnerabilityAssessmentRuleBaselinesOperations.
    /// </summary>
    public static partial class DatabaseVulnerabilityAssessmentRuleBaselinesOperationsExtensions
    {
            /// <summary>
            /// Gets a database's vulnerability assessment rule baseline.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group that contains the resource. You can obtain
            /// this value from the Azure Resource Manager API or the portal.
            /// </param>
            /// <param name='serverName'>
            /// The name of the server.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database for which the vulnerability assessment rule
            /// baseline is defined.
            /// </param>
            /// <param name='ruleId'>
            /// The vulnerability assessment rule ID.
            /// </param>
            /// <param name='baselineName'>
            /// The name of the vulnerability assessment rule baseline (default implies a
            /// baseline on a database level rule and master for server level rule).
            /// Possible values include: 'master', 'default'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DatabaseVulnerabilityAssessmentRuleBaselineInner> GetAsync(this IDatabaseVulnerabilityAssessmentRuleBaselinesOperations operations, string resourceGroupName, string serverName, string databaseName, string ruleId, VulnerabilityAssessmentPolicyBaselineName baselineName, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetWithHttpMessagesAsync(resourceGroupName, serverName, databaseName, ruleId, baselineName, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Creates or updates a database's vulnerability assessment rule baseline.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group that contains the resource. You can obtain
            /// this value from the Azure Resource Manager API or the portal.
            /// </param>
            /// <param name='serverName'>
            /// The name of the server.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database for which the vulnerability assessment rule
            /// baseline is defined.
            /// </param>
            /// <param name='ruleId'>
            /// The vulnerability assessment rule ID.
            /// </param>
            /// <param name='baselineName'>
            /// The name of the vulnerability assessment rule baseline (default implies a
            /// baseline on a database level rule and master for server level rule).
            /// Possible values include: 'master', 'default'
            /// </param>
            /// <param name='baselineResults'>
            /// The rule baseline result
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<DatabaseVulnerabilityAssessmentRuleBaselineInner> CreateOrUpdateAsync(this IDatabaseVulnerabilityAssessmentRuleBaselinesOperations operations, string resourceGroupName, string serverName, string databaseName, string ruleId, VulnerabilityAssessmentPolicyBaselineName baselineName, IList<DatabaseVulnerabilityAssessmentRuleBaselineItem> baselineResults, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateOrUpdateWithHttpMessagesAsync(resourceGroupName, serverName, databaseName, ruleId, baselineName, baselineResults, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Removes the database's vulnerability assessment rule baseline.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group that contains the resource. You can obtain
            /// this value from the Azure Resource Manager API or the portal.
            /// </param>
            /// <param name='serverName'>
            /// The name of the server.
            /// </param>
            /// <param name='databaseName'>
            /// The name of the database for which the vulnerability assessment rule
            /// baseline is defined.
            /// </param>
            /// <param name='ruleId'>
            /// The vulnerability assessment rule ID.
            /// </param>
            /// <param name='baselineName'>
            /// The name of the vulnerability assessment rule baseline (default implies a
            /// baseline on a database level rule and master for server level rule).
            /// Possible values include: 'master', 'default'
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteAsync(this IDatabaseVulnerabilityAssessmentRuleBaselinesOperations operations, string resourceGroupName, string serverName, string databaseName, string ruleId, VulnerabilityAssessmentPolicyBaselineName baselineName, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteWithHttpMessagesAsync(resourceGroupName, serverName, databaseName, ruleId, baselineName, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

    }
}
