// <auto-generated>
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// </auto-generated>

namespace Microsoft.Azure.Management.Sql.Fluent.Models
{
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A database vulnerability assessment.
    /// </summary>
    [Rest.Serialization.JsonTransformation]
    public partial class DatabaseVulnerabilityAssessmentInner : ProxyResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the
        /// DatabaseVulnerabilityAssessmentInner class.
        /// </summary>
        public DatabaseVulnerabilityAssessmentInner()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the
        /// DatabaseVulnerabilityAssessmentInner class.
        /// </summary>
        /// <param name="storageContainerPath">A blob storage container path to
        /// hold the scan results (e.g.
        /// https://myStorage.blob.core.windows.net/VaScans/).  It is required
        /// if server level vulnerability assessment policy doesn't set</param>
        /// <param name="storageContainerSasKey">A shared access signature (SAS
        /// Key) that has write access to the blob container specified in
        /// 'storageContainerPath' parameter. If 'storageAccountAccessKey'
        /// isn't specified, StorageContainerSasKey is required.</param>
        /// <param name="storageAccountAccessKey">Specifies the identifier key
        /// of the storage account for vulnerability assessment scan results.
        /// If 'StorageContainerSasKey' isn't specified,
        /// storageAccountAccessKey is required.</param>
        /// <param name="recurringScans">The recurring scans settings</param>
        public DatabaseVulnerabilityAssessmentInner(string id = default(string), string name = default(string), string type = default(string), string storageContainerPath = default(string), string storageContainerSasKey = default(string), string storageAccountAccessKey = default(string), VulnerabilityAssessmentRecurringScansProperties recurringScans = default(VulnerabilityAssessmentRecurringScansProperties))
            : base(id, name, type)
        {
            StorageContainerPath = storageContainerPath;
            StorageContainerSasKey = storageContainerSasKey;
            StorageAccountAccessKey = storageAccountAccessKey;
            RecurringScans = recurringScans;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets a blob storage container path to hold the scan results
        /// (e.g. https://myStorage.blob.core.windows.net/VaScans/).  It is
        /// required if server level vulnerability assessment policy doesn't
        /// set
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageContainerPath")]
        public string StorageContainerPath { get; set; }

        /// <summary>
        /// Gets or sets a shared access signature (SAS Key) that has write
        /// access to the blob container specified in 'storageContainerPath'
        /// parameter. If 'storageAccountAccessKey' isn't specified,
        /// StorageContainerSasKey is required.
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageContainerSasKey")]
        public string StorageContainerSasKey { get; set; }

        /// <summary>
        /// Gets or sets specifies the identifier key of the storage account
        /// for vulnerability assessment scan results. If
        /// 'StorageContainerSasKey' isn't specified, storageAccountAccessKey
        /// is required.
        /// </summary>
        [JsonProperty(PropertyName = "properties.storageAccountAccessKey")]
        public string StorageAccountAccessKey { get; set; }

        /// <summary>
        /// Gets or sets the recurring scans settings
        /// </summary>
        [JsonProperty(PropertyName = "properties.recurringScans")]
        public VulnerabilityAssessmentRecurringScansProperties RecurringScans { get; set; }

    }
}
